(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    668941,      18806]
NotebookOptionsPosition[    620123,      17984]
NotebookOutlinePosition[    620497,      18001]
CellTagsIndexPosition[    620454,      17998]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["LFSRs", "Section",
 CellChangeTimes->{{3.752396363543951*^9, 
  3.752396364569502*^9}},ExpressionUUID->"dcd5b47e-013a-48a7-be10-\
cda80ac72cac"],

Cell[TextData[StyleBox["Use \[OpenCurlyQuote]Evaluate Notebook\
\[CloseCurlyQuote] in \[OpenCurlyQuote]Evaluation\[CloseCurlyQuote] menu to \
get everything loaded (blue text should change to black, this will take about \
15 seconds). Scroll down for Problem Sheet 5 Question 2 and (later) 3, 4 and \
for Berlekamp\[Dash]Massey (M.Sc.). ",
 FontWeight->"Bold",
 FontSlant->"Italic"]], "Subsection",
 CellChangeTimes->{{3.7483488283317547`*^9, 3.748348836540545*^9}, {
   3.748365965893056*^9, 3.748365973492836*^9}, {3.750342597283184*^9, 
   3.7503426133477507`*^9}, 3.750773678670416*^9, {3.7516538137516737`*^9, 
   3.7516538216509027`*^9}, {3.751653997452572*^9, 3.751654038892419*^9}, {
   3.751654261638949*^9, 3.751654289399984*^9}, {3.775907552618701*^9, 
   3.775907564036459*^9}, 3.782195993005167*^9, {3.782206495178187*^9, 
   3.782206496259069*^9}, {3.7822071416867943`*^9, 3.782207166049252*^9}, {
   3.7822341196754923`*^9, 3.782234132016295*^9}, {3.783960274037982*^9, 
   3.783960276192388*^9}},
 FontWeight->"Plain",ExpressionUUID->"e72e416d-521a-4fee-a3f8-629371a09719"],

Cell[CellGroupData[{

Cell[TextData[{
 "Preliminaries: note ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " lists are indexed from 1: use Entry to number from 0: e.g. \
Entry[{0,1,1,0,1},4] evaluates to the final entry 1."
}], "Subsection",
 CellChangeTimes->{{3.750339780267097*^9, 3.750339781619979*^9}, {
   3.750349941275914*^9, 3.7503499468548613`*^9}, 3.750773684556664*^9, {
   3.793084212106286*^9, 
   3.793084258325107*^9}},ExpressionUUID->"b8520252-0ff8-494f-897c-\
1ed1c99b2d96"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TF", "[", "x_", "]"}], ":=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"x", ",", 
    RowBox[{"TableDepth", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7498077642616*^9, 3.7498077701315928`*^9}},
 CellLabel->
  "In[202]:=",ExpressionUUID->"f35bb72d-50e7-4510-b36e-0ea44bcf2cfa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Iverson", "[", "True", "]"}], ":=", "1"}], ";", " ", 
  RowBox[{
   RowBox[{"Iverson", "[", "False", "]"}], ":=", "0"}]}]], "Input",
 CellChangeTimes->{{3.750327349729587*^9, 3.750327357837775*^9}},
 CellLabel->
  "In[203]:=",ExpressionUUID->"358fd49b-e743-4b6a-bdbd-8ec977b69900"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Words", "[", 
   RowBox[{"0", ",", "_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", "}"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7498114186264267`*^9, 3.74981142634767*^9}, {
  3.775715382310052*^9, 3.775715391830978*^9}},
 CellLabel->
  "In[204]:=",ExpressionUUID->"54e438ae-97d3-4a60-9f5d-ccbd3de42b69"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Words", "[", 
   RowBox[{"n_", ",", "q_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", "e", "}"}], "~", "Join", "~", "w"}], ",", 
      RowBox[{"{", 
       RowBox[{"e", ",", 
        RowBox[{"Range", "[", 
         RowBox[{"0", ",", 
          RowBox[{"q", "-", "1"}]}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"w", ",", 
        RowBox[{"Words", "[", 
         RowBox[{
          RowBox[{"n", "-", "1"}], ",", "q"}], "]"}]}], "}"}]}], "]"}], ",", 
    "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749811427092277*^9, 3.749811455230137*^9}, {
  3.7757153942005367`*^9, 3.7757154648804493`*^9}, {3.775715503229617*^9, 
  3.775715537920434*^9}},
 CellLabel->
  "In[205]:=",ExpressionUUID->"c3ab7357-9b09-477b-9770-739f6efebc7f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BinaryWords", "[", "n_", "]"}], ":=", 
  RowBox[{"Words", "[", 
   RowBox[{"n", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.77571555057965*^9, 3.775715561872068*^9}},
 CellLabel->
  "In[206]:=",ExpressionUUID->"a4751333-a4b1-4b06-8297-b995d224a6ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonZeroBinaryWords", "[", "l_", "]"}], ":=", 
  RowBox[{
   RowBox[{"BinaryWords", "[", "l", "]"}], "[", 
   RowBox[{"[", 
    RowBox[{"2", ";;", 
     RowBox[{"2", "^", "l"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->
  "In[207]:=",ExpressionUUID->"84e64a6a-5c95-4c0d-9057-40ce75bee30e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ModTwo", "[", "x_", "]"}], ":=", 
  RowBox[{"PolynomialMod", "[", 
   RowBox[{"x", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.750341183957456*^9, 3.750341187249415*^9}, {
  3.777568108032694*^9, 3.7775681091716127`*^9}},
 CellLabel->
  "In[208]:=",ExpressionUUID->"93a79fcb-fabd-4265-a47a-79b0f17caf1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Entry", "[", 
    RowBox[{"bs_", ",", "j_"}], "]"}], "/;", 
   RowBox[{"j", "\[GreaterEqual]", "0"}]}], ":=", 
  RowBox[{"bs", "[", 
   RowBox[{"[", 
    RowBox[{"j", "+", "1"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7503499307201*^9, 3.750349937757127*^9}, {
  3.7757156976432467`*^9, 3.775715700115868*^9}},
 CellLabel->
  "In[209]:=",ExpressionUUID->"bf73e156-b09b-405e-8638-da3380749e7c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Entry", "[", 
    RowBox[{"bs_", ",", "j_"}], "]"}], "/;", 
   RowBox[{"j", "<", "0"}]}], ":=", 
  RowBox[{"bs", "[", 
   RowBox[{"[", "j", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.77571570221889*^9, 3.775715712272694*^9}, {
  3.775715744199891*^9, 3.775715744816456*^9}},
 CellLabel->
  "In[210]:=",ExpressionUUID->"48bb1567-034d-466b-be48-e338314d8923"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs_", ",", "yMin_", ",", "yMax_", ",", "col_"}], "]"}], ":=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<+\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"FontSize", "\[Rule]", "20"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"col", ",", 
       RowBox[{"PointSize", "[", "0.02", "]"}]}], "}"}]}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"yMin", ",", "yMax"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.75130337462801*^9, 3.751303378811008*^9}, {
  3.751304313699641*^9, 3.7513043423261633`*^9}, {3.751304651259473*^9, 
  3.7513046655417423`*^9}},
 CellLabel->
  "In[211]:=",ExpressionUUID->"bb6cafd8-4219-46d0-b657-d9e2f166d587"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs_", ",", "yMin_", ",", "yMax_"}], "]"}], ":=", 
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs", ",", "yMin", ",", "yMax", ",", "Black"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751303118964024*^9, 3.751303125299849*^9}, {
  3.7513033814981413`*^9, 3.751303386349511*^9}, {3.7513046685236588`*^9, 
  3.7513046745830317`*^9}},
 CellLabel->
  "In[212]:=",ExpressionUUID->"7d17d65a-cdd8-4040-9569-5b3915925176"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BigListPlot", "[", "xs_", "]"}], ":=", 
  RowBox[{"BigListPlot", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"-", "1"}], ",", "1"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751370352631255*^9, 3.751370358377068*^9}},
 CellLabel->
  "In[213]:=",ExpressionUUID->"d305b802-1ef0-4baa-8fa2-feb5b45f664f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$RecursionLimit", "=", "2000"}], ";"}]], "Input",
 CellChangeTimes->{{3.75145216600084*^9, 3.751452173419005*^9}, {
  3.7657971739878597`*^9, 3.765797174857956*^9}, {3.775717424083817*^9, 
  3.775717424415921*^9}, {3.775719997467637*^9, 3.77571999833281*^9}},
 CellLabel->
  "In[214]:=",ExpressionUUID->"15d6e8d6-531c-4ba0-b2ce-bf24e6ed1b7d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TimesLists", "[", 
   RowBox[{"xs_", ",", "ys_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"x", "*", "y"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "xs"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "ys"}], "}"}]}], "]"}], ",", "2"}], "]"}], "//", 
   "Sort"}]}]], "Input",
 CellChangeTimes->{{3.77764241772256*^9, 3.777642432674581*^9}, {
  3.777642519245287*^9, 3.7776425200352182`*^9}},
 CellLabel->
  "In[215]:=",ExpressionUUID->"04140778-a316-4fbc-bbe6-ca7fa057b1b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BMod", "[", "f_", "]"}], ":=", 
  RowBox[{"PolynomialMod", "[", 
   RowBox[{
    RowBox[{"f", "//", "Normal"}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.782544746579857*^9, 3.782544748581588*^9}},
 CellLabel->
  "In[216]:=",ExpressionUUID->"9c27ef61-2acf-49b8-8792-a23de056681f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllZero", "[", "xs_", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "\[Equal]", "0"}], "&"}], "/@", "xs"}], ")"}]}]}]], "Input",\

 CellChangeTimes->{{3.783444789035859*^9, 3.783444827132463*^9}},
 CellLabel->
  "In[217]:=",ExpressionUUID->"412c0729-20af-4ab9-ba97-41b2f54dddb9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TakeEvery", "[", 
   RowBox[{"ks_", ",", "m_", ",", 
    RowBox[{"c_:", "0"}]}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Entry", "[", 
     RowBox[{"ks", ",", 
      RowBox[{
       RowBox[{"m", "*", "j"}], "+", "c"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "0", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Length", "[", "ks", "]"}], "-", "1", "-", "c"}], ")"}], "/",
        "m"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.793084320167831*^9, 3.793084373859952*^9}, {
  3.793084471511302*^9, 3.7930845039470167`*^9}},
 CellLabel->
  "In[218]:=",ExpressionUUID->"ac9e4d7a-d99b-4725-a7ca-235639bdb395"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["LFSRs", "Section",
 CellChangeTimes->{{3.7498009260110817`*^9, 3.749800928370831*^9}, 
   3.750339789029271*^9, {3.775716403416613*^9, 
   3.775716414941237*^9}},ExpressionUUID->"7fe319ed-0102-4658-ae42-\
f003dce31d4f"],

Cell[CellGroupData[{

Cell["Keystreams", "Subsection",
 CellChangeTimes->{{3.749801350604734*^9, 
  3.749801351636012*^9}},ExpressionUUID->"68495d32-5051-49f6-a9e7-\
fcf737202a1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NextBit", "[", 
   RowBox[{"ts_", ",", "k_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"q", "\[Equal]", "2"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Mod", "[", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"Entry", "[", 
         RowBox[{"k", ",", 
          RowBox[{"-", "t"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", "ts"}], "}"}]}], "]"}], ",", "2"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"e", "=", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Entry", "[", 
            RowBox[{"k", ",", 
             RowBox[{"-", "t"}]}], "]"}], "*", 
           RowBox[{"ts", "[", 
            RowBox[{"[", "t", "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "1", ",", 
            RowBox[{"Length", "[", "ts", "]"}]}], "}"}]}], "]"}]}], "}"}], 
      ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"q", ">", "0"}], ",", 
        RowBox[{"Mod", "[", 
         RowBox[{"e", ",", "q"}], "]"}], ",", "e"}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7498009486863823`*^9, 3.749801011552217*^9}, {
  3.749801061805192*^9, 3.7498010631623096`*^9}, {3.775715788551054*^9, 
  3.7757157952757883`*^9}, {3.775716504291206*^9, 3.775716591398538*^9}, {
  3.782216573334978*^9, 3.782216617191576*^9}},
 CellLabel->
  "In[219]:=",ExpressionUUID->"d128e455-883e-4a03-ae56-6cf4217bf07b"],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Programming note.",
  FontSlant->"Italic"],
 " In binary case, ts is the list of taps, so k_s = sum_{t in T} k_{s-t}. In \
general case, ts is the list of coefficients, so k_s = sum_{t=1}^l ts[[t]] \
k_{s-t}; for this course you only need the binary case."
}], "Subsubsection",
 CellChangeTimes->{{3.7757170356943283`*^9, 3.775717099621516*^9}, {
  3.78221665324854*^9, 3.782216670108891*^9}, {3.7822310471029882`*^9, 
  3.7822310872443666`*^9}, {3.782234147452669*^9, 
  3.782234147692729*^9}},ExpressionUUID->"43d70fbb-db9b-4350-8d39-\
5ea1285951a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NextWord", "[", 
   RowBox[{"ts_", ",", "k_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Entry", "[", 
      RowBox[{"k", ",", "j"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", 
       RowBox[{
        RowBox[{"Length", "[", "k", "]"}], "-", "1"}]}], "}"}]}], "]"}], "~", 
   "Join", "~", 
   RowBox[{"{", 
    RowBox[{"NextBit", "[", 
     RowBox[{"ts", ",", "k", ",", "q"}], "]"}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.7498010712979317`*^9, 3.749801101156521*^9}, {
  3.7498011694676332`*^9, 3.749801170330361*^9}, {3.775715901517603*^9, 
  3.775715912577013*^9}},
 CellLabel->
  "In[220]:=",ExpressionUUID->"3ceee378-1929-43cf-ba00-743e3e0a28b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NextWords", "[", 
   RowBox[{"ts_", ",", "k_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", 
      RowBox[{"kNext", "=", "k"}], ",", 
      RowBox[{"ws", "=", 
       RowBox[{"{", "k", "}"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"s", "=", "0"}], ",", 
       RowBox[{"s", "<", "n"}], ",", 
       RowBox[{"s", "++"}], ",", 
       RowBox[{
        RowBox[{"kNext", "=", 
         RowBox[{"NextWord", "[", 
          RowBox[{"ts", ",", "kNext", ",", "q"}], "]"}]}], ";", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"ws", ",", "kNext"}], "]"}]}]}], "]"}], ";", "ws"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777620673032012*^9, 3.777620808025505*^9}, 
   3.777620871482769*^9},
 CellLabel->
  "In[221]:=",ExpressionUUID->"2715e150-1268-4a26-9dab-a8dbda5bd223"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Keystream", "[", 
   RowBox[{"ts_", ",", "k_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
     RowBox[{"NextWords", "[", 
      RowBox[{"ts", ",", "k", ",", "n", ",", "q"}], "]"}]}], ")"}], "[", 
   RowBox[{"[", 
    RowBox[{"1", ";;", "n"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7776208165679502`*^9, 3.777620845262539*^9}, {
  3.777621091254005*^9, 3.777621095177738*^9}},
 CellLabel->
  "In[222]:=",ExpressionUUID->"4e8e5376-a929-4889-8cf9-c0e2de4a848f"]
}, Open  ]],

Cell["\<\
This uses the \[OpenCurlyQuote]Very Useful Property\[CloseCurlyQuote] to get \
the keystream from k, F(k), F^2(k) , ... \
\>", "Subsubsection",
 CellChangeTimes->{{3.775747508806726*^9, 3.775747595909124*^9}, {
  3.777620898150889*^9, 
  3.777621032778488*^9}},ExpressionUUID->"cabad2d0-8b49-4142-814b-\
d27ad9f6ae53"],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Programming note.",
  FontSlant->"Italic"],
 " Generally the lecturer prefers to use recursion, rather than \
\[OpenCurlyQuote]for\[CloseCurlyQuote] loops. But Mathematica gets slow (or \
even fails) if one has very deep recursions, so less elegant code sometimes \
has to be used. For comparison, the recursive version is below. You will find \
it starts to fail on keystreams of length 1995 (one would expect \
$RecusionLimit = 2000; presumably the internals of Mathematica use up 5 \
levels of stack)."
}], "Subsubsection",
 CellChangeTimes->{{3.777621034267497*^9, 3.777621078988481*^9}, {
  3.7776211730291567`*^9, 3.7776212133126917`*^9}, {3.78221667683107*^9, 
  3.782216695909734*^9}, {3.7822167500705757`*^9, 3.7822168502483263`*^9}, {
  3.78223415003506*^9, 
  3.782234160064217*^9}},ExpressionUUID->"ba1037c8-03e1-415f-b1ab-\
5b1c436e9b3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamRec", "[", 
   RowBox[{"ts_", ",", "k_", ",", "0", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.74980121253475*^9, 3.749801229639965*^9}, {
  3.775715916849141*^9, 3.7757159195394487`*^9}, {3.7757474994336042`*^9, 
  3.775747499735365*^9}},
 CellLabel->
  "In[223]:=",ExpressionUUID->"90d2ac1b-8eb1-4a07-b858-f9301c523d69"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamRec", "[", 
   RowBox[{"ts_", ",", "k_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"kNew", " ", "=", " ", 
      RowBox[{"NextWord", "[", 
       RowBox[{"ts", ",", "k", ",", "q"}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Entry", "[", 
       RowBox[{"k", ",", "0"}], "]"}], "}"}], "~", "Join", "~", 
     RowBox[{"KeystreamRec", "[", 
      RowBox[{"ts", ",", "kNew", ",", 
       RowBox[{"n", "-", "1"}], ",", "q"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749801230809013*^9, 3.749801282084489*^9}, {
  3.77571592220068*^9, 3.775715924202167*^9}, {3.775716985291844*^9, 
  3.7757169918132668`*^9}, {3.7757475021102962`*^9, 3.775747505025299*^9}},
 CellLabel->
  "In[224]:=",ExpressionUUID->"778561b9-76fc-448f-9468-602ed626fda5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 6.3", "Subsection",
 CellChangeTimes->{{3.7757475618114853`*^9, 3.775747562520472*^9}, 
   3.777621152218835*^9, {3.7777949954723186`*^9, 3.7777949990285883`*^9}, 
   3.7822066985819597`*^9},ExpressionUUID->"0e5fc754-6578-45e3-9914-\
548a82583447"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "20"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7776211184353647`*^9, 3.7776211883053017`*^9}, {
  3.777795001333817*^9, 3.777795001971425*^9}, {3.777795085081554*^9, 
  3.7777950852189817`*^9}},
 CellLabel->
  "In[225]:=",ExpressionUUID->"5f17137c-3ea2-4026-83b1-a125e28c38d2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.7776211213170433`*^9, 3.7776211886210337`*^9}, 
   3.7777950026001368`*^9, 3.777795085517531*^9, 3.7821959668210573`*^9, 
   3.7821961603942623`*^9, 3.7821975552243137`*^9, 3.782197611574459*^9, 
   3.782197669551464*^9, 3.782208428713855*^9, 3.782216620849016*^9, 
   3.782232644955015*^9, 3.782233578240892*^9, 3.78223542642208*^9, 
   3.7823215619720507`*^9, 3.78247896180899*^9, 3.782551934081379*^9, 
   3.782803068085816*^9, 3.782812891289049*^9, 3.782822190006641*^9, 
   3.783084478985169*^9, 3.7830965633398027`*^9, 3.783097548915187*^9, 
   3.78310163322726*^9, 3.783186654854103*^9, 3.783445219702119*^9, 
   3.783878243244676*^9, 3.783929785805955*^9, 3.784214437932949*^9, 
   3.784214706520483*^9, 3.7842147802702713`*^9, 3.784390636280795*^9, 
   3.784390943588375*^9, 3.7921360365065527`*^9, 3.793084201987321*^9, 
   3.7933399470569057`*^9, 3.794985745458523*^9, 3.794986390834055*^9, 
   3.7949882270482073`*^9, 3.798871694663275*^9, 3.799333448088561*^9},
 CellLabel->
  "Out[225]=",ExpressionUUID->"0912abc4-d7a2-4b27-8c62-67e263567db4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", "20"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.775717401124939*^9, 3.775717460557406*^9}, {
  3.77574764880261*^9, 3.7757476535842524`*^9}, {3.777795009452702*^9, 
  3.777795022823818*^9}, {3.777795086637678*^9, 3.7777950867787037`*^9}},
 CellLabel->
  "In[226]:=",ExpressionUUID->"5b742c10-3741-496f-8587-2c884a2c4c32"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.775717411741672*^9, 3.775717460887436*^9}, 
   3.775719492244658*^9, 3.775720118384757*^9, 3.77572029565366*^9, 
   3.7757236000890408`*^9, 3.7757236495986013`*^9, 3.775723682744151*^9, 
   3.77572379991669*^9, 3.775723883351241*^9, 3.775747601466704*^9, {
   3.775747646402556*^9, 3.775747653970456*^9}, 3.7758943657191687`*^9, 
   3.775907531288575*^9, 3.777029688943877*^9, 3.77718832544563*^9, 
   3.777567619731456*^9, 3.7775681256973057`*^9, 3.7775682715084743`*^9, 
   3.777620417244566*^9, {3.777621082420739*^9, 3.777621105602261*^9}, {
   3.777795018211789*^9, 3.777795023131133*^9}, 3.7777950870827017`*^9, 
   3.782195966936514*^9, 3.782196160515459*^9, 3.782197555323955*^9, 
   3.7821976116447287`*^9, 3.782197669649334*^9, 3.7822084288088512`*^9, 
   3.782216622203142*^9, 3.782232645096036*^9, 3.782233578390828*^9, 
   3.782235426531248*^9, 3.782321562082304*^9, 3.7824789619402657`*^9, 
   3.782551934264831*^9, 3.782803068193079*^9, 3.7828128914314013`*^9, 
   3.7828221901545963`*^9, 3.783084479091704*^9, 3.783096563469742*^9, 
   3.783097549061421*^9, 3.783101633413652*^9, 3.783186654964036*^9, 
   3.783445219838201*^9, 3.783878243370351*^9, 3.783929785909504*^9, 
   3.784214438051882*^9, 3.784214706799157*^9, 3.784214780387241*^9, 
   3.784390636386449*^9, 3.7843909436914997`*^9, 3.7921360366268463`*^9, 
   3.793084202092204*^9, 3.7933399473503027`*^9, 3.794985745585693*^9, 
   3.794986390937832*^9, 3.79498822717844*^9, 3.7988716948420353`*^9, 
   3.799333448198471*^9},
 CellLabel->
  "Out[226]=",ExpressionUUID->"3ca98eec-8dd7-4f58-9f64-319ddb2f1a0a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NextWords", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "20"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.777795077269655*^9, 3.7777950830552998`*^9}},
 CellLabel->
  "In[227]:=",ExpressionUUID->"ee10bdf7-3a12-43cd-b46a-01ea3bd3e848"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7821959670274057`*^9, 3.7821961637210417`*^9, 
  3.782197555406505*^9, 3.782197611727153*^9, 3.782197669733966*^9, 
  3.7822084288984222`*^9, 3.782216622955858*^9, 3.7822326452439213`*^9, 
  3.7822335785309477`*^9, 3.782235426624819*^9, 3.782321562214304*^9, 
  3.78247896207722*^9, 3.782551934583315*^9, 3.782803068298642*^9, 
  3.782812891580842*^9, 3.782822190311544*^9, 3.783084479186061*^9, 
  3.783096563604014*^9, 3.7830975492185*^9, 3.783101633597713*^9, 
  3.7831866550773067`*^9, 3.783445219954465*^9, 3.783878243600119*^9, 
  3.783929786005209*^9, 3.784214438159059*^9, 3.7842147070368433`*^9, 
  3.7842147805200167`*^9, 3.7843906364881372`*^9, 3.784390946453178*^9, 
  3.79213603674545*^9, 3.793084202193488*^9, 3.7933399475120373`*^9, 
  3.794985745823072*^9, 3.7949863915456543`*^9, 3.794988227703136*^9, 
  3.798871694942154*^9, 3.7993334482957563`*^9},
 CellLabel->
  "Out[227]=",ExpressionUUID->"1b639230-f68e-4176-bc7f-7e993c61740f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Period of an invertible LFSR", "Subsection",
 CellChangeTimes->{{3.749801352926066*^9, 3.749801353603024*^9}, {
  3.7498021493289337`*^9, 3.749802157584196*^9}, {3.775717481498682*^9, 
  3.775717483732677*^9}},ExpressionUUID->"fe4ae4fd-d8f4-4552-9ab1-\
e2d125ba2833"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LFSRIsInvertible", "[", 
   RowBox[{"ts_", ",", "l_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"q", "\[Equal]", "2"}], ",", 
    RowBox[{"MemberQ", "[", 
     RowBox[{"ts", ",", "l"}], "]"}], ",", 
    RowBox[{"Not", "[", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"ts", "[", 
         RowBox[{"[", "l", "]"}], "]"}], ",", "q"}], "]"}], "\[Equal]", "0"}],
      "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.775718292592616*^9, 3.775718324787106*^9}, 
   3.775718401434664*^9, {3.7757184763343687`*^9, 3.775718478427343*^9}},
 CellLabel->
  "In[228]:=",ExpressionUUID->"d41cb2c7-da4c-4991-94a3-7ef39d5e43be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NextWords", "[", 
   RowBox[{"ts_", ",", "k_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "F", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"F", "[", "v_", "]"}], ":=", 
      RowBox[{"NextWord", "[", 
       RowBox[{"ts", ",", "v", ",", "q"}], "]"}]}], ";", " ", 
     RowBox[{"NestList", "[", 
      RowBox[{"F", ",", "k", ",", "n"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749801493621715*^9, 3.749801547292173*^9}, {
  3.775715949309557*^9, 3.7757159559473553`*^9}},
 CellLabel->
  "In[229]:=",ExpressionUUID->"08fb816b-7083-4191-876d-229980ae459c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NextWordsTagged", "[", 
   RowBox[{"ts_", ",", "k_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"vs", " ", "=", " ", 
       RowBox[{"NextWords", "[", 
        RowBox[{"ts", ",", "k", ",", 
         RowBox[{
          RowBox[{"q", "^", 
           RowBox[{"Length", "[", "k", "]"}]}], "-", "1"}], ",", "q"}], 
        "]"}]}], ",", "ps"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"vs", "[", 
         RowBox[{"[", 
          RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{
         RowBox[{"q", "^", 
          RowBox[{"Length", "[", "k", "]"}]}], "-", "1"}]}], "}"}]}], "]"}]}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.749801569814333*^9, 3.749801601351479*^9}, {
  3.749801644343009*^9, 3.749801801317294*^9}, {3.7498018343329487`*^9, 
  3.749801834607934*^9}, {3.775715960991912*^9, 3.775715982635807*^9}, {
  3.7757185201451607`*^9, 3.775718548130115*^9}},
 CellLabel->
  "In[230]:=",ExpressionUUID->"8a61c224-a1eb-4e61-8af2-413eaab73346"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamPeriod", "[", 
   RowBox[{"ts_", ",", "k_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"LFSRIsInvertible", "[", 
     RowBox[{"ts", ",", 
      RowBox[{"Length", "[", "k", "]"}], ",", "q"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ps", "=", 
         RowBox[{"Delete", "[", 
          RowBox[{
           RowBox[{"NextWordsTagged", "[", 
            RowBox[{"ts", ",", "k", ",", "q"}], "]"}], ",", "1"}], "]"}]}], 
        ",", "rs"}], "}"}], ",", 
      RowBox[{
       RowBox[{"rs", ":=", 
        RowBox[{"Select", "[", 
         RowBox[{"ps", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "k"}], "&"}]}], 
         "]"}]}], ";", 
       RowBox[{
        RowBox[{"rs", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Throw", "[", 
     RowBox[{"Print", "[", 
      RowBox[{
      "\"\<LFSR with taps \>\"", ",", "ts", ",", 
       "\"\< is not invertible with initial key \>\"", ",", " ", "k"}], "]"}],
      "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749801784661975*^9, 3.749801866861113*^9}, {
  3.74980196549547*^9, 3.7498019685132523`*^9}, {3.749802006145756*^9, 
  3.749802046293277*^9}, {3.775715974075829*^9, 3.7757159989616947`*^9}, {
  3.775717489039639*^9, 3.775717511079733*^9}, {3.775717574285541*^9, 
  3.775717624212162*^9}, {3.7757176676451483`*^9, 3.775717668333976*^9}, {
  3.775717717577735*^9, 3.775717762325263*^9}, {3.775717805888332*^9, 
  3.775717853725494*^9}, {3.7757182559940367`*^9, 3.77571828346163*^9}},
 CellLabel->
  "In[231]:=",ExpressionUUID->"00d78f28-8682-4b2b-8b87-7b585786ad9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamCycle", "[", 
   RowBox[{"ts_", ",", "k_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Keystream", "[", 
   RowBox[{"ts", ",", "k", ",", 
    RowBox[{"KeystreamPeriod", "[", 
     RowBox[{"ts", ",", "k", ",", "q"}], "]"}], ",", "q"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.775717895149766*^9, 3.775717913616157*^9}},
 CellLabel->
  "In[232]:=",ExpressionUUID->"bb2200d4-2ca5-4720-b0bd-3748f544adb6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Keystream", "[", 
   RowBox[{"ts_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"KeystreamCycle", "[", 
   RowBox[{"ts", ",", "k"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777568224972864*^9, 3.777568245317678*^9}},
 CellLabel->
  "In[233]:=",ExpressionUUID->"0c735fcf-c5a5-4437-b2c4-97a461a3b184"]
}, Open  ]],

Cell[CellGroupData[{

Cell["All keystreams", "Subsection",
 CellChangeTimes->{{3.749813492773929*^9, 
  3.7498134952403593`*^9}},ExpressionUUID->"7e922286-3601-4138-8afa-\
5b70b8f10ae8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllKeystreamsFrom", "[", 
   RowBox[{"ts_", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.7498134974012957`*^9, 3.749813508533918*^9}, {
  3.749813764607315*^9, 3.749813764944107*^9}, {3.775716020610626*^9, 
  3.775716021905883*^9}},
 CellLabel->
  "In[234]:=",ExpressionUUID->"716ee0b4-49fa-4480-ae3e-36c191a3645f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllKeystreamsFrom", "[", 
   RowBox[{"ts_", ",", "vs_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"k", "=", 
       RowBox[{"vs", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"ks", "=", 
       RowBox[{"KeystreamCycle", "[", 
        RowBox[{"ts", ",", 
         RowBox[{"vs", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "q"}], "]"}]}], ",", "ws"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{"ws", ":=", 
      RowBox[{"NextWords", "[", 
       RowBox[{"ts", ",", "k", ",", 
        RowBox[{"Length", "[", "ks", "]"}], ",", "q"}], "]"}]}], ";", 
     RowBox[{
      RowBox[{"{", "ks", "}"}], "~", "Join", "~", 
      RowBox[{"AllKeystreamsFrom", "[", 
       RowBox[{"ts", ",", 
        RowBox[{"Complement", "[", 
         RowBox[{"vs", ",", "ws"}], "]"}], ",", "q"}], "]"}]}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7498135097420473`*^9, 3.749813561209214*^9}, {
  3.749813605027719*^9, 3.749813693715356*^9}, {3.7498137579550447`*^9, 
  3.749813774150515*^9}, {3.775716023733858*^9, 3.775716045618285*^9}, {
  3.775717974924089*^9, 3.775717977101884*^9}},
 CellLabel->
  "In[235]:=",ExpressionUUID->"7d3b2da7-48a8-4215-8f78-98fa5923403a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AllKeystreams", "[", 
   RowBox[{"ts_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"AllKeystreamsFrom", "[", 
   RowBox[{"ts", ",", 
    RowBox[{"Words", "[", 
     RowBox[{"n", ",", "q"}], "]"}], ",", "q"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7498137762086983`*^9, 3.749813789180992*^9}, {
  3.7757160493725557`*^9, 3.7757160541954813`*^9}, {3.7757183464493637`*^9, 
  3.775718365337368*^9}},
 CellLabel->
  "In[236]:=",ExpressionUUID->"db496a13-568f-4f76-b91b-841e60217a08"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamLengths", "[", 
   RowBox[{"ts_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Length", "/@", 
    RowBox[{"AllKeystreams", "[", 
     RowBox[{"ts", ",", "n", ",", "q"}], "]"}]}], "//", "Sort"}]}]], "Input",
 CellChangeTimes->{{3.749813801788332*^9, 3.74981381950403*^9}, {
  3.7757160568213587`*^9, 3.775716059101242*^9}, {3.777636854007756*^9, 
  3.777636856059677*^9}},
 CellLabel->
  "In[237]:=",ExpressionUUID->"053add1b-f2e2-48f6-aaea-53e1bf442e52"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Keystream to polynomial: note \[OpenCurlyQuote]normal\[CloseCurlyQuote] \
converts power series to polynomial\
\>", "Subsection",
 CellChangeTimes->{{3.777614914019353*^9, 3.777614926741702*^9}, {
  3.777615623134544*^9, 
  3.777615629924934*^9}},ExpressionUUID->"059c0fe5-bc3e-4960-97ee-\
f737af03d31e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamToPolynomial", "[", "ks_", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ks", "[", 
      RowBox[{"[", 
       RowBox[{"i", "+", "1"}], "]"}], "]"}], "*", 
     RowBox[{"z", "^", "i"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{
       RowBox[{"Length", "[", "ks", "]"}], "-", "1"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777568430631666*^9, 3.777568471656101*^9}, 
   3.782198708558573*^9},
 CellLabel->
  "In[238]:=",ExpressionUUID->"c97a8199-b6d0-42c4-a35b-d15d0df638dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamQuotient", "[", 
   RowBox[{"ts_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"kP", "=", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Entry", "[", 
           RowBox[{"k", ",", "i"}], "]"}], "*", 
          RowBox[{"z", "^", "i"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{
            RowBox[{"Length", "[", "k", "]"}], "-", "1"}]}], "}"}]}], "]"}]}],
       ",", 
      RowBox[{"aP", "=", 
       RowBox[{"1", "+", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{"z", "^", "t"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "ts"}], "}"}]}], "]"}]}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"PolynomialMod", "[", 
      RowBox[{
       RowBox[{"kP", "*", "aP"}], ",", 
       RowBox[{"z", "^", 
        RowBox[{"Length", "[", "k", "]"}]}]}], "]"}], "/", "aP"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777569008704596*^9, 3.777569135992392*^9}, {
  3.782198710255858*^9, 3.782198715251609*^9}},
 CellLabel->
  "In[239]:=",ExpressionUUID->"a8d4f298-d94e-492e-86b5-d392e76ecca0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FeedbackPolynomial", "[", 
   RowBox[{"ts_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"q", "\[Equal]", "2"}], ",", 
    RowBox[{"1", "+", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"z", "^", "t"}], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", "ts"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"1", "+", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ts", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "*", 
        RowBox[{"z", "^", "i"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "ts", "]"}]}], "}"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777635098092248*^9, 3.777635100210143*^9}, {
  3.777635280809471*^9, 3.777635329651675*^9}, {3.782198719316683*^9, 
  3.782198719896175*^9}},
 CellLabel->
  "In[240]:=",ExpressionUUID->"ca524cc2-5608-48f2-b4db-e31e2d0663c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PolynomialNumeratorToKeystream", "[", 
   RowBox[{"ts_", ",", "p_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"CoefficientList", "[", 
   RowBox[{
    RowBox[{"PolynomialMod", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"p", "/", 
          RowBox[{"FeedbackPolynomial", "[", 
           RowBox[{"ts", ",", "q"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"z", ",", "0", ",", 
           RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "//", "Normal"}], ",", 
      "q"}], "]"}], ",", "z"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7776358445758142`*^9, 3.777635906222928*^9}, {
  3.7776360622666407`*^9, 3.77763610069944*^9}, {3.782198720542005*^9, 
  3.7821987210243263`*^9}},
 CellLabel->
  "In[241]:=",ExpressionUUID->"7d704294-1be2-4e00-89aa-91a913f49147"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FeedbackPolynomialToTaps", "[", 
   RowBox[{"f_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"q", "\[Equal]", "2"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"CoefficientList", "[", 
             RowBox[{"f", ",", "z"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", "i"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Exponent", "[", 
            RowBox[{"f", ",", "z"}], "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], "&"}]}], "]"}]}],
     ",", 
    RowBox[{
     RowBox[{"CoefficientList", "[", 
      RowBox[{"f", ",", "z"}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ";;", 
       RowBox[{
        RowBox[{"Exponent", "[", 
         RowBox[{"f", ",", "z"}], "]"}], "+", "1"}]}], "]"}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777644764187415*^9, 3.777644943201283*^9}, {
  3.782198721677096*^9, 3.7821987350378847`*^9}},
 CellLabel->
  "In[242]:=",ExpressionUUID->"94aa72f9-e355-4bee-baca-799a8fe515d8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section",
 CellChangeTimes->{{3.777615644484552*^9, 
  3.777615645252439*^9}},ExpressionUUID->"d4ed4e6a-58a9-48ce-976d-\
b3909fdc79a2"],

Cell[CellGroupData[{

Cell["Example 6.3", "Subsection",
 CellChangeTimes->{{3.7498138211478252`*^9, 3.749813824366907*^9}, {
   3.7502481864182863`*^9, 3.750248187740389*^9}, {3.750248648514125*^9, 
   3.7502486499877996`*^9}, {3.777615659850607*^9, 3.7776156615670433`*^9}, 
   3.7776214922556267`*^9, {3.782197803745438*^9, 
   3.782197811744174*^9}},ExpressionUUID->"df50ce1e-f12a-49a8-b741-\
129316b2f621"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AllKeystreams", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", "4"}], "]"}], "//", "TF"}]], "Input",\

 CellChangeTimes->{{3.749813695418393*^9, 3.749813750000169*^9}, 
   3.749813796744363*^9, {3.7501435989120207`*^9, 3.7501436143177547`*^9}, {
   3.7757189231392193`*^9, 3.775718923888542*^9}},
 CellLabel->
  "In[243]:=",ExpressionUUID->"d3319e56-33af-4388-80e0-60e58cef5573"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
    {"0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.749813706129727*^9, 3.749813750263813*^9}, 
   3.749813797140336*^9, {3.750143599776637*^9, 3.750143614619869*^9}, 
   3.750343149814311*^9, 3.750771707179287*^9, 3.751271323990806*^9, 
   3.751312604903153*^9, 3.751312660079183*^9, 3.751452127885045*^9, 
   3.75145218716145*^9, {3.751466074543252*^9, 3.751466130720559*^9}, 
   3.751653763409247*^9, 3.751654254194713*^9, 3.751794577945154*^9, 
   3.75233227151825*^9, 3.752339862357506*^9, 3.752390910729991*^9, 
   3.7525137452978973`*^9, 3.7525138720142384`*^9, 3.752513919107835*^9, 
   3.7525964778522377`*^9, 3.752841017498921*^9, 3.7528410634393263`*^9, 
   3.752845910715104*^9, 3.7528460186102*^9, 3.753267422154303*^9, 
   3.765797179283944*^9, 3.765797401206869*^9, 3.765809519660203*^9, 
   3.775637905721141*^9, 3.775663896242064*^9, 3.775716796864954*^9, 
   3.775718767884841*^9, 3.775718924313884*^9, 3.7757194925775557`*^9, 
   3.775720118717339*^9, 3.775723600421132*^9, 3.775723650732727*^9, 
   3.775723683739574*^9, 3.775723803097116*^9, 3.77572388368257*^9, 
   3.7757476091249104`*^9, 3.7757476584925747`*^9, 3.775894366115587*^9, 
   3.775907531730421*^9, 3.7770296892713337`*^9, 3.777188325849656*^9, 
   3.777567620277999*^9, 3.7775681291318607`*^9, 3.777568272673511*^9, 
   3.777620417494707*^9, 3.782195967298233*^9, 3.7821961640479317`*^9, 
   3.782197555818959*^9, 3.782197614718089*^9, 3.782197672797987*^9, 
   3.78220842986902*^9, 3.782232645663383*^9, 3.782233578959752*^9, 
   3.782235427562066*^9, 3.7823215624129353`*^9, 3.782478962868122*^9, 
   3.7825519349750147`*^9, 3.782803068504446*^9, 3.782812891844701*^9, 
   3.7828221914038477`*^9, 3.7830844795079603`*^9, 3.783096564520015*^9, 
   3.783097549447915*^9, 3.783101633871808*^9, 3.783186655378487*^9, 
   3.7834452202148438`*^9, 3.783878243961774*^9, 3.78392978635261*^9, 
   3.7842144384218473`*^9, 3.784214709498601*^9, 3.784214780832494*^9, 
   3.784390637029126*^9, 3.784390946819621*^9, 3.792136037090129*^9, 
   3.793084202449831*^9, 3.793339947875782*^9, 3.79498574610573*^9, 
   3.794986391966935*^9, 3.79498822822795*^9, 3.798871695228075*^9, 
   3.799333448559608*^9},
 CellLabel->
  "Out[243]//TableForm=",ExpressionUUID->"67d887b9-2d64-494d-ac35-\
9991a604495e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercise 6.6", "Subsection",
 CellChangeTimes->{{3.777621494059373*^9, 3.7776214991330214`*^9}, {
  3.782197821795627*^9, 
  3.782197822533783*^9}},ExpressionUUID->"81a91348-4740-450e-85ec-\
57d32804140a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", "15"}], "]"}]], "Input",
 CellChangeTimes->{{3.750531556340699*^9, 3.7505315563442*^9}, {
  3.77571892748757*^9, 3.775718947796617*^9}, {3.777615727872838*^9, 
  3.777615778065218*^9}},
 CellLabel->
  "In[244]:=",ExpressionUUID->"dc05b608-809e-4634-aaa3-2c20dbb21eea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.7505315574399433`*^9, 3.750771707275208*^9, 3.751271324021323*^9, 
   3.7513126049320583`*^9, 3.751312660110178*^9, 3.751452127917307*^9, 
   3.75145218724778*^9, {3.751466074609848*^9, 3.751466130771348*^9}, 
   3.751653763444392*^9, 3.751654254224461*^9, 3.751794577983202*^9, 
   3.752332271560462*^9, 3.7523398624019938`*^9, 3.752390910809359*^9, 
   3.7525137453436403`*^9, 3.752513872074952*^9, 3.75251391914854*^9, 
   3.7525964778855877`*^9, 3.7528410175705214`*^9, 3.752841063490725*^9, 
   3.752845910772175*^9, 3.752846018647436*^9, 3.753267422218148*^9, 
   3.765797179335183*^9, 3.7657974012547083`*^9, 3.765809519714868*^9, 
   3.775637905785623*^9, 3.775663896319913*^9, 3.7757168060867987`*^9, {
   3.775718928647388*^9, 3.775718948115633*^9}, 3.77571949266105*^9, 
   3.775720121552581*^9, 3.775723600504716*^9, 3.7757236508328943`*^9, 
   3.7757236838229*^9, 3.77572380319772*^9, 3.775723883783557*^9, 
   3.775747621039118*^9, 3.775747660429031*^9, 3.7758943661870832`*^9, 
   3.775907531802985*^9, 3.77702968936024*^9, 3.77718832593419*^9, 
   3.77756762035363*^9, 3.7775681292654953`*^9, 3.7775682727560596`*^9, {
   3.777615729687765*^9, 3.777615778689596*^9}, 3.7776204176097918`*^9, 
   3.782195967406732*^9, 3.782196164148212*^9, 3.7821975559066772`*^9, 
   3.782197614804756*^9, 3.782197672901456*^9, 3.782208429965725*^9, 
   3.782232645793993*^9, 3.782233579094027*^9, 3.78223542765837*^9, 
   3.782321562515567*^9, 3.782478963005348*^9, 3.7825519353939133`*^9, 
   3.782803068596204*^9, 3.782812892014718*^9, 3.78282219156218*^9, 
   3.783084479607677*^9, 3.7830965646543903`*^9, 3.7830975495534163`*^9, 
   3.783101634030312*^9, 3.783186655483266*^9, 3.783445220336911*^9, 
   3.7838782440771637`*^9, 3.78392978646056*^9, 3.78421443854465*^9, 
   3.784214709616995*^9, 3.784214780969325*^9, 3.784390637137253*^9, 
   3.784390946925869*^9, 3.792136037193722*^9, 3.793084202559458*^9, 
   3.79333994802487*^9, 3.794985746244326*^9, 3.79498639207341*^9, 
   3.794988228345132*^9, 3.7988716953384237`*^9, 3.79933344868281*^9},
 CellLabel->
  "Out[244]=",ExpressionUUID->"7a39eb62-121d-4eec-953a-df8a2fafd355"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercise 6.7", "Subsection",
 CellChangeTimes->{{3.7776215012775307`*^9, 3.7776215073008127`*^9}, {
  3.782197828191701*^9, 
  3.78219782838029*^9}},ExpressionUUID->"6ba7fe3e-75fe-44a5-bda9-\
e3a3895b721a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "15"}], "]"}], 
   ",", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", "15"}], 
    "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.777615667487032*^9, 3.777615708731515*^9}},
 CellLabel->
  "In[245]:=",ExpressionUUID->"d752dcdd-2d07-43b1-a93d-d93e617c8103"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0",
      ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0",
      ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQA+KIvwteW6m+cXyi52ZhC6Rrnn2O/677xvHLy/YKEM20
tl7tB5D2yLqrC6JDrBVNQXTbmYOlf4F05uq9Hpx6bxyrfdP3gmg274olXED6
yO/gzSZA+kxOSl8jkK6790V/KZDmWzbtvLz+G8eu0M7ZKkB656zvqppA+sLi
b+YrgfRnnZly64H0uYptM0H0oTduMzYC6fvqn6VvA2nFDf0xkQZvHBNN287o
GALVewZ9dwXSXSE3vlwA0l8OXRS7CKRLW5bLg2ipfcv/qhm9cey5naiiDqRn
F61888bhjSPHxoinu53eOJ4Qbjtq4fzG8eQk76QYtzeOetuCN4Portc3Z8QC
6TSWdxeP+r5x9Dog57nc740jANJ7nCA=
  "],
 CellLabel->
  "Out[245]=",ExpressionUUID->"0a997a8f-f380-4d0c-852a-09733139be1d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AllKeystreams", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.7776157138158007`*^9, 3.77761571708932*^9}, {
  3.777615793104066*^9, 3.777615793340618*^9}},
 CellLabel->
  "In[246]:=",ExpressionUUID->"2c9d9d93-32b9-413c-8af8-1e597bd88b57"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}],
     "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQA2KmRrNvVqpvHPluB1rYAukWg+/x33XfONaZdleA6FOx
TWo/gLSHzANdEH3NRsUURJ+6Klb2F0hbvTjowan3xrFGNWcviD408fQSLiDt
Vxu12QRIW2zK6GsE0jyhP/WXAukJYrPOy+u/cZyV0DtbBUhnMP1V1QTSxTd/
mq8E0hsvvJNbD6Q3rNwzE0SLKPvO2AikV1z7Jn0bSB8KnhwTafDGUe9I5xkd
wzeOQstCv7sC6Q2nb3+5AKRF5J6KXQTS8QGX5EG08vdVf9WM3jhW8KWqqAPp
dwvXvHnj8MZxK1fM091ObxwfBvYctXB+4yg2JSApxu2No1pi9GYQ/aTt0YxY
IJ1k8/HiUV+g/DQlz+V+bxwB+vGVwA==
  "],
 CellLabel->
  "Out[246]=",ExpressionUUID->"26665094-5126-43a7-99e4-2ee0dfe67fe4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercise 6.9", "Subsection",
 CellChangeTimes->{{3.777740113114717*^9, 3.777740130906706*^9}, 
   3.777740702982129*^9, {3.777798641455731*^9, 3.777798641633851*^9}, 
   3.7821978402002363`*^9},ExpressionUUID->"e01bbd4a-309e-445f-92f1-\
3bb761d24a5c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "30"}], "]"}]], "Input",
 CellChangeTimes->{{3.777740704392975*^9, 3.777740704480777*^9}},
 CellLabel->
  "In[247]:=",ExpressionUUID->"552cd961-9dd1-477f-a1aa-84440747670f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQA2LFW7nny1XfONYulvgCovsafsV/133jeOJDXwWIFmVo
VfsBpIu+PdIF0Qz56qYgOu2LbNlfIB28/5gHp94bx1eshXtBtIH3xSVcQHrq
0djNJkDarzq/rxFIB/z8p78USK/qnXteXv+No53QpNkqQFpkI5OaJpA25vpr
vhJI++R+lVsPpH8YH5gJohcuCJqxEUjnzvkrfRtIuylPj4k0ANrX3ntGx/CN
Y8fJiO+uQPpO6/0vF4B0XYGw+EUgzXvprTyITlNa91fN6I2jSXiGijqIfrn+
zRuHN45/dsc/3e30xrHs9YSjFs5AdbFhSTFuQPvPxW8G0QU1z2fEAmmzoi8X
j/q+cbz+Ws1zud8bRwAtvZkB
  "],
 CellLabel->
  "Out[247]=",ExpressionUUID->"12700a5d-3436-4bf1-bdd6-ed7b61116f97"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToPolynomial", "[", 
  RowBox[{"Keystream", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "30"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.777740450049714*^9, 3.7777404536975737`*^9}, {
  3.777740706834526*^9, 3.77774070691217*^9}},
 CellLabel->
  "In[248]:=",ExpressionUUID->"542e8490-ccf3-47a8-a5d1-c654a86fd803"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "4"], "+", 
  SuperscriptBox["z", "5"], "+", 
  SuperscriptBox["z", "6"], "+", 
  SuperscriptBox["z", "9"], "+", 
  SuperscriptBox["z", "11"], "+", 
  SuperscriptBox["z", "12"], "+", 
  SuperscriptBox["z", "13"], "+", 
  SuperscriptBox["z", "16"], "+", 
  SuperscriptBox["z", "18"], "+", 
  SuperscriptBox["z", "19"], "+", 
  SuperscriptBox["z", "20"], "+", 
  SuperscriptBox["z", "23"], "+", 
  SuperscriptBox["z", "25"], "+", 
  SuperscriptBox["z", "26"], "+", 
  SuperscriptBox["z", "27"]}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQB2LzbQevlKu+cbzOnvEFRL+p+hv/XfeNo5r8pAoQfXRt
u9oPIF064akuiJ4rq2UKohvm5u4B0en/FMr+Aun2GZc8OPXeOPorle4F0Scj
ryzhAtKmPImbTYC0zrbivkYgzcHPbrAUSN/hXnheXv+NI1vE9NkqQHpSOoea
JpAu8GW0WAni7/sptx5IPwo9MhNEi38Mn7ERSC94xSBzG0jvOj4rJtLgjWP0
gYlndAzfOIqkpX53BdJlDY+/XADSDlvUxC8C6TWRX+RB9PPZO/+qGb1xXFWU
raIOpKM5N7954/DGkedF0tPdTkDzTKYdtXB+47jDKDYpxu2No35u8mYQvWDj
6xmxQDpg1t+LR33fOD5Yp+W53O+NIwDoHpqy
  "],
 CellLabel->
  "Out[248]=",ExpressionUUID->"b2945776-bfe8-4e63-9248-2315241b2f6f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KeystreamToPolynomial", "[", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "30"}], "]"}], "]"}], 
   "*", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"z", "^", "7"}]}], ")"}]}], "//", "ModTwo"}]], "Input",
 CellChangeTimes->{{3.777740132301206*^9, 3.777740144148473*^9}, {
  3.777740177015636*^9, 3.77774018757778*^9}, {3.7777402599144506`*^9, 
  3.7777402731461897`*^9}, {3.7777404005818033`*^9, 3.777740400668467*^9}, {
  3.7777407093442*^9, 3.777740709446583*^9}, {3.7821987754021072`*^9, 
  3.7821987755010557`*^9}},
 CellLabel->
  "In[249]:=",ExpressionUUID->"8c05ea5e-267c-4bc0-b02a-5e05ea85ba03"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "4"], "+", 
  SuperscriptBox["z", "5"], "+", 
  SuperscriptBox["z", "6"], "+", 
  SuperscriptBox["z", "30"], "+", 
  SuperscriptBox["z", "32"], "+", 
  SuperscriptBox["z", "33"], "+", 
  SuperscriptBox["z", "34"]}]], "Output",
 CellChangeTimes->{
  3.777740144511141*^9, {3.77774017972029*^9, 3.777740187931096*^9}, 
   3.77774027348561*^9, 3.777740401383891*^9, {3.777740709736891*^9, 
   3.7777407340316153`*^9}, 3.782195968012635*^9, 3.782196164671165*^9, 
   3.7821975563230124`*^9, 3.782197615256401*^9, 3.782197673400014*^9, {
   3.7821987574323874`*^9, 3.7821987760673532`*^9}, 3.782208433142859*^9, 
   3.7822326472661867`*^9, 3.78223358030827*^9, 3.782235430743466*^9, 
   3.782321563147843*^9, 3.782478963749387*^9, 3.78255193644489*^9, 
   3.782803069153479*^9, 3.7828128928650923`*^9, 3.782822192445586*^9, 
   3.783084480139998*^9, 3.783096567953452*^9, 3.783097550268635*^9, 
   3.783101634931323*^9, 3.783186656128977*^9, 3.783445220956875*^9, 
   3.783878244660083*^9, 3.783929787276352*^9, 3.784214439225006*^9, 
   3.784214713311891*^9, 3.784214783832178*^9, 3.78439063791637*^9, 
   3.784390947459906*^9, 3.792136037694578*^9, 3.793084203191349*^9, 
   3.7933399488387938`*^9, 3.794985747095661*^9, 3.79498639522679*^9, 
   3.794988231498598*^9, 3.7988716960391083`*^9, 3.7993334494468117`*^9},
 CellLabel->
  "Out[249]=",ExpressionUUID->"2588da9b-2d86-4651-bfc7-4ffaeeda5c44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KeystreamToPolynomial", "[", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "30"}], "]"}], "]"}], 
   "*", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"z", "^", "2"}], "+", 
     RowBox[{"z", "^", "3"}]}], ")"}]}], "//", "ModTwo"}]], "Input",
 CellChangeTimes->{{3.777740284824779*^9, 3.7777402877545156`*^9}, {
  3.78219877854033*^9, 3.782198780186565*^9}},
 CellLabel->
  "In[250]:=",ExpressionUUID->"2670e880-db1b-4518-a61b-66266f323b61"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "30"]}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQB+KV7cwHylXfOJbJFH4H0YINzAnfdd842i2bUQGibWV6
1X4A6SW7XumC6B4RA1MQvSO1fz+Izt2pXvYXSHvZf/fg1HvjKMU+cS+IPt5/
ewkXkHYuydhsAqT1HWv6GoG0wwJRg6VAWrh+xXl5faC90xbOVgHSSsuF1TSB
9K+d7BYrgbToCSb59UBavPjMTBBttDp5xkYgzX+JXeY2kH5mvSgm0uCN4521
M87oGL5xdPIq+u4KpGcse/XlApBmSdIVvwikzbn/y4PojrkH/qoZvXGszSxS
UQfSC3J2vnnj8MbxcVDm091OQPXh849aOAPtmZqRFOP2xjGfKXsziG5Y/WVG
LJD+Vs966agv0B5JI8/lfm8cAc41lBU=
  "],
 CellLabel->
  "Out[250]=",ExpressionUUID->"92a66940-072b-49bc-bfaa-44185fda9c68"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"z", "^", "2"}], "+", 
        RowBox[{"z", "^", "3"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"z", ",", "0", ",", "30"}], "}"}]}], "]"}], "//", "Normal"}], "//",
   "ModTwo"}]], "Input",
 CellChangeTimes->{{3.7777402987516813`*^9, 3.777740344866067*^9}, {
  3.7777407366176863`*^9, 3.777740736809105*^9}, {3.782198751072146*^9, 
  3.78219875335981*^9}},
 CellLabel->
  "In[251]:=",ExpressionUUID->"b53861e4-c823-448e-914e-457b4501d4b1"],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "3"], "+", 
  SuperscriptBox["z", "4"], "+", 
  SuperscriptBox["z", "7"], "+", 
  SuperscriptBox["z", "9"], "+", 
  SuperscriptBox["z", "10"], "+", 
  SuperscriptBox["z", "11"], "+", 
  SuperscriptBox["z", "14"], "+", 
  SuperscriptBox["z", "16"], "+", 
  SuperscriptBox["z", "17"], "+", 
  SuperscriptBox["z", "18"], "+", 
  SuperscriptBox["z", "21"], "+", 
  SuperscriptBox["z", "23"], "+", 
  SuperscriptBox["z", "24"], "+", 
  SuperscriptBox["z", "25"], "+", 
  SuperscriptBox["z", "28"], "+", 
  SuperscriptBox["z", "30"]}]], "Output",
 CellChangeTimes->{{3.777740308120966*^9, 3.7777403451538563`*^9}, 
   3.77774073735738*^9, 3.782195968229184*^9, 3.7821961649444227`*^9, 
   3.782197556489468*^9, 3.782197615442622*^9, 3.782197673603075*^9, {
   3.782198753696618*^9, 3.782198783144009*^9}, 3.782208433348332*^9, 
   3.78223264797649*^9, 3.782233580730309*^9, 3.7822354309825087`*^9, 
   3.782321563371929*^9, 3.7824789640326767`*^9, 3.782551936868833*^9, 
   3.782803069374496*^9, 3.782812893290175*^9, 3.7828221929048653`*^9, 
   3.783084480395515*^9, 3.783096568235733*^9, 3.783097550518693*^9, 
   3.783101635314279*^9, 3.7831866563428164`*^9, 3.7834452212199717`*^9, 
   3.783878244876515*^9, 3.783929787708497*^9, 3.784214439459154*^9, 
   3.784214713527854*^9, 3.784214784118896*^9, 3.784390638117083*^9, 
   3.78439094771104*^9, 3.7921360379286747`*^9, 3.793084203392324*^9, 
   3.793339949139551*^9, 3.794985747432879*^9, 3.794986395477618*^9, 
   3.794988231779904*^9, 3.79887169627288*^9, 3.799333449683447*^9},
 CellLabel->
  "Out[251]=",ExpressionUUID->"ad7913e8-6a61-457e-aeee-5d83d31b6bb1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", "30"}], "]"}]], "Input",
 CellChangeTimes->{{3.7777405894734364`*^9, 3.777740589944149*^9}, {
  3.7777407434793997`*^9, 3.777740748171023*^9}},
 CellLabel->
  "In[252]:=",ExpressionUUID->"091cebf7-4d61-45c8-8365-0866b00952ce"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQB+Jzfmeelqu+cXRSWv8TRO/L4074rvvG8Y/8wgowHTpJ
7QeQ3nXqgy6IduOwMAXR5yx+7AfRvYF6ZX+BtFclmyen3hvHtoxFe0G0wd9H
S7iANGts/mYTIK3r19rXCKTvOikYLAXSScnrz8vrv3F8wLhhtgqQZrmkqaYJ
4jMJWawE0jvfc8uvB9LSJVdngugthgUzNgLphAg+mdtAOu/oqphIgzeOv6bO
P6Nj+MZRbWXld1cgPS3w05cLQNpmnYn4RSDtNodDAUSzMB7/q2b0xrEpoUpF
HUgLPTjw5o3DG8fdLgVPdzu9cdwfsvKohfMbR8EjxUkxbkB3vCjaDKKX+P+d
EQuk73LxXDrq+8bRs9nSc7nfG0cAR02YNQ==
  "],
 CellLabel->
  "Out[252]=",ExpressionUUID->"ca86294a-84ff-4c2e-9e3e-097ad0a428d4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Non-binary example with Fibonacci sequence and then modulo 5, 10 (off the \
syllabus, but maybe of interest)\
\>", "Subsection",
 CellChangeTimes->{{3.775718954550331*^9, 3.77571904021091*^9}, {
  3.782231145062212*^9, 
  3.782231174424573*^9}},ExpressionUUID->"cac8c3a2-4b7a-4b1a-9b4d-\
8c375506e06e"],

Cell[CellGroupData[{

Cell["\<\
 k_s = k_ {s - 1} + k_ {s - 2}; taps are the coefficients 1 and 1 (see \
comment on NextBit above) \
\>", "Subsubsection",
 CellChangeTimes->{{3.775719022762702*^9, 
  3.775719025385873*^9}},ExpressionUUID->"6b50bc99-d6e0-4d08-8951-\
03cee94faa4e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", "30", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.782231168487185*^9, 3.782231206564777*^9}},
 CellLabel->
  "In[253]:=",ExpressionUUID->"b91148d2-19fd-42a8-bb67-567d4a0bb63c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", "13", 
   ",", "21", ",", "34", ",", "55", ",", "89", ",", "144", ",", "233", ",", 
   "377", ",", "610", ",", "987", ",", "1597", ",", "2584", ",", "4181", ",", 
   "6765", ",", "10946", ",", "17711", ",", "28657", ",", "46368", ",", 
   "75025", ",", "121393", ",", "196418", ",", "317811", ",", "514229"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.782231190286195*^9, 3.782232648405635*^9, 
  3.7822335812936287`*^9, 3.782235431192569*^9, 3.782321563580748*^9, 
  3.782478964299865*^9, 3.782551937228615*^9, 3.7828030695918016`*^9, 
  3.782812893716357*^9, 3.782822193543076*^9, 3.783084480725307*^9, 
  3.783096568520949*^9, 3.783097550814413*^9, 3.783101635695088*^9, 
  3.7831866565925827`*^9, 3.783445221476881*^9, 3.7838782451244793`*^9, 
  3.783929788009184*^9, 3.784214439765794*^9, 3.784214713794464*^9, 
  3.78421478444776*^9, 3.784390638336297*^9, 3.784390947952991*^9, 
  3.792136038156904*^9, 3.793084203622777*^9, 3.7933399494851923`*^9, 
  3.7949857478305893`*^9, 3.794986395722992*^9, 3.794988232081065*^9, 
  3.798871696505928*^9, 3.799333449946411*^9},
 CellLabel->
  "Out[253]=",ExpressionUUID->"65c300a4-f28c-4e75-995d-fd2df079b992"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", "30", ",", "5"}], "]"}]], "Input",
 CellChangeTimes->{{3.782231201526204*^9, 3.782231207772168*^9}},
 CellLabel->
  "In[254]:=",ExpressionUUID->"9582a003-fd2f-4c67-935e-0ea23e60a098"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "2", ",", "3", ",", "0", ",", "3", ",", "3", 
   ",", "1", ",", "4", ",", "0", ",", "4", ",", "4", ",", "3", ",", "2", ",", 
   "0", ",", "2", ",", "2", ",", "4", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "2", ",", "3", ",", "0", ",", "3", ",", "3", ",", "1", ",", "4"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.782231202130136*^9, 3.782231208040365*^9}, 
   3.782232648598954*^9, 3.7822335815661993`*^9, 3.782235431321312*^9, 
   3.782321563679678*^9, 3.7824789645095873`*^9, 3.782551937563582*^9, 
   3.782803069708149*^9, 3.7828128939352627`*^9, 3.7828221936720667`*^9, 
   3.783084480893536*^9, 3.783096568686275*^9, 3.783097550973941*^9, 
   3.78310163588065*^9, 3.783186656730657*^9, 3.7834452216712914`*^9, 
   3.7838782452365026`*^9, 3.7839297881582317`*^9, 3.784214439892399*^9, 
   3.7842147138945827`*^9, 3.784214784600816*^9, 3.784390638444931*^9, 
   3.784390948075144*^9, 3.792136038262432*^9, 3.793084203739975*^9, 
   3.793339949677126*^9, 3.794985748028821*^9, 3.794986395872621*^9, 
   3.794988232215704*^9, 3.798871696623234*^9, 3.7993334500672703`*^9},
 CellLabel->
  "Out[254]=",ExpressionUUID->"8916b58d-3632-4ee8-9df9-5efb562dea37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AllKeystreams", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "2", ",", "5"}], "]"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.775719029697034*^9, 3.775719065132102*^9}},
 CellLabel->
  "In[255]:=",ExpressionUUID->"6e74c221-24d0-4108-831f-00a83aa592b1"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>"},
    {"0", "1", "1", "2", "3", "0", "3", "3", "1", "4", "0", "4", "4", "3", 
     "2", "0", "2", "2", "4", "1"},
    {"1", "3", "4", 
     "2", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.775719044683421*^9, 3.775719065599259*^9}, 
   3.775719492945353*^9, 3.775720121918394*^9, 3.775723600670788*^9, 
   3.7757236534562407`*^9, 3.7757236839887533`*^9, 3.775723803397725*^9, 
   3.7757238839487553`*^9, 3.775747665768571*^9, 3.775894366501436*^9, 
   3.7759075319651012`*^9, 3.7770296895218267`*^9, 3.777188326128295*^9, 
   3.777567620522292*^9, 3.777568129464623*^9, 3.777568272922093*^9, 
   3.7776204186804667`*^9, 3.782195968990049*^9, 3.782196165621014*^9, 
   3.7821975571573153`*^9, 3.782197616117053*^9, 3.782197674382699*^9, 
   3.782208433544819*^9, 3.782232648811183*^9, 3.7822335818341618`*^9, 
   3.782235431427397*^9, 3.7823215637990513`*^9, 3.7824789646489162`*^9, 
   3.78255193780727*^9, 3.7828030698137712`*^9, 3.7828128941673927`*^9, 
   3.7828221939464703`*^9, 3.7830844810609283`*^9, 3.7830965688188343`*^9, 
   3.783097551174809*^9, 3.783101636063978*^9, 3.783186656908779*^9, 
   3.7834452218410063`*^9, 3.783878245346191*^9, 3.783929788302096*^9, 
   3.7842144400011263`*^9, 3.784214713994772*^9, 3.78421478476845*^9, 
   3.784390638914332*^9, 3.784390948174624*^9, 3.792136038361936*^9, 
   3.793084203842669*^9, 3.793339949878832*^9, 3.7949857482021637`*^9, 
   3.794986395991837*^9, 3.7949882323495703`*^9, 3.798871696740498*^9, 
   3.799333450181242*^9},
 CellLabel->
  "Out[255]//TableForm=",ExpressionUUID->"2b377120-2884-447c-a7fa-\
d00b9b3e516d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Length", "/@", 
     RowBox[{"AllKeystreams", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", "2", ",", "10"}], "]"}]}], "//", 
    "TF"}], ",", 
   RowBox[{
    RowBox[{"AllKeystreams", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", "2", ",", "10"}], "]"}], "//", 
    "TF"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.775719074709662*^9, 3.7757190749867353`*^9}, {
  3.775719130150132*^9, 3.7757191394106007`*^9}},
 CellLabel->
  "In[256]:=",ExpressionUUID->"f739c3e6-176f-4ee1-814e-909c6bbb933e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"1"},
      {"60"},
      {"20"},
      {"3"},
      {"12"},
      {"4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]], ",", 
   TagBox[GridBox[{
      {"0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {"0", "1", "1", "2", "3", "5", "8", "3", "1", "4", "5", "9", "4", "3", 
       "7", "0", "7", "7", "4", "1", "5", "6", "1", "7", "8", "5", "3", "8", 
       "1", "9", "0", "9", "9", "8", "7", "5", "2", "7", "9", "6", "5", "1", 
       "6", "7", "3", "0", "3", "3", "6", "9", "5", "4", "9", "3", "2", "5", 
       "7", "2", "9", "1"},
      {"0", "2", "2", "4", "6", "0", "6", "6", "2", "8", "0", "8", "8", "6", 
       "4", "0", "4", "4", "8", 
       "2", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {"0", "5", 
       "5", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {"1", "3", "4", "7", "1", "8", "9", "7", "6", "3", "9", 
       "2", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
      {"2", "6", "8", 
       "4", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.775719075460684*^9, {3.77571913198387*^9, 3.775719139652404*^9}, 
   3.775719493026554*^9, 3.775720122034865*^9, 3.775723600797543*^9, 
   3.77572365369783*^9, 3.775723684070245*^9, 3.7757238035147657`*^9, 
   3.775723884031878*^9, 3.775747667410574*^9, 3.775894366583214*^9, 
   3.775907532048313*^9, 3.777029689696512*^9, 3.777188326200124*^9, 
   3.7775676206214046`*^9, 3.777568129563754*^9, 3.777568275607572*^9, 
   3.777620422203237*^9, 3.777636863354439*^9, 3.7821959691672897`*^9, 
   3.782196165719161*^9, 3.7821975572405977`*^9, 3.782197616220333*^9, 
   3.7821976745175133`*^9, 3.78220843366555*^9, 3.7822326491478977`*^9, 
   3.782233582104241*^9, 3.782235431595601*^9, 3.782321563901835*^9, 
   3.782478964817009*^9, 3.782551938434202*^9, 3.782803069924945*^9, 
   3.782812894464856*^9, 3.782822194311705*^9, 3.783084481228457*^9, 
   3.783096568987068*^9, 3.7830975513738613`*^9, 3.783101636248218*^9, 
   3.783186657031804*^9, 3.783445222023711*^9, 3.783878245451962*^9, 
   3.7839297886126127`*^9, 3.784214440117839*^9, 3.7842147141023397`*^9, 
   3.784214784975005*^9, 3.784390639088258*^9, 3.784390948292721*^9, 
   3.79213603846524*^9, 3.7930842039588633`*^9, 3.793339950040419*^9, 
   3.794985748368967*^9, 3.794986396124628*^9, 3.7949882325001163`*^9, 
   3.798871696839468*^9, 3.7993334503191547`*^9},
 CellLabel->
  "Out[256]=",ExpressionUUID->"11d0d81a-804a-42e7-8d29-456da6b75d16"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["For start of Lecture 17 (2019 version)", "Section",
 CellChangeTimes->{{3.777615570074749*^9, 3.777615583411027*^9}, {
  3.782206002582765*^9, 
  3.7822060077288637`*^9}},ExpressionUUID->"df6cbd15-de77-470c-98ef-\
862347567859"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SimplifyKeystream", "[", 
   RowBox[{"f_", ",", "q_"}], "]"}], ":=", 
  RowBox[{"PolynomialMod", "[", 
   RowBox[{
    RowBox[{"f", "//.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{"g_", ",", "_"}], "]"}], "\[RuleDelayed]", "g"}], "}"}]}], 
    ",", "q"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777620601402158*^9, 3.777620609455903*^9}},
 CellLabel->
  "In[257]:=",ExpressionUUID->"04947d38-987a-49ff-bb36-f9080582ba68"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SimplifyKeystream", "[", "f_", "]"}], ":=", 
  RowBox[{"SimplifyKeystream", "[", 
   RowBox[{"f", ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7776201697098207`*^9, 3.777620182787051*^9}, {
  3.777620214917555*^9, 3.777620247946678*^9}, {3.777620293918269*^9, 
  3.77762029799566*^9}, {3.777620339833399*^9, 3.7776203503241262`*^9}, {
  3.7776204646378098`*^9, 3.7776204898571978`*^9}, {3.777620578345935*^9, 
  3.777620613966249*^9}},
 CellLabel->
  "In[258]:=",ExpressionUUID->"31cd3958-1c68-41e2-865c-473bc23451a6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NextWords", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"k0", ",", "k1", ",", "k2", ",", "k3"}], "}"}], ",", "15"}], 
    "]"}], " ", "//", " ", "SimplifyKeystream"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.777621248337122*^9, 3.777621264313055*^9}},
 CellLabel->
  "In[259]:=",ExpressionUUID->"92df64b3-18c6-4a24-8823-096c87eadf9a"],

Cell[BoxData[
 TagBox[GridBox[{
    {"k0", "k1", "k2", "k3"},
    {"k1", "k2", "k3", 
     RowBox[{"k0", "+", "k1"}]},
    {"k2", "k3", 
     RowBox[{"k0", "+", "k1"}], 
     RowBox[{"k1", "+", "k2"}]},
    {"k3", 
     RowBox[{"k0", "+", "k1"}], 
     RowBox[{"k1", "+", "k2"}], 
     RowBox[{"k2", "+", "k3"}]},
    {
     RowBox[{"k0", "+", "k1"}], 
     RowBox[{"k1", "+", "k2"}], 
     RowBox[{"k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k3"}]},
    {
     RowBox[{"k1", "+", "k2"}], 
     RowBox[{"k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k3"}], 
     RowBox[{"k0", "+", "k2"}]},
    {
     RowBox[{"k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k3"}], 
     RowBox[{"k0", "+", "k2"}], 
     RowBox[{"k1", "+", "k3"}]},
    {
     RowBox[{"k0", "+", "k1", "+", "k3"}], 
     RowBox[{"k0", "+", "k2"}], 
     RowBox[{"k1", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k2"}]},
    {
     RowBox[{"k0", "+", "k2"}], 
     RowBox[{"k1", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k2"}], 
     RowBox[{"k1", "+", "k2", "+", "k3"}]},
    {
     RowBox[{"k1", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k2"}], 
     RowBox[{"k1", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k2", "+", "k3"}]},
    {
     RowBox[{"k0", "+", "k1", "+", "k2"}], 
     RowBox[{"k1", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k2", "+", "k3"}]},
    {
     RowBox[{"k1", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k1", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k3"}]},
    {
     RowBox[{"k0", "+", "k1", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k3"}], "k0"},
    {
     RowBox[{"k0", "+", "k2", "+", "k3"}], 
     RowBox[{"k0", "+", "k3"}], "k0", "k1"},
    {
     RowBox[{"k0", "+", "k3"}], "k0", "k1", "k2"},
    {"k0", "k1", "k2", "k3"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7776212528291607`*^9, 3.777621264498959*^9}, 
   3.782195969330173*^9, 3.782196165947855*^9, 3.7821975573872223`*^9, 
   3.7821976164081707`*^9, 3.782197674697255*^9, 3.782208433813561*^9, 
   3.782232649327713*^9, 3.782233582330092*^9, 3.7822354317283373`*^9, 
   3.782321564030085*^9, 3.7824789650139847`*^9, 3.7825519389494143`*^9, 
   3.782803070054722*^9, 3.7828128946640663`*^9, 3.7828221949350023`*^9, 
   3.783084481484207*^9, 3.783096569148478*^9, 3.783097551625744*^9, 
   3.783101636490966*^9, 3.7831866572068567`*^9, 3.783445222277993*^9, 
   3.7838782459792128`*^9, 3.783929788775515*^9, 3.784214440280519*^9, 
   3.784214714295182*^9, 3.7842147851979713`*^9, 3.7843906392478313`*^9, 
   3.7843909484701223`*^9, 3.792136038610249*^9, 3.7930842040903187`*^9, 
   3.7933399502577677`*^9, 3.794985748608803*^9, 3.79498639629073*^9, 
   3.794988232695394*^9, 3.7988716970194187`*^9, 3.799333450497519*^9},
 CellLabel->
  "Out[259]//TableForm=",ExpressionUUID->"eb8494d6-b484-457d-80b8-\
b3b5e641d9f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
All keystream lengths for all invertible binary LFSRs of width 2, 3, 4, 5, ...\
\>", "Subsubsection",
 CellChangeTimes->{{3.753267515540544*^9, 3.753267517633033*^9}, {
  3.775719300953463*^9, 
  3.775719301459778*^9}},ExpressionUUID->"d8d763bb-7f76-4a34-8109-\
add6d36790be"],

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "l_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ts", "~", "Join", "~", 
       RowBox[{"{", "l", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"KeystreamLengths", "[", 
       RowBox[{
        RowBox[{"ts", "~", "Join", "~", 
         RowBox[{"{", "l", "}"}]}], ",", "l"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FeedbackPolynomial", "[", 
       RowBox[{"ts", "~", "Join", "~", 
        RowBox[{"{", "l", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Factor", "[", 
       RowBox[{
        RowBox[{"FeedbackPolynomial", "[", 
         RowBox[{"ts", "~", "Join", "~", 
          RowBox[{"{", "l", "}"}]}], "]"}], ",", 
        RowBox[{"Modulus", "\[Rule]", "2"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PrimitivePolynomialQ", "[", 
       RowBox[{
        RowBox[{"FeedbackPolynomial", "[", 
         RowBox[{"ts", "~", "Join", "~", 
          RowBox[{"{", "l", "}"}]}], "]"}], ",", "2"}], "]"}]}], 
     "\[IndentingNewLine]", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ts", ",", 
      RowBox[{"Subsets", "[", 
       RowBox[{"Range", "[", 
        RowBox[{"1", ",", 
         RowBox[{"l", "-", "1"}]}], "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.749813836675458*^9, 3.749813841243833*^9}, {
   3.749826314820984*^9, 3.749826356211019*^9}, {3.749826404512755*^9, 
   3.749826442525065*^9}, {3.749826585834292*^9, 3.7498266083101273`*^9}, {
   3.749826640701651*^9, 3.749826644487377*^9}, {3.750248670345141*^9, 
   3.750248681130028*^9}, {3.775719603465063*^9, 3.775719616900508*^9}, {
   3.77572018158387*^9, 3.7757202178460197`*^9}, {3.775720340603981*^9, 
   3.7757203439172983`*^9}, {3.775720390608796*^9, 3.775720402825762*^9}, {
   3.777636558109*^9, 3.777636564381853*^9}, {3.777636600552348*^9, 
   3.777636679654307*^9}, {3.777637935430991*^9, 3.777637988854312*^9}, {
   3.777638053110427*^9, 3.777638140938654*^9}, {3.777638174026476*^9, 
   3.777638211691571*^9}, 3.77763826042459*^9, {3.7776391613502703`*^9, 
   3.777639193409587*^9}, {3.777639774199806*^9, 3.777639788057837*^9}, {
   3.777639849552297*^9, 3.7776398505357103`*^9}, {3.777641445716855*^9, 
   3.777641491131323*^9}, {3.777730782157692*^9, 3.777730860521624*^9}},
 CellLabel->
  "In[260]:=",ExpressionUUID->"dbbbc000-b8c8-465e-b4c0-3e40788467c8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "3", "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.749826369528356*^9, 3.749826414449423*^9}, {
  3.749826446216291*^9, 3.749826446766514*^9}},
 CellLabel->
  "In[261]:=",ExpressionUUID->"07bd3c17-4440-4737-b977-fa09a47fda93"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "3", ",", "3"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "7"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "3"]}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "3"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "7"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], "3"], "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.749826385262704*^9, 3.7498264470264893`*^9}, 
   3.749826615027532*^9, 3.749826648332601*^9, 3.750248684627675*^9, 
   3.750343152662292*^9, 3.750771709673415*^9, 3.7512713266083803`*^9, 
   3.751312607236312*^9, 3.751312662199107*^9, 3.751452131119546*^9, 
   3.751452189110628*^9, {3.7514660771265783`*^9, 3.751466132815469*^9}, 
   3.7516537653028517`*^9, 3.751654255834037*^9, 3.751794580407658*^9, 
   3.752332273271471*^9, 3.7523398641504*^9, 3.752390914030908*^9, 
   3.7525137480373507`*^9, 3.752513877148932*^9, 3.752513922115099*^9, 
   3.752596479845561*^9, 3.752841020494855*^9, 3.752841068279191*^9, 
   3.7528459142521963`*^9, 3.752846022613516*^9, 3.753267427092483*^9, 
   3.7657971834433937`*^9, 3.76579740501513*^9, 3.76580952286423*^9, 
   3.775637907445983*^9, 3.775663903043747*^9, 3.775719503476069*^9, 
   3.775720126292341*^9, 3.775720413279806*^9, 3.775723605131382*^9, 
   3.775723656119914*^9, 3.7757236884594383`*^9, 3.775723806200663*^9, 
   3.775723888523535*^9, 3.7758943684831343`*^9, 3.775907533956942*^9, 
   3.777029691444621*^9, 3.777188328303945*^9, 3.77756762238026*^9, 
   3.7775681326368513`*^9, 3.7775682806128674`*^9, 3.777620424529789*^9, {
   3.77763660922936*^9, 3.7776366230970697`*^9}, 3.7776366833925333`*^9, 
   3.777636875027485*^9, 3.777637994650216*^9, 3.777638059549839*^9, {
   3.7776381246442757`*^9, 3.777638143652628*^9}, 3.777638203715056*^9, {
   3.777638235970641*^9, 3.777638265788418*^9}, {3.777639178248633*^9, 
   3.777639195672007*^9}, 3.777639796238841*^9, 3.7776398534704447`*^9, {
   3.777641452382546*^9, 3.7776414927532787`*^9}, {3.7777308230603437`*^9, 
   3.777730863683696*^9}, 3.782195970675282*^9, 3.782196167514065*^9, 
   3.782197558957953*^9, 3.782197618231179*^9, 3.782197676870165*^9, 
   3.782208433931094*^9, 3.7822326494662333`*^9, 3.782233582489747*^9, 
   3.782235431860963*^9, 3.7823215641432457`*^9, 3.7824789651664257`*^9, 
   3.782551939192347*^9, 3.782803070188599*^9, 3.782812894809823*^9, 
   3.782822195134123*^9, 3.783084481690378*^9, 3.783096569316786*^9, 
   3.7830975518799753`*^9, 3.783101636688692*^9, 3.783186657355246*^9, 
   3.783445222544396*^9, 3.783878246711537*^9, 3.783929788921647*^9, 
   3.784214440435926*^9, 3.784214714427248*^9, 3.784214785365588*^9, 
   3.784390639401454*^9, 3.784390948623053*^9, 3.792136038748555*^9, 
   3.793084204244953*^9, 3.793339951040579*^9, 3.7949857487780848`*^9, 
   3.794986396472473*^9, 3.794988232879929*^9, 3.798871697206139*^9, 
   3.799333450678504*^9},
 CellLabel->
  "Out[261]//TableForm=",ExpressionUUID->"88d2bf02-95c8-49ec-a3e7-\
018076b36837"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "4", "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.74982649085606*^9, 3.74982649491138*^9}, {
  3.777639208889056*^9, 3.777639209937768*^9}},
 CellLabel->
  "In[262]:=",ExpressionUUID->"87f0b30a-57ab-4607-8148-3d5d741c12a4"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2", ",", "4", ",", "4", ",", "4"}], "}"}], 
     
     RowBox[{"1", "+", 
      SuperscriptBox["z", "4"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], "4"], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "15"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "4"]}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "4"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "6"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "4"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}], ")"}], "2"], "False"},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "15"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "7", ",", "7"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "4"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2", ",", "3", ",", "3", ",", "6"}], "}"}], 
     
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "z"}], ")"}], "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "7", ",", "7"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "5", ",", "5", ",", "5"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"]}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"]}], "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7498264916795187`*^9, 3.749826495200057*^9}, {
   3.749826619493731*^9, 3.7498266492111893`*^9}, 3.750248686581349*^9, 
   3.750343152736899*^9, 3.750771709706991*^9, 3.751271326638216*^9, 
   3.751312607274794*^9, 3.751312662227991*^9, 3.751452131171438*^9, 
   3.751452189170858*^9, {3.7514660771939573`*^9, 3.7514661328640842`*^9}, 
   3.7516537653387003`*^9, 3.751654255887341*^9, 3.751794580466446*^9, 
   3.7523322733107567`*^9, 3.752339864199967*^9, 3.752390914111663*^9, 
   3.7525137480687513`*^9, 3.752513877348563*^9, 3.75251392216576*^9, 
   3.7525964799100733`*^9, 3.752841020569367*^9, 3.75284106834195*^9, 
   3.752845914332615*^9, 3.752846022654736*^9, 3.753267427212961*^9, 
   3.765797183507805*^9, 3.765797405057056*^9, 3.7658095229365587`*^9, 
   3.775637907579475*^9, 3.775663903128367*^9, 3.775719503609034*^9, 
   3.7757201264572067`*^9, 3.775720422105044*^9, 3.7757236052152576`*^9, 
   3.775723656293394*^9, 3.77572368856256*^9, 3.775723806301866*^9, 
   3.77572388862362*^9, 3.77589436856596*^9, 3.775907534033166*^9, 
   3.7770296915404177`*^9, 3.777188328384282*^9, 3.77756762248213*^9, 
   3.777568132736912*^9, 3.777568280697336*^9, 3.777620424697098*^9, {
   3.777636614270026*^9, 3.777636624243134*^9}, 3.777636686052414*^9, 
   3.7776368760063667`*^9, 3.777639210275799*^9, 3.7776398022149343`*^9, 
   3.7776398551714373`*^9, 3.777641493610692*^9, 3.777730869337357*^9, 
   3.782195970789282*^9, 3.782196167667295*^9, 3.782197559038775*^9, 
   3.7821976183723993`*^9, 3.782197677020805*^9, 3.782208434032936*^9, 
   3.782232649596434*^9, 3.782233582766275*^9, 3.782235431982873*^9, 
   3.7823215642538157`*^9, 3.782478965299555*^9, 3.78255193942421*^9, 
   3.782803070297696*^9, 3.7828128949487867`*^9, 3.782822195306019*^9, 
   3.783084481861877*^9, 3.783096569490799*^9, 3.783097552170846*^9, 
   3.783101636856998*^9, 3.7831866574617243`*^9, 3.783445222829936*^9, 
   3.7838782480307407`*^9, 3.783929789039583*^9, 3.784214440552453*^9, 
   3.784214714530127*^9, 3.784214785501936*^9, 3.784390639502088*^9, 
   3.784390948779332*^9, 3.792136038843471*^9, 3.7930842043411903`*^9, 
   3.79333995121102*^9, 3.794985748882988*^9, 3.794986396592039*^9, 
   3.794988233068157*^9, 3.798871697307527*^9, 3.7993334507807207`*^9},
 CellLabel->
  "Out[262]//TableForm=",ExpressionUUID->"d2229b65-0439-45bb-85d6-\
b55973bd82f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"T", "[", "5", "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7501509503240128`*^9, 3.750150952160171*^9}},
 CellLabel->
  "In[263]:=",ExpressionUUID->"a58789a8-9f74-4b04-a515-ae326a52f59c"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "5", "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",", 
       "5"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "7", ",", "21"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "31"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "5"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "31"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "5"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "7", ",", "21"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2", ",", "7", ",", "7", ",", "14"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "z"}], ")"}], "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "15", ",", "15"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "2", ",", "4", ",", "4", ",", "4", ",", "8", ",", 
       "8"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], "5"], "False"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "2", ",", "3", ",", "3", ",", "4", ",", "6", ",", 
       "12"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "z"}], ")"}], "3"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "15", ",", "15"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "2", ",", "7", ",", "7", ",", "14"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "z"}], ")"}], "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"]}], ")"}]}], "False"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "31"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "5"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "31"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "31"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "31"}], "}"}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], "True"},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "1", ",", "3", ",", "3", ",", "6", ",", "6", ",", "6", ",", 
       "6"}], "}"}], 
     RowBox[{"1", "+", "z", "+", 
      SuperscriptBox["z", "2"], "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "4"], "+", 
      SuperscriptBox["z", "5"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "z"}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", "z", "+", 
         SuperscriptBox["z", "2"]}], ")"}], "2"]}], "False"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.750150952548313*^9, 3.750248688632142*^9, 3.750343153013076*^9, 
   3.750771709786808*^9, 3.7512713267120447`*^9, 3.751312607349812*^9, 
   3.7513126623111887`*^9, 3.7514521312525578`*^9, 3.7514521892531643`*^9, {
   3.751466077274625*^9, 3.751466132942733*^9}, 3.751653765416148*^9, 
   3.7516542559617577`*^9, 3.751794580542325*^9, 3.752332273448202*^9, 
   3.752339864278749*^9, 3.752390914200337*^9, 3.752513748157929*^9, 
   3.7525138775335903`*^9, 3.7525139222587957`*^9, 3.752596480001437*^9, 
   3.7528410206464167`*^9, 3.7528410684191847`*^9, 3.752845914491362*^9, 
   3.752846022770129*^9, 3.753267427289111*^9, 3.7657971835809717`*^9, 
   3.765797405202711*^9, 3.765809523053475*^9, 3.775637907722494*^9, 
   3.775663903256246*^9, 3.7757195037438993`*^9, 3.775720126576407*^9, 
   3.775720430249158*^9, 3.775723605365769*^9, 3.775723656503756*^9, 
   3.775723688791526*^9, 3.775723806411105*^9, 3.7757238887641706`*^9, 
   3.775894368688311*^9, 3.77590753415175*^9, 3.777029691684236*^9, 
   3.777188328505087*^9, 3.777567622782385*^9, 3.777568132906724*^9, 
   3.777568280809765*^9, 3.777620424960012*^9, 3.7776366275677156`*^9, 
   3.77763668823451*^9, 3.7776368792879353`*^9, 3.777639261655663*^9, 
   3.777639858149886*^9, 3.777641501762165*^9, 3.777730874310769*^9, 
   3.7821959709784403`*^9, 3.782196167875011*^9, 3.7821975591853867`*^9, 
   3.782197618548716*^9, 3.782197677146318*^9, 3.782208434199008*^9, 
   3.782232649743326*^9, 3.78223358319217*^9, 3.7822354321701403`*^9, 
   3.782321564383726*^9, 3.782478965531423*^9, 3.782551939704731*^9, 
   3.782803070428021*^9, 3.782812895081441*^9, 3.782822195461898*^9, 
   3.783084482048362*^9, 3.7830965696862707`*^9, 3.78309755240837*^9, 
   3.783101637029608*^9, 3.7831866575786858`*^9, 3.7834452231203413`*^9, 
   3.783878248283536*^9, 3.783929789293795*^9, 3.7842144409091063`*^9, 
   3.784214714654272*^9, 3.784214785652205*^9, 3.7843906396508617`*^9, 
   3.7843909490165787`*^9, 3.792136039052709*^9, 3.793084204478595*^9, 
   3.793339951698701*^9, 3.794985749097774*^9, 3.7949863968158703`*^9, 
   3.794988233459111*^9, 3.798871697435602*^9, 3.799333450993815*^9},
 CellLabel->
  "Out[263]//TableForm=",ExpressionUUID->"256b7b0b-08ab-40e3-866c-\
d90623f5a383"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Numbers to and from 8 bit bytes", "Section",
 CellChangeTimes->{{3.7498075955236807`*^9, 3.749807600796365*^9}, {
  3.749807779891333*^9, 3.749807785023295*^9}, {3.74981105977956*^9, 
  3.7498110604806137`*^9}},ExpressionUUID->"8c69d485-adbf-4c7f-8bb4-\
ad36eefed0cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBitsLE", "[", 
   RowBox[{"0", ",", "n_"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.7498076662125883`*^9, 3.749807687589244*^9}},
 CellLabel->
  "In[264]:=",ExpressionUUID->"721c8e78-f0ad-4a61-8f18-bd08689c1e2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBitsLE", "[", 
   RowBox[{"l_", ",", "n_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Mod", "[", 
     RowBox[{"n", ",", "2"}], "]"}], "}"}], "~", "Join", "~", 
   RowBox[{"ToBitsLE", "[", 
    RowBox[{
     RowBox[{"l", "-", "1"}], ",", 
     RowBox[{"Quotient", "[", 
      RowBox[{"n", ",", "2"}], "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.749807677250236*^9, 3.7498077270918503`*^9}},
 CellLabel->
  "In[265]:=",ExpressionUUID->"9649efed-29d4-49f7-8e31-0ea8cdeba83e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBits", "[", 
   RowBox[{"l_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Reverse", "@", 
   RowBox[{"ToBitsLE", "[", 
    RowBox[{"l", ",", "n"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.749807729344584*^9, 3.749807739765668*^9}},
 CellLabel->
  "In[266]:=",ExpressionUUID->"ec37a5d4-fee5-4544-8626-1b1eac9a1ce9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToEightBits", "[", "n_", "]"}], ":=", 
  RowBox[{"ToBits", "[", 
   RowBox[{"8", ",", "n"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749807638465221*^9, 3.749807663824357*^9}, {
  3.749807743537683*^9, 3.7498077450812387`*^9}},
 CellLabel->
  "In[267]:=",ExpressionUUID->"57109bdb-0a46-48a8-8617-7cf03d8a487a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FromBitsLE", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", "0"}]], "Input",
 CellChangeTimes->{{3.749811092129428*^9, 3.749811108387788*^9}},
 CellLabel->
  "In[268]:=",ExpressionUUID->"40f2526e-d548-4eaa-ab2d-d5d809ebd7ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FromBitsLE", "[", "xs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"xs", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "+", 
   RowBox[{"2", "*", 
    RowBox[{"FromBitsLE", "[", 
     RowBox[{"Delete", "[", 
      RowBox[{"xs", ",", "1"}], "]"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.749811109122476*^9, 3.749811124596344*^9}},
 CellLabel->
  "In[269]:=",ExpressionUUID->"c9003530-ffda-4cca-8462-0ce20f2afce1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FromEightBits", "[", "bs_", "]"}], ":=", 
  RowBox[{"FromBitsLE", "[", 
   RowBox[{"Reverse", "[", "bs", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7498110652451963`*^9, 3.749811090243595*^9}},
 CellLabel->
  "In[270]:=",ExpressionUUID->"175d1e81-ae07-4d73-bc55-5d476143481c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Plaintext to ASCII bits", "Section",
 CellChangeTimes->{{3.749807791638582*^9, 
  3.7498077965229883`*^9}},ExpressionUUID->"a2eea997-f27f-433e-8cfd-\
fe83ec128e86"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CharacterToASCII", "[", "c_", "]"}], ":=", 
  RowBox[{"ToEightBits", "[", 
   RowBox[{
    RowBox[{"ToCharacterCode", "[", "c", "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749807802414331*^9, 3.749807868837906*^9}, {
  3.749807950469593*^9, 3.749807951481634*^9}},
 CellLabel->
  "In[271]:=",ExpressionUUID->"9f5bc608-1567-4a99-9032-58fca8ff2fd0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"c", ",", 
      RowBox[{
       RowBox[{"ToCharacterCode", "[", "c", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"CharacterToASCII", "[", "c", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\"\< \>\"", ",", "\"\<.\>\"", ",", "\"\<,\>\"", ",", "\"\<;\>\""}], 
        "}"}], "~", "Join", "~", 
       RowBox[{"CharacterRange", "[", 
        RowBox[{"\"\<A\>\"", ",", "\"\<E\>\""}], "]"}], "~", "Join", "~", 
       RowBox[{"CharacterRange", "[", 
        RowBox[{"\"\<a\>\"", ",", "\"\<e\>\""}], "]"}], "~", "Join", "~", 
       RowBox[{"{", "\"\<p,z\>\"", "}"}]}]}], "}"}]}], "]"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.749807815619893*^9, 3.749807839174074*^9}, {
  3.749807885822249*^9, 3.749807889588352*^9}, {3.7498079546107616`*^9, 
  3.749807955630142*^9}, {3.750248247050068*^9, 3.750248348631024*^9}, {
  3.75024854433115*^9, 3.750248549213098*^9}, {3.751041997525556*^9, 
  3.7510420154519367`*^9}, {3.751043040817678*^9, 3.75104304104712*^9}, {
  3.751286769722312*^9, 3.751286769845872*^9}, {3.751452144359498*^9, 
  3.751452144439777*^9}},
 CellLabel->
  "In[272]:=",ExpressionUUID->"cd23c790-7472-4435-95ff-e696fcda8641"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\" \"\>", "32", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\".\"\>", "46", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
       "0"}], "}"}]},
    {"\<\",\"\>", "44", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\";\"\>", "59", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"\<\"A\"\>", "65", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"B\"\>", "66", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"\<\"C\"\>", "67", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"\<\"D\"\>", "68", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\"E\"\>", "69", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"a\"\>", "97", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"b\"\>", "98", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "0"}], "}"}]},
    {"\<\"c\"\>", "99", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
       "1"}], "}"}]},
    {"\<\"d\"\>", "100", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "0"}], "}"}]},
    {"\<\"e\"\>", "101", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
       "1"}], "}"}]},
    {"\<\"p,z\"\>", "112", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
       "0"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.750248304193478*^9, 3.750248317963942*^9}, 
   3.750248349411231*^9, 3.7502485545108433`*^9, 3.7503431505868187`*^9, 
   3.7507717079933643`*^9, {3.751042003148902*^9, 3.751042016117793*^9}, 
   3.7510430414438868`*^9, 3.7512713249735823`*^9, 3.7512867709084873`*^9, 
   3.751312605873796*^9, 3.751312660885002*^9, 3.751452128686022*^9, 
   3.751452187996818*^9, {3.751466075660329*^9, 3.75146613153771*^9}, 
   3.7516537640972643`*^9, 3.751654254877557*^9, 3.751794578895362*^9, 
   3.7523322723418694`*^9, 3.752339863055532*^9, 3.7523909118146677`*^9, 
   3.75251374641444*^9, 3.752513874779766*^9, 3.752513920328043*^9, 
   3.752596478748136*^9, 3.7528410188935328`*^9, 3.7528410648887997`*^9, 
   3.75284591186028*^9, 3.7528460200040817`*^9, 3.7532674244324703`*^9, 
   3.765797181638154*^9, 3.765797402886538*^9, 3.765809520742044*^9, 
   3.7756379064980907`*^9, 3.775663901400074*^9, 3.7757194937281322`*^9, 
   3.775720123654985*^9, 3.7757236029981537`*^9, 3.775723654602469*^9, 
   3.775723687306319*^9, 3.775723804365856*^9, 3.7757238873670197`*^9, 
   3.7758943672794037`*^9, 3.775907532846304*^9, 3.7770296903876963`*^9, 
   3.7771883270670233`*^9, 3.77756762131124*^9, 3.777568130415147*^9, 
   3.777568278903248*^9, 3.7776204228196907`*^9, 3.782195969544627*^9, 
   3.782196166141514*^9, 3.782197557766696*^9, 3.78219761665152*^9, 
   3.7821976749382877`*^9, 3.782208434748069*^9, 3.7822326499545813`*^9, 
   3.782233583450028*^9, 3.782235432347897*^9, 3.782321564542544*^9, 
   3.782478965728395*^9, 3.782551940179715*^9, 3.782803070606207*^9, 
   3.782812895303418*^9, 3.782822195694612*^9, 3.783084482189419*^9, 
   3.7830965699653387`*^9, 3.783097552747917*^9, 3.78310163728375*^9, 
   3.783186657758827*^9, 3.7834452234568233`*^9, 3.783878248554665*^9, 
   3.78392978956809*^9, 3.7842144411446877`*^9, 3.784214715000093*^9, 
   3.784214785947619*^9, 3.7843906398559027`*^9, 3.7843909492726192`*^9, 
   3.7921360392619753`*^9, 3.7930842047507763`*^9, 3.7933399521369457`*^9, 
   3.794985749327561*^9, 3.794986397112898*^9, 3.7949882338315363`*^9, 
   3.798871697706653*^9, 3.799333451571322*^9},
 CellLabel->
  "Out[272]//TableForm=",ExpressionUUID->"c931ad9c-85b0-4c6e-9eeb-\
f08662ca7c1a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Observe that the most significant bit, corresponding to 2^7 = 128, is always \
0, and the second most significant bit, corresponding to 2^6 = 64, is always \
1 except for space and the punctuation characters\
\>", "Subsection",
 CellChangeTimes->{{3.749807917394046*^9, 3.7498079441766243`*^9}, {
  3.750248333176403*^9, 3.750248335125345*^9}, {3.7502484926201344`*^9, 
  3.750248492857504*^9}, {3.750248558236948*^9, 
  3.750248563007779*^9}},ExpressionUUID->"2efd07be-83be-4c25-9d3f-\
e8c3b969d2d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBytes", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.750248442725436*^9, 3.750248448022807*^9}},
 CellLabel->
  "In[273]:=",ExpressionUUID->"c6bb27a9-af5c-44dc-b01d-e63dd667a263"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBytes", "[", "bs_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"FromEightBits", "[", 
     RowBox[{"bs", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "8"}], "]"}], "]"}], "]"}], "}"}], "~", "Join", "~", 
   RowBox[{"ToBytes", "[", 
    RowBox[{"bs", "[", 
     RowBox[{"[", 
      RowBox[{"9", ";;", 
       RowBox[{"Length", "[", "bs", "]"}]}], "]"}], "]"}], "]"}]}]}]], "Input",\

 CellChangeTimes->{{3.7502483802377996`*^9, 3.750248467889812*^9}, {
  3.750340309471781*^9, 3.750340314802183*^9}},
 CellLabel->
  "In[274]:=",ExpressionUUID->"d2f6f18a-0419-43c0-aa70-a0a9ca888339"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringToASCIIBytes", "[", "str_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"CharacterToASCII", "[", 
     RowBox[{"StringTake", "[", 
      RowBox[{"str", ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "j"}], "}"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", 
      RowBox[{"StringLength", "[", "str", "]"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.749807975852521*^9, 3.74980804004381*^9}, {
  3.7502485083245287`*^9, 3.750248508671074*^9}, {3.750340432897299*^9, 
  3.750340433750786*^9}, {3.750340568547821*^9, 3.750340589994907*^9}},
 CellLabel->
  "In[275]:=",ExpressionUUID->"fb219d2f-150f-4fdd-870b-915fd7b5b1fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringToASCIIBits", "[", "str_", "]"}], ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"StringToASCIIBytes", "[", "str", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7503409422009*^9, 3.7503409549375877`*^9}, {
  3.750341013817608*^9, 3.7503410368568373`*^9}},
 CellLabel->
  "In[276]:=",ExpressionUUID->"a3b46dd0-83ed-4201-8668-6f0f729425fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ASCIIBitsToString", "[", "bs_", "]"}], ":=", 
  RowBox[{"FromCharacterCode", "/@", 
   RowBox[{"ToBytes", "[", "bs", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750341330296894*^9, 3.7503413770703917`*^9}},
 CellLabel->
  "In[277]:=",ExpressionUUID->"3756a7f1-1661-4fcb-b9ef-3be4547eb6bd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
LFSR Cryptosystem: note encryption and decryption are the same function on \
bits\
\>", "Section",
 CellChangeTimes->{{3.749808077207443*^9, 3.749808082608724*^9}, {
   3.7498110004327087`*^9, 3.749811006184123*^9}, 
   3.750341205516445*^9},ExpressionUUID->"dd42704d-55ed-484d-81a7-\
3ca57ac9deb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EncryptBits", "[", 
   RowBox[{"ts_", ",", "k_", ",", "bs_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"Keystream", "[", 
     RowBox[{"ts", ",", "k", ",", 
      RowBox[{"Length", "[", "bs", "]"}]}], "]"}], "+", "bs"}], " ", "//", 
   "ModTwo"}]}]], "Input",
 CellChangeTimes->{{3.749810961563836*^9, 3.749810984625881*^9}, {
  3.750341194710017*^9, 3.750341205516753*^9}, {3.775719247975486*^9, 
  3.775719250990526*^9}},
 CellLabel->
  "In[278]:=",ExpressionUUID->"9d165fee-8bd1-4977-9491-8337168130f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EncryptString", "[", 
   RowBox[{"ts_", ",", "k_", ",", "str_"}], "]"}], ":=", 
  RowBox[{"EncryptBits", "[", 
   RowBox[{"ts", ",", "k", ",", 
    RowBox[{"StringToASCIIBits", "[", "str", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7498107228452187`*^9, 3.7498107757294283`*^9}, {
   3.749810815499099*^9, 3.749810827801696*^9}, {3.749810922901129*^9, 
   3.7498109589508333`*^9}, {3.750340962382999*^9, 3.7503409627773113`*^9}, 
   3.750341205517993*^9},
 CellLabel->
  "In[279]:=",ExpressionUUID->"a95a1b0c-f1c4-4c36-976d-8dc2d4ddc9a5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DecryptBits", "[", 
   RowBox[{"ts_", ",", "k_", ",", "bs_"}], "]"}], ":=", 
  RowBox[{"ASCIIBitsToString", "[", 
   RowBox[{"EncryptBits", "[", 
    RowBox[{"ts", ",", "k", ",", "bs"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7503414801059093`*^9, 3.750341515621826*^9}, 
   3.750341655443118*^9},
 CellLabel->
  "In[280]:=",ExpressionUUID->"a3fa0507-59cd-41e9-953a-04783edf1220"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Problem Sheet 5 Question 2:",
  FontWeight->"Bold"],
 " use LFSR of width 5 with taps {3,5}. "
}], "Section",
 CellChangeTimes->{{3.7503270143849287`*^9, 3.750327021339941*^9}, {
   3.750327052330233*^9, 3.7503270775426598`*^9}, 3.750339871698657*^9, {
   3.750339921557337*^9, 3.750339957913619*^9}, {3.750339997216475*^9, 
   3.7503400150042133`*^9}, 3.7503400475290413`*^9, {3.750340469171751*^9, 
   3.75034050728078*^9}, {3.750341078324312*^9, 3.750341078785187*^9}, 
   3.750341916352232*^9, {3.750342618407715*^9, 3.7503426208331957`*^9}, 
   3.750772196610105*^9, {3.775719528998405*^9, 
   3.775719531638163*^9}},ExpressionUUID->"f2e93dfc-94aa-43df-8c5b-\
0f5e43ff79ac"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["If you do not have a ciphertext to decrypt, please \
use the one below",
 FontWeight->"Bold"]], "Subsection",
 CellChangeTimes->{{3.750350016880498*^9, 
  3.750350025791665*^9}},ExpressionUUID->"383a5bb3-2e2b-40b2-952e-\
bc54fe5d2366"],

Cell[BoxData[
 RowBox[{"yFromLecturer", ":=", " ", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
    ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",",
     "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1",
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
    ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",",
     "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1",
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
    ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",",
     "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
    "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0",
     ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
    ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",",
     "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
    "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0",
     ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
    ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",",
     "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
    "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1",
     ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
    ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",",
     "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
    "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0",
     ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7503500494224997`*^9, 3.750350066037056*^9}, {
  3.7757195359482603`*^9, 3.775719545564892*^9}},
 CellLabel->
  "In[281]:=",ExpressionUUID->"69ebe8f2-f565-4a6b-84e2-8d9add3b145a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToEightBits", "/@", 
  RowBox[{"ToBytes", "[", "yFromLecturer", "]"}]}]], "Input",
 CellChangeTimes->{{3.751042656611554*^9, 3.751042670630992*^9}, {
  3.775719559135442*^9, 3.775719560810708*^9}},
 CellLabel->
  "In[282]:=",ExpressionUUID->"0c8a55ae-ada3-483b-aebe-31b50badb9af"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.751042665583577*^9, 3.75104267096074*^9}, 
   3.751271325420867*^9, 3.751312606346065*^9, 3.751312661399488*^9, 
   3.751452129746735*^9, 3.751452188380707*^9, {3.751466076069212*^9, 
   3.751466132003664*^9}, 3.751653764610612*^9, 3.751654255275264*^9, 
   3.7517945793373947`*^9, 3.752332272730236*^9, 3.752339863503604*^9, 
   3.7523909125055847`*^9, 3.752513747065219*^9, 3.7525138754589767`*^9, 
   3.752513920974546*^9, 3.7525964791519547`*^9, 3.752841019450295*^9, 
   3.752841066048542*^9, 3.752845912531993*^9, 3.7528460211490383`*^9, 
   3.7532674254310083`*^9, 3.76579718260781*^9, 3.7657974040786753`*^9, 
   3.7658095217556057`*^9, 3.77563790664767*^9, 3.775663901532783*^9, 
   3.775719493944992*^9, 3.775720123932295*^9, 3.7757236036625967`*^9, 
   3.775723654805174*^9, 3.775723687513215*^9, 3.775723804618039*^9, 
   3.775723887583447*^9, 3.7758943675502996`*^9, 3.775907533082573*^9, 
   3.777029690525072*^9, 3.777188327399645*^9, 3.777567621477386*^9, 
   3.777568130630493*^9, 3.7775682797345943`*^9, 3.7776204230265503`*^9, 
   3.782195969738571*^9, 3.7821961663262672`*^9, 3.782197558003798*^9, 
   3.7821976169028273`*^9, 3.7821976752548428`*^9, 3.782208435082335*^9, 
   3.7822326501272306`*^9, 3.782233583635254*^9, 3.782235432938863*^9, 
   3.78232156471456*^9, 3.7824789659515457`*^9, 3.782551940885923*^9, 
   3.782803070773901*^9, 3.782812895519301*^9, 3.78282219595181*^9, 
   3.783084482343276*^9, 3.783096570259687*^9, 3.783097552987103*^9, 
   3.783101637569158*^9, 3.7831866579560223`*^9, 3.783445223744152*^9, 
   3.7838782488213663`*^9, 3.783929789800264*^9, 3.784214441365088*^9, 
   3.784214715269292*^9, 3.784214786213356*^9, 3.784390640154768*^9, 
   3.7843909495560827`*^9, 3.7921360394629*^9, 3.7930842049442368`*^9, 
   3.793339952417179*^9, 3.794985749567177*^9, 3.794986397414158*^9, 
   3.7949882342045403`*^9, 3.798871697983426*^9, 3.799333451920979*^9},
 CellLabel->
  "Out[282]=",ExpressionUUID->"88e1ebdf-95c1-4ecc-ab2f-6ef1d6eeb005"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
In this example, the first letter h becomes 104 = 64 + 32 + 8 = 01101000 in \
binary. We need 10*8 = 80 positions of the keystream to encode. The key used \
in the example is 11111\
\>", "Subsection",
 CellChangeTimes->{
  3.750340508840908*^9, {3.750341083040101*^9, 3.750341093861248*^9}, {
   3.750341152341441*^9, 3.750341159167904*^9}, {3.750341552309492*^9, 
   3.750341553100635*^9}, {3.750343461809904*^9, 3.7503435023042192`*^9}, {
   3.75326748756009*^9, 
   3.753267487905456*^9}},ExpressionUUID->"4c6122d8-072b-4092-b367-\
1d76b190ecc7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringToASCIIBits", "[", "\"\<helloworld\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.750340971182897*^9, 3.750340976969533*^9}, {
  3.750343465267705*^9, 3.7503434663633327`*^9}},
 CellLabel->
  "In[283]:=",ExpressionUUID->"4ecb1aa1-c6bf-4246-80b8-c0536f940051"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7503409774590673`*^9, {3.750341017013524*^9, 3.750341038904307*^9}, 
   3.7503419218656607`*^9, 3.750343151528895*^9, 3.7503434667659693`*^9, 
   3.7507717087538633`*^9, 3.751271325571692*^9, 3.7513126063969593`*^9, 
   3.751312661424761*^9, 3.7514521298289633`*^9, 3.751452188409627*^9, {
   3.7514660761261578`*^9, 3.751466132055542*^9}, 3.751653764643814*^9, 
   3.751654255323235*^9, 3.751794579367413*^9, 3.752332272758271*^9, 
   3.752339863541995*^9, 3.752390912581778*^9, 3.7525137471449347`*^9, 
   3.7525138756548347`*^9, 3.752513921034362*^9, 3.7525964791774263`*^9, 
   3.752841019547861*^9, 3.7528410661865797`*^9, 3.752845912590747*^9, 
   3.752846021181431*^9, 3.753267425458592*^9, 3.7657971826879683`*^9, 
   3.7657974041010637`*^9, 3.765809521791415*^9, 3.775637906726713*^9, 
   3.77566390163099*^9, 3.77571949402846*^9, 3.775720124059209*^9, 
   3.775723603730138*^9, 3.775723654901202*^9, 3.775723687591731*^9, 
   3.775723804767392*^9, 3.7757238876664047`*^9, 3.7758943676331263`*^9, 
   3.7759075331664467`*^9, 3.777029690605009*^9, 3.777188327486602*^9, 
   3.777567621556396*^9, 3.777568130731038*^9, 3.777568279814736*^9, 
   3.777620423159237*^9, 3.7821959698397417`*^9, 3.7821961664311533`*^9, 
   3.782197558110158*^9, 3.7821976170281897`*^9, 3.782197675412981*^9, 
   3.782208435248378*^9, 3.782232650231189*^9, 3.7822335837866898`*^9, 
   3.782235433123217*^9, 3.782321564832714*^9, 3.782478966081314*^9, 
   3.782551941034206*^9, 3.7828030708763123`*^9, 3.782812895648258*^9, 
   3.782822196107683*^9, 3.783084482425075*^9, 3.783096570456163*^9, 
   3.783097553104409*^9, 3.783101637746949*^9, 3.783186658061943*^9, 
   3.7834452238785067`*^9, 3.7838782489580517`*^9, 3.7839297898994417`*^9, 
   3.784214441529984*^9, 3.7842147153821783`*^9, 3.7842147863529367`*^9, 
   3.784390640261897*^9, 3.784390949712029*^9, 3.7921360395669537`*^9, 
   3.793084205045417*^9, 3.793339952560343*^9, 3.794985749684224*^9, 
   3.794986397616228*^9, 3.794988234417591*^9, 3.798871698081057*^9, 
   3.79933345211548*^9},
 CellLabel->
  "Out[283]=",ExpressionUUID->"a8f47352-9bd0-46c7-a9a9-a17dfe9e1e35"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", "80"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.7503410488763227`*^9, 3.750341097896962*^9}, {
   3.750341138924212*^9, 3.750341141552452*^9}, {3.750341556502736*^9, 
   3.750341558068181*^9}, {3.750341923406951*^9, 3.7503419235456867`*^9}, 
   3.750343505965254*^9, {3.775719568507413*^9, 3.775719568790702*^9}},
 CellLabel->
  "In[284]:=",ExpressionUUID->"b0d4604e-0f8b-4ab1-a739-561cd3c3074e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.750341146193882*^9, 3.750341147878168*^9}, 
   3.750341558543535*^9, 3.750341923790765*^9, 3.75034315159836*^9, 
   3.750343506344589*^9, 3.750771708969585*^9, 3.75127132561069*^9, 
   3.751312606440099*^9, 3.7513126614696903`*^9, 3.7514521303965483`*^9, 
   3.751452188465413*^9, {3.751466076193775*^9, 3.75146613210466*^9}, 
   3.75165376467903*^9, 3.7516542553573217`*^9, 3.751794579440186*^9, 
   3.752332272793592*^9, 3.7523398635854473`*^9, 3.7523909126281567`*^9, 
   3.752513747196786*^9, 3.752513875708397*^9, 3.752513921108389*^9, 
   3.75259647924008*^9, 3.752841019575884*^9, 3.752841066287038*^9, 
   3.7528459126495953`*^9, 3.752846021268606*^9, 3.7532674256671467`*^9, 
   3.7657971829003687`*^9, 3.765797404254402*^9, 3.7658095218423023`*^9, 
   3.775637906798263*^9, 3.775663901710713*^9, 3.7757194941114893`*^9, 
   3.77572012434245*^9, 3.775723603798088*^9, 3.775723655001999*^9, 
   3.775723687709873*^9, 3.7757238049509773`*^9, 3.775723887750842*^9, 
   3.775894367716991*^9, 3.775907533238263*^9, 3.777029690708654*^9, 
   3.777188327570547*^9, 3.777567621629401*^9, 3.777568130830639*^9, 
   3.777568279897574*^9, 3.77762042329385*^9, 3.7821959699390917`*^9, 
   3.782196166550226*^9, 3.782197558192876*^9, 3.782197617172778*^9, 
   3.782197675590067*^9, 3.782208435431636*^9, 3.782232650345549*^9, 
   3.782233583928314*^9, 3.7822354332894773`*^9, 3.7823215649319153`*^9, 
   3.7824789662167053`*^9, 3.7825519411564617`*^9, 3.782803070982328*^9, 
   3.7828128957824297`*^9, 3.78282219626248*^9, 3.783084482533205*^9, 
   3.783096570731518*^9, 3.783097553220788*^9, 3.7831016379316187`*^9, 
   3.7831866581962757`*^9, 3.783445223992117*^9, 3.783878249101529*^9, 
   3.783929789990364*^9, 3.784214441701644*^9, 3.7842147154911957`*^9, 
   3.7842147864882298`*^9, 3.784390640400272*^9, 3.784390949939579*^9, 
   3.792136039662941*^9, 3.793084205143015*^9, 3.793339952700789*^9, 
   3.794985749785878*^9, 3.794986397783533*^9, 3.794988234567872*^9, 
   3.7988716981772003`*^9, 3.799333452345406*^9},
 CellLabel->
  "Out[284]=",ExpressionUUID->"71c09139-3a0b-463c-95b0-f5ad90f0d951"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "80"}], "]"}], "+", 
   RowBox[{"StringToASCIIBits", "[", "\"\<helloworld\>\"", "]"}]}], "//", 
  "ModTwo"}]], "Input",
 CellChangeTimes->{{3.7503411727680693`*^9, 3.750341221908956*^9}, {
  3.750341561216662*^9, 3.7503415619128847`*^9}, {3.7503419251591883`*^9, 
  3.750341925282823*^9}, {3.7503435079557943`*^9, 3.750343510831276*^9}, {
  3.775719570309321*^9, 3.775719570686975*^9}},
 CellLabel->
  "In[285]:=",ExpressionUUID->"a2b6b921-7e2b-4ebc-90e4-bc8e71abbc67"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.750341219182921*^9, 3.750341222300561*^9}, 
   3.750341562487207*^9, 3.7503419255205183`*^9, 3.750343151667058*^9, 
   3.7503435111445436`*^9, 3.750771709120213*^9, 3.751271325736493*^9, 
   3.751312606471627*^9, 3.751312661543124*^9, 3.75145213049608*^9, 
   3.751452188515872*^9, {3.751466076259697*^9, 3.75146613214681*^9}, 
   3.751653764745331*^9, 3.7516542553916397`*^9, 3.7517945795016336`*^9, 
   3.752332272824479*^9, 3.752339863619066*^9, 3.752390912737369*^9, 
   3.752513747245549*^9, 3.752513875750733*^9, 3.75251392119914*^9, 
   3.752596479310584*^9, 3.752841019655286*^9, 3.752841066453682*^9, 
   3.752845912694895*^9, 3.7528460214452*^9, 3.7532674257654457`*^9, 
   3.765797182954534*^9, 3.765797404316264*^9, 3.7658095218996477`*^9, 
   3.775637906868718*^9, 3.775663901794661*^9, 3.7757194941942253`*^9, 
   3.775720124709124*^9, 3.775723603914091*^9, 3.7757236551355963`*^9, 
   3.7757236878097267`*^9, 3.775723805102662*^9, 3.775723887833517*^9, 
   3.7758943678001957`*^9, 3.775907533341572*^9, 3.777029690790126*^9, 
   3.777188327653639*^9, 3.777567621705785*^9, 3.7775681309348183`*^9, 
   3.777568279981085*^9, 3.777620423510023*^9, 3.782195970028008*^9, 
   3.782196166649415*^9, 3.782197558272147*^9, 3.7821976173043137`*^9, 
   3.7821976757922907`*^9, 3.7822084356194696`*^9, 3.78223265047964*^9, 
   3.782233584085175*^9, 3.782235433650886*^9, 3.7823215650357513`*^9, 
   3.7824789663482943`*^9, 3.782551941285811*^9, 3.7828030710922823`*^9, 
   3.782812895916641*^9, 3.782822196424549*^9, 3.783084482626301*^9, 
   3.783096571068878*^9, 3.783097553336982*^9, 3.783101638114506*^9, 
   3.783186658328864*^9, 3.783445224115078*^9, 3.7838782492668047`*^9, 
   3.783929790083499*^9, 3.78421444189475*^9, 3.7842147156018353`*^9, 
   3.784214786635741*^9, 3.784390640552349*^9, 3.784390950112657*^9, 
   3.792136039761735*^9, 3.793084205242844*^9, 3.793339952846178*^9, 
   3.794985749885708*^9, 3.794986397969139*^9, 3.794988234701888*^9, 
   3.798871698310519*^9, 3.799333452474024*^9},
 CellLabel->
  "Out[285]=",ExpressionUUID->"6a648b35-00cc-4f22-a5a3-1b693c06dddf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7512874142633142`*^9, 3.7512874206295967`*^9}, {
  3.775719572652945*^9, 3.7757195733821497`*^9}},
 CellLabel->
  "In[286]:=",ExpressionUUID->"e4a96625-d930-45ad-97b1-d6bdbf1c97e3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.751287421134776*^9, 3.751312606525206*^9, 3.751312661573698*^9, 
   3.751452130544814*^9, 3.751452188564859*^9, {3.75146607632692*^9, 
   3.7514661322055283`*^9}, 3.7516537647775803`*^9, 3.751654255421473*^9, 
   3.751794579535305*^9, 3.752332272856854*^9, 3.752339863685162*^9, 
   3.7523909127861557`*^9, 3.752513747296749*^9, 3.752513875823357*^9, 
   3.752513921245569*^9, 3.7525964793387737`*^9, 3.752841019755834*^9, 
   3.752841066598774*^9, 3.7528459127461*^9, 3.7528460214841413`*^9, 
   3.7532674259491653`*^9, 3.76579718300315*^9, 3.765797404400045*^9, 
   3.765809521931954*^9, 3.7756379069405603`*^9, 3.77566390187853*^9, 
   3.7757194942781*^9, 3.775720125209873*^9, 3.775723603997361*^9, 
   3.7757236552349567`*^9, 3.775723687891982*^9, 3.77572380525272*^9, 
   3.775723887917645*^9, 3.775894367884502*^9, 3.77590753341626*^9, 
   3.777029690873569*^9, 3.77718832773388*^9, 3.7775676217886133`*^9, 
   3.777568131723344*^9, 3.7775682800645847`*^9, 3.777620423648777*^9, 
   3.7821959701222343`*^9, 3.78219616676646*^9, 3.782197558361329*^9, 
   3.7821976174376802`*^9, 3.782197675985005*^9, 3.782208435812717*^9, 
   3.782232650596375*^9, 3.782233584251485*^9, 3.782235434844791*^9, 
   3.782321565142095*^9, 3.7824789664844418`*^9, 3.7825519414058313`*^9, 
   3.782803071204472*^9, 3.7828128960495157`*^9, 3.782822196682852*^9, 
   3.783084482726284*^9, 3.783096571292137*^9, 3.783097553454708*^9, 
   3.783101638297894*^9, 3.78318665846592*^9, 3.7834452242278833`*^9, 
   3.783878249408654*^9, 3.783929790190024*^9, 3.7842144421607113`*^9, 
   3.784214715833795*^9, 3.7842147867708883`*^9, 3.784390640652769*^9, 
   3.78439095027796*^9, 3.792136039862179*^9, 3.793084205343009*^9, 
   3.793339953332464*^9, 3.7949857499866047`*^9, 3.7949863981816807`*^9, 
   3.7949882348344517`*^9, 3.7988716984120007`*^9, 3.7993334525887117`*^9},
 CellLabel->
  "Out[286]=",ExpressionUUID->"15a63dae-ae97-45ce-b759-1ec2958512a5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Alternatively you can do this in one operation: as \
bytes",
 FontWeight->"Bold"]], "Subsection",
 CellChangeTimes->{{3.7503412275442457`*^9, 3.750341237414918*^9}, {
  3.7503416056481123`*^9, 3.750341615086584*^9}, {3.750342721792651*^9, 
  3.750342730086433*^9}, {3.7532674507631493`*^9, 3.7532674543025846`*^9}, {
  3.792136114016882*^9, 
  3.792136115125012*^9}},ExpressionUUID->"8b218f54-f3cd-4650-8b40-\
d6a68652b7a3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToEightBits", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"EncryptString", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
      "\"\<ismathematicsanartorascience\>\""}], "]"}], "//", "ToBytes"}], 
   ")"}]}]], "Input",
 CellChangeTimes->{{3.750341238267643*^9, 3.750341269608017*^9}, {
  3.7503415649115868`*^9, 3.750341565781242*^9}, {3.750341928015848*^9, 
  3.750341928126885*^9}, {3.750343439635829*^9, 3.75034344143362*^9}, {
  3.751027400685029*^9, 3.751027403416649*^9}, {3.751041437777604*^9, 
  3.75104150399207*^9}, {3.751041544099246*^9, 3.7510415690724688`*^9}, {
  3.7757195766082582`*^9, 3.775719578168014*^9}},
 CellLabel->
  "In[287]:=",ExpressionUUID->"4481fde5-4903-4e7f-8d6f-3c51fc48b048"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
     "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
     "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.7503412519791107`*^9, 3.750341269887363*^9}, 
   3.750341566223858*^9, 3.750341928370442*^9, 3.750343152281295*^9, 
   3.750343441814279*^9, 3.750343516538076*^9, 3.7507717092698402`*^9, {
   3.7510273876883497`*^9, 3.751027403877598*^9}, 3.7510414395077753`*^9, {
   3.751041478058055*^9, 3.7510415042737303`*^9}, {3.751041547016123*^9, 
   3.7510415693269587`*^9}, 3.751271325848174*^9, 3.751312606619658*^9, 
   3.751312661662066*^9, 3.75145213064697*^9, 3.751452188667468*^9, {
   3.7514660765880413`*^9, 3.751466132305793*^9}, 3.751653764846423*^9, 
   3.75165425549193*^9, 3.751794579672072*^9, 3.752332272925414*^9, 
   3.7523398637555943`*^9, 3.752390913003193*^9, 3.752513747363638*^9, 
   3.752513875933999*^9, 3.7525139213892527`*^9, 3.7525964794126787`*^9, 
   3.752841019958819*^9, 3.752841067068042*^9, 3.752845912902104*^9, 
   3.752846021573708*^9, 3.753267426249648*^9, 3.7657971830550957`*^9, 
   3.765797404515958*^9, 3.7658095220352983`*^9, 3.775637907016047*^9, 
   3.7756639019608727`*^9, 3.7757195005016947`*^9, 3.775720125323278*^9, 
   3.775723604082082*^9, 3.775723655334947*^9, 3.775723687976028*^9, 
   3.77572380540372*^9, 3.7757238880167418`*^9, 3.7758943679747963`*^9, 
   3.775907533499213*^9, 3.777029690954076*^9, 3.777188327817278*^9, 
   3.777567621880549*^9, 3.777568131870749*^9, 3.777568280147332*^9, 
   3.777620423776101*^9, 3.782195970222869*^9, 3.782196166917623*^9, 
   3.782197558457415*^9, 3.7821976175739717`*^9, 3.782197676149094*^9, 
   3.782208436030644*^9, 3.782232650713187*^9, 3.7822335844464912`*^9, 
   3.782235435194858*^9, 3.7823215652652903`*^9, 3.7824789666336803`*^9, 
   3.7825519416680107`*^9, 3.78280307131068*^9, 3.782812896181615*^9, 
   3.782822196940577*^9, 3.783084482826038*^9, 3.7830965715087*^9, 
   3.7830975535712233`*^9, 3.783101640967538*^9, 3.783186658599505*^9, 
   3.7834452243385353`*^9, 3.7838782495539513`*^9, 3.7839297902821703`*^9, 
   3.784214442450223*^9, 3.7842147168873873`*^9, 3.7842147869033937`*^9, 
   3.784390640773818*^9, 3.784390950433729*^9, 3.7921360399938374`*^9, 
   3.79308420546136*^9, 3.793339953480455*^9, 3.794985750117147*^9, 
   3.794986398316798*^9, 3.7949882349688663`*^9, 3.798871698527677*^9, 
   3.799333452706368*^9},
 CellLabel->
  "Out[287]=",ExpressionUUID->"2a9f29cc-f0ed-4497-bdf5-5fbb5e6ac864"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["The bits below are the ciphertext which you should \
email to the other three people in your cell (pick your own message please!)",
 
 FontWeight->"Bold"]], "Subsection",
 CellChangeTimes->{{3.7921361163740377`*^9, 
  3.792136121448847*^9}},ExpressionUUID->"3fac8a95-abb9-424f-9958-\
ef64143a6b35"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Join", "@@", 
  RowBox[{"ToEightBits", "/@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"EncryptString", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
       "\"\<theeightbitasciicodeisinefficient\>\""}], "]"}], "//", 
     "ToBytes"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.7826523448017483`*^9, 3.7826523878587313`*^9}},
 CellLabel->
  "In[288]:=",ExpressionUUID->"b803e2a5-9bf3-4490-b9f4-ed180cd05262"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.7826523757305107`*^9, 3.7826523882948847`*^9}, 
   3.782803071414611*^9, 3.782812896316224*^9, 3.7828221970990753`*^9, 
   3.783084482926505*^9, 3.783096571676529*^9, 3.783097553705337*^9, 
   3.7831016412076*^9, 3.7831866587276897`*^9, 3.783445224456506*^9, 
   3.783878249699872*^9, 3.783929790370534*^9, 3.784214442734654*^9, 
   3.7842147191744003`*^9, 3.784214787063912*^9, 3.78439064088264*^9, 
   3.784390950592614*^9, 3.792136040108595*^9, 3.7930842055783052`*^9, 
   3.793339953660058*^9, 3.7949857502365713`*^9, 3.794986398413281*^9, 
   3.794988235100829*^9, 3.798871698626893*^9, 3.799333452824242*^9},
 CellLabel->
  "Out[288]=",ExpressionUUID->"42d643c6-f705-49c6-9e5f-8b2ad441c305"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
On bits, encryption is the same as decryption, so the bits for \
\[OpenCurlyDoubleQuote]helloworld\[CloseCurlyDoubleQuote] are obtained by \
adding the keystream (assuming you know the key) again\
\>", "Subsection",
 CellChangeTimes->{{3.750341277962841*^9, 3.750341295107746*^9}, {
  3.750341432032786*^9, 3.750341434459936*^9}, {3.7503427517010508`*^9, 
  3.750342754735361*^9}, {3.750343444772788*^9, 
  3.750343446058852*^9}},ExpressionUUID->"ae548b0e-1d59-402e-8b4a-\
2113362b3478"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     "80"}], "]"}], "+", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "0", ",", "1"}], "}"}]}], "//", "ModTwo"}]], "Input",
 CellChangeTimes->{{3.750341436056497*^9, 3.750341453959764*^9}, {
  3.750341568017041*^9, 3.750341590530368*^9}, {3.750341931188566*^9, 
  3.7503419400734587`*^9}, {3.750343452065258*^9, 3.750343456062689*^9}, {
  3.775719583054719*^9, 3.7757195843258038`*^9}},
 CellLabel->
  "In[289]:=",ExpressionUUID->"fce95233-b17d-4cf8-8e6e-61a94cb0c2d1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.750341454211828*^9, {3.750341569139152*^9, 3.750341591548579*^9}, 
   3.750341941105854*^9, 3.7503431523278008`*^9, {3.750343452634717*^9, 
   3.7503434564335203`*^9}, 3.75034351849542*^9, 3.750771709387121*^9, 
   3.751271325898274*^9, 3.751312606793535*^9, 3.751312661736758*^9, 
   3.7514521306867027`*^9, 3.751452188717445*^9, {3.7514660766421347`*^9, 
   3.751466132355508*^9}, 3.751653764879035*^9, 3.751654255525131*^9, 
   3.751794580071999*^9, 3.7523322729574003`*^9, 3.752339863808522*^9, 
   3.7523909131286697`*^9, 3.752513747470599*^9, 3.7525138760006323`*^9, 
   3.752513921441745*^9, 3.752596479442938*^9, 3.75284102006536*^9, 
   3.752841067108499*^9, 3.752845913079298*^9, 3.7528460216119337`*^9, 
   3.7532674263257933`*^9, 3.7657971830863867`*^9, 3.765797404649867*^9, 
   3.765809522086748*^9, 3.775637907100171*^9, 3.7756639020438213`*^9, 
   3.775719501086358*^9, 3.775720125374105*^9, 3.775723604164879*^9, 
   3.775723655454316*^9, 3.7757236880583677`*^9, 3.775723805585576*^9, 
   3.775723888099985*^9, 3.775894368069125*^9, 3.775907533584351*^9, 
   3.7770296910557127`*^9, 3.777188327902362*^9, 3.777567621972739*^9, 
   3.777568132019376*^9, 3.777568280260352*^9, 3.777620423911729*^9, 
   3.782195970332487*^9, 3.782196167061702*^9, 3.7821975585436373`*^9, 
   3.7821976177280693`*^9, 3.782197676307753*^9, 3.782208436217548*^9, 
   3.78223265084573*^9, 3.782233584611393*^9, 3.78223543529845*^9, 
   3.782321565425705*^9, 3.782478966783784*^9, 3.782551941800962*^9, 
   3.782803071516658*^9, 3.78281289646763*^9, 3.78282219725273*^9, 
   3.783084483029986*^9, 3.783096571823532*^9, 3.7830975538319283`*^9, 
   3.783101641404954*^9, 3.783186658892785*^9, 3.783445224584956*^9, 
   3.7838782498707113`*^9, 3.78392979051311*^9, 3.784214442967942*^9, 
   3.78421471940417*^9, 3.784214787214731*^9, 3.784390641083473*^9, 
   3.784390950709833*^9, 3.792136040227969*^9, 3.793084205694294*^9, 
   3.7933399538095007`*^9, 3.794985750352594*^9, 3.79498639851422*^9, 
   3.794988235235342*^9, 3.7988716987332087`*^9, 3.7993334529410686`*^9},
 CellLabel->
  "Out[289]=",ExpressionUUID->"de197cf3-e630-4b76-9b70-7a9fc1f08582"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hence the plaintext is", "Subsection",
 CellChangeTimes->{{3.7503413231375713`*^9, 
  3.750341325810444*^9}},ExpressionUUID->"19f1db7a-f921-4df8-8c6d-\
a40cf450faf5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ASCIIBitsToString", "[", 
  RowBox[{"{", 
   RowBox[{
   "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
    ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",",
     "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1",
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
    ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",",
     "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
    "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1",
     ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
    ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",",
     "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.750341388809505*^9, 3.7503413952384253`*^9}, {
   3.75034157864494*^9, 3.7503415964712687`*^9}, 3.750343524836932*^9},
 CellLabel->
  "In[290]:=",ExpressionUUID->"362d78b4-f6e5-461c-b3cd-f0144e703eb7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"h\"\>", ",", "\<\"e\"\>", ",", "\<\"l\"\>", ",", "\<\"l\"\>", 
   ",", "\<\"o\"\>", ",", "\<\"w\"\>", ",", "\<\"o\"\>", ",", "\<\"r\"\>", 
   ",", "\<\"l\"\>", ",", "\<\"d\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.750341395783462*^9, {3.750341579868555*^9, 3.7503415970544577`*^9}, 
   3.750343152383049*^9, 3.750343525441744*^9, 3.750771709416081*^9, 
   3.751271325943465*^9, 3.751312606819618*^9, 3.751312661767211*^9, 
   3.751452130718607*^9, 3.751452188764883*^9, {3.751466076709469*^9, 
   3.7514661323974867`*^9}, 3.751653764910911*^9, 3.751654255585121*^9, 
   3.75179458010408*^9, 3.752332273002035*^9, 3.7523398638576717`*^9, 
   3.752390913233169*^9, 3.75251374752767*^9, 3.752513876040004*^9, 
   3.752513921535075*^9, 3.7525964794733047`*^9, 3.752841020097529*^9, 
   3.7528410672126703`*^9, 3.752845913177516*^9, 3.7528460216476994`*^9, 
   3.753267426409047*^9, 3.7657971831889343`*^9, 3.7657974048007927`*^9, 
   3.765809522122357*^9, 3.775637907194628*^9, 3.775663902127516*^9, 
   3.7757195011539507`*^9, 3.775720125459262*^9, 3.775723604248176*^9, 
   3.7757236556041*^9, 3.775723688142787*^9, 3.775723805752735*^9, 
   3.77572388818381*^9, 3.775894368155224*^9, 3.775907533693573*^9, 
   3.777029691139167*^9, 3.777188327984302*^9, 3.7775676220874643`*^9, 
   3.7775681321854143`*^9, 3.777568280347493*^9, 3.777620424044902*^9, 
   3.782195970430964*^9, 3.782196167201486*^9, 3.782197558643813*^9, 
   3.7821976178718224`*^9, 3.78219767647655*^9, 3.782208436396166*^9, 
   3.782232650962371*^9, 3.7822335847527227`*^9, 3.782235435414343*^9, 
   3.782321565600273*^9, 3.782478966913887*^9, 3.782551941948477*^9, 
   3.782803071614029*^9, 3.7828128965999947`*^9, 3.782822197391239*^9, 
   3.7830844831264343`*^9, 3.783096571953306*^9, 3.783097553956498*^9, 
   3.783101641592863*^9, 3.783186659033146*^9, 3.783445224718112*^9, 
   3.783878250022575*^9, 3.783929790623207*^9, 3.784214443230193*^9, 
   3.784214719542212*^9, 3.784214787352024*^9, 3.784390641249566*^9, 
   3.784390950808958*^9, 3.792136040335034*^9, 3.7930842058154373`*^9, 
   3.793339953945279*^9, 3.794985750485816*^9, 3.7949863986343184`*^9, 
   3.79498823539754*^9, 3.798871698829371*^9, 3.799333453050811*^9},
 CellLabel->
  "Out[290]=",ExpressionUUID->"63cf5734-c7e5-4923-8480-17f62f7bcfc9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Alternatively you can do this in one operation \
starting from the ciphertext (assuming you know the key)",
 FontWeight->"Bold"]], "Subsection",
 CellChangeTimes->{{3.750341467175679*^9, 3.7503414714751167`*^9}, {
  3.750341958483535*^9, 3.750341960931882*^9}, {3.750342734878487*^9, 
  3.750342769311602*^9}},ExpressionUUID->"3bb4f889-d462-4cc3-966b-\
12cc5eb6cf84"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecryptBits", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
     ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", 
     ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
     ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1"}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7503414758651247`*^9, 3.750341476676097*^9}, {
   3.750341520455724*^9, 3.7503415208574743`*^9}, {3.750341627236637*^9, 
   3.7503416366629887`*^9}, {3.750341948577593*^9, 3.750341957680818*^9}, 
   3.750343535157833*^9, 3.7510274168500233`*^9, 3.75104140895152*^9, {
   3.7510428124230757`*^9, 3.751042815184816*^9}, {3.775719587965725*^9, 
   3.775719588307769*^9}},
 CellLabel->
  "In[291]:=",ExpressionUUID->"85497670-6aa1-4e91-a714-a425bbc93c75"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"a\"\>", ",", "\<\"p\"\>", ",", "\<\"l\"\>", ",", "\<\"a\"\>", 
   ",", "\<\"i\"\>", ",", "\<\"n\"\>", ",", "\<\"t\"\>", ",", "\<\"e\"\>", 
   ",", "\<\"x\"\>", ",", "\<\"t\"\>", ",", "\<\"f\"\>", ",", "\<\"o\"\>", 
   ",", "\<\"r\"\>", ",", "\<\"s\"\>", ",", "\<\"h\"\>", ",", "\<\"e\"\>", 
   ",", "\<\"e\"\>", ",", "\<\"t\"\>", ",", "\<\"f\"\>", ",", "\<\"i\"\>", 
   ",", "\<\"v\"\>", ",", "\<\"e\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7503415212819433`*^9, {3.750341638766591*^9, 3.7503416582124243`*^9}, {
   3.750341949277453*^9, 3.7503419623400097`*^9}, 3.7503431524340677`*^9, 
   3.750343535972807*^9, 3.750771709484952*^9, 3.751027423080606*^9, 
   3.751041410651746*^9, {3.75104281345059*^9, 3.75104281545072*^9}, 
   3.7512713260204782`*^9, 3.7513126068818483`*^9, 3.751312661826519*^9, 
   3.751452130768366*^9, 3.751452188815712*^9, {3.7514660767761803`*^9, 
   3.751466132447268*^9}, 3.751653764966361*^9, 3.7516542556289387`*^9, 
   3.751794580135953*^9, 3.752332273040052*^9, 3.7523398638856363`*^9, 
   3.7523909134694843`*^9, 3.752513747580595*^9, 3.7525138761659527`*^9, 
   3.752513921757441*^9, 3.752596479506958*^9, 3.752841020165551*^9, 
   3.752841067319446*^9, 3.7528459132957373`*^9, 3.7528460216945143`*^9, 
   3.7532674265491457`*^9, 3.765797183237507*^9, 3.765797404844297*^9, 
   3.765809522166732*^9, 3.7756379072707*^9, 3.775663902254417*^9, 
   3.775719503223493*^9, 3.775720125540225*^9, 3.775723604380074*^9, 
   3.775723655772485*^9, 3.775723688243731*^9, 3.775723805917886*^9, 
   3.7757238883013783`*^9, 3.775894368239026*^9, 3.7759075337703733`*^9, 
   3.7770296912277308`*^9, 3.77718832806914*^9, 3.777567622179799*^9, 
   3.777568132341353*^9, 3.777568280431616*^9, 3.777620424193255*^9, 
   3.782195970529231*^9, 3.782196167339075*^9, 3.782197558772888*^9, 
   3.782197618017002*^9, 3.782197676624868*^9, 3.782208436579103*^9, 
   3.782232651095647*^9, 3.7822335849328337`*^9, 3.782235435526692*^9, 
   3.78232156580116*^9, 3.782478967047846*^9, 3.7825519421673*^9, 
   3.7828030717261*^9, 3.782812896733838*^9, 3.782822197528974*^9, 
   3.783084483226132*^9, 3.7830965720772448`*^9, 3.7830975540841417`*^9, 
   3.7831016417993717`*^9, 3.783186659165546*^9, 3.7834452248402033`*^9, 
   3.7838782501804743`*^9, 3.78392979072535*^9, 3.7842144434040728`*^9, 
   3.784214719684442*^9, 3.784214787489457*^9, 3.784390641368856*^9, 
   3.784390950939353*^9, 3.7921360404472427`*^9, 3.793084205927129*^9, 
   3.79333995438101*^9, 3.794985750604542*^9, 3.794986398785389*^9, 
   3.7949882355343933`*^9, 3.7988716989281797`*^9, 3.799333453190268*^9},
 CellLabel->
  "Out[291]=",ExpressionUUID->"a77f1fe3-1630-454f-bbfc-403ec22cf40d"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Problem Sheet 5 Questions 3 and 4",
  FontWeight->"Bold"],
 ": Deducing taps from keystream"
}], "Section",
 CellChangeTimes->{{3.7498021855257797`*^9, 3.749802188603448*^9}, {
   3.750337522699232*^9, 3.7503375253633413`*^9}, 3.751044621617494*^9, 
   3.7778159433941803`*^9, 3.777816454008028*^9, {3.782206776598384*^9, 
   3.782206791716618*^9}, {3.782207017393059*^9, 3.7822070188716717`*^9}, {
   3.782207127502939*^9, 
   3.782207135615595*^9}},ExpressionUUID->"647a6bfa-e532-4f48-a35f-\
1e7d7c550b67"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamMatrix", "[", 
   RowBox[{"l_", ",", "ks_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Entry", "[", 
       RowBox[{"ks", ",", "i"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "j", ",", 
        RowBox[{"j", "+", "l", "-", "1"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "0", ",", 
      RowBox[{"n", "-", "l", "-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7182884918245373`*^9, 3.718288565085256*^9}, 
   3.718373594971146*^9, {3.7498028364696074`*^9, 3.749802845819837*^9}, {
   3.775720938361013*^9, 3.775721002026168*^9}},
 CellLabel->
  "In[292]:=",ExpressionUUID->"0289aae2-6d1c-4f23-96ac-a0cdc00d88da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamMatrix", "[", 
   RowBox[{"l_", ",", "ks_"}], "]"}], ":=", 
  RowBox[{"KeystreamMatrix", "[", 
   RowBox[{"l", ",", "ks", ",", 
    RowBox[{"Length", "[", "ks", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749802851205031*^9, 3.749802861003014*^9}},
 CellLabel->
  "In[293]:=",ExpressionUUID->"91c7318e-1b48-4736-90ff-c54202fad52d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamEquation", "[", 
   RowBox[{"l_", ",", "ks_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"M", "=", 
       RowBox[{"KeystreamMatrix", "[", 
        RowBox[{"l", ",", "ks", ",", "n"}], "]"}]}], ",", 
      RowBox[{"b", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Entry", "[", 
          RowBox[{"ks", ",", "j"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "l", ",", 
           RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"M", ",", "b"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7498028069828997`*^9, 3.749802831969673*^9}, {
  3.749802865808577*^9, 3.749802910404685*^9}, {3.775721490469054*^9, 
  3.775721520508073*^9}},
 CellLabel->
  "In[294]:=",ExpressionUUID->"a6386952-5006-44bf-9d1a-e0fe4b109e62"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamEquationPrinted", "[", 
   RowBox[{"l_", ",", "ks_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"M", "=", 
       RowBox[{
        RowBox[{"KeystreamEquation", "[", 
         RowBox[{"l", ",", "ks", ",", "n"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"b", "=", 
       RowBox[{
        RowBox[{"KeystreamEquation", "[", 
         RowBox[{"l", ",", "ks", ",", "n"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"M", "//", "MatrixForm"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"t", "[", 
            RowBox[{"l", "+", "1", "-", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", "l"}], "}"}]}], "]"}], "}"}], "]"}], "//",
        "MatrixForm"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", "b", "}"}], "]"}], "//", "MatrixForm"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7757214556641912`*^9, 3.775721481709573*^9}, {
  3.7757215228498497`*^9, 3.775721638663066*^9}},
 CellLabel->
  "In[295]:=",ExpressionUUID->"2657faa8-09a3-4d23-8b85-4ce050a08c15"],

Cell[CellGroupData[{

Cell["\<\
 This is the equation that taps must satisfy given bits k_0, ..., k_{n-1} of \
the keystream\
\>", "Subsubsection",
 CellChangeTimes->{{3.7757211155813217`*^9, 
  3.7757211523918867`*^9}},ExpressionUUID->"36d9de0e-0367-4b8c-a6e4-\
e3f72be24a9c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SolveKeystreamEquation", "[", 
   RowBox[{"l_", ",", "ks_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "=", 
      RowBox[{"KeystreamEquation", "[", 
       RowBox[{"l", ",", "ks", ",", "n"}], "]"}]}], "}"}], ",", 
    RowBox[{"LinearSolve", "[", 
     RowBox[{
      RowBox[{"p", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"p", "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{"Modulus", "\[Rule]", "2"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749807180935108*^9, 3.7498072061988707`*^9}, 
   3.749807237342886*^9, {3.749807427588234*^9, 3.749807486054348*^9}, {
   3.77781622614505*^9, 3.7778162271021357`*^9}, {3.777816662850518*^9, 
   3.7778166762786493`*^9}},
 CellLabel->
  "In[296]:=",ExpressionUUID->"1ea5b44d-5308-40b1-a638-085c6b742e4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GuessTaps", "[", 
   RowBox[{"l_", ",", "ks_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"u", "=", 
      RowBox[{"SolveKeystreamEquation", "[", 
       RowBox[{"l", ",", "ks", ",", "n"}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"u", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"l", "+", "1", "-", "i"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "l"}], "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}], "&"}]}], 
       "]"}]}], "//", "Sort"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777816678335648*^9, 3.777816786535451*^9}},
 CellLabel->
  "In[297]:=",ExpressionUUID->"8a5b58a1-c384-44b5-94c7-c1a71c5c0b99"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Question 3 on Sheet 5: first keystream is 00100110: keystream equations have \
solution {1,1,0,0} corresponding to taps 3 and 4\
\>", "Subsection",
 CellChangeTimes->{{3.750342797717762*^9, 3.750342805727768*^9}, {
   3.750413183080428*^9, 3.750413183418766*^9}, 3.777816374326005*^9, {
   3.777816455831119*^9, 3.777816458346615*^9}, {3.782206795388568*^9, 
   3.782206796475008*^9}, {3.782206952675218*^9, 
   3.782206987799156*^9}},ExpressionUUID->"eabab49b-f49c-474a-8a2a-\
68e8611d1b5b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"KeystreamEquationPrinted", "[", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0"}], "}"}], ",", "8"}], "]"}], ",", 
   RowBox[{"SolveKeystreamEquation", "[", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0"}], "}"}], ",", "8"}], "]"}], ",", 
   RowBox[{"GuessTaps", "[", 
    RowBox[{"4", ",", 
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
       "0"}], "}"}], ",", "8"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.7757210211920567`*^9, 3.775721032173324*^9}, {
  3.775721081689518*^9, 3.77572110665256*^9}, {3.775721193491152*^9, 
  3.775721232068872*^9}, {3.7757213136671553`*^9, 3.775721316213863*^9}, {
  3.775721408239008*^9, 3.775721412224572*^9}, {3.775721711967257*^9, 
  3.7757217122145443`*^9}, {3.7778164397032137`*^9, 3.7778164438793097`*^9}, {
  3.777816637913965*^9, 3.777816641912013*^9}, {3.777816840077798*^9, 
  3.7778168478911133`*^9}},
 CellLabel->
  "In[298]:=",ExpressionUUID->"c48ccc4e-7533-4350-8142-704cac5d4e20"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "1", "0"},
         {"0", "1", "0", "0"},
         {"1", "0", "0", "1"},
         {"0", "0", "1", "1"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"t", "[", "4", "]"}]},
         {
          RowBox[{"t", "[", "3", "]"}]},
         {
          RowBox[{"t", "[", "2", "]"}]},
         {
          RowBox[{"t", "[", "1", "]"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0"},
         {"1"},
         {"1"},
         {"0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.77781664227151*^9, 3.777816664820396*^9}, {
   3.7778167668797693`*^9, 3.7778167883339167`*^9}, 3.777816848433221*^9, 
   3.7821959767966757`*^9, 3.7821961721913958`*^9, 3.782197563310357*^9, 
   3.78219762275307*^9, 3.7821976836919413`*^9, 3.782206798126831*^9, 
   3.7822084367348623`*^9, 3.7822326512383347`*^9, 3.782233585117011*^9, 
   3.7822354362284803`*^9, 3.782321565966435*^9, 3.782478967260551*^9, 
   3.78255194247121*^9, 3.782803071867619*^9, 3.782812896925877*^9, 
   3.782822197745578*^9, 3.783084483380145*^9, 3.783096572267791*^9, 
   3.783097554316607*^9, 3.783101642073163*^9, 3.783186659367364*^9, 
   3.783445225030715*^9, 3.783878250459153*^9, 3.783929791414618*^9, 
   3.784214444207527*^9, 3.7842147201373453`*^9, 3.784214787730401*^9, 
   3.7843906416150713`*^9, 3.784390951150467*^9, 3.792136040621265*^9, 
   3.793084206102459*^9, 3.793339954787306*^9, 3.794985751170331*^9, 
   3.7949863990423117`*^9, 3.794988235829843*^9, 3.79887169918257*^9, 
   3.7993334534522247`*^9},
 CellLabel->
  "Out[298]=",ExpressionUUID->"c95e1f2a-1a01-40e8-a038-254f3e829280"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Question 4 on Sheet 5: keystream obtained by adding keystreams of LFSRs {3,4} \
width 4 and {2,3} width 3: we saw in lectures it has period lcm(15,7) = 105. \
Also used in Example 8.2.\
\>", "Subsection",
 CellChangeTimes->{{3.782207023872856*^9, 3.782207044391336*^9}, {
  3.782544906732163*^9, 3.782544916129945*^9}, {3.7826395746857643`*^9, 
  3.7826395780127087`*^9}},ExpressionUUID->"985ddd81-6645-46f4-a2d6-\
908a0f80c880"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.782207045049302*^9, 3.782207075626552*^9}, {
  3.782208078713334*^9, 3.7822080794473763`*^9}},
 CellLabel->
  "In[299]:=",ExpressionUUID->"d04b7b9a-5651-4d4a-ab1c-b2e1ce4e3c2a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1",
      ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}],
     "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.782207072718573*^9, 3.782207077540001*^9}, 
   3.782208436843527*^9, 3.782232651340693*^9, 3.7822335852521343`*^9, 
   3.782235436487033*^9, 3.78232156607022*^9, 3.782478967400735*^9, 
   3.782551942602985*^9, 3.782803071964427*^9, 3.7828128970413218`*^9, 
   3.7828221978787317`*^9, 3.783084483460898*^9, 3.78309657237698*^9, 
   3.783097554439323*^9, 3.783101642233115*^9, 3.783186659498733*^9, 
   3.7834452251611547`*^9, 3.783878250618142*^9, 3.783929791524803*^9, 
   3.784214444429696*^9, 3.784214720347034*^9, 3.784214787887125*^9, 
   3.78439064176511*^9, 3.78439095124679*^9, 3.792136040729784*^9, 
   3.79308420620891*^9, 3.7933399549473257`*^9, 3.794985751549438*^9, 
   3.7949863991819897`*^9, 3.794988235950149*^9, 3.7988716993091784`*^9, 
   3.7993334535706177`*^9},
 CellLabel->
  "Out[299]=",ExpressionUUID->"b829fddd-2169-4bcc-a938-c752a1b25120"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "30"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7822080839317427`*^9, 3.782208087767296*^9}},
 CellLabel->
  "In[300]:=",ExpressionUUID->"32fd99f4-676e-4c16-a08a-9efcfd88567f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.782208088411941*^9, 3.782208436961038*^9, 
  3.78223265146275*^9, 3.7822335853794203`*^9, 3.782235436577402*^9, 
  3.7823215661637*^9, 3.782478967534574*^9, 3.782551942824793*^9, 
  3.7828030720643167`*^9, 3.782812897183839*^9, 3.782822198025481*^9, 
  3.7830844835851297`*^9, 3.783096572503058*^9, 3.783097554554364*^9, 
  3.7831016424164877`*^9, 3.783186659634163*^9, 3.783445225276598*^9, 
  3.7838782507660103`*^9, 3.78392979164854*^9, 3.7842144446379633`*^9, 
  3.784214721326414*^9, 3.784214788036071*^9, 3.7843906418610373`*^9, 
  3.784390951342209*^9, 3.792136040829247*^9, 3.793084206310808*^9, 
  3.7933399551132402`*^9, 3.794985751670957*^9, 3.79498639933573*^9, 
  3.79498823608626*^9, 3.798871699414604*^9, 3.7993334536745853`*^9},
 CellLabel->
  "Out[300]=",ExpressionUUID->"4295e830-9920-42e6-b9d3-337459f6cd2b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "30"}], "]"}]], "Input",
 CellChangeTimes->{{3.782208093372738*^9, 3.782208095399938*^9}},
 CellLabel->
  "In[301]:=",ExpressionUUID->"35d6184e-3890-41de-aa74-5aa9cf9d7f72"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.782208097008774*^9, 3.782208437077244*^9, 
  3.782232651579588*^9, 3.782233585531878*^9, 3.7822354366779757`*^9, 
  3.78232156627337*^9, 3.782478967664995*^9, 3.7825519429977694`*^9, 
  3.782803072157586*^9, 3.7828128973166103`*^9, 3.782822198172122*^9, 
  3.78308448369382*^9, 3.783096572626175*^9, 3.783097554690896*^9, 
  3.783101642599498*^9, 3.783186659767256*^9, 3.783445225395117*^9, 
  3.783878250904726*^9, 3.783929791751437*^9, 3.784214444776731*^9, 
  3.7842147218521347`*^9, 3.7842147881978416`*^9, 3.784390641962249*^9, 
  3.784390951444113*^9, 3.79213604093286*^9, 3.793084206409522*^9, 
  3.7933399552731457`*^9, 3.7949857517896023`*^9, 3.794986399468697*^9, 
  3.794988236219417*^9, 3.798871699516542*^9, 3.799333453789295*^9},
 CellLabel->
  "Out[301]=",ExpressionUUID->"efba188f-5606-4f85-b40f-536b126dd99c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"usQ4", ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Keystream", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"3", ",", "4"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "105"}], 
       "]"}], "+", 
      RowBox[{"Keystream", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "105"}], "]"}]}], 
     ")"}], "//", "ModTwo"}]}], ";", " ", "usQ4"}]], "Input",
 CellChangeTimes->{{3.782207078685006*^9, 3.782207102191784*^9}, {
  3.7822073145017433`*^9, 3.782207314960619*^9}, {3.782208105062302*^9, 
  3.7822081145665894`*^9}, {3.782544900415169*^9, 3.782544903736487*^9}},
 CellLabel->
  "In[302]:=",ExpressionUUID->"162c539b-758f-482c-8ed0-97ea24bd1f4f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.782207315426242*^9, {3.782208107516415*^9, 3.7822081150076513`*^9}, 
   3.782208437207453*^9, 3.7822326516951227`*^9, 3.7822335856677437`*^9, 
   3.7822354376421223`*^9, 3.7823215663805*^9, 3.782478967810526*^9, 
   3.7825449041731663`*^9, 3.7825519435029097`*^9, 3.782803072272732*^9, 
   3.7828128974491987`*^9, 3.7828221983067617`*^9, 3.783084483794324*^9, 
   3.783096572753813*^9, 3.783097554805217*^9, 3.783101645736499*^9, 
   3.7831866599011097`*^9, 3.7834452255097446`*^9, 3.7838782510476513`*^9, 
   3.7839297918606253`*^9, 3.784214444962391*^9, 3.7842147222162333`*^9, 
   3.784214788340261*^9, 3.78439064210487*^9, 3.784390951547303*^9, 
   3.79213604105787*^9, 3.7930842065260477`*^9, 3.7933399554266987`*^9, 
   3.794985751905077*^9, 3.794986399584793*^9, 3.79498823635214*^9, 
   3.798871699611079*^9, 3.799333453906348*^9},
 CellLabel->
  "Out[302]=",ExpressionUUID->"e5a46db1-ba64-40cc-bfe1-182fb27b175e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
You could now use the linear algebra method: as a first guess, we suppose \
that an LFSR of width 4 might work, and use 15 equations\
\>", "Subsubsection",
 CellChangeTimes->{{3.782207110493607*^9, 3.782207114378243*^9}, {
  3.782207332334886*^9, 3.782207344334944*^9}, {3.7822074218555117`*^9, 
  3.782207438591908*^9}, {3.782207473830757*^9, 3.782207479004982*^9}, {
  3.7822081552621613`*^9, 3.782208166366762*^9}, {3.782208282063636*^9, 
  3.782208282252327*^9}},ExpressionUUID->"23844b88-be46-44a7-bb36-\
0916abfc988e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamEquationPrinted", "[", 
  RowBox[{"4", ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", "15"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7822073304726667`*^9, 3.7822074238801928`*^9}, {
  3.7822081689231367`*^9, 3.782208169278903*^9}, {3.782208284375874*^9, 
  3.782208284461155*^9}},
 CellLabel->
  "In[303]:=",ExpressionUUID->"05a70527-7971-4703-9801-3004f842e316"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", "0", "0", "0"},
       {"0", "0", "0", "1"},
       {"0", "0", "1", "1"},
       {"0", "1", "1", "1"},
       {"1", "1", "1", "1"},
       {"1", "1", "1", "0"},
       {"1", "1", "0", "1"},
       {"1", "0", "1", "0"},
       {"0", "1", "0", "1"},
       {"1", "0", "1", "1"},
       {"0", "1", "1", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {
        RowBox[{"t", "[", "4", "]"}]},
       {
        RowBox[{"t", "[", "3", "]"}]},
       {
        RowBox[{"t", "[", "2", "]"}]},
       {
        RowBox[{"t", "[", "1", "]"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1"},
       {"1"},
       {"1"},
       {"1"},
       {"0"},
       {"1"},
       {"0"},
       {"1"},
       {"1"},
       {"1"},
       {"0"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellChangeTimes->{{3.782207372304212*^9, 3.7822074254924793`*^9}, 
   3.782208169622862*^9, 3.7822082848272676`*^9, 3.782208437310553*^9, 
   3.782232651828917*^9, 3.7822335857951202`*^9, 3.782235438116424*^9, 
   3.7823215664820213`*^9, 3.782478967980914*^9, 3.7825519437685823`*^9, 
   3.782803072365623*^9, 3.78281289759662*^9, 3.782822198445366*^9, 
   3.783084483894154*^9, 3.783096572876213*^9, 3.783097554922687*^9, 
   3.7831016460795403`*^9, 3.783186660059684*^9, 3.783445225631154*^9, 
   3.783878251205093*^9, 3.7839297919694633`*^9, 3.784214445172824*^9, 
   3.784214722330962*^9, 3.784214788485117*^9, 3.78439064224191*^9, 
   3.784390951642632*^9, 3.792136041161549*^9, 3.793084206643827*^9, 
   3.7933399555780687`*^9, 3.794985752020443*^9, 3.794986399702641*^9, 
   3.794988236513151*^9, 3.798871699713944*^9, 3.799333454018029*^9},
 CellLabel->
  "Out[303]=",ExpressionUUID->"dc83adf0-0b0c-4161-a83b-18e3b2f620df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SolveKeystreamEquation", "[", 
  RowBox[{"4", ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1",
      ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
     ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
     ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
     ",", "1"}], "}"}], ",", "15"}], "]"}]], "Input",
 CellChangeTimes->{{3.782207395246132*^9, 3.782207428109033*^9}, {
  3.782208238011346*^9, 3.7822082885509367`*^9}},
 CellLabel->
  "In[304]:=",ExpressionUUID->"f55511b9-9aed-430a-8eea-4d15ec605645"],

Cell[BoxData[
 TemplateBox[{
  "LinearSolve","nosol",
   "\"Linear equation encountered that has no solution.\"",2,304,29,
   28947309689106358534,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.782208275936924*^9, 3.7822082888594427`*^9}, 
   3.7822084374348392`*^9, 3.782232651964076*^9, 3.782233585946045*^9, 
   3.78223543822068*^9, 3.7823215665814857`*^9, 3.782478968101862*^9, 
   3.782551943903337*^9, 3.782803072465353*^9, 3.782812897734169*^9, 
   3.782822198580014*^9, 3.783084483995174*^9, 3.783096573050827*^9, 
   3.783097555040262*^9, 3.783101646268785*^9, 3.783186660174811*^9, 
   3.7834452257597713`*^9, 3.7838782513726377`*^9, 3.783929792064877*^9, 
   3.784214445358128*^9, 3.784214722456192*^9, 3.784214788625808*^9, 
   3.78439064233117*^9, 3.784390951743586*^9, 3.792136041256963*^9, 
   3.7930842067581043`*^9, 3.7933399557437563`*^9, 3.794985752135128*^9, 
   3.794986399818668*^9, 3.79498823663589*^9, 3.7988716998130608`*^9, 
   3.799333454117391*^9},
 CellLabel->
  "During evaluation of \
In[304]:=",ExpressionUUID->"f65c3b7f-868a-4cb8-89e1-2703b9898fd8"],

Cell[BoxData[
 RowBox[{"LinearSolve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0",
      ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"Modulus", "\[Rule]", "2"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.782207406232731*^9, 3.782207428467573*^9}, 
   3.782208172364923*^9, {3.782208238510639*^9, 3.782208288895492*^9}, 
   3.782208437466896*^9, 3.782232652001135*^9, 3.78223358598715*^9, 
   3.782235438277607*^9, 3.782321566614169*^9, 3.782478968140614*^9, 
   3.78255194396441*^9, 3.782803072504772*^9, 3.7828128977941227`*^9, 
   3.782822198616617*^9, 3.783084484055398*^9, 3.783096573118186*^9, 
   3.783097555096814*^9, 3.783101646311947*^9, 3.78318666020802*^9, 
   3.7834452258177137`*^9, 3.783878251443277*^9, 3.783929792112166*^9, 
   3.7842144454849787`*^9, 3.784214722486565*^9, 3.784214788681559*^9, 
   3.784390642367468*^9, 3.7843909518030567`*^9, 3.7921360413250504`*^9, 
   3.793084206793182*^9, 3.7933399558280983`*^9, 3.7949857521993837`*^9, 
   3.794986399872316*^9, 3.794988236689782*^9, 3.798871699886704*^9, 
   3.7993334541515303`*^9},
 CellLabel->
  "Out[304]=",ExpressionUUID->"affd5595-b841-427a-b962-7571c88c35d5"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Since no solution was found, try increasing 4 (first argument to \
SolveKeystreamEquation) above, until you get a solution. Then check the \
corresponding taps give the full keystream: it\[CloseCurlyQuote]s known to \
generate u_0...u_14, but might go wrong after that.\
\>", "Subsubsection",
 CellChangeTimes->{{3.782207441232897*^9, 3.782207507935836*^9}, {
  3.78220753873917*^9, 3.782207544685663*^9}, {3.782207623899942*^9, 
  3.782207626663156*^9}, {3.782207658199593*^9, 3.7822077762274933`*^9}, {
  3.782208186692439*^9, 3.782208230171019*^9}, {3.782208290744355*^9, 
  3.782208308743473*^9}},ExpressionUUID->"4f47f168-c5a4-407b-ba15-\
670ae60049e0"],

Cell[CellGroupData[{

Cell[TextData[{
 "There is also a much more elegant approach using annihilators. The two \
below show the product of the feedback polynomial g{3,4}(z) and the power \
series k0+k1z+k2z^2 + ... for the keystream k0k1k2 ... of the LFSR with taps \
{3,4} and width 4 is a polynomial: i.e. g{3,4}(z) ",
 StyleBox["annihilates",
  FontSlant->"Italic"],
 " the power series."
}], "Subsubsection",
 CellChangeTimes->{{3.782208230873499*^9, 3.782208233810532*^9}, {
  3.782544788745105*^9, 3.782544837040413*^9}, {3.782552026977213*^9, 
  3.78255215331355*^9}},ExpressionUUID->"362d52af-4dc6-4cfd-8543-\
a109aae2d9b9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToPolynomial", "[", 
  RowBox[{"Keystream", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "105"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.782207520740179*^9, 3.7822075652988987`*^9}, {
  3.782207599702631*^9, 3.782207603993721*^9}, {3.782544875522971*^9, 
  3.782544876120165*^9}},
 CellLabel->
  "In[305]:=",ExpressionUUID->"86c45a40-c86a-4b14-9ccf-031d2a90bfd6"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "3"], "+", 
  SuperscriptBox["z", "6"], "+", 
  SuperscriptBox["z", "7"], "+", 
  SuperscriptBox["z", "9"], "+", 
  SuperscriptBox["z", "11"], "+", 
  SuperscriptBox["z", "12"], "+", 
  SuperscriptBox["z", "13"], "+", 
  SuperscriptBox["z", "14"], "+", 
  SuperscriptBox["z", "18"], "+", 
  SuperscriptBox["z", "21"], "+", 
  SuperscriptBox["z", "22"], "+", 
  SuperscriptBox["z", "24"], "+", 
  SuperscriptBox["z", "26"], "+", 
  SuperscriptBox["z", "27"], "+", 
  SuperscriptBox["z", "28"], "+", 
  SuperscriptBox["z", "29"], "+", 
  SuperscriptBox["z", "33"], "+", 
  SuperscriptBox["z", "36"], "+", 
  SuperscriptBox["z", "37"], "+", 
  SuperscriptBox["z", "39"], "+", 
  SuperscriptBox["z", "41"], "+", 
  SuperscriptBox["z", "42"], "+", 
  SuperscriptBox["z", "43"], "+", 
  SuperscriptBox["z", "44"], "+", 
  SuperscriptBox["z", "48"], "+", 
  SuperscriptBox["z", "51"], "+", 
  SuperscriptBox["z", "52"], "+", 
  SuperscriptBox["z", "54"], "+", 
  SuperscriptBox["z", "56"], "+", 
  SuperscriptBox["z", "57"], "+", 
  SuperscriptBox["z", "58"], "+", 
  SuperscriptBox["z", "59"], "+", 
  SuperscriptBox["z", "63"], "+", 
  SuperscriptBox["z", "66"], "+", 
  SuperscriptBox["z", "67"], "+", 
  SuperscriptBox["z", "69"], "+", 
  SuperscriptBox["z", "71"], "+", 
  SuperscriptBox["z", "72"], "+", 
  SuperscriptBox["z", "73"], "+", 
  SuperscriptBox["z", "74"], "+", 
  SuperscriptBox["z", "78"], "+", 
  SuperscriptBox["z", "81"], "+", 
  SuperscriptBox["z", "82"], "+", 
  SuperscriptBox["z", "84"], "+", 
  SuperscriptBox["z", "86"], "+", 
  SuperscriptBox["z", "87"], "+", 
  SuperscriptBox["z", "88"], "+", 
  SuperscriptBox["z", "89"], "+", 
  SuperscriptBox["z", "93"], "+", 
  SuperscriptBox["z", "96"], "+", 
  SuperscriptBox["z", "97"], "+", 
  SuperscriptBox["z", "99"], "+", 
  SuperscriptBox["z", "101"], "+", 
  SuperscriptBox["z", "102"], "+", 
  SuperscriptBox["z", "103"], "+", 
  SuperscriptBox["z", "104"]}]], "Output",
 CellChangeTimes->{{3.782207531493877*^9, 3.78220756556549*^9}, 
   3.7822076042560167`*^9, 3.782208437579186*^9, 3.782232652125342*^9, 
   3.7822335862796583`*^9, 3.782235438374523*^9, 3.782321566713456*^9, 
   3.782478968265905*^9, 3.782544876552696*^9, 3.782551944410386*^9, 
   3.782803072609911*^9, 3.782812897922426*^9, 3.782822198741516*^9, 
   3.78308448414426*^9, 3.783096573226604*^9, 3.7830975552830143`*^9, 
   3.783101646498095*^9, 3.783186660335606*^9, 3.783445225932597*^9, 
   3.783878251581677*^9, 3.7839297922102957`*^9, 3.784214445730775*^9, 
   3.784214722610446*^9, 3.784214788818121*^9, 3.784390642469595*^9, 
   3.784390951894971*^9, 3.7921360414334803`*^9, 3.793084206942995*^9, 
   3.793339955977735*^9, 3.7949857523293343`*^9, 3.794986399967617*^9, 
   3.7949882368198767`*^9, 3.798871699995491*^9, 3.7993334542566223`*^9},
 CellLabel->
  "Out[305]=",ExpressionUUID->"3029874b-3bb7-4430-925f-a340c7c354da"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KeystreamToPolynomial", "[", 
     RowBox[{"Keystream", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "105"}], 
      "]"}], "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"z", "^", "3"}], "+", 
      RowBox[{"z", "^", "4"}]}], ")"}]}], "//", "Expand"}], "//", 
  "BMod"}]], "Input",
 CellChangeTimes->{{3.782544877959749*^9, 3.782544878820009*^9}},
 CellLabel->
  "In[306]:=",ExpressionUUID->"ae8fc042-5f6a-4e74-877d-9a0361e59370"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "3"], "+", 
  SuperscriptBox["z", "108"]}]], "Output",
 CellChangeTimes->{3.7822076074776163`*^9, 3.7822084376948433`*^9, 
  3.7822326522476473`*^9, 3.782233586413916*^9, 3.782235438479458*^9, 
  3.7823215668144283`*^9, 3.7824789683993196`*^9, 3.78254484241965*^9, 
  3.782544879153655*^9, 3.7825519445384617`*^9, 3.782803072726294*^9, 
  3.782812898050433*^9, 3.7828221988590097`*^9, 3.783084484244326*^9, 
  3.783096573343101*^9, 3.783097555384646*^9, 3.783101646687114*^9, 
  3.783186660465991*^9, 3.783445226061624*^9, 3.783878251723947*^9, 
  3.783929792309943*^9, 3.784214445914006*^9, 3.784214722743573*^9, 
  3.784214788958888*^9, 3.7843906426027193`*^9, 3.7843909520389137`*^9, 
  3.792136041533309*^9, 3.793084207060285*^9, 3.793339956144915*^9, 
  3.794985752457943*^9, 3.7949864000852633`*^9, 3.794988236953314*^9, 
  3.798871700116631*^9, 3.7993334544302273`*^9},
 CellLabel->
  "Out[306]=",ExpressionUUID->"d069afc8-ced3-4c93-9f83-e34134d6553d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Similarly the power series for the LFSR with taps {2,3} of width 3 is \
annihilated by 1+z^2+z^3\
\>", "Subsubsection",
 CellChangeTimes->{{3.782552097689486*^9, 3.782552115611534*^9}, {
  3.782552158135868*^9, 
  3.782552160162406*^9}},ExpressionUUID->"1d7a7905-6acb-4fc5-898a-\
0249264021fd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToPolynomial", "[", 
  RowBox[{"Keystream", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "105"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7822075795297947`*^9, 3.782207617818347*^9}, {
  3.782544881105969*^9, 3.782544881561417*^9}},
 CellLabel->
  "In[307]:=",ExpressionUUID->"dfef1f40-13d4-4ac6-a079-075226c3c8d4"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "4"], "+", 
  SuperscriptBox["z", "5"], "+", 
  SuperscriptBox["z", "6"], "+", 
  SuperscriptBox["z", "9"], "+", 
  SuperscriptBox["z", "11"], "+", 
  SuperscriptBox["z", "12"], "+", 
  SuperscriptBox["z", "13"], "+", 
  SuperscriptBox["z", "16"], "+", 
  SuperscriptBox["z", "18"], "+", 
  SuperscriptBox["z", "19"], "+", 
  SuperscriptBox["z", "20"], "+", 
  SuperscriptBox["z", "23"], "+", 
  SuperscriptBox["z", "25"], "+", 
  SuperscriptBox["z", "26"], "+", 
  SuperscriptBox["z", "27"], "+", 
  SuperscriptBox["z", "30"], "+", 
  SuperscriptBox["z", "32"], "+", 
  SuperscriptBox["z", "33"], "+", 
  SuperscriptBox["z", "34"], "+", 
  SuperscriptBox["z", "37"], "+", 
  SuperscriptBox["z", "39"], "+", 
  SuperscriptBox["z", "40"], "+", 
  SuperscriptBox["z", "41"], "+", 
  SuperscriptBox["z", "44"], "+", 
  SuperscriptBox["z", "46"], "+", 
  SuperscriptBox["z", "47"], "+", 
  SuperscriptBox["z", "48"], "+", 
  SuperscriptBox["z", "51"], "+", 
  SuperscriptBox["z", "53"], "+", 
  SuperscriptBox["z", "54"], "+", 
  SuperscriptBox["z", "55"], "+", 
  SuperscriptBox["z", "58"], "+", 
  SuperscriptBox["z", "60"], "+", 
  SuperscriptBox["z", "61"], "+", 
  SuperscriptBox["z", "62"], "+", 
  SuperscriptBox["z", "65"], "+", 
  SuperscriptBox["z", "67"], "+", 
  SuperscriptBox["z", "68"], "+", 
  SuperscriptBox["z", "69"], "+", 
  SuperscriptBox["z", "72"], "+", 
  SuperscriptBox["z", "74"], "+", 
  SuperscriptBox["z", "75"], "+", 
  SuperscriptBox["z", "76"], "+", 
  SuperscriptBox["z", "79"], "+", 
  SuperscriptBox["z", "81"], "+", 
  SuperscriptBox["z", "82"], "+", 
  SuperscriptBox["z", "83"], "+", 
  SuperscriptBox["z", "86"], "+", 
  SuperscriptBox["z", "88"], "+", 
  SuperscriptBox["z", "89"], "+", 
  SuperscriptBox["z", "90"], "+", 
  SuperscriptBox["z", "93"], "+", 
  SuperscriptBox["z", "95"], "+", 
  SuperscriptBox["z", "96"], "+", 
  SuperscriptBox["z", "97"], "+", 
  SuperscriptBox["z", "100"], "+", 
  SuperscriptBox["z", "102"], "+", 
  SuperscriptBox["z", "103"], "+", 
  SuperscriptBox["z", "104"]}]], "Output",
 CellChangeTimes->{{3.782207589554544*^9, 3.782207618034968*^9}, 
   3.7822084377992563`*^9, 3.782232652362535*^9, 3.782233586641453*^9, 
   3.782235438577158*^9, 3.78232156694702*^9, 3.7824789685329227`*^9, 
   3.7825448819360323`*^9, 3.782551944736165*^9, 3.782803072844109*^9, 
   3.782812898166337*^9, 3.7828221989932613`*^9, 3.783084484345777*^9, 
   3.783096573459947*^9, 3.7830975555063257`*^9, 3.783101649776606*^9, 
   3.7831866606014977`*^9, 3.783445226194912*^9, 3.783878251864039*^9, 
   3.7839297924127407`*^9, 3.784214446287775*^9, 3.784214722871663*^9, 
   3.7842147891034184`*^9, 3.7843906427117157`*^9, 3.7843909521432333`*^9, 
   3.7921360416465673`*^9, 3.7930842071766453`*^9, 3.793339956337872*^9, 
   3.7949857525678473`*^9, 3.794986400212338*^9, 3.794988237084447*^9, 
   3.798871700212241*^9, 3.799333454557165*^9},
 CellLabel->
  "Out[307]=",ExpressionUUID->"2d8ab56d-0933-46b0-b3d5-94248bcc22a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KeystreamToPolynomial", "[", 
     RowBox[{"Keystream", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "105"}], "]"}], "]"}], 
    "*", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"z", "^", "2"}], "+", 
      RowBox[{"z", "^", "3"}]}], ")"}]}], "//", "Expand"}], "//", 
  "BMod"}]], "Input",
 CellChangeTimes->{
  3.782207620251824*^9, {3.782544885447198*^9, 3.782544886003358*^9}},
 CellLabel->
  "In[308]:=",ExpressionUUID->"11babc03-83be-468f-b7e3-e3b42e4f33bb"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "107"]}]], "Output",
 CellChangeTimes->{3.78220762057585*^9, 3.782208437911942*^9, 
  3.782232652479972*^9, 3.782233586812758*^9, 3.7822354386751423`*^9, 
  3.782321567063303*^9, 3.782478968658207*^9, 3.7825448409016943`*^9, 
  3.782544888527328*^9, 3.7825519448547983`*^9, 3.782803072948522*^9, 
  3.7828128982825537`*^9, 3.7828221991122637`*^9, 3.783084484444512*^9, 
  3.783096573576665*^9, 3.783097555623178*^9, 3.783101650002852*^9, 
  3.783186660733336*^9, 3.783445226310796*^9, 3.783878251999901*^9, 
  3.783929792525175*^9, 3.784214446482532*^9, 3.784214723367841*^9, 
  3.784214789281818*^9, 3.7843906428115387`*^9, 3.784390952243005*^9, 
  3.7921360417455482`*^9, 3.7930842072933073`*^9, 3.793339956493857*^9, 
  3.7949857526884527`*^9, 3.7949864003185263`*^9, 3.794988237219634*^9, 
  3.79887170039312*^9, 3.7993334580990877`*^9},
 CellLabel->
  "Out[308]=",ExpressionUUID->"2355944a-9599-4875-bf0b-1bf0a5bc35a6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Here is the sum of the two keystreams as a power series.", \
"Subsubsection",
 CellChangeTimes->{{3.782552163664866*^9, 
  3.782552207488277*^9}},ExpressionUUID->"60081ff1-f2be-4d1b-b104-\
57a5c2616912"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToPolynomial", "[", "usQ4", "]"}]], "Input",
 CellChangeTimes->{{3.7822075103881903`*^9, 3.782207516269456*^9}},
 CellLabel->
  "In[309]:=",ExpressionUUID->"5d59817f-3c68-4f8e-95d0-96e3cdfdca99"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "3"], "+", 
  SuperscriptBox["z", "4"], "+", 
  SuperscriptBox["z", "5"], "+", 
  SuperscriptBox["z", "7"], "+", 
  SuperscriptBox["z", "14"], "+", 
  SuperscriptBox["z", "16"], "+", 
  SuperscriptBox["z", "19"], "+", 
  SuperscriptBox["z", "20"], "+", 
  SuperscriptBox["z", "21"], "+", 
  SuperscriptBox["z", "22"], "+", 
  SuperscriptBox["z", "23"], "+", 
  SuperscriptBox["z", "24"], "+", 
  SuperscriptBox["z", "25"], "+", 
  SuperscriptBox["z", "28"], "+", 
  SuperscriptBox["z", "29"], "+", 
  SuperscriptBox["z", "30"], "+", 
  SuperscriptBox["z", "32"], "+", 
  SuperscriptBox["z", "34"], "+", 
  SuperscriptBox["z", "36"], "+", 
  SuperscriptBox["z", "40"], "+", 
  SuperscriptBox["z", "42"], "+", 
  SuperscriptBox["z", "43"], "+", 
  SuperscriptBox["z", "46"], "+", 
  SuperscriptBox["z", "47"], "+", 
  SuperscriptBox["z", "52"], "+", 
  SuperscriptBox["z", "53"], "+", 
  SuperscriptBox["z", "55"], "+", 
  SuperscriptBox["z", "56"], "+", 
  SuperscriptBox["z", "57"], "+", 
  SuperscriptBox["z", "59"], "+", 
  SuperscriptBox["z", "60"], "+", 
  SuperscriptBox["z", "61"], "+", 
  SuperscriptBox["z", "62"], "+", 
  SuperscriptBox["z", "63"], "+", 
  SuperscriptBox["z", "65"], "+", 
  SuperscriptBox["z", "66"], "+", 
  SuperscriptBox["z", "68"], "+", 
  SuperscriptBox["z", "71"], "+", 
  SuperscriptBox["z", "73"], "+", 
  SuperscriptBox["z", "75"], "+", 
  SuperscriptBox["z", "76"], "+", 
  SuperscriptBox["z", "78"], "+", 
  SuperscriptBox["z", "79"], "+", 
  SuperscriptBox["z", "83"], "+", 
  SuperscriptBox["z", "84"], "+", 
  SuperscriptBox["z", "87"], "+", 
  SuperscriptBox["z", "90"], "+", 
  SuperscriptBox["z", "95"], "+", 
  SuperscriptBox["z", "99"], "+", 
  SuperscriptBox["z", "100"], "+", 
  SuperscriptBox["z", "101"]}]], "Output",
 CellChangeTimes->{3.7822075167380466`*^9, 3.782207594608082*^9, 
  3.782208438015998*^9, 3.7822326525961943`*^9, 3.78223358694566*^9, 
  3.782235438786504*^9, 3.782321567165739*^9, 3.782478968789443*^9, 
  3.782544922313117*^9, 3.782551944970578*^9, 3.782803073059505*^9, 
  3.782812898399508*^9, 3.782822199255842*^9, 3.783084484547801*^9, 
  3.783096573703479*^9, 3.7830975557560577`*^9, 3.7831016501875772`*^9, 
  3.783186660863263*^9, 3.783445226421268*^9, 3.783878252143692*^9, 
  3.783929792630856*^9, 3.784214446605912*^9, 3.784214723495278*^9, 
  3.784214789419734*^9, 3.784390642914748*^9, 3.784390952343361*^9, 
  3.79213604184274*^9, 3.7930842074058228`*^9, 3.79333995663977*^9, 
  3.794985752801764*^9, 3.7949864004152718`*^9, 3.794988237352816*^9, 
  3.7988717005305643`*^9, 3.7993334584618387`*^9},
 CellLabel->
  "Out[309]=",ExpressionUUID->"7cd2eeed-8793-4e17-9df2-6a09376692aa"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Now try to find a polynomial built out of 1+z^3+z^4 and 1+z^2+z^3 that \
annihilates the sum of the keystreams\
\>", "Subsubsection",
 CellChangeTimes->{{3.782544851360179*^9, 3.782544870221518*^9}, {
  3.782552013642046*^9, 3.782552016885689*^9}, {3.782552200825861*^9, 
  3.7825522043895473`*^9}, {3.782827068369339*^9, 3.782827074175424*^9}, {
  3.792136160340578*^9, 
  3.792136168451145*^9}},ExpressionUUID->"7b6bd876-cd20-43dd-b95a-\
25ac7d872a85"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 8.2: add keystreams for LFSR width 4 taps {3,4}", "Section",
 CellChangeTimes->{{3.751352896618413*^9, 3.751352922567355*^9}, {
   3.7778159046690474`*^9, 3.7778159092616377`*^9}, 3.782208331885881*^9, {
   3.78263959192801*^9, 
   3.782639593080591*^9}},ExpressionUUID->"7a9fce8a-60f1-45a3-9689-\
ef7a3b43e127"],

Cell[CellGroupData[{

Cell["\<\
Adding keystream to a shift of itself just gives another keystream for the \
same LFSR\
\>", "Subsubsection",
 CellChangeTimes->{{3.777816069535088*^9, 
  3.777816080280875*^9}},ExpressionUUID->"6ab1d1ba-5314-4063-9881-\
36735d049367"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ks34", " ", ":=", " ", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "20"}], 
    "]"}]}], ";", "ks34"}]], "Input",
 CellChangeTimes->{{3.7513529235660257`*^9, 3.751352940325098*^9}, {
  3.775719675684602*^9, 3.775719677328587*^9}, {3.777815995155623*^9, 
  3.7778160321512337`*^9}, {3.777818183779598*^9, 3.777818184006216*^9}, {
  3.7778182478507566`*^9, 3.777818248154297*^9}, {3.777818436026743*^9, 
  3.7778184363642197`*^9}, {3.7828129891848288`*^9, 3.782812999841547*^9}},
 CellLabel->
  "In[310]:=",ExpressionUUID->"dd28c3f7-d9d5-4011-9705-3d3764634879"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7778183087446537`*^9, 3.777818436779976*^9, 3.782195977123934*^9, 
   3.7821961724227047`*^9, 3.7821975635590477`*^9, 3.782197623021308*^9, 
   3.782197685575911*^9, 3.782208438290537*^9, 3.782232652829976*^9, 
   3.7822335872787457`*^9, 3.7822354389561377`*^9, 3.782321567381598*^9, 
   3.782478969133688*^9, 3.782551945084827*^9, 3.782803073165064*^9, 
   3.782812898537218*^9, {3.782812993009982*^9, 3.782813000224246*^9}, 
   3.782822199375856*^9, 3.7830844846555023`*^9, 3.783096573820887*^9, 
   3.783097555872438*^9, 3.783101650385301*^9, 3.78318666100196*^9, 
   3.783445226539998*^9, 3.7838782522775097`*^9, 3.783929792766755*^9, 
   3.784214446918228*^9, 3.7842147236271772`*^9, 3.784214789551721*^9, 
   3.7843906430476933`*^9, 3.7843909524431667`*^9, 3.792136041949683*^9, 
   3.7930842075267963`*^9, 3.793339956760694*^9, 3.794985752921722*^9, 
   3.794986400518407*^9, 3.794988237486546*^9, 3.7988717006899643`*^9, 
   3.799333458607884*^9},
 CellLabel->
  "Out[310]=",ExpressionUUID->"9b8ed333-ed5f-4eaa-9441-245b58fb3954"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ks34Shifted", " ", ":=", " ", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", "20"}], 
    "]"}]}], ";", "ks34Shifted"}]], "Input",
 CellChangeTimes->{{3.777816022946354*^9, 3.777816036801738*^9}, {
  3.7778181071337423`*^9, 3.77781815851425*^9}, {3.777818191778597*^9, 
  3.777818201842873*^9}, {3.7778182498288097`*^9, 3.777818250103553*^9}, {
  3.777818438222817*^9, 3.7778184385821743`*^9}, {3.782812991587152*^9, 
  3.782813004090683*^9}},
 CellLabel->
  "In[311]:=",ExpressionUUID->"1b25fc58-c104-4cc5-bffc-0b6f51e29751"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.777816037565164*^9, {3.77781810759624*^9, 3.777818159333131*^9}, {
   3.777818192943152*^9, 3.7778182143693447`*^9}, 3.77781825038548*^9, 
   3.7778184388522*^9, 3.782195977219256*^9, 3.782196172504949*^9, 
   3.782197563639913*^9, 3.78219762310467*^9, 3.782197685674705*^9, 
   3.7822084383757553`*^9, 3.7822326529445972`*^9, 3.7822335877710047`*^9, 
   3.782235439053669*^9, 3.782321567482924*^9, 3.782478969256433*^9, 
   3.782551945250681*^9, 3.782803073286408*^9, 3.782812898753168*^9, 
   3.782813004374776*^9, 3.782822199490209*^9, 3.783084484735799*^9, 
   3.783096573937044*^9, 3.783097555988661*^9, 3.783101650588462*^9, 
   3.783186661146152*^9, 3.783445226655374*^9, 3.783878252440509*^9, 
   3.783929792871994*^9, 3.784214447147996*^9, 3.7842147237683687`*^9, 
   3.784214789685165*^9, 3.784390643162814*^9, 3.784390952542824*^9, 
   3.7921360420921497`*^9, 3.793084207647553*^9, 3.793339956876668*^9, 
   3.794985753037545*^9, 3.7949864006180477`*^9, 3.7949882376481867`*^9, 
   3.798871700838715*^9, 3.799333458823497*^9},
 CellLabel->
  "Out[311]=",ExpressionUUID->"13f74b1e-178f-4378-992f-817f9f152673"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"ks34", "+", "ks34Shifted"}], "//", "ModTwo"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", "20"}], 
     "]"}]}], "}"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.77781603890515*^9, 3.777816063547133*^9}, {
  3.7778182208012342`*^9, 3.777818225085669*^9}, {3.777818260558221*^9, 
  3.77781827175314*^9}, {3.7778184014040117`*^9, 3.777818401914769*^9}, {
  3.77781844090272*^9, 3.7778184412642403`*^9}, {3.782813005943747*^9, 
  3.782813006929018*^9}},
 CellLabel->
  "In[312]:=",ExpressionUUID->"2090cfd6-038c-4f00-a0f8-66157c3467d2"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", 
     "1", "1", "1", "1", "0", "0"},
    {"1", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", 
     "1", "1", "1", "1", "0", "0"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7778160585906267`*^9, 3.777816064010007*^9}, {
   3.777818206324842*^9, 3.777818225423133*^9}, {3.777818262165237*^9, 
   3.7778182721784983`*^9}, 3.77781840206054*^9, 3.777818441575564*^9, 
   3.782195977306759*^9, 3.782196172586521*^9, 3.782197563724167*^9, 
   3.7821976231874104`*^9, 3.782197686841878*^9, 3.782208438478035*^9, 
   3.782232653063673*^9, 3.7822335880292597`*^9, 3.782235439153715*^9, 
   3.782321567588276*^9, 3.782478969390712*^9, 3.7825519453735933`*^9, 
   3.782803073393302*^9, 3.782812898870009*^9, 3.7828130082564363`*^9, 
   3.782822199608967*^9, 3.783084484832405*^9, 3.783096574068935*^9, 
   3.7830975561051083`*^9, 3.783101651088932*^9, 3.783186661284534*^9, 
   3.78344522678829*^9, 3.783878252569118*^9, 3.783929792974948*^9, 
   3.784214447288216*^9, 3.7842147239003963`*^9, 3.784214789818123*^9, 
   3.784390643291641*^9, 3.784390952642601*^9, 3.792136042196457*^9, 
   3.793084207760581*^9, 3.793339956996395*^9, 3.794985753156645*^9, 
   3.794986400719199*^9, 3.794988237786746*^9, 3.7988717009733562`*^9, 
   3.7993334593352833`*^9},
 CellLabel->
  "Out[312]//TableForm=",ExpressionUUID->"93c22652-c043-439d-a18d-\
9fc7280fb8de"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Sum of keystream with keystream for LFSR width 3 taps {2,3} was in Sheet 5 \
Question 4 above.\
\>", "Subsubsection",
 CellChangeTimes->{{3.78263959799702*^9, 
  3.782639610487012*^9}},ExpressionUUID->"771f53e8-0012-4be8-91b8-\
8f8794ab87b4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "200"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.782824692898423*^9, 3.782824698845196*^9}},
 CellLabel->
  "In[313]:=",ExpressionUUID->"d21443d5-e0fd-4160-b30e-f1c984b04cd2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.782824699579769*^9, 3.783084484931774*^9, 
  3.783096574186302*^9, 3.783097556234557*^9, 3.78310165153477*^9, 
  3.783186661415736*^9, 3.783445226906085*^9, 3.7838782527094183`*^9, 
  3.783929793075313*^9, 3.78421444744455*^9, 3.784214724056031*^9, 
  3.784214789953328*^9, 3.784390643395154*^9, 3.7843909527422647`*^9, 
  3.7921360423011923`*^9, 3.793084207875617*^9, 3.793339957112969*^9, 
  3.794985753269506*^9, 3.794986400815482*^9, 3.794988237924004*^9, 
  3.798871701099619*^9, 3.7993334598837337`*^9},
 CellLabel->
  "Out[313]=",ExpressionUUID->"90b4c53b-77cf-4e8f-be35-095fb2b5646d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "200"}], "]"}]], "Input",
 CellChangeTimes->{{3.782824707217833*^9, 3.782824710357308*^9}},
 CellLabel->
  "In[314]:=",ExpressionUUID->"54db74e2-0224-4c44-95f2-91ad0f6cced8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.782824711954916*^9, 3.783084485031835*^9, 
  3.7830965743038797`*^9, 3.783097556337329*^9, 3.783101651872127*^9, 
  3.783186661551071*^9, 3.783445227022928*^9, 3.783878252842894*^9, 
  3.783929793174755*^9, 3.7842144475715237`*^9, 3.7842147241863956`*^9, 
  3.784214790086022*^9, 3.7843906434973516`*^9, 3.784390952842963*^9, 
  3.792136042417405*^9, 3.7930842080400352`*^9, 3.793339957228066*^9, 
  3.794985753416873*^9, 3.7949864009175*^9, 3.7949882380570793`*^9, 
  3.798871701200809*^9, 3.79933346000045*^9},
 CellLabel->
  "Out[314]=",ExpressionUUID->"30761e32-6741-4b9e-bba2-d67d9a3049af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "200"}], "]"}],
    "+", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "200"}], "]"}]}], "//", 
  "ModTwo"}]], "Input",
 CellChangeTimes->{{3.782824748266136*^9, 3.782824762128982*^9}},
 CellLabel->
  "In[315]:=",ExpressionUUID->"d67b1852-5873-4c7f-8603-f0b1580c5a63"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.7828247580946283`*^9, 3.7828247626997643`*^9}, 
   3.783084485132214*^9, 3.783096574421463*^9, 3.783097556455967*^9, 
   3.783101652138363*^9, 3.783186661684819*^9, 3.783445227138558*^9, 
   3.783878252977502*^9, 3.7839297932668943`*^9, 3.78421444778053*^9, 
   3.784214724329021*^9, 3.784214790249071*^9, 3.784390643614265*^9, 
   3.784390952942685*^9, 3.792136042518073*^9, 3.79308420814303*^9, 
   3.79333995737318*^9, 3.794985753539599*^9, 3.794986401035445*^9, 
   3.7949882381893167`*^9, 3.798871701342928*^9, 3.799333460117734*^9},
 CellLabel->
  "Out[315]=",ExpressionUUID->"90c0cb22-b3fd-4202-b066-91bfdd25f8a8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
See the model answers for why this is the right feedback polynomial for the \
sum of the keystreams\
\>", "Subsubsection",
 CellChangeTimes->{{3.7831016828841248`*^9, 
  3.78310169940071*^9}},ExpressionUUID->"ff2984fc-962c-43d6-b245-\
efc6c61e83d8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"z", "^", "3"}], "+", 
      RowBox[{"z", "^", "4"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"z", "^", "2"}], "+", 
      RowBox[{"z", "^", "3"}]}], ")"}]}], "//", "Expand"}], "//", 
  "BMod"}]], "Input",
 CellChangeTimes->{{3.783100285862817*^9, 3.78310030034748*^9}},
 CellLabel->
  "In[316]:=",ExpressionUUID->"1faad803-62dc-4925-b9fe-c49f2ef0e870"],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["z", "2"], "+", 
  SuperscriptBox["z", "4"], "+", 
  SuperscriptBox["z", "5"], "+", 
  SuperscriptBox["z", "7"]}]], "Output",
 CellChangeTimes->{{3.783100296681602*^9, 3.783100300639112*^9}, {
   3.783101653483934*^9, 3.783101680790543*^9}, 3.783186661816648*^9, 
   3.783445227256681*^9, 3.7838782531186028`*^9, 3.7839297933666353`*^9, 
   3.784214447970139*^9, 3.78421472446146*^9, 3.784214790498371*^9, 
   3.784390643719941*^9, 3.7843909530719433`*^9, 3.792136042633923*^9, 
   3.793084208244924*^9, 3.793339957494617*^9, 3.794985753655072*^9, 
   3.7949864011348457`*^9, 3.794988238324316*^9, 3.798871701545794*^9, 
   3.7993334602332163`*^9},
 CellLabel->
  "Out[316]=",ExpressionUUID->"f2ca4468-25fe-4554-ba4a-9e7da306892a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "4", ",", "5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", " ", 
    RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}],
     "}"}], ",", " ", "200"}], "]"}]], "Input",
 CellChangeTimes->{{3.7828247854143543`*^9, 3.782824812655352*^9}},
 CellLabel->
  "In[317]:=",ExpressionUUID->"e4a28d8d-be4c-4664-bd25-cb0fac796cb6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.7828248146901207`*^9, 3.783084485231635*^9, 
  3.783096574536706*^9, 3.783097556571932*^9, 3.783101652423023*^9, 
  3.7831866619505453`*^9, 3.783445227373584*^9, 3.783878253248303*^9, 
  3.783929793460445*^9, 3.78421444809886*^9, 3.784214724595817*^9, 
  3.784214790651401*^9, 3.784390643821707*^9, 3.7843909531651373`*^9, 
  3.792136042746026*^9, 3.793084208341558*^9, 3.793339957611662*^9, 
  3.794985753772403*^9, 3.7949864012650337`*^9, 3.794988238457541*^9, 
  3.7988717016452293`*^9, 3.799333460350646*^9},
 CellLabel->
  "Out[317]=",ExpressionUUID->"5fc4cbda-e91a-405e-9ca8-51169f5f4671"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Correlation", "Section",
 CellChangeTimes->{{3.7510268126469517`*^9, 3.751026814716701*^9}, {
  3.7510286390751057`*^9, 
  3.751028641994541*^9}},ExpressionUUID->"84b9020a-f60d-473a-8d45-\
204a5345d4ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Corr", "[", 
   RowBox[{"xs_", ",", "ys_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"1", ",", 
            RowBox[{"Length", "[", "xs", "]"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"Equal", "[", 
            RowBox[{
             RowBox[{"xs", "[", 
              RowBox[{"[", "#1", "]"}], "]"}], ",", 
             RowBox[{"ys", "[", 
              RowBox[{"[", "#1", "]"}], "]"}]}], "]"}], "&"}]}], "]"}], ")"}],
        "//", "Length"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"s", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Length", "[", "xs", "]"}], "-", "s"}], ")"}]}], ")"}], "/", 
     
     RowBox[{"Length", "[", "xs", "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7510268154502373`*^9, 3.751026963600924*^9}},
 CellLabel->
  "In[318]:=",ExpressionUUID->"fdf1d846-50c2-492e-9cbe-99fdd8ed72b9"],

Cell[CellGroupData[{

Cell["Example of Proposition 7.7", "Subsubsection",
 CellChangeTimes->{{3.7828270517933083`*^9, 
  3.782827056434483*^9}},ExpressionUUID->"9ed5f865-961e-4044-b0ae-\
32f493ce0837"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamCycle", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7510286648392467`*^9, 3.751028682049608*^9}, {
  3.775719735737823*^9, 3.775719736183304*^9}, {3.7757236271158237`*^9, 
  3.7757236278670177`*^9}, {3.775723665669723*^9, 3.775723667231557*^9}},
 CellLabel->
  "In[319]:=",ExpressionUUID->"5c32a284-ac68-4a31-9219-ea4b32660540"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.751028672302741*^9, 3.751028682514502*^9}, 
   3.7512713276666117`*^9, 3.7513126080938053`*^9, 3.751312662918929*^9, 
   3.751452132868075*^9, 3.751452190164754*^9, {3.751466078413389*^9, 
   3.75146613399025*^9}, 3.7516537666613817`*^9, 3.75165425677824*^9, 
   3.751794581703307*^9, 3.752332274592545*^9, 3.752339865185665*^9, 
   3.752390915649089*^9, 3.7525137493426723`*^9, 3.752513879220952*^9, 
   3.752513923111326*^9, 3.752596480498534*^9, 3.752841021479382*^9, 
   3.7528410698384027`*^9, 3.752845916626231*^9, 3.7528460237371883`*^9, 
   3.7532674282030497`*^9, 3.765797184356336*^9, 3.7657974068176203`*^9, 
   3.76580952500161*^9, 3.775637908678856*^9, 3.775663907707505*^9, 
   3.775719517586247*^9, 3.775723607760983*^9, 3.7757236584571667`*^9, 
   3.7757236910830517`*^9, 3.775723807769401*^9, 3.775723890428898*^9, 
   3.775894369799164*^9, 3.775907535249156*^9, 3.777029692771546*^9, 
   3.777188329787263*^9, 3.7775676243131437`*^9, 3.777568134732835*^9, 
   3.77756828216063*^9, 3.7776204272591457`*^9, 3.782195977864066*^9, 
   3.782196173215016*^9, 3.782197564277835*^9, 3.7821976237222977`*^9, 
   3.7821976906350517`*^9, 3.782208439087948*^9, 3.7822326538142014`*^9, 
   3.782233589196262*^9, 3.782235439772572*^9, 3.7823215682306213`*^9, 
   3.782478970175077*^9, 3.7825519461000032`*^9, 3.782803073501348*^9, 
   3.782812899035489*^9, 3.782822199769553*^9, 3.78308448535435*^9, 
   3.7830965746901484`*^9, 3.783097556715231*^9, 3.783101653899856*^9, 
   3.783186662144773*^9, 3.783445227517042*^9, 3.7838782535048733`*^9, 
   3.783929793639649*^9, 3.784214448363117*^9, 3.7842147247958107`*^9, 
   3.784214791016828*^9, 3.784390643998537*^9, 3.7843909533218*^9, 
   3.792136042917432*^9, 3.793084208489048*^9, 3.7933399577923527`*^9, 
   3.79498575395625*^9, 3.7949864014316273`*^9, 3.794988238654607*^9, 
   3.798871701778728*^9, 3.799333460527668*^9},
 CellLabel->
  "Out[319]=",ExpressionUUID->"116790dc-5ff1-4da3-9a68-bbb773be95f8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Corr", "[", 
  RowBox[{
   RowBox[{"KeystreamCycle", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "]"}], 
   ",", 
   RowBox[{"KeystreamCycle", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], "]"}]}],
   "]"}]], "Input",
 CellChangeTimes->{{3.7510269076645*^9, 3.75102691435154*^9}, {
  3.7510269686945744`*^9, 3.751026988258601*^9}, {3.751028693387199*^9, 
  3.75102876637122*^9}, {3.775719738588459*^9, 3.775719741212174*^9}, {
  3.775723629881836*^9, 3.775723630529196*^9}, {3.775723670755493*^9, 
  3.775723671523649*^9}, {3.7757238139018183`*^9, 3.775723814847628*^9}},
 CellLabel->
  "In[320]:=",ExpressionUUID->"12826c78-0d21-4997-b085-8d2c2a322373"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["1", "31"]}]], "Output",
 CellChangeTimes->{{3.751026914786145*^9, 3.751026988746316*^9}, {
   3.7510287345248003`*^9, 3.7510287668951817`*^9}, 3.7512713277242737`*^9, 
   3.7513126081483173`*^9, 3.7513126629434977`*^9, 3.7514521329039183`*^9, 
   3.751452190199242*^9, {3.751466078460404*^9, 3.7514661340392714`*^9}, 
   3.7516537666978827`*^9, 3.75165425680348*^9, 3.751794581833493*^9, 
   3.7523322746215353`*^9, 3.752339865269166*^9, 3.7523909157374573`*^9, 
   3.75251374939294*^9, 3.752513879453306*^9, 3.7525139231793613`*^9, 
   3.752596480540018*^9, 3.752841021554133*^9, 3.75284106987326*^9, 
   3.752845916685734*^9, 3.752846023771068*^9, 3.7532674282461367`*^9, 
   3.765797184384982*^9, 3.765797406858979*^9, 3.765809525034307*^9, 
   3.775637908770875*^9, 3.77566390779557*^9, 3.77571951770361*^9, 
   3.775723607878105*^9, 3.7757236585664377`*^9, 3.775723691372333*^9, 
   3.775723807911178*^9, 3.775723890649973*^9, 3.775894369883353*^9, 
   3.775907535320112*^9, 3.7770296928752403`*^9, 3.777188329922604*^9, 
   3.777567624390218*^9, 3.777568134799317*^9, 3.777568282249136*^9, 
   3.7776204273793373`*^9, 3.7821959779485283`*^9, 3.78219617331499*^9, 
   3.782197564356359*^9, 3.7821976237874403`*^9, 3.7821976907292233`*^9, 
   3.782208439173809*^9, 3.782232653947421*^9, 3.782233589567441*^9, 
   3.782235439871526*^9, 3.782321568331024*^9, 3.782478970324185*^9, 
   3.7825519462199087`*^9, 3.7828030736109247`*^9, 3.782812899153406*^9, 
   3.782822199874696*^9, 3.783084485435903*^9, 3.783096574792192*^9, 
   3.783097556839202*^9, 3.783101654100359*^9, 3.7831866622849216`*^9, 
   3.783445227613865*^9, 3.783878253632017*^9, 3.783929793743132*^9, 
   3.7842144485299873`*^9, 3.7842147249339933`*^9, 3.784214791280764*^9, 
   3.784390644112062*^9, 3.784390953416872*^9, 3.792136043027915*^9, 
   3.79308420859251*^9, 3.793339957911365*^9, 3.794985754087552*^9, 
   3.794986401536086*^9, 3.7949882387904673`*^9, 3.798871701896638*^9, 
   3.7993334606521683`*^9},
 CellLabel->
  "Out[320]=",ExpressionUUID->"671428a5-97b8-4d8e-86a2-4609b2fda3cf"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Correlation attack on Geffe generator (Example 8.3)", "Section",
 CellChangeTimes->{{3.751367382933428*^9, 3.7513673913737173`*^9}, 
   3.782208363637631*^9},ExpressionUUID->"e8aa5e59-b2ca-4eab-96cf-\
5f556240f3ac"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ks4", "[", "n_", "]"}], ":=", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "n"}], "]"}]}],
   ";", 
  RowBox[{
   RowBox[{"ks3", "[", "n_", "]"}], ":=", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "n"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"gs4", "[", "n_", "]"}], ":=", 
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "n"}], "]"}]}],
   ";", 
  RowBox[{
   RowBox[{"usGeffe", "[", "n_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"gs4", "[", "n", "]"}], "[", 
         RowBox[{"[", "i", "]"}], "]"}], "*", 
        RowBox[{
         RowBox[{"ks3", "[", "n", "]"}], "[", 
         RowBox[{"[", "i", "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{
           RowBox[{"gs4", "[", "n", "]"}], "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ")"}], "*", 
        RowBox[{
         RowBox[{"ks4", "[", "n", "]"}], "[", 
         RowBox[{"[", "i", "]"}], "]"}]}]}], "//", "ModTwo"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ks4", "[", "20", "]"}], ",", 
     RowBox[{"ks3", "[", "20", "]"}], ",", 
     RowBox[{"gs4", "[", "20", "]"}], ",", 
     RowBox[{"usGeffe", "[", "20", "]"}]}], "}"}], "//", "TF"}]}]], "Input",
 CellChangeTimes->{{3.777819056608006*^9, 3.777819157413488*^9}, {
  3.777819187520143*^9, 3.777819188030363*^9}, {3.777819361863928*^9, 
  3.777819392144988*^9}, {3.777819492885956*^9, 3.7778194930273533`*^9}, {
  3.7826410501628838`*^9, 3.782641050637537*^9}, {3.782641617926252*^9, 
  3.782641679919484*^9}, {3.7826417307378407`*^9, 3.782641731095437*^9}},
 CellLabel->
  "In[321]:=",ExpressionUUID->"ca730dd4-efd0-4e0a-9ee1-0fb88ba25883"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", 
     "1", "0", "0", "0", "1", "0"},
    {"0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1"},
    {"0", "0", "0", "1", "1", "1", "1", "0", "1", "0", "1", "1", "0", "0", 
     "1", "0", "0", "0", "1", "1"},
    {"0", "0", "0", "0", "1", "1", "1", "1", "0", "1", "0", "1", "1", "1", 
     "0", "0", "0", "0", "1", "1"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7778190989599752`*^9, 3.777819108019209*^9}, {
   3.777819158389949*^9, 3.777819188329837*^9}, {3.777819363017186*^9, 
   3.777819392634675*^9}, 3.777819494222589*^9, 3.777819803904676*^9, 
   3.782195978036627*^9, 3.782196173414403*^9, 3.7821975644408903`*^9, 
   3.782197623872514*^9, 3.782197690818885*^9, 3.782208439316003*^9, 
   3.782232654063924*^9, 3.7822335899464273`*^9, 3.782235439973043*^9, 
   3.782321568439157*^9, 3.7824789704864492`*^9, 3.782551946391768*^9, 
   3.782641051098233*^9, {3.7826416830330143`*^9, 3.782641693919771*^9}, 
   3.782641733858316*^9, 3.78280307386339*^9, 3.782812899402843*^9, 
   3.782812976585556*^9, 3.7828222000089808`*^9, 3.783084485547876*^9, 
   3.783096574910718*^9, 3.783097556955146*^9, 3.783101654304327*^9, 
   3.783186662413189*^9, 3.7834452277246647`*^9, 3.783878253766457*^9, 
   3.7839297938987713`*^9, 3.784214448732609*^9, 3.7842147257407303`*^9, 
   3.784214791477211*^9, 3.7843906442346077`*^9, 3.784390953526482*^9, 
   3.792136043378462*^9, 3.7930842086929207`*^9, 3.793339958024349*^9, 
   3.794985754202384*^9, 3.794986401635016*^9, 3.794988238923476*^9, 
   3.7988717019915657`*^9, 3.7993334607812157`*^9},
 CellLabel->
  "Out[321]//TableForm=",ExpressionUUID->"6a141ae4-2ac6-47c3-825f-\
829671a2f358"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeffeKeystream", "[", 
   RowBox[{
   "ts_", ",", "k_", ",", "tsP_", ",", "kP_", ",", "tsC_", ",", "kC_", ",", 
    "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ks", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{"ts", ",", "k", ",", "n"}], "]"}]}], ",", 
      RowBox[{"ksP", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{"tsP", ",", "kP", ",", "n"}], "]"}]}], ",", 
      RowBox[{"cs", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{"tsC", ",", "kC", ",", "n"}], "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"cs", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{"ks", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"ksP", "[", 
         RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.7513674665878553`*^9, 3.751367466836775*^9}, {
  3.751369717960232*^9, 3.751369837570115*^9}, {3.751369892775062*^9, 
  3.7513699160337133`*^9}, {3.751370432459733*^9, 3.7513704332930403`*^9}, {
  3.782821783471027*^9, 3.782821841352744*^9}},
 CellLabel->
  "In[322]:=",ExpressionUUID->"a20c9716-eee1-4328-8615-8b3296e2b4c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GeffeKeystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "20"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751369839273882*^9, 3.751369904209519*^9}, {
   3.751370187471957*^9, 3.7513701914620028`*^9}, {3.751370436179611*^9, 
   3.75137043823171*^9}, {3.775723708239499*^9, 3.775723716238751*^9}, {
   3.7828216880298653`*^9, 3.782821734624914*^9}, {3.782821793864008*^9, 
   3.7828217943260593`*^9}, 3.782821846983451*^9},
 CellLabel->
  "In[323]:=",ExpressionUUID->"acdb7496-1037-48d6-a7e2-045ab9f3a646"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.751369883263937*^9, 3.75136991770582*^9}, 
   3.7513701922802753`*^9, 3.7513704386678953`*^9, 3.7513743100087852`*^9, 
   3.75145213308409*^9, 3.751452190330353*^9, {3.751466078675041*^9, 
   3.7514661341562777`*^9}, 3.751653766834358*^9, 3.751654256942021*^9, 
   3.7517945819340963`*^9, 3.752332274741356*^9, 3.752339865457075*^9, 
   3.7523909158902807`*^9, 3.75251374957847*^9, 3.7525138798229637`*^9, 
   3.75251392337006*^9, 3.7525964807640343`*^9, 3.752841021730912*^9, 
   3.7528410705707197`*^9, 3.752845917174472*^9, 3.752846023949588*^9, 
   3.753267428494266*^9, 3.76579718455689*^9, 3.765797407017746*^9, 
   3.765809525210229*^9, 3.775637909296444*^9, 3.775663907903414*^9, 
   3.775719517849317*^9, 3.775723608288484*^9, 3.7757236586789837`*^9, 
   3.775723691547246*^9, 3.7757238080360947`*^9, 3.775723890961228*^9, 
   3.77589437020086*^9, 3.775907535433058*^9, 3.777029693119974*^9, 
   3.77718833010427*^9, 3.777567624512725*^9, 3.777568134903263*^9, 
   3.777568282395171*^9, 3.777620427530867*^9, 3.782195978148953*^9, 
   3.7821961735112877`*^9, 3.782197564556365*^9, 3.78219762397237*^9, 
   3.782197690954109*^9, 3.782208439425815*^9, 3.7822326541941633`*^9, 
   3.7822335903459806`*^9, 3.782235440096671*^9, 3.782321568549388*^9, 
   3.782478970623042*^9, 3.782551946532461*^9, 3.78280307397397*^9, 
   3.7828128995442867`*^9, {3.782821719250527*^9, 3.782821735004602*^9}, {
   3.7828217913859797`*^9, 3.782821847273265*^9}, 3.7828222001564083`*^9, 
   3.783084485678049*^9, 3.783096575079357*^9, 3.783097557090767*^9, 
   3.783101654521831*^9, 3.783186662554846*^9, 3.783445227866948*^9, 
   3.783878253944704*^9, 3.783929794029067*^9, 3.784214449046789*^9, 
   3.784214727845564*^9, 3.7842147918150883`*^9, 3.784390644408278*^9, 
   3.784390953672443*^9, 3.7921360438033953`*^9, 3.793084208808268*^9, 
   3.79333995818861*^9, 3.79498575437967*^9, 3.794986401785433*^9, 
   3.794988239102166*^9, 3.79887170209407*^9, 3.799333460947982*^9},
 CellLabel->
  "Out[323]=",ExpressionUUID->"80a60256-2b2b-45b3-9f70-a92ccd1db388"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamCorrelations", "[", 
   RowBox[{"ts_", ",", "l_", ",", "us_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Corr", "[", 
     RowBox[{
      RowBox[{"Keystream", "[", 
       RowBox[{"ts", ",", "k", ",", 
        RowBox[{"Length", "[", "us", "]"}]}], "]"}], ",", "us"}], "]"}], ",", 
    
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"NonZeroBinaryWords", "[", "l", "]"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.751367392467093*^9, 3.751367468339336*^9}, {
   3.7513702343641148`*^9, 3.751370248216242*^9}, {3.751370297916668*^9, 
   3.7513702993066187`*^9}, {3.775719744209262*^9, 3.775719744707302*^9}, 
   3.775723856021306*^9},
 CellLabel->
  "In[324]:=",ExpressionUUID->"31954fa9-f229-4e4e-8273-4250e5bbed31"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamCorrelations", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
     ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.751370198053851*^9, 3.751370227683551*^9}, {
   3.7757237192850637`*^9, 3.7757237206019506`*^9}, {3.775723766776245*^9, 
   3.7757237680823393`*^9}, 3.782822044158248*^9},
 CellLabel->
  "In[325]:=",ExpressionUUID->"ebaa4ab5-8769-4010-a161-951f5ddd7430"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["7", "10"], ",", "0", ",", 
   RowBox[{"-", 
    FractionBox["1", "2"]}], ",", 
   FractionBox["1", "10"], ",", 
   RowBox[{"-", 
    FractionBox["1", "5"]}], ",", 
   FractionBox["1", "10"], ",", 
   RowBox[{"-", 
    FractionBox["1", "5"]}]}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGDQB+Ke/0l68xXfOCrd8cr5BKQLJD7c/AGkDXYsOy6j8sZx
2SNX2ywgbRgrXKis+sbxx/T7G0A0zwT/wyA63bXM0hZI/8txT/yu+8ZR32hz
JYj26Z6i/gNIpz9i1AfRQg7J5iA6P+VD2V8g7c9yypNT743jk3VX9oHoEHm2
ZVxA2uy7yBYTIH3LOqK/EUhHfQwxXAqknZY5XZDXf+M4P7VijgqQ5pJfL6wJ
pCd0cKqD6L09J65oAemnkjstVgLpwonP5NcD6Ub/5bNAtJjq9VkbgfSKK9dk
bgPpQ5vqYyMN3jhefnnorI4h0PwpLj9cgfQVS41vF4C0UpK85EUg7dfFqAii
LWdN/Kdm9MZxkoOlqjqQfnan9u0bB6A4t9yz3U5vHHsqTh+zcH7jmCUWmBzj
BgzHyzZbQLQ6+4uZsUA6TuH4paO+bxw1ZJd4Lfd74wgAEdOyDQ==
  "],
 CellLabel->
  "Out[325]=",ExpressionUUID->"bb9cad01-e297-404e-afb9-b5438726bd2a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
The correlation of 7/10 for the key (0,0,1) stands out as the biggest\
\>", "Subsubsection",
 CellChangeTimes->{{3.782826921177156*^9, 
  3.782826962443622*^9}},ExpressionUUID->"9bcf77fc-d200-4fc6-bd0f-\
542bb442c1c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"BigListPlot", "[", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["7", "10"], ",", "0", ",", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], ",", 
      FractionBox["1", "10"], ",", 
      RowBox[{"-", 
       FractionBox["1", "5"]}], ",", 
      FractionBox["1", "10"], ",", 
      RowBox[{"-", 
       FractionBox["1", "5"]}]}], "}"}], "]"}], ",", 
   RowBox[{
    RowBox[{"NonZeroBinaryWords", "[", "3", "]"}], "//", "TF"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.7513703117277813`*^9, 3.751370347720787*^9}, {
   3.751370420514595*^9, 3.751370421657536*^9}, 3.7513743688919373`*^9, 
   3.7828220631665783`*^9, {3.782826912009302*^9, 3.782826914678009*^9}, {
   3.782827011579906*^9, 3.78282701206881*^9}},
 CellLabel->
  "In[326]:=",ExpressionUUID->"8bd45cd5-dfb1-40e7-b2dd-54fb9be64213"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox["\<\"+\"\>",
          StripOnInput->False,
          FontSize->20], {0., 0.}], {{{1., 0.7}}, {{2., 0.}}, {{3., -0.5}}, {{
        4., 0.1}}, {{5., -0.2}}, {{6., 0.1}}, {{
        7., -0.2}}}]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 7.}, {-1, 1}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   TagBox[GridBox[{
      {"0", "0", "1"},
      {"0", "1", "0"},
      {"0", "1", "1"},
      {"1", "0", "0"},
      {"1", "0", "1"},
      {"1", "1", "0"},
      {"1", "1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7513743694129543`*^9, 3.751452133270335*^9, 3.751452190416049*^9, {
   3.751466078796585*^9, 3.751466134279201*^9}, 3.751653767008574*^9, 
   3.751654257056671*^9, 3.751794582089036*^9, 3.752332274925262*^9, 
   3.752339865581997*^9, 3.752390916112143*^9, 3.7525137497997837`*^9, 
   3.752513879999672*^9, 3.752513923565639*^9, 3.752596480919797*^9, 
   3.752841021911873*^9, 3.75284107073934*^9, 3.752845917383828*^9, 
   3.752846024105658*^9, 3.7532674287609787`*^9, 3.7657971846702013`*^9, 
   3.765797407236376*^9, 3.7658095254480247`*^9, 3.7756379096454687`*^9, 
   3.775663908162034*^9, 3.7757195181901484`*^9, 3.775723891268874*^9, 
   3.775894370629842*^9, 3.775907535675177*^9, 3.777029693433791*^9, 
   3.777188330280868*^9, 3.777567624943233*^9, 3.777568135549015*^9, 
   3.77756828269877*^9, 3.77762042794808*^9, 3.782195978382077*^9, 
   3.7821961738106813`*^9, 3.782197564841569*^9, 3.782197624234303*^9, 
   3.782197691306192*^9, 3.7822084397320833`*^9, 3.782232654550555*^9, 
   3.782233591298443*^9, 3.782235440406509*^9, 3.782321568774341*^9, 
   3.78247897090351*^9, 3.782551946894959*^9, 3.7828030742125387`*^9, 
   3.78281290000974*^9, 3.782822063835235*^9, 3.7828222004299803`*^9, 
   3.782826915583617*^9, 3.7828270123086567`*^9, 3.783084486040494*^9, 
   3.783096575457518*^9, 3.783097557485388*^9, 3.7831016551081963`*^9, 
   3.7831866629343348`*^9, 3.783445228269863*^9, 3.783878254405683*^9, 
   3.7839297943297167`*^9, 3.784214449523164*^9, 3.7842147297356567`*^9, 
   3.784214792484235*^9, 3.784390644772135*^9, 3.784390954050242*^9, 
   3.792136044240684*^9, 3.793084210184203*^9, 3.793339958670657*^9, 
   3.794985754879993*^9, 3.794986402146266*^9, 3.794988239548131*^9, 
   3.798871702496524*^9, 3.799333461827611*^9},
 CellLabel->
  "Out[326]=",ExpressionUUID->"c82ed19e-9b44-475b-813d-1ccdb3721d12"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamCorrelations", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", "4", ",", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
      "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "]"}],
   "//", "N"}]], "Input",
 CellChangeTimes->{{3.75137037809914*^9, 3.751370380946393*^9}, {
  3.775723780911384*^9, 3.775723782148336*^9}, {3.782822077414003*^9, 
  3.7828221033660803`*^9}, {3.7828256048172894`*^9, 3.782825605558823*^9}},
 CellLabel->
  "In[327]:=",ExpressionUUID->"2eaf788c-afab-4a8f-bd89-852d7dfa6cdb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5`", ",", "0.1`", ",", 
   RowBox[{"-", "0.2`"}], ",", "0.4`", ",", "0.1`", ",", "0.1`", ",", 
   RowBox[{"-", "0.2`"}], ",", "0.`", ",", "0.1`", ",", "0.1`", ",", "0.2`", 
   ",", 
   RowBox[{"-", "0.2`"}], ",", 
   RowBox[{"-", "0.1`"}], ",", 
   RowBox[{"-", "0.5`"}], ",", 
   RowBox[{"-", "0.4`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.782825599617934*^9, 3.782825610873049*^9}, 
   3.783084486125539*^9, 3.7830965755795307`*^9, 3.783097557606966*^9, 
   3.783101655300095*^9, 3.78318666306597*^9, 3.783445228390149*^9, 
   3.783878254696137*^9, 3.783929794434185*^9, 3.7842144496588087`*^9, 
   3.784214729964675*^9, 3.784214792849276*^9, 3.784390644886204*^9, 
   3.7843909542328577`*^9, 3.7921360444587297`*^9, 3.793084210505947*^9, 
   3.793339958794248*^9, 3.794985755095552*^9, 3.794986402368277*^9, 
   3.794988239691333*^9, 3.798871702674567*^9, 3.799333462175982*^9},
 CellLabel->
  "Out[327]=",ExpressionUUID->"e4cb0ee5-fb7c-47f0-8e8a-c8cf7606507f"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
The correlation is 1/2 (exactly as theoretically predicted) for the key \
(0,0,0,1). There are a few other largish correlations (the -1/2 is a bit \
surprising), but still the attack works to find the key.\
\>", "Subsubsection",
 CellChangeTimes->{{3.782826956974345*^9, 
  3.782826996524976*^9}},ExpressionUUID->"c0157232-d434-4629-a000-\
28f432de384b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"BigListPlot", "[", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["1", "2"], ",", 
      FractionBox["1", "10"], ",", 
      RowBox[{"-", 
       FractionBox["1", "5"]}], ",", 
      FractionBox["2", "5"], ",", 
      FractionBox["1", "10"], ",", 
      FractionBox["1", "10"], ",", 
      RowBox[{"-", 
       FractionBox["1", "5"]}], ",", "0", ",", 
      FractionBox["1", "10"], ",", 
      FractionBox["1", "10"], ",", 
      FractionBox["1", "5"], ",", 
      RowBox[{"-", 
       FractionBox["1", "5"]}], ",", 
      RowBox[{"-", 
       FractionBox["1", "10"]}], ",", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], ",", 
      RowBox[{"-", 
       FractionBox["2", "5"]}]}], "}"}], "]"}], ",", 
   RowBox[{
    RowBox[{"NonZeroBinaryWords", "[", "4", "]"}], "//", "TF"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.751370398296653*^9, 3.751370413118534*^9}, 
   3.751374403582794*^9, {3.782822091826763*^9, 3.78282211094768*^9}, {
   3.782826947141371*^9, 3.782826948458633*^9}, {3.782827005329606*^9, 
   3.78282700585542*^9}},
 CellLabel->
  "In[328]:=",ExpressionUUID->"e24f7fef-89c8-4aa7-bc7c-946197205a2b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {
      {GrayLevel[0], AbsolutePointSize[6], AbsoluteThickness[1.6], 
       GeometricTransformationBox[InsetBox[
         StyleBox["\<\"+\"\>",
          StripOnInput->False,
          FontSize->20], {0., 0.}], {{{1., 0.5}}, {{2., 0.1}}, {{
        3., -0.2}}, {{4., 0.4}}, {{5., 0.1}}, {{6., 0.1}}, {{7., -0.2}}, {{8.,
         0.}}, {{9., 0.1}}, {{10., 0.1}}, {{11., 0.2}}, {{12., -0.2}}, {{
        13., -0.1}}, {{14., -0.5}}, {{15., -0.4}}}]}, {}}, {}, {}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0., 0},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    ImagePadding->All,
    Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& ), "CopiedValueFunction" -> ({
          (Identity[#]& )[
           Part[#, 1]], 
          (Identity[#]& )[
           Part[#, 2]]}& )}},
    PlotRange->{{0., 15.}, {-1, 1}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {0, 0}},
    Ticks->{Automatic, Automatic}], ",", 
   TagBox[GridBox[{
      {"0", "0", "0", "1"},
      {"0", "0", "1", "0"},
      {"0", "0", "1", "1"},
      {"0", "1", "0", "0"},
      {"0", "1", "0", "1"},
      {"0", "1", "1", "0"},
      {"0", "1", "1", "1"},
      {"1", "0", "0", "0"},
      {"1", "0", "0", "1"},
      {"1", "0", "1", "0"},
      {"1", "0", "1", "1"},
      {"1", "1", "0", "0"},
      {"1", "1", "0", "1"},
      {"1", "1", "1", "0"},
      {"1", "1", "1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[2.0999999999999996`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Function[BoxForm`e$, 
     TableForm[BoxForm`e$, TableDepth -> 2]]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.75137440404644*^9, 3.7514521336699257`*^9, 3.751452190566737*^9, {
   3.75146607894582*^9, 3.7514661344240227`*^9}, 3.751653767124835*^9, 
   3.751654257239428*^9, 3.751794582180627*^9, 3.75233227502382*^9, 
   3.752339865703596*^9, 3.7523909163324537`*^9, 3.75251374991912*^9, 
   3.752513880194345*^9, 3.7525139238800297`*^9, 3.7525964810389214`*^9, 
   3.7528410222172737`*^9, 3.752841070904924*^9, 3.752845917647402*^9, 
   3.752846024421052*^9, 3.753267429109021*^9, 3.765797185032415*^9, 
   3.765797407352747*^9, 3.765809526012417*^9, 3.775637909881699*^9, 
   3.775663908469768*^9, 3.77571951847124*^9, 3.775723891709168*^9, 
   3.7758943714739723`*^9, 3.7759075360106773`*^9, 3.7770296938450336`*^9, 
   3.77718833055443*^9, 3.777567625228467*^9, 3.7775681358877983`*^9, 
   3.777568282933302*^9, 3.777620428277361*^9, 3.782195978746719*^9, 
   3.782196174285821*^9, 3.782197565088238*^9, 3.7821976244344473`*^9, 
   3.782197691550624*^9, 3.782208439998201*^9, 3.782232654921413*^9, 
   3.78223359260456*^9, 3.782235440793442*^9, 3.7823215690381393`*^9, 
   3.7824789712670193`*^9, 3.782551947320573*^9, 3.782803074701962*^9, 
   3.782812900317299*^9, 3.782821998197637*^9, {3.782822093545988*^9, 
   3.78282211195818*^9}, 3.782822200793347*^9, 3.782825626536069*^9, 
   3.782826949021158*^9, 3.782827006093155*^9, 3.783084486231048*^9, 
   3.783096575718849*^9, 3.783097557740293*^9, 3.783101655519095*^9, 
   3.783186663217811*^9, 3.783445228509849*^9, 3.783878255328827*^9, 
   3.783929794547165*^9, 3.784214449820136*^9, 3.784214730112667*^9, 
   3.7842147931701202`*^9, 3.78439064501124*^9, 3.7843909543407927`*^9, 
   3.79213604458788*^9, 3.793084210624834*^9, 3.793339958933518*^9, 
   3.794985755252865*^9, 3.7949864024837723`*^9, 3.794988239964254*^9, 
   3.798871702777611*^9, 3.799333462374362*^9},
 CellLabel->
  "Out[328]=",ExpressionUUID->"6dcdce08-64c9-477d-a29b-117de56b272b"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Quadratic stream cipher (with m quadratic factors) [mostly commented out as \
takes a while to evaluate]\
\>", "Section",
 CellChangeTimes->{{3.751299652814713*^9, 3.75129965823402*^9}, {
   3.751300577965785*^9, 3.751300589189732*^9}, 3.75137048901947*^9, {
   3.7828273728677998`*^9, 3.782827390961157*^9}, {3.7834441284719973`*^9, 
   3.783444129023158*^9}},ExpressionUUID->"658750c3-2edf-46c6-ba0a-\
6c4211a7da42"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Q", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"Plus", "@@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "*", 
       RowBox[{"y", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], "]"}]}], "//", 
   "ModTwo"}]}]], "Input",
 CellChangeTimes->{{3.751299669240592*^9, 3.751299725895666*^9}, {
  3.7512997614811363`*^9, 3.751299764295781*^9}},
 CellLabel->
  "In[329]:=",ExpressionUUID->"1f46602f-167c-4f55-9638-97abc8c52480"],

Cell[CellGroupData[{

Cell["\<\
We need the keystream to have period at least 1023 = 2^10, so two LFSRs of \
coprime periods around about 32 = 2^5 are indicated: use {0,2} length 5 \
(period 31) and {0,1,3,4} length 6, period 63\
\>", "Subsection",
 CellChangeTimes->{{3.751300017267988*^9, 3.751300056322237*^9}, {
  3.751300263636194*^9, 
  3.751300273568717*^9}},ExpressionUUID->"9633a7b0-a3b9-42d8-b3eb-\
2e1b5e42e5ab"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "]"}], 
    " ", "//", " ", "Length"}], ",", 
   RowBox[{
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "3", ",", "5", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
       "}"}]}], "]"}], "//", "Length"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.7513000586032133`*^9, 3.751300086243422*^9}, {
  3.751300259035108*^9, 3.751300339447263*^9}, {3.783084666612756*^9, 
  3.783084670224436*^9}},
 CellLabel->
  "In[330]:=",ExpressionUUID->"5e0880dd-0181-4dc5-9b32-a9e21c9330da"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"31", ",", "63"}], "}"}]], "Output",
 CellChangeTimes->{3.783445228655796*^9, 3.783878256252446*^9, 
  3.783929794723168*^9, 3.784214449981275*^9, 3.784214730295879*^9, 
  3.7842147934175386`*^9, 3.7843906451824627`*^9, 3.7843909545045233`*^9, 
  3.79213604476798*^9, 3.793084210764331*^9, 3.793339959124873*^9, 
  3.7949857555223513`*^9, 3.794986402652247*^9, 3.794988240186151*^9, 
  3.798871702927619*^9, 3.7993334640693283`*^9},
 CellLabel->
  "Out[330]=",ExpressionUUID->"cca1e7de-bd38-4745-8f13-9247e0ae85bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"31", "*", "63"}]], "Input",
 CellChangeTimes->{{3.783087381398034*^9, 3.783087387103903*^9}},
 CellLabel->
  "In[331]:=",ExpressionUUID->"e68ee020-572c-47af-a8fe-5cec401fe283"],

Cell[BoxData["1953"], "Output",
 CellChangeTimes->{3.783445228779187*^9, 3.7838782563848267`*^9, 
  3.783929794824545*^9, 3.7842144501862507`*^9, 3.7842147303948193`*^9, 
  3.784214793569853*^9, 3.7843906452808*^9, 3.784390954597736*^9, 
  3.7921360448835163`*^9, 3.793084210861581*^9, 3.7933399592568197`*^9, 
  3.794985755639018*^9, 3.794986402756065*^9, 3.794988240308393*^9, 
  3.798871703031608*^9, 3.799333465181477*^9},
 CellLabel->
  "Out[331]=",ExpressionUUID->"23aacd6c-16f0-44b4-b4ea-2f03e3140a1f"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"QKeystream", "[", 
   RowBox[{"m_", ",", "k_", ",", "kp_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ks", " ", "=", " ", 
       RowBox[{"Keystream", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "5"}], "}"}], ",", "k", ",", "n"}], "]"}]}], ",", 
      
      RowBox[{"kps", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2", ",", "3", ",", "5", ",", "6"}], "}"}], ",", "kp", ",", 
         "n"}], "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"m", "-", "1"}]}], "}"}]}], "]"}], "~", "Join", "~", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Q", "[", 
        RowBox[{
         RowBox[{"ks", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"r", "+", "1"}], ";;", 
            RowBox[{"r", "+", "m"}]}], "]"}], "]"}], ",", 
         RowBox[{"kps", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"r", "+", "1"}], ";;", 
            RowBox[{"r", "+", "m"}]}], "]"}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "0", ",", 
         RowBox[{"n", "-", "m"}]}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751300472428463*^9, 3.75130054143757*^9}, {
  3.751300574067062*^9, 3.751300638529505*^9}, {3.751301173519928*^9, 
  3.7513012141877747`*^9}, {3.751370494332016*^9, 3.751370541212015*^9}, {
  3.783084674438593*^9, 3.783084678363958*^9}},
 CellLabel->
  "In[332]:=",ExpressionUUID->"6f7c20f5-bd31-488e-a659-a7da3fce6f12"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"NumberOfSamesDifferents", "[", 
    RowBox[{"ks_", ",", "us_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sames", "=", 
       RowBox[{"Length", "[", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"0", ",", 
            RowBox[{
             RowBox[{"Length", "[", "ks", "]"}], "-", "1"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"ks", "[", 
             RowBox[{"[", 
              RowBox[{"#1", "+", "1"}], "]"}], "]"}], "\[Equal]", 
            RowBox[{"us", "[", 
             RowBox[{"[", 
              RowBox[{"#1", "+", "1"}], "]"}], "]"}]}], "&"}]}], "]"}], 
        "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"sames", ",", 
       RowBox[{
        RowBox[{"Length", "[", "ks", "]"}], "-", "sames"}]}], "}"}]}], 
    "]"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.751303976595632*^9, 3.751304018198518*^9}},
 CellLabel->
  "In[333]:=",ExpressionUUID->"416dd472-6558-4ffa-9b2c-a971523fb479"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"TestQ", "[", 
    RowBox[{"m_", ",", "k_", ",", "kp_", ",", "kGuess_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ks", "=", 
         RowBox[{"Keystream", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "2"}], "}"}], ",", "k", ",", "n"}], "]"}]}], 
        ",", 
        RowBox[{"ksp", "=", 
         RowBox[{"Keystream", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "3", ",", "4"}], "}"}], ",", "kp", 
           ",", "n"}], "]"}]}], ",", 
        RowBox[{"ksGuess", "=", 
         RowBox[{"Keystream", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "2"}], "}"}], ",", "kGuess", ",", "n"}], 
          "]"}]}], ",", 
        RowBox[{"us", "=", 
         RowBox[{"QKeystream", "[", 
          RowBox[{"m", ",", "k", ",", "kp", ",", "n"}], "]"}]}]}], "}"}], ",",
       "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"ks", ",", "ksp", ",", "us", ",", 
        RowBox[{"Range", "[", 
         RowBox[{"0", ",", 
          RowBox[{"n", "-", "1"}]}], "]"}], ",", "ksGuess", ",", 
        RowBox[{"NumberOfSamesDifferents", "[", 
         RowBox[{"ks", ",", "us"}], "]"}], ",", 
        RowBox[{"NumberOfSamesDifferents", "[", 
         RowBox[{"ksGuess", ",", "us"}], "]"}]}], "}"}]}], "]"}], "//", 
    "TF"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.751300657521515*^9, 3.751300802988715*^9}, {
   3.751302080247735*^9, 3.75130208590156*^9}, {3.751303697953412*^9, 
   3.7513038890375957`*^9}, {3.751303921539056*^9, 3.7513039690643187`*^9}, {
   3.751304024519046*^9, 3.751304042577405*^9}, {3.751304082779297*^9, 
   3.751304084450754*^9}, {3.751370492532057*^9, 3.751370522400344*^9}, 
   3.751455428590184*^9},
 CellLabel->
  "In[334]:=",ExpressionUUID->"05e3b4e6-bf07-4ed4-afc0-e50593949467"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"TestQ", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
    "1024"}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751300804212429*^9, 3.751300811757729*^9}, {
   3.751302089505453*^9, 3.7513021011426153`*^9}, 3.751303593237*^9, {
   3.751303804666745*^9, 3.7513038058120203`*^9}, {3.751304049044918*^9, 
   3.751304072794487*^9}, 3.751455429577098*^9},
 CellLabel->
  "In[335]:=",ExpressionUUID->"5ff4c386-b90b-4b0d-963c-8aa149a67049"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"CorrelationForKey", "[", 
    RowBox[{"us_", ",", "kGuess_"}], "]"}], ":=", 
   RowBox[{"Corr", "[", 
    RowBox[{"us", ",", 
     RowBox[{"Keystream", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"3", ",", "5"}], "}"}], ",", "kGuess", ",", 
       RowBox[{"Length", "[", "us", "]"}]}], "]"}]}], "]"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751301483120571*^9, 3.751301485566634*^9}, {
   3.751301528604154*^9, 3.7513015785196123`*^9}, {3.75130182579076*^9, 
   3.7513018364383917`*^9}, {3.7513024019613256`*^9, 3.751302403602351*^9}, 
   3.751370552728458*^9, 3.7514630512813873`*^9, {3.783084854305634*^9, 
   3.783084855699904*^9}},
 CellLabel->
  "In[336]:=",ExpressionUUID->"3888365f-ea39-4d2d-bd12-f60734dc1ea9"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Correlations", "[", "us_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FromBitsLE", "[", 
        RowBox[{"kGuess", "//", "Reverse"}], "]"}], ",", "kGuess", ",", 
       RowBox[{"CorrelationForKey", "[", 
        RowBox[{"us", ",", "kGuess"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"kGuess", ",", 
       RowBox[{"NonZeroBinaryWords", "[", "5", "]"}]}], "}"}]}], "]"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751301838105009*^9, 3.751301853373073*^9}, {
   3.751301941099828*^9, 3.751301949457881*^9}, {3.751302428448996*^9, 
   3.751302445359174*^9}, {3.751304388292652*^9, 3.751304389178425*^9}, {
   3.751370554661664*^9, 3.751370562770649*^9}, 3.751463052580018*^9, 
   3.751466117944591*^9},
 CellLabel->
  "In[337]:=",ExpressionUUID->"37d03ff1-a00f-4395-9c10-827800798ac0"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"PlotCorrelations", "[", "us_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"cs", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "&"}], "/@", 
        RowBox[{"Correlations", "[", "us", "]"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"BigListPlot", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"cs", "[", 
            RowBox[{"[", "k", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", "1", ",", 
           RowBox[{"Length", "[", "cs", "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"Min", "[", "cs", "]"}], "-", "0.05"}], ",", 
       RowBox[{
        RowBox[{"Max", "[", "cs", "]"}], "+", "0.05"}]}], "]"}]}], "]"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751302965502688*^9, 3.751302982131464*^9}, {
   3.7513030533825293`*^9, 3.751303078365625*^9}, {3.751303133328836*^9, 
   3.751303195789616*^9}, {3.751303408233733*^9, 3.751303409226932*^9}, {
   3.751303475701209*^9, 3.751303478939722*^9}, {3.751304681828074*^9, 
   3.7513047799404783`*^9}, {3.751370558118435*^9, 3.7513705602002897`*^9}, 
   3.751463057799999*^9, 3.751463114033194*^9},
 CellLabel->
  "In[338]:=",ExpressionUUID->"1802c8bf-9057-425d-b7ca-9cb808427f31"],

Cell[CellGroupData[{

Cell["\<\
Demonstration in lecture:  the highly secret keys are k = 00111 and k\
\[CloseCurlyQuote] = 000001\
\>", "Subsubsection",
 CellChangeTimes->{{3.78282222124373*^9, 3.7828222233173523`*^9}, {
  3.783084929755889*^9, 
  3.783084930117243*^9}},ExpressionUUID->"cc40fcf8-0ccb-41ad-befc-\
8a9c5eeb578c"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"QKeystream", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], 
    ",", "100"}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751302993334029*^9, 3.7513029946564693`*^9}, {
  3.751370597528038*^9, 3.7513705984407578`*^9}, {3.75146593112461*^9, 
  3.751465933702734*^9}},
 CellLabel->
  "In[339]:=",ExpressionUUID->"8891ec7b-13ca-4447-8027-768598119f14"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Correlations", "[", 
   RowBox[{"QKeystream", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], 
     ",", "1024"}], "]"}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751301951184248*^9, 3.751302009478799*^9}, {
   3.751302459998809*^9, 3.75130248219244*^9}, {3.751303000637803*^9, 
   3.751303000775242*^9}, {3.7513042676102533`*^9, 3.751304268823148*^9}, 
   3.751370566725526*^9, {3.751370601610607*^9, 3.751370603231123*^9}, 
   3.751463061109317*^9},
 CellLabel->
  "In[340]:=",ExpressionUUID->"2da0dfb7-a6be-4b74-b54d-aa3f3ac88d63"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
The first argument is m: when m=1 the key 00111_2 = 7 leaps out. When m=5, it \
is not possible to distinguish the true key by this attack.\
\>", "Subsubsection",
 CellChangeTimes->{{3.78309584851628*^9, 3.783095882977437*^9}, {
  3.7830961722850437`*^9, 
  3.7830961838100224`*^9}},ExpressionUUID->"09452199-2d87-4800-b502-\
4cfed7842ad0"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"PlotCorrelations", "[", 
   RowBox[{"QKeystream", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], 
     ",", "1024"}], "]"}], "]"}], "*)"}]], "Input",
 CellChangeTimes->{{3.7513030068734837`*^9, 3.751303015835964*^9}, {
   3.7513031486313467`*^9, 3.751303148861784*^9}, {3.751303183134246*^9, 
   3.751303183231882*^9}, {3.751303428974855*^9, 3.7513034473035297`*^9}, {
   3.7513034974634647`*^9, 3.751303530585968*^9}, {3.751303573700741*^9, 
   3.751303574797529*^9}, {3.751304295818906*^9, 3.751304374502705*^9}, {
   3.7513044580815563`*^9, 3.7513044847242813`*^9}, 3.751452200639428*^9, 
   3.751463109108162*^9, {3.783087466099886*^9, 3.7830874665166817`*^9}, {
   3.783087496622863*^9, 3.783087497048867*^9}, {3.783090511928175*^9, 
   3.783090512135148*^9}, {3.783095885295341*^9, 3.783095893851859*^9}, {
   3.7830961638126497`*^9, 3.7830961692667227`*^9}},
 CellLabel->
  "In[341]:=",ExpressionUUID->"e59d6f07-e671-4ed0-a2c2-6095e38082c8"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Example", "[", 
    RowBox[{"k_", ",", "kp_"}], "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PlotCorrelations", "[", 
      RowBox[{"QKeystream", "[", 
       RowBox[{"m", ",", "k", ",", "kp", ",", "1024"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "5"}], "}"}]}], "]"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.751304525872797*^9, 3.75130455472801*^9}, {
   3.751304595414618*^9, 3.751304595511656*^9}, 3.7514522075949593`*^9, 
   3.751463121692872*^9, {3.7514632255361433`*^9, 3.751463227644346*^9}, {
   3.75146582922213*^9, 3.7514658318347473`*^9}},
 CellLabel->
  "In[342]:=",ExpressionUUID->"dea4da8b-f412-4b72-83b7-e4ad3bea25ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
There are 2^m - 2 fake keys with correlation about 1/2^m: explanation for \
m=2: k_{s-1}k\[CloseCurlyQuote]_{s-1} + k_sk\[CloseCurlyQuote]_s is, in each \
position, one of 0, k_{s-1}, k_s, k_{s-1} + k_s, depending on the key stream \
for k\[CloseCurlyQuote]. So we expect correlation 1/4 with each of the \
keystreams for the keys 0, F^{-1}(k), k, F^{-1}k + k. (See Question 6 on \
Sheet 7 and model answers for a proof.)\
\>", "Subsubsection",
 CellChangeTimes->{{3.751535552307351*^9, 3.7515356287957983`*^9}, {
  3.751537838470152*^9, 3.751537924674457*^9}, {3.751636615693885*^9, 
  3.7516366292341537`*^9}},ExpressionUUID->"c2c446e7-a324-42f5-80fe-\
fcaa9450753e"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"KeysWithCorrelationAtLeast", "[", 
    RowBox[{"m_", ",", "k_", ",", "kp_", ",", "\[Alpha]_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"cs", " ", "=", 
       RowBox[{"Correlations", "[", 
        RowBox[{"QKeystream", "[", 
         RowBox[{"m", ",", "k", ",", "kp", ",", "1024"}], "]"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"Select", "[", 
      RowBox[{"cs", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "\[GreaterEqual]", "\[Alpha]"}], 
        "&"}]}], "]"}]}], "]"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.751535645921729*^9, 3.7515357041807404`*^9}, {
  3.7515357972868633`*^9, 3.751535798351839*^9}},
 CellLabel->
  "In[343]:=",ExpressionUUID->"fe9e57d7-5789-4e06-80ab-60d1a4c0605e"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "]"}], "//",
    "Length"}], "*)"}]], "Input",
 CellChangeTimes->{{3.783096264705298*^9, 3.783096286041609*^9}},
 CellLabel->
  "In[344]:=",ExpressionUUID->"36cd62b9-90e4-4b73-b9e0-1c153b4394a6"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeystreams", "[", 
    RowBox[{"k_", ",", "kp_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ks", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3", ",", "5"}], "}"}], ",", "k", ",", "1024"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "1024"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", "ks", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ks", "[", 
         RowBox[{"[", 
          RowBox[{"31", ";;", "1024"}], "]"}], "]"}], "~", "Join", "~", 
        RowBox[{"ks", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", "30"}], "]"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"ks", "[", 
            RowBox[{"[", 
             RowBox[{"31", ";;", "1024"}], "]"}], "]"}], "~", "Join", "~", 
           RowBox[{"ks", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "30"}], "]"}], "]"}]}], ")"}], "+", "ks"}], "//",
         "ModTwo"}], ",", "\[IndentingNewLine]", 
       RowBox[{"QKeystream", "[", 
        RowBox[{"2", ",", "k", ",", "kp", ",", "1024"}], "]"}]}], "}"}]}], 
    "]"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.751538015105269*^9, 3.7515381975897703`*^9}, {
  3.751538449906349*^9, 3.751538450176297*^9}, {3.751538606798669*^9, 
  3.751538611613534*^9}, {3.78308482869104*^9, 3.783084829024703*^9}, {
  3.783096208376552*^9, 3.78309624481454*^9}},
 CellLabel->
  "In[345]:=",ExpressionUUID->"58a28190-bdfd-473b-9605-676b8aeae0d3"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeystreams", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
      "}"}]}], "]"}], "//", "TF"}], "*)"}]], "Input",
 CellChangeTimes->{{3.75153816211257*^9, 3.751538175431143*^9}},
 CellLabel->
  "In[346]:=",ExpressionUUID->"a57a33b7-5ad0-42df-8808-fceb07388b86"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeysWithCorrelations", "[", 
    RowBox[{"k_", ",", "kp_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"fs", "=", 
        RowBox[{"FakeKeystreams", "[", 
         RowBox[{"k", ",", "kp"}], "]"}]}], ",", "g"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"g", "[", "vs_", "]"}], ":=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FromBitsLE", "[", 
          RowBox[{"Reverse", "[", 
           RowBox[{"vs", "[", 
            RowBox[{"[", 
             RowBox[{"1", ";;", "5"}], "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"vs", "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", "5"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"Corr", "[", 
           RowBox[{"vs", ",", 
            RowBox[{"fs", "[", 
             RowBox[{"[", "5", "]"}], "]"}]}], "]"}], "//", "N"}]}], "}"}]}], 
      ";", " ", 
      RowBox[{"g", " ", "/@", " ", 
       RowBox[{"fs", "[", 
        RowBox[{"[", 
         RowBox[{"1", ";;", "4"}], "]"}], "]"}]}]}]}], "]"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751538201399559*^9, 3.751538250870275*^9}, {
  3.751538458358836*^9, 3.7515386760652733`*^9}, {3.751544436652017*^9, 
  3.751544437227166*^9}},
 CellLabel->
  "In[347]:=",ExpressionUUID->"d7634f89-329c-4d7a-ba80-3b616aeb1cbf"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example: note the correlations change slightly with k\[CloseCurlyQuote] but \
are always about 1/4: the data below is used on Sheet 6\
\>", "Subsubsection",
 CellChangeTimes->{{3.7515388660509644`*^9, 3.751538876377268*^9}, {
  3.7515390049294233`*^9, 3.7515390074438457`*^9}, {3.751654234308077*^9, 
  3.7516542430391493`*^9}, {3.783096069665824*^9, 
  3.783096069734321*^9}},ExpressionUUID->"b1558e4a-ad01-4af6-9250-\
dcc4edef19d9"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeysWithCorrelations", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
      "}"}]}], "]"}], "//", "TF"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751654222565054*^9, 3.7516542231736593`*^9}, {
  3.78309609806466*^9, 3.783096116777501*^9}},
 CellLabel->
  "In[348]:=",ExpressionUUID->"83c7c8f7-3f3a-4073-8e51-6facd71f37c9"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeysWithCorrelations", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
      "}"}]}], "]"}], "//", "TF"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751538252808111*^9, 3.751538259579294*^9}, 
   3.751538629249905*^9, {3.751544394187886*^9, 3.7515443965061417`*^9}, 
   3.7515444746185513`*^9},
 CellLabel->
  "In[349]:=",ExpressionUUID->"f4969d3d-2b47-48c8-8f0f-97e7382a562c"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeysWithCorrelations", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
      "}"}]}], "]"}], "//", "TF"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751654232502295*^9, 3.751654232727303*^9}},
 CellLabel->
  "In[350]:=",ExpressionUUID->"69a80420-8a80-49a7-8b68-53d1977f9d0e"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"FakeKeysWithCorrelations", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
      "}"}]}], "]"}], "//", "TF"}], "*)"}]], "Input",
 CellChangeTimes->{{3.751538994553495*^9, 3.751538994667355*^9}, {
  3.751544517014749*^9, 3.7515445172310753`*^9}, {3.751544641044886*^9, 
  3.751544641134159*^9}},
 CellLabel->
  "In[351]:=",ExpressionUUID->"eaabc332-c7f9-4952-af0d-cf49d3e0935f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Question 2 on Sheet 6",
 FontWeight->"Bold"]], "Section",
 CellChangeTimes->{{3.751011155028461*^9, 3.75101115716466*^9}, 
   3.782803076962063*^9},ExpressionUUID->"4ea3f260-82b5-4cc6-bcbc-\
2f690cbc8bb6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", "511", "]"}]], "Input",
 CellChangeTimes->{{3.75101122858591*^9, 3.751011234157609*^9}},
 CellLabel->
  "In[352]:=",ExpressionUUID->"835bf556-e668-4ab8-b6a5-b22604496f1e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"7", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"73", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.782812900365367*^9, 3.782822210765388*^9, 
  3.783084486497467*^9, 3.78309657936213*^9, 3.7830975581521683`*^9, 
  3.7831016559454527`*^9, 3.783186663641268*^9, 3.783445229216187*^9, 
  3.783878261530895*^9, 3.783929795144783*^9, 3.784214450436454*^9, 
  3.784214730726668*^9, 3.784214794015356*^9, 3.7843906456092978`*^9, 
  3.784390954863037*^9, 3.792136045197109*^9, 3.793084211108783*^9, 
  3.793339959805406*^9, 3.794985756022703*^9, 3.794986403060535*^9, 
  3.79498824072149*^9, 3.7988717032498817`*^9, 3.799333465580882*^9},
 CellLabel->
  "Out[352]=",ExpressionUUID->"4e12c877-754a-4b9f-bbe4-dc4a495ad602"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"X", "^", "511"}], "+", "1"}], ",", 
   RowBox[{"Modulus", "\[Rule]", "2"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7828030929406548`*^9, 3.782803101738955*^9}},
 CellLabel->
  "In[353]:=",ExpressionUUID->"02dc5c5b-709b-4f8c-b0e0-3ac532705e24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "+", "X"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.7828031020852213`*^9, 3.782812900501253*^9, 
  3.782822210930945*^9, 3.783084486582892*^9, 3.7830965794778433`*^9, 
  3.78309755827312*^9, 3.783101656151103*^9, 3.783186663785177*^9, 
  3.783445229314185*^9, 3.783878261681529*^9, 3.783929795243726*^9, 
  3.784214450573762*^9, 3.784214730835047*^9, 3.784214794152*^9, 
  3.784390645713138*^9, 3.784390954960692*^9, 3.792136045313052*^9, 
  3.7930842112138777`*^9, 3.7933399599640493`*^9, 3.794985756143498*^9, 
  3.7949864031730747`*^9, 3.794988240882609*^9, 3.798871703350287*^9, 
  3.799333465688151*^9},
 CellLabel->
  "Out[353]=",ExpressionUUID->"79a76f0e-0e34-47c2-b068-f3e67122301a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Factor", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"X", "^", "73"}], "+", "1"}], ",", 
   RowBox[{"Modulus", "\[Rule]", "2"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.751011385214086*^9, 3.751011391649253*^9}, {
  3.782803104291566*^9, 3.782803106955323*^9}},
 CellLabel->
  "In[354]:=",ExpressionUUID->"d1c10f3e-7348-4a36-9b5b-bc8894a22131"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "+", "X"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", "X", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "2"], "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "4"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "3"], "+", 
    SuperscriptBox["X", "6"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["X", "5"], "+", 
    SuperscriptBox["X", "7"], "+", 
    SuperscriptBox["X", "8"], "+", 
    SuperscriptBox["X", "9"]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.7510113922871103`*^9, 3.751271327906665*^9, 3.751312608299254*^9, 
   3.751312663110134*^9, 3.7514521344280663`*^9, 3.751452190766704*^9, {
   3.751466079092428*^9, 3.751466134572135*^9}, 3.751653767261117*^9, 
   3.7516542573498898`*^9, 3.751794582347394*^9, 3.752332275154451*^9, 
   3.7523398658352137`*^9, 3.752390916665392*^9, 3.7525137501106052`*^9, 
   3.752513880374404*^9, 3.752513924061369*^9, 3.7525964811912537`*^9, 
   3.752841022360607*^9, 3.752841071070415*^9, 3.752845917786394*^9, 
   3.752846024708695*^9, 3.753267429246551*^9, 3.765797185208123*^9, 
   3.7657974075847197`*^9, 3.7658095262023153`*^9, 3.7756379101388073`*^9, 
   3.775663908680643*^9, 3.775719518883423*^9, 3.775723891908638*^9, 
   3.775894371781309*^9, 3.7759075362653437`*^9, 3.777029694453341*^9, 
   3.777188330784193*^9, 3.777567625663123*^9, 3.777568136135119*^9, 
   3.777568283161252*^9, 3.777620429100337*^9, 3.7821959790024567`*^9, 
   3.782196175017206*^9, 3.782197565436782*^9, 3.782197624674664*^9, 
   3.782197691818665*^9, 3.782208440422447*^9, 3.782232655277142*^9, 
   3.782233593064794*^9, 3.782235441457378*^9, 3.782321569366816*^9, 
   3.7824789716538887`*^9, 3.7825519480708113`*^9, 3.782803075037228*^9, 
   3.78280310727004*^9, 3.782812900634817*^9, 3.7828222110978737`*^9, 
   3.783084486681958*^9, 3.783096579704694*^9, 3.783097558488332*^9, 
   3.7831016563499537`*^9, 3.78318666391923*^9, 3.7834452294248257`*^9, 
   3.7838782618374557`*^9, 3.783929795343796*^9, 3.784214450766988*^9, 
   3.78421473099369*^9, 3.784214794303503*^9, 3.784390645830824*^9, 
   3.784390955066389*^9, 3.792136045466628*^9, 3.793084211387472*^9, 
   3.793339960102621*^9, 3.7949857562594357`*^9, 3.794986403318737*^9, 
   3.794988241058127*^9, 3.798871703451311*^9, 3.79933346580474*^9},
 CellLabel->
  "Out[354]=",ExpressionUUID->"361b2fa9-1905-4ebd-bf70-6e3df2ef5b64"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "/@", 
  RowBox[{"AllKeystreams", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "9"}], "}"}], ",", "9"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.782803131012496*^9, 3.782803148308592*^9}},
 CellLabel->
  "In[355]:=",ExpressionUUID->"0e888897-00fc-4bab-9551-aa7d447311fe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "73", ",", "73", ",", "73", ",", "73", ",", "73", ",", "73", ",", 
   "73"}], "}"}]], "Output",
 CellChangeTimes->{{3.782803140408019*^9, 3.782803149090726*^9}, 
   3.782812900979458*^9, 3.782822211281844*^9, 3.783084486979125*^9, 
   3.783096579873541*^9, 3.7830975586656437`*^9, 3.78310165654403*^9, 
   3.783186664089281*^9, 3.783445229589756*^9, 3.783878262017152*^9, 
   3.78392979551089*^9, 3.784214451074173*^9, 3.784214731249256*^9, 
   3.784214794500414*^9, 3.784390646012384*^9, 3.784390955312497*^9, 
   3.7921360456373034`*^9, 3.793084211557967*^9, 3.793339960304728*^9, 
   3.794985756426284*^9, 3.794986403487227*^9, 3.794988241239962*^9, 
   3.798871703618458*^9, 3.799333466053878*^9},
 CellLabel->
  "Out[355]=",ExpressionUUID->"c009c593-0a0e-48a3-8612-28caae12a1e6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Berlekamp\[Dash]Massey",
 FontWeight->"Bold"]], "Section",
 CellChangeTimes->{{3.752332325519305*^9, 3.7523323416011143`*^9}, {
  3.752339174918445*^9, 3.7523391908140306`*^9}, {3.752390563750856*^9, 
  3.752390568193513*^9}, {3.765797457645417*^9, 3.765797460252589*^9}, {
  3.7821961326488*^9, 3.782196133200783*^9}, {3.7822312397929363`*^9, 
  3.782231248755753*^9}, {3.78223178602243*^9, 
  3.78223179893256*^9}},ExpressionUUID->"e422bf2b-b8ce-47e4-9fe4-\
d5297b662e30"],

Cell[CellGroupData[{

Cell["\<\
The polynomial setup makes it no harder to work over an arbitrary field. For \
MT5462 we only need the default binary case. Examples below.\
\>", "Subsubsection",
 CellChangeTimes->{{3.7822318022452593`*^9, 
  3.782231830366042*^9}},ExpressionUUID->"aa6edde8-aa56-4595-b1fa-\
6cec381a29e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonZeroPositions", "[", "ks_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"#", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"ks", "[", 
          RowBox[{"[", 
           RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{
          RowBox[{"Length", "[", "ks", "]"}], "-", "1"}]}], "}"}]}], "]"}], 
     ",", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "==", "0"}], "]"}], "&"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.751650002515435*^9, 3.751650092657708*^9}, {
  3.752333706724646*^9, 3.752333713917204*^9}},
 CellLabel->
  "In[356]:=",ExpressionUUID->"8fb96835-a8ba-4a36-89dc-c1c96967b3b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FirstNonZeroPosition", "[", "ks_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ps", "=", 
      RowBox[{"NonZeroPositions", "[", "ks", "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"ps", "\[Equal]", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"Length", "[", "ks", "]"}], ",", 
      RowBox[{"ps", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751649912920952*^9, 3.751649930231793*^9}, {
  3.751650099752013*^9, 3.751650107651896*^9}, {3.7930850480156183`*^9, 
  3.79308506743097*^9}, {3.793085249794525*^9, 3.793085250513618*^9}},
 CellLabel->
  "In[357]:=",ExpressionUUID->"e1e8ec0f-5d1f-4f30-8db0-64fcc2becfe0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UMod", "[", 
   RowBox[{"x_", ",", "p_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"p", "\[Equal]", "0"}], ",", "x", ",", 
    RowBox[{"Mod", "[", 
     RowBox[{"x", ",", "p"}], "]"}]}], "]"}]}]], "Input",
 CellLabel->
  "In[358]:=",ExpressionUUID->"1d41eeb0-593c-4a30-b103-728d932b48e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyCoefficient", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "ln_", ",", "fn_"}], "}"}], ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"UMod", "[", 
   RowBox[{
    RowBox[{"Coefficient", "[", 
     RowBox[{
      RowBox[{"fn", "*", "k"}], ",", 
      RowBox[{"z", "^", "n"}]}], "]"}], ",", "p"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.752334362953464*^9, 3.7523343877118177`*^9}, 
   3.782232368095134*^9, 3.7822325800731907`*^9, {3.782235801531*^9, 
   3.782235809899138*^9}},
 CellLabel->
  "In[359]:=",ExpressionUUID->"16be062e-deb8-445d-a132-029d633b0117"]
}, Open  ]],

Cell["\<\
Here f[n] annihilates up to degree n-1 (so n terms) with an error polynomial \
of degree <= l[n]-1. The function above returns the the coefficient of z^n in \
the product k(x)f[n](x); step (a) applies if a[n] = 0 and otherwise step (b). \
\>", "Subsubsection",
 CellChangeTimes->{{3.752336928853725*^9, 3.752336982220385*^9}, {
   3.752391744447152*^9, 3.752391745917718*^9}, {3.765797448308237*^9, 
   3.765797455255322*^9}, {3.782196136337658*^9, 3.782196137208253*^9}, {
   3.782231867011601*^9, 3.782231894317239*^9}, {3.782232047690001*^9, 
   3.782232103339451*^9}, 3.782232372421342*^9, {3.7822328622634363`*^9, 
   3.782232864367063*^9}},ExpressionUUID->"31fa9d88-9649-4238-b56b-\
f5ca2fab3d0a"],

Cell[CellGroupData[{

Cell["\<\
Generally {m,lm,am,fm} records the polynomial wrong for position m, so am /= 0\
\>", "Subsubsection",
 CellChangeTimes->{{3.7822328719287243`*^9, 3.7822328910636587`*^9}, {
  3.782233202972496*^9, 
  3.782233205663671*^9}},ExpressionUUID->"362dbf31-0c23-45a8-891f-\
7ccce0422651"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NewPolynomial", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m_", ",", "am_", ",", "fm_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "an_", ",", "fn_"}], "}"}], ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"p", "\[Equal]", "0"}], ",", 
    RowBox[{
     RowBox[{"fn", "-", 
      RowBox[{
       RowBox[{"an", "/", "am"}], "*", 
       RowBox[{"z", "^", 
        RowBox[{"(", 
         RowBox[{"n", "-", "m"}], ")"}]}], "*", "fm"}]}], "//", "Expand"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"PolynomialMod", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"fn", "-", 
        RowBox[{"an", "*", 
         RowBox[{"PowerMod", "[", 
          RowBox[{"am", ",", 
           RowBox[{"-", "1"}], ",", "p"}], "]"}], "*", 
         RowBox[{"z", "^", 
          RowBox[{"(", 
           RowBox[{"n", "-", "m"}], ")"}]}], "*", "fm"}]}], "//", "Expand"}], 
      ",", "p"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7523906024239607`*^9, 3.75239063810842*^9}, {
   3.7523907177889547`*^9, 3.7523907317553883`*^9}, {3.782231904295219*^9, 
   3.782231941747551*^9}, 3.782232311016992*^9},
 CellLabel->
  "In[360]:=",ExpressionUUID->"f0848c0e-721b-4051-803a-1dcc34abb59c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyStepB1", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m_", ",", "lm_", ",", "am_", ",", "fm_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "ln_", ",", "an_", ",", "fn_"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"n", "+", "1", "-", "ln"}], ">", "ln"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"n", ",", "ln", ",", "an", ",", "fn"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", " ", 
        RowBox[{"n", "+", "1", "-", "ln"}], ",", 
        RowBox[{"NewPolynomial", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"m", ",", "am", ",", "fm"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "an", ",", "fn"}], "}"}], ",", "p"}], "]"}]}], 
       "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", " ", "ln", ",", " ", 
        RowBox[{"NewPolynomial", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"m", ",", "am", ",", "fm"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "an", ",", "fn"}], "}"}], ",", "p"}], "]"}]}], 
       "}"}]}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.7516497012982597`*^9, 3.751649796506403*^9}, 
   3.751650177868176*^9, {3.751650443603773*^9, 3.751650503263238*^9}, {
   3.751650819640543*^9, 3.7516508217626753`*^9}, {3.75233237400342*^9, 
   3.752332381114612*^9}, {3.7523329070688562`*^9, 3.752333022028185*^9}, {
   3.752334677131762*^9, 3.752334677657896*^9}, {3.752336122360785*^9, 
   3.752336122662675*^9}, {3.75233616402164*^9, 3.752336164344843*^9}, {
   3.752336298232521*^9, 3.752336300761218*^9}, {3.7523365513811398`*^9, 
   3.752336555024048*^9}, {3.7523393447796173`*^9, 3.752339348809272*^9}, {
   3.7523905750413837`*^9, 3.752390594214514*^9}, {3.75239076394421*^9, 
   3.752390780069318*^9}, {3.7822319540656843`*^9, 3.782231996723812*^9}, 
   3.782232586469324*^9},
 CellLabel->
  "In[361]:=",ExpressionUUID->"dff8af42-61e7-4c5e-8197-8b7dc876cd8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyStepB2", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m_", ",", "lm_", ",", "am_", ",", "fm_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"nPlus_", ",", "lnPlus_", ",", "fnPlus_"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"nPlus", ",", "lnPlus", ",", 
      RowBox[{"BerlekampMasseyCoefficient", "[", 
       RowBox[{"k", ",", 
        RowBox[{"{", 
         RowBox[{"nPlus", ",", "lnPlus", ",", "fnPlus"}], "}"}], ",", "p"}], 
       "]"}], ",", "fnPlus"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7523363059529133`*^9, 3.752336365777356*^9}, {
  3.752390790095914*^9, 3.752390809860668*^9}, {3.7523908497081537`*^9, 
  3.752390849869013*^9}, {3.782232003286261*^9, 3.7822320087389708`*^9}, {
  3.782232588656745*^9, 3.7822325977922297`*^9}, {3.782235543258089*^9, 
  3.7822355474863586`*^9}, {3.782235747100371*^9, 3.782235750160671*^9}, {
  3.782235790637257*^9, 3.782235796914569*^9}},
 CellLabel->
  "In[362]:=",ExpressionUUID->"bd6087a7-d8d7-4538-ad82-374212be3624"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyStepB", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m_", ",", "lm_", ",", "am_", ",", "fm_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "ln_", ",", "an_", ",", "fn_"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"p_:", "2"}]}], "]"}], " ", ":=", "\[IndentingNewLine]", 
  RowBox[{"BerlekampMasseyStepB2", "[", 
   RowBox[{"k", ",", 
    RowBox[{"BerlekampMasseyStepB1", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "ln", ",", "an", ",", "fn"}], "}"}]}], "}"}], ",", 
      "p"}], "]"}], ",", "p"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.752336377748569*^9, 3.7523364678908243`*^9}, {
  3.7523365199820557`*^9, 3.7523365277578917`*^9}, {3.752390796297969*^9, 
  3.7523908144785748`*^9}, {3.782232116130333*^9, 3.782232133804673*^9}, {
  3.782232473589528*^9, 3.782232473762742*^9}, {3.782232590186225*^9, 
  3.7822325950516663`*^9}, {3.782235786974904*^9, 3.7822357872257347`*^9}},
 CellLabel->
  "In[363]:=",ExpressionUUID->"86340e21-4680-4c7a-9e6b-5e044c766c62"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyInitialization", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"cs", " ", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"UMod", "[", 
          RowBox[{"#", ",", "p"}], "]"}], "&"}], "/@", 
        RowBox[{"CoefficientList", "[", 
         RowBox[{"k", ",", "z"}], "]"}]}]}], ",", "c"}], "}"}], ",", 
    RowBox[{
     RowBox[{"c", "=", 
      RowBox[{"FirstNonZeroPosition", "[", "cs", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"c", "\[Equal]", 
        RowBox[{"Length", "[", "cs", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"c", ",", "0", ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"c", "\[Equal]", "0"}], ",", 
             RowBox[{"k", "/.", 
              RowBox[{"{", 
               RowBox[{"z", "\[Rule]", "0"}], "}"}]}], ",", 
             RowBox[{"Coefficient", "[", 
              RowBox[{"k", ",", 
               RowBox[{"z", "^", "c"}]}], "]"}]}], "]"}], ",", "1"}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"c", "+", "1"}], ",", 
           RowBox[{"c", "+", "1"}], ",", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"k", ",", 
             RowBox[{"z", "^", 
              RowBox[{"(", 
               RowBox[{"c", "+", "1"}], ")"}]}]}], "]"}], ",", "1"}], "}"}]}],
         "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.75164989863043*^9, 3.7516499083671207`*^9}, {
   3.7516501134678917`*^9, 3.7516501557767467`*^9}, {3.751652048952251*^9, 
   3.751652049218564*^9}, {3.752333035630486*^9, 3.752333052437008*^9}, {
   3.752333336724835*^9, 3.752333339865662*^9}, {3.75233343203648*^9, 
   3.752333439037269*^9}, {3.752333619523185*^9, 3.752333636182431*^9}, 
   3.752334245247571*^9, {3.752337109931134*^9, 3.7523371125204353`*^9}, {
   3.752390820890847*^9, 3.752390825978825*^9}, {3.752391118225857*^9, 
   3.752391137790766*^9}, 3.7523911696243362`*^9, 3.7523917539438953`*^9, {
   3.752391874731368*^9, 3.7523918981620417`*^9}, {3.782232156639306*^9, 
   3.782232170836389*^9}, {3.782232321810411*^9, 3.782232322864743*^9}, 
   3.782232601799097*^9, {3.7930850950216503`*^9, 3.793085181994988*^9}, {
   3.79498916894125*^9, 3.794989220442128*^9}},
 CellLabel->
  "In[364]:=",ExpressionUUID->"fce32fe8-e173-4566-b910-74de02d4530b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyStep", "[", 
   RowBox[{"k_", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m_", ",", "lm_", ",", "am_", ",", "fm_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "ln_", ",", "an_", ",", "fn_"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"UMod", "[", 
      RowBox[{"an", ",", "p"}], "]"}], "\[Equal]", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"n", "+", "1"}], ",", "ln", ",", 
        RowBox[{"BerlekampMasseyCoefficient", "[", 
         RowBox[{"k", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"n", "+", "1"}], ",", "ln", ",", "fn"}], "}"}], ",", 
          "p"}], "]"}], ",", "fn"}], "}"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BerlekampMasseyStepB", "[", 
     RowBox[{"k", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "ln", ",", "an", ",", "fn"}], "}"}]}], "}"}], ",", 
      "p"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751650180661565*^9, 3.751650195299733*^9}, {
  3.7516502940356283`*^9, 3.75165042788526*^9}, {3.751650510627396*^9, 
  3.751650516420394*^9}, {3.751650815525271*^9, 3.7516508537498617`*^9}, {
  3.751652864478149*^9, 3.7516528657643633`*^9}, {3.752333088774541*^9, 
  3.7523331368419123`*^9}, {3.7523331751877947`*^9, 3.752333238675935*^9}, {
  3.7523344030120296`*^9, 3.752334408071766*^9}, {3.7523362055480547`*^9, 
  3.752336217123397*^9}, {3.752337481051214*^9, 3.752337481395981*^9}, {
  3.7523376776924458`*^9, 3.75233768651155*^9}, {3.752390837896806*^9, 
  3.7523908555577*^9}, {3.752391256863214*^9, 3.752391259084394*^9}, {
  3.7822321802729607`*^9, 3.782232198151528*^9}, {3.7822326061871977`*^9, 
  3.782232610075963*^9}, {3.7822358609301977`*^9, 3.7822358858463573`*^9}},
 CellLabel->
  "In[365]:=",ExpressionUUID->"b33a8328-c147-4475-a086-002375ae7738"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFrom", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k_", ",", "nMax_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m_", ",", "lm_", ",", "am_", ",", "fm_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "ln_", ",", "an_", ",", "fn_"}], "}"}]}], "}"}], 
    ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"n", ">=", "nMax"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "ln", ",", "0", ",", "fn"}], "}"}]}], "}"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"n", ",", "ln", ",", "an", ",", "fn"}], "}"}]}], "}"}], 
      "}"}], "~", "Join", "~", 
     RowBox[{"BerlekampMasseyFrom", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"k", ",", "nMax"}], "}"}], ",", 
       RowBox[{"BerlekampMasseyStep", "[", 
        RowBox[{"k", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"m", ",", "lm", ",", "am", ",", "fm"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "ln", ",", "an", ",", "fn"}], "}"}]}], "}"}], 
         ",", "p"}], "]"}], ",", "p"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751651119293689*^9, 3.751651166007679*^9}, {
   3.751651213961755*^9, 3.7516513158427277`*^9}, {3.7516522978182287`*^9, 
   3.751652298026822*^9}, {3.751652924487754*^9, 3.751652926282454*^9}, {
   3.752335964479961*^9, 3.752335974740479*^9}, {3.7523360374307823`*^9, 
   3.7523360882374372`*^9}, {3.752336276631755*^9, 3.7523362772875137`*^9}, {
   3.7523374287203836`*^9, 3.752337446839922*^9}, {3.752337752837285*^9, 
   3.752337757976179*^9}, {3.7523908595420523`*^9, 3.752390867560858*^9}, {
   3.782232203870521*^9, 3.782232230441223*^9}, {3.78223261188161*^9, 
   3.782232616668483*^9}, {3.782234023819538*^9, 3.782234024093569*^9}, {
   3.782235925226528*^9, 3.782235939617998*^9}, 3.782552317138036*^9},
 CellLabel->
  "In[366]:=",ExpressionUUID->"5212550a-bc03-450f-892a-5e5918d23cfe"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functions on keystreams", "Subsubsection",
 CellChangeTimes->{{3.782233209510668*^9, 
  3.78223321176759*^9}},ExpressionUUID->"efd95474-370d-4100-b253-\
f92e4f0283ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFull", "[", 
   RowBox[{"ks_", ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k", "=", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ks", "[", 
          RowBox[{"[", 
           RowBox[{"r", "+", "1"}], "]"}], "]"}], "*", 
         RowBox[{"z", "^", "r"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"r", ",", "0", ",", 
          RowBox[{
           RowBox[{"Length", "[", "ks", "]"}], "-", "1"}]}], "}"}]}], "]"}]}],
      "}"}], ",", 
    RowBox[{"BerlekampMasseyFrom", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "ks", "]"}]}], "}"}], ",", 
      RowBox[{"BerlekampMasseyInitialization", "[", 
       RowBox[{"k", ",", "p"}], "]"}], ",", "p"}], "]"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.7516529525974216`*^9, 3.751652965732273*^9}, {
  3.751653257588758*^9, 3.751653258052864*^9}, {3.752337779413207*^9, 
  3.75233785206213*^9}, {3.752338074477783*^9, 3.752338075232025*^9}, {
  3.752338111109447*^9, 3.7523381182466516`*^9}, {3.752338218619179*^9, 
  3.75233825322606*^9}, {3.752390869236053*^9, 3.7523908727716417`*^9}, {
  3.752391148660419*^9, 3.752391149065063*^9}, {3.782232236225967*^9, 
  3.7822322558463*^9}, {3.782232618607348*^9, 3.782232623645382*^9}, {
  3.7822331819686823`*^9, 3.7822331839779863`*^9}, {3.782235916906321*^9, 
  3.7822359223489227`*^9}, {3.794988897341861*^9, 3.794988897622651*^9}, {
  3.7949889402675323`*^9, 3.794988940425585*^9}},
 CellLabel->
  "In[367]:=",ExpressionUUID->"1e6ba31b-82ba-428c-b0ea-fb9308ac4c24"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMassey", "[", 
   RowBox[{"ks_", ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"r", "=", 
      RowBox[{"BerlekampMasseyFull", "[", 
       RowBox[{"ks", ",", "p"}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"r", "[", 
      RowBox[{"[", 
       RowBox[{"Length", "[", "r", "]"}], "]"}], "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.751653254533366*^9, 3.751653294971097*^9}, {
  3.752337783993746*^9, 3.752337793842766*^9}, {3.752338910021162*^9, 
  3.752338932376711*^9}, {3.7523908746954813`*^9, 3.752390879248081*^9}, {
  3.782232267871241*^9, 3.7822322747804728`*^9}, {3.782232625078946*^9, 
  3.7822326271677027`*^9}},
 CellLabel->
  "In[368]:=",ExpressionUUID->"dc9d3ed0-c5cc-41a8-b63d-47f45679684c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LinearComplexity", "[", 
   RowBox[{"ks_", ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"AllZero", "[", "ks", "]"}], ",", "0", ",", 
    RowBox[{
     RowBox[{"BerlekampMassey", "[", 
      RowBox[{"ks", ",", "p"}], "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.783444281985515*^9, 3.7834442861907597`*^9}, {
   3.783444354775078*^9, 3.783444364405243*^9}, 3.7834445888195267`*^9, {
   3.783444727932028*^9, 3.783444776253016*^9}},
 CellLabel->
  "In[369]:=",ExpressionUUID->"95ca7819-ae7e-4039-a76d-1d07d10d54d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LinearComplexities", "[", 
   RowBox[{"ks_", ",", 
    RowBox[{"p_:", "2"}]}], "]"}], ":=", 
  RowBox[{"LinearComplexity", "/@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ks", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "r"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "1", ",", 
       RowBox[{"Length", "[", "ks", "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.783444531373008*^9, 3.783444556879529*^9}, 
   3.783444591658235*^9, {3.783444930397793*^9, 3.783444944623644*^9}},
 CellLabel->
  "In[370]:=",ExpressionUUID->"daec97f8-75ad-4993-bbe7-28b08c698539"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Small example: twice Fibonacci sequence: try changing an early term, or the \
characteristic (change final argument from 0 to an odd prime)\
\>", "Subsection",
 CellChangeTimes->{{3.752333251316822*^9, 3.752333264529133*^9}, {
  3.75233922996511*^9, 3.752339255962248*^9}, {3.7523393023046913`*^9, 
  3.7523393054892282`*^9}, {3.752339508020232*^9, 3.75233951316853*^9}, {
  3.752391319420129*^9, 3.752391348219511*^9}, {3.7825522416457853`*^9, 
  3.782552241973096*^9}},ExpressionUUID->"9b587d4c-6bf0-49c8-90da-\
d7ee9a2721a9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"fs", ":=", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", 
     "13", ",", "21", ",", "34", ",", "55", ",", "89", ",", "144"}], "}"}]}], 
  ";", 
  RowBox[{"ksTest", ":=", 
   RowBox[{"2", "*", "fs"}]}], ";", "ksTest"}]], "Input",
 CellChangeTimes->{{3.7523393725976543`*^9, 3.752339395251773*^9}, {
  3.752339445345941*^9, 3.7523394457879677`*^9}, {3.752391476950235*^9, 
  3.752391480634864*^9}},
 CellLabel->
  "In[371]:=",ExpressionUUID->"b47b917d-4cb0-4ef4-90cf-31aa9716b587"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "2", ",", "2", ",", "4", ",", "6", ",", "10", ",", "16", ",", 
   "26", ",", "42", ",", "68", ",", "110", ",", "178", ",", "288"}], 
  "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJwVy11IkwEUxvEVerGKLmdtOl1OnWa5xSu9JNJObSNrDbIudKSlc0rOvpRM
GUST0EvRoMkUFuI3ocaGZAUWJVqErKEg7KIFwxvPEiRfX2tJ51w8/OCBv67+
fqX7gEKhMNOmja1y2s4mqKVP++zYb4+QTj5rCum05ImRqUbWo/lR7CRfzckm
trLR7esiVYaWrT3S8SvgTJG3Coq0X6VNeJkct84eRfCsBY1z5Eq0R3ikQ7hd
bdnwkaXxO8YgafMH722TFvNwTCZDcdeXTD1CWrvnfDMpJJracvMQJiqqQuyx
afzMzu7WlpWTkqGjfvcUgn6rzstmqhsKZfLGTlsJOyL2nmXX9OrH/0iLf0Gj
PE390tuTrLlcdZl1rJYtsP391rFD5LXuc2GBFP09vT7+E0OmUVKpfBDJLkHQ
rI8O6ckXdQ8NhWTLTEKcJJ2urpwZ0vs8FmBz7TmDr8mJJ0eyYuQbmK+pNiKs
uuMrxSaE4USnbCW/+e9KEfLS377j38lwUZWO9bYv7+efQbhub80rICXb+ySa
EbTRzo13FxBMGaol8SLCR3HAddOG8CG/I8z+FEoDNeTTyMEk261O32bnD/+J
Ll5FSGUtXxl3IPwHsW79FA==
  "],
 CellLabel->
  "Out[371]=",ExpressionUUID->"b005fd96-4baa-4c71-8396-60255222fc99"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFull", "[", 
   RowBox[{"ksTest", ",", "0"}], "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7825522539485397`*^9, 3.782552260970316*^9}},
 CellLabel->
  "In[372]:=",ExpressionUUID->"a5074edd-9c32-43ac-9c2c-fdb5621ac1e9"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "2", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "2", ",", 
       RowBox[{"1", "-", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"11", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"12", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"13", ",", "2", ",", "0", ",", 
       RowBox[{"1", "-", "z", "-", 
        SuperscriptBox["z", "2"]}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.782552261534034*^9, 3.782552320273172*^9, 
  3.782803075593421*^9, 3.782812901317102*^9, 3.782822211695107*^9, 
  3.7830844872265053`*^9, 3.783096580195792*^9, 3.783097558975156*^9, 
  3.783101657208251*^9, 3.783186664518284*^9, 3.7834443089113398`*^9, 
  3.783445229924717*^9, 3.7838782631824093`*^9, 3.783929795909329*^9, 
  3.78421445156384*^9, 3.7842147327058*^9, 3.784214794892599*^9, 
  3.784390646372213*^9, 3.784390955665065*^9, 3.792136046002493*^9, 
  3.793084211919197*^9, 3.7930851863909807`*^9, 3.793085272668996*^9, 
  3.793339960815174*^9, 3.7949857568771877`*^9, 3.7949864038581543`*^9, 
  3.7949882418220797`*^9, 3.794988905518445*^9, 3.794988944888785*^9, 
  3.7949892704466143`*^9, 3.798871703917365*^9, 3.799333470359647*^9},
 CellLabel->
  "Out[372]//TableForm=",ExpressionUUID->"1519fec6-c83b-4031-86de-\
bab7b3d582d5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example: number of regions made by joining up all pairs of n points around \
the circle\
\>", "Subsection",
 CellChangeTimes->{{3.7822165188984127`*^9, 3.782216544428063*^9}, {
  3.7822166365812263`*^9, 
  3.782216637712323*^9}},ExpressionUUID->"55998dc9-741a-4816-bb91-\
7b45f1a6bad4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BerlekampMassey", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "4", ",", "8", ",", "16", ",", "31", ",", "57", ",", 
     "99", ",", "163", ",", "256", ",", "386"}], "}"}], ",", "0"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.782216425926345*^9, 3.782216472202725*^9}, {
  3.78223323279895*^9, 3.78223324949512*^9}, {3.7822340396162*^9, 
  3.7822340404509974`*^9}},
 CellLabel->
  "In[373]:=",ExpressionUUID->"b57247b7-ab2e-4249-9f5a-612a9c665b38"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"11", ",", "5", ",", "0", ",", 
   RowBox[{"1", "-", 
    RowBox[{"5", " ", "z"}], "+", 
    RowBox[{"10", " ", 
     SuperscriptBox["z", "2"]}], "-", 
    RowBox[{"10", " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"5", " ", 
     SuperscriptBox["z", "4"]}], "-", 
    SuperscriptBox["z", "5"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.782216448955621*^9, 3.782216472661875*^9}, 
   3.782232656986269*^9, {3.782233234628312*^9, 3.782233249826366*^9}, 
   3.782233594315181*^9, {3.78223403325904*^9, 3.782234040746703*^9}, 
   3.782235442572178*^9, 3.7822358988769493`*^9, 3.782235950748891*^9, 
   3.782321570132244*^9, 3.782478972645277*^9, 3.782551949255129*^9, 
   3.782803075697916*^9, 3.78281290145077*^9, 3.7828222118644753`*^9, 
   3.783084487332527*^9, 3.783096580311739*^9, 3.783097559090538*^9, 
   3.78310165740844*^9, 3.783186664651471*^9, 3.783445230039439*^9, 
   3.7838782634664917`*^9, 3.783929796051991*^9, 3.784214451709745*^9, 
   3.784214732833869*^9, 3.7842147950452747`*^9, 3.784390646526985*^9, 
   3.7843909557661543`*^9, 3.792136046118784*^9, 3.7930842120284643`*^9, 
   3.793339960963702*^9, 3.794985757009554*^9, 3.7949864039571953`*^9, 
   3.794988242227565*^9, 3.794989273134156*^9, 3.798871704016388*^9, 
   3.799333470456978*^9},
 CellLabel->
  "Out[373]=",ExpressionUUID->"6cfcf78d-5c1c-4802-a41e-a86313665d5a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"5", ",", 
     RowBox[{"-", "10"}], ",", "10", ",", 
     RowBox[{"-", "5"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4", ",", "8", ",", "16", ",", "31"}], "}"}], 
   ",", "15", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.782216476495455*^9, 3.782216514362814*^9}, {
  3.7822166295662937`*^9, 3.782216632857191*^9}},
 CellLabel->
  "In[374]:=",ExpressionUUID->"feb7b596-63c8-477a-8390-fde9bf1662b6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "4", ",", "8", ",", "16", ",", "31", ",", "57", ",", 
   "99", ",", "163", ",", "256", ",", "386", ",", "562", ",", "794", ",", 
   "1093", ",", "1471"}], "}"}]], "Output",
 CellChangeTimes->{{3.7822164930782824`*^9, 3.782216514706202*^9}, {
   3.7822166275303164`*^9, 3.782216633300942*^9}, 3.78223265709693*^9, 
   3.782233594519677*^9, 3.782234042974218*^9, 3.7822354427052526`*^9, 
   3.782235899653174*^9, 3.7822359514467897`*^9, 3.782321570263588*^9, 
   3.782478972771393*^9, 3.782551949372785*^9, 3.7828030757945013`*^9, 
   3.7828129015834417`*^9, 3.7828222121809607`*^9, 3.783084487432225*^9, 
   3.783096580429179*^9, 3.783097559223447*^9, 3.78310165760806*^9, 
   3.783186664783689*^9, 3.783445230155932*^9, 3.783878264570801*^9, 
   3.783929796151392*^9, 3.784214451939599*^9, 3.784214732966412*^9, 
   3.784214795186078*^9, 3.784390646825138*^9, 3.784390955866081*^9, 
   3.7921360462316227`*^9, 3.7930842121580772`*^9, 3.793339961103037*^9, 
   3.794985757125279*^9, 3.79498640405361*^9, 3.794988242567687*^9, 
   3.794989273960185*^9, 3.798871704117491*^9, 3.7993334706541853`*^9},
 CellLabel->
  "Out[374]=",ExpressionUUID->"a52b984c-988b-438d-8673-a7ed1cc16661"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check works on zero keystream and an edgy-case", "Subsection",
 CellChangeTimes->{{3.793085278958521*^9, 3.793085284559754*^9}, {
  3.794989279996726*^9, 
  3.79498928607067*^9}},ExpressionUUID->"010de687-446e-4b41-8313-\
cfc3f6103c9b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"BerlekampMassey", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
    "]"}], ",", 
   RowBox[{"BerlekampMassey", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], 
    "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.793085285460169*^9, 3.793085316427621*^9}, {
  3.794989287126836*^9, 3.7949892957509527`*^9}},
 CellLabel->
  "In[375]:=",ExpressionUUID->"f2a797ce-0f2c-433d-acfe-5ec5a5d76a5e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "3", ",", "0", ",", 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.793085304384624*^9, 3.793085316703005*^9}, 
   3.7933399612276173`*^9, 3.794985757246257*^9, 3.794986404156279*^9, 
   3.7949882427242737`*^9, {3.794989276610394*^9, 3.794989296097651*^9}, 
   3.798871704216798*^9, 3.799333470775025*^9},
 CellLabel->
  "Out[375]=",ExpressionUUID->"f11189f8-12fa-4f08-916b-93298fc85f28"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Problem Sheet 5 Question 4", "Subsection",
 CellChangeTimes->{{3.782639826006694*^9, 
  3.782639828612968*^9}},ExpressionUUID->"53db41a3-7c6e-4ed5-8a3e-\
1a9cad481c43"],

Cell[CellGroupData[{

Cell[BoxData["usQ4"], "Input",
 CellChangeTimes->{{3.782639829249552*^9, 3.782639829854929*^9}},
 CellLabel->
  "In[376]:=",ExpressionUUID->"e85dfd36-fccb-498d-b3b9-e6c73a7aeebb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
   "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", 
   ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", 
   ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.782639830606385*^9, 3.782803075895969*^9, 
  3.782812901717415*^9, 3.782822212614202*^9, 3.783084487533197*^9, 
  3.783096580546933*^9, 3.783097559340082*^9, 3.783101657981634*^9, 
  3.783186664919116*^9, 3.783445230272894*^9, 3.783878264833507*^9, 
  3.783929796253577*^9, 3.7842144521997538`*^9, 3.784214733099003*^9, 
  3.784214795334247*^9, 3.7843906469873247`*^9, 3.784390955966053*^9, 
  3.7921360463470783`*^9, 3.7930842122610683`*^9, 3.793339961363482*^9, 
  3.7949857573615503`*^9, 3.7949864042581663`*^9, 3.7949882428783817`*^9, 
  3.794989299404661*^9, 3.7988717043177843`*^9, 3.799333470896346*^9},
 CellLabel->
  "Out[376]=",ExpressionUUID->"0dc802cc-2a71-49c2-9655-1a708bf93612"]
}, Open  ]],

Cell[CellGroupData[{

Cell["First 13 entries used for M.Sc. Example 5.4", "Subsubsection",
 CellChangeTimes->{{3.782723289165464*^9, 
  3.782723307464465*^9}},ExpressionUUID->"7e9df92a-2406-46ff-bf2f-\
1f31b5a33a45"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"usQ4", "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", "13"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.782721556573257*^9, 3.7827215595120707`*^9}},
 CellLabel->
  "In[377]:=",ExpressionUUID->"04b1ab9e-079d-4825-9a2b-e6bc3c449975"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.782721559822988*^9, 3.782803075994026*^9, 
  3.7828129018625927`*^9, 3.782822213166478*^9, 3.78308448763494*^9, 
  3.78309658068427*^9, 3.783097559470912*^9, 3.783101658175003*^9, 
  3.783186665069376*^9, 3.783445230388752*^9, 3.783878265165913*^9, 
  3.7839297963609324`*^9, 3.784214452467379*^9, 3.784214733235956*^9, 
  3.7842147954761553`*^9, 3.784390647152851*^9, 3.784390956066023*^9, 
  3.792136046769375*^9, 3.793084212423407*^9, 3.793339961498578*^9, 
  3.794985757478258*^9, 3.7949864044024973`*^9, 3.7949882430438128`*^9, 
  3.794989300863455*^9, 3.798871704416885*^9, 3.799333471008108*^9},
 CellLabel->
  "Out[377]=",ExpressionUUID->"b7c866de-18d7-47bf-8cfa-8e96b9fef373"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFull", "[", 
   RowBox[{"usQ4", "[", 
    RowBox[{"[", 
     RowBox[{"1", ";;", "20"}], "]"}], "]"}], "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.782639832104043*^9, 3.782639850123904*^9}},
 CellLabel->
  "In[378]:=",ExpressionUUID->"e4986900-e8cb-444e-84d7-3106f4d9888a"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "3", ",", "1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"11", ",", "6", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"13", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"14", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"15", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"16", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"17", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"18", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"19", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"12", ",", "6", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"20", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.782728189591096*^9, 3.78280307609385*^9, 
  3.782812902000326*^9, 3.7828222134632053`*^9, 3.7830844877331038`*^9, 
  3.7830965808035107`*^9, 3.7830975595903063`*^9, 3.783101658381823*^9, 
  3.7831866651985607`*^9, 3.783445230497179*^9, 3.7838782657070208`*^9, 
  3.783929796467094*^9, 3.7842144526952868`*^9, 3.784214733702389*^9, 
  3.7842147956021643`*^9, 3.784390647281579*^9, 3.784390956165317*^9, 
  3.792136047038001*^9, 3.793084212528386*^9, 3.793339961705575*^9, 
  3.794985757622122*^9, 3.794986404507238*^9, 3.7949882431957617`*^9, 
  3.79498930415849*^9, 3.798871704519153*^9, 3.7993334711249*^9},
 CellLabel->
  "Out[378]//TableForm=",ExpressionUUID->"f758dce9-a916-4214-b847-\
d8279b25d030"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"0", ",", "29"}], "]"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
       ",", "30"}], "]"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", "30"}], "]"}],
     ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
       ",", "30"}], "]"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "3", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
       ",", "30"}], "]"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "4", ",", "5", ",", "7"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
       "}"}], ",", "30"}], "]"}], ",", 
    RowBox[{"usQ4", "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "30"}], "]"}], "]"}]}], "}"}], "//", "TF"}]], "Input",\

 CellChangeTimes->{{3.7826402545658903`*^9, 3.782640278028173*^9}, {
  3.78264048152472*^9, 3.78264048159805*^9}, {3.782654486435279*^9, 
  3.782654575295072*^9}},
 CellLabel->
  "In[379]:=",ExpressionUUID->"25521fe2-c065-4810-85f3-08de1751cf06"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13",
      "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", 
     "26", "27", "28", "29"},
    {"0", "0", "1", "1", "1", "1", "0", "1", "0", "0", "1", "1", "1", "0", 
     "1", "0", "0", "1", "1", "1", "0", "1", "0", "0", "1", "1", "1", "0", 
     "1", "0"},
    {"0", "0", "1", "1", "1", "1", "0", "1", "0", "1", "1", "0", "0", "1", 
     "0", "0", "0", "1", "1", "1", "1", "0", "1", "0", "1", "1", "0", "0", 
     "1", "0"},
    {"0", "0", "1", "1", "1", "1", "0", "1", "0", "0", "1", "1", "1", "0", 
     "1", "0", "0", "1", "1", "1", "0", "1", "0", "0", "1", "1", "1", "0", 
     "1", "0"},
    {"0", "0", "1", "1", "1", "1", "0", "1", "0", "0", "0", "0", "1", "0", 
     "1", "1", "1", "1", "0", "1", "0", "0", "0", "0", "1", "0", "1", "1", 
     "1", "1"},
    {"0", "0", "1", "1", "1", "1", "0", "1", "0", "0", "0", "0", "0", "0", 
     "1", "0", "1", "0", "0", "1", "1", "1", "1", "1", "1", "1", "0", "0", 
     "1", "1"},
    {"0", "0", "1", "1", "1", "1", "0", "1", "0", "0", "0", "0", "0", "0", 
     "1", "0", "1", "0", "0", "1", "1", "1", "1", "1", "1", "1", "0", "0", 
     "1", "1"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.782640272017058*^9, 3.782640278322041*^9}, 
   3.782640481972081*^9, {3.7826545357270613`*^9, 3.7826545756843653`*^9}, 
   3.782803076193461*^9, 3.7828129021341667`*^9, 3.782822213749048*^9, 
   3.783084487847466*^9, 3.783096580921176*^9, 3.78309755972328*^9, 
   3.78310165857591*^9, 3.783186665353178*^9, 3.783445230607415*^9, 
   3.783878267021735*^9, 3.78392979657749*^9, 3.784214452840806*^9, 
   3.784214734153679*^9, 3.784214795764853*^9, 3.7843906473814783`*^9, 
   3.784390956305256*^9, 3.792136047296974*^9, 3.793084212628183*^9, 
   3.7933399618461447`*^9, 3.794985757744589*^9, 3.794986404606193*^9, 
   3.794988243343869*^9, 3.798871704617899*^9, 3.799333471241482*^9},
 CellLabel->
  "Out[379]//TableForm=",ExpressionUUID->"6e4cb5d7-c7a2-4a1c-a8a9-\
c88374ef4477"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Geffe generator (Example 8.3 and 5.2 in M.Sc. Notes)", "Subsection",
 CellChangeTimes->{{3.782641141598363*^9, 3.7826411513028173`*^9}, {
  3.798872723100851*^9, 
  3.798872729432167*^9}},ExpressionUUID->"73d0086e-cae7-416c-ba6b-\
1a6696182e9a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"usGeffe", "[", "30", "]"}]], "Input",
 CellChangeTimes->{{3.782641128337492*^9, 3.782641128448409*^9}, {
  3.782641717626793*^9, 3.7826417191105003`*^9}},
 CellLabel->
  "In[380]:=",ExpressionUUID->"3e7b6814-4a45-4941-9585-f412b3f16267"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.782641128676227*^9, 3.7826411541257467`*^9}, {
   3.782641719456005*^9, 3.782641741006196*^9}, 3.782803076400832*^9, 
   3.782812902370305*^9, 3.7828130244407663`*^9, 3.782822214315421*^9, 
   3.7830844879510307`*^9, 3.783096581045224*^9, 3.7830975598401117`*^9, 
   3.7831016587628393`*^9, 3.7831866655678053`*^9, 3.783445230723731*^9, 
   3.783878267447249*^9, 3.783929796680279*^9, 3.784214452981661*^9, 
   3.7842147344994802`*^9, 3.7842147958857737`*^9, 3.7843906476093693`*^9, 
   3.784390956409111*^9, 3.792136047407608*^9, 3.793084212730904*^9, 
   3.793339962001459*^9, 3.794985757861017*^9, 3.794986404708242*^9, 
   3.794988243495038*^9, 3.7988717047203913`*^9, 3.799333471509015*^9},
 CellLabel->
  "Out[380]=",ExpressionUUID->"1065901f-74a8-4aaa-97a3-7c1b82df76e7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFull", "[", 
   RowBox[{"usGeffe", "[", "30", "]"}], "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7826411641663437`*^9, 3.7826411643295383`*^9}, {
  3.7826418143842773`*^9, 3.782641820581153*^9}},
 CellLabel->
  "In[381]:=",ExpressionUUID->"dcc72ea0-fdda-4448-8f29-e3c79fcd656d"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "5", ",", "1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"11", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"12", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"13", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"13", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"14", ",", "9", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"13", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"15", ",", "9", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"13", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"16", ",", "9", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"13", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"17", ",", "9", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"13", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"18", ",", "9", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"18", ",", "9", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"19", ",", "10", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"18", ",", "9", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"20", ",", "10", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"20", ",", "10", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"21", ",", "11", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"20", ",", "10", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"22", ",", "11", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"22", ",", "11", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"23", ",", "12", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"22", ",", "11", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"24", ",", "12", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"22", ",", "11", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"25", ",", "12", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"25", ",", "12", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"26", ",", "14", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "12"], "+", 
        SuperscriptBox["z", "13"], "+", 
        SuperscriptBox["z", "14"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"25", ",", "12", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"27", ",", "14", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "13"], "+", 
        SuperscriptBox["z", "14"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"25", ",", "12", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "11"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"28", ",", "14", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"], "+", 
        SuperscriptBox["z", "14"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"28", ",", "14", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"], "+", 
        SuperscriptBox["z", "14"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"29", ",", "15", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"], "+", 
        SuperscriptBox["z", "12"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"28", ",", "14", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"], "+", 
        SuperscriptBox["z", "14"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"30", ",", "15", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "7"], "+", 
        SuperscriptBox["z", "8"], "+", 
        SuperscriptBox["z", "9"], "+", 
        SuperscriptBox["z", "10"], "+", 
        SuperscriptBox["z", "11"], "+", 
        SuperscriptBox["z", "12"]}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.782641164690978*^9, 3.782641821601088*^9, 
  3.782803076758423*^9, 3.782812902782543*^9, 3.782813025710403*^9, 
  3.7828222146138372`*^9, 3.78308448804705*^9, 3.783096581170635*^9, 
  3.7830975599583282`*^9, 3.7831016590580072`*^9, 3.783186665699448*^9, 
  3.78344523082542*^9, 3.7838782675721817`*^9, 3.783929796787202*^9, 
  3.784214453339355*^9, 3.784214735101871*^9, 3.784214796011713*^9, 
  3.784390647893396*^9, 3.784390956526372*^9, 3.792136047595768*^9, 
  3.793084212834606*^9, 3.793339962147818*^9, 3.794985757977652*^9, 
  3.794986404808978*^9, 3.794988243639974*^9, 3.798871704898664*^9, 
  3.799333471739215*^9},
 CellLabel->
  "Out[381]//TableForm=",ExpressionUUID->"6193b402-e3c6-4d5c-9c7a-\
e64959953da2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example 5.8 in M.Sc. notes", "Subsection",
 CellChangeTimes->{{3.783325237335767*^9, 
  3.783325244511092*^9}},ExpressionUUID->"ee3a3bcc-aae6-46a2-a6e6-\
d7517207175e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFull", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0",
      ",", "0", ",", "0", ",", "1"}], "}"}], "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7833252455483828`*^9, 3.7833252893039827`*^9}, {
  3.78332539334002*^9, 3.783325426742279*^9}},
 CellLabel->
  "In[382]:=",ExpressionUUID->"68b0f41f-3d61-4e06-9214-012d9723092e"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "1", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "3"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"8", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "5", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"8", ",", "4", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"10", ",", "5", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"11", ",", "6", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "5"]}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.783325256079213*^9, 3.7833252905594*^9}, {
   3.783325394127804*^9, 3.783325427079783*^9}, 3.783445230953641*^9, 
   3.783878267688272*^9, 3.7839297968863688`*^9, 3.7842144536373997`*^9, 
   3.784214735385578*^9, 3.784214796186617*^9, 3.784390648049088*^9, 
   3.7843909566435757`*^9, 3.792136047703698*^9, 3.793084212948401*^9, 
   3.793339962297348*^9, 3.794985758093535*^9, 3.7949864049239883`*^9, 
   3.794988243772832*^9, 3.7988717050015182`*^9, 3.799333471864669*^9},
 CellLabel->
  "Out[382]//TableForm=",ExpressionUUID->"d1f0f5a6-9e10-4496-b773-\
16e875df5235"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Problem Sheet 6 Question 3",
 FontWeight->"Bold"]], "Subsection",
 CellChangeTimes->{{3.7516507543928823`*^9, 3.7516507634795*^9}, {
   3.751653192898158*^9, 3.751653225344503*^9}, 3.751794245907179*^9, {
   3.752391416567224*^9, 3.752391420937289*^9}, 3.782196225253193*^9, {
   3.782817949275733*^9, 
   3.782817950395465*^9}},ExpressionUUID->"538771cf-5812-4a69-9704-\
13a355769e77"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BerlekampMasseyFull", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1",
      ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
    "}"}], "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7516513291704607`*^9, 3.751651340394039*^9}, {
  3.751652307097785*^9, 3.751652307677692*^9}, {3.7516524034781923`*^9, 
  3.751652403568963*^9}, {3.751652976115652*^9, 3.751652981338553*^9}, {
  3.751653274566091*^9, 3.751653275026037*^9}, {3.752391425147889*^9, 
  3.7523914283935823`*^9}, {3.782233222306172*^9, 3.782233228604355*^9}, {
  3.782235599932002*^9, 3.782235607469349*^9}, {3.7828134232945747`*^9, 
  3.782813423452236*^9}},
 CellLabel->
  "In[383]:=",ExpressionUUID->"9b2d9eb4-154a-4d65-95f0-56599efc7b41"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "3", ",", "0", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"]}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"11", ",", "7", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"12", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"13", ",", "7", ",", "1", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "5"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"14", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "3", ",", "1", ",", 
       RowBox[{"1", "+", "z"}]}], "}"}], 
     RowBox[{"{", 
      RowBox[{"15", ",", "7", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"], "+", 
        SuperscriptBox["z", "6"], "+", 
        SuperscriptBox["z", "7"]}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.751794228605109*^9, 3.751794583421076*^9, 3.752332275862113*^9, 
   3.7523398665877867`*^9, 3.752390917469139*^9, 3.752391459945539*^9, 
   3.752391917371161*^9, 3.752513895153706*^9, 3.752513935901885*^9, 
   3.752596491259843*^9, 3.75284108352159*^9, 3.75284603701684*^9, 
   3.753267441690523*^9, 3.765797421342463*^9, 3.765809541057291*^9, 
   3.775637924412067*^9, 3.775663922315763*^9, 3.775723907509984*^9, 
   3.7758943891992283`*^9, 3.775907549237639*^9, 3.777029707306552*^9, 
   3.7771883475361547`*^9, 3.777567643791835*^9, 3.7775681549634447`*^9, 
   3.7775682955296707`*^9, 3.777620443117341*^9, 3.7821959879413557`*^9, 
   3.782196187279479*^9, 3.782196220816832*^9, 3.782197579336788*^9, 
   3.7821976277797737`*^9, 3.78219769266434*^9, 3.782208441016189*^9, 
   3.782232656848749*^9, {3.782233224513954*^9, 3.7822332290556917`*^9}, 
   3.782233594174863*^9, 3.782235442421893*^9, {3.782235592968688*^9, 
   3.78223560789327*^9}, 3.782235821447089*^9, 3.782235894304489*^9, 
   3.7822359476536217`*^9, 3.782321570031111*^9, 3.782478972509489*^9, 
   3.782551949135099*^9, 3.7828030768828793`*^9, 3.782812903011306*^9, 
   3.7828134240311527`*^9, 3.782822214875538*^9, 3.7830844881506777`*^9, 
   3.783096581287099*^9, 3.7830975600905857`*^9, 3.783101659260819*^9, 
   3.7831866658325872`*^9, 3.783445231060767*^9, 3.7838782678017883`*^9, 
   3.7839297969833508`*^9, 3.784214453825355*^9, 3.784214735685753*^9, 
   3.784214796326784*^9, 3.784390648182424*^9, 3.7843909567771597`*^9, 
   3.792136047812718*^9, 3.793084213049659*^9, 3.7933399624306707`*^9, 
   3.7949857582113037`*^9, 3.794986405021364*^9, 3.794988243906741*^9, 
   3.798871705103136*^9, 3.7993334720169983`*^9},
 CellLabel->
  "Out[383]//TableForm=",ExpressionUUID->"c827695f-cdec-4e2b-9cbd-\
65ed57177e36"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check", "Subsubsection",
 CellChangeTimes->{{3.782813304596273*^9, 
  3.782813305572475*^9}},ExpressionUUID->"706624c4-9a29-47f7-a75a-\
2a437fa71f78"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
      "0"}], "}"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", "15"}], "]"}], ",", 
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "6", ",", "7"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
       "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
       "}"}], ",", "15"}], "]"}]}], "}"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.782813272122381*^9, 3.782813298456997*^9}, {
  3.782813374969006*^9, 3.7828134352306833`*^9}},
 CellLabel->
  "In[384]:=",ExpressionUUID->"16da7f7f-9398-43a8-ac46-20c4384fae63"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "0", "1", "1", "1", "1", "1", "1", "1", "0", "1", "1", "1", "1", 
     "0"},
    {"1", "0", "1", "1", "1", "1", "1", "1", "1", "1", "1", "1", "1", "1", 
     "1"},
    {"1", "0", "1", "1", "1", "1", "1", "1", "1", "0", "1", "1", "1", "1", "0"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7828132807560596`*^9, 3.782813298809146*^9}, {
   3.782813391286758*^9, 3.782813435834756*^9}, 3.782822215008589*^9, 
   3.7830844882514143`*^9, 3.7830965814051027`*^9, 3.783097560224983*^9, 
   3.783101659466675*^9, 3.783186665968658*^9, 3.783445231173971*^9, 
   3.783878268017687*^9, 3.7839297971187153`*^9, 3.784214454089777*^9, 
   3.7842147368081417`*^9, 3.784214796453483*^9, 3.784390648313802*^9, 
   3.784390956902939*^9, 3.7921360479213448`*^9, 3.793084213150467*^9, 
   3.793339962544798*^9, 3.7949857583284817`*^9, 3.794986405125258*^9, 
   3.794988244079441*^9, 3.79887170520093*^9, 3.79933347214677*^9},
 CellLabel->
  "Out[384]//TableForm=",ExpressionUUID->"bb81279b-20ea-419f-8b16-\
98f6d79de81f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Final part of Section 5: linear complexity of the keystream of the \
1-quadratic stream cipher\
\>", "Subsection",
 CellChangeTimes->{{3.7834441579876966`*^9, 
  3.783444171137179*^9}},ExpressionUUID->"77909174-728b-4063-8688-\
a2e50fdbaf93"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"usQuadratic", "[", 
    RowBox[{"m_", ",", "k_", ",", "kp_", ",", 
     RowBox[{"N_:", "30"}]}], "]"}], " ", ":=", 
   RowBox[{"QKeystream", "[", 
    RowBox[{"m", ",", "k", ",", "kp", ",", "N"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"usQuadratic", "[", 
      RowBox[{"m", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
        "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", "1", ",", "5"}], "}"}]}], "]"}], "//", 
   "TF"}]}]], "Input",
 CellChangeTimes->{{3.7834443813745337`*^9, 3.783444400027457*^9}, {
   3.78344443163682*^9, 3.783444477017009*^9}, {3.783444510227159*^9, 
   3.783444518683103*^9}, {3.783444613254525*^9, 3.783444616037253*^9}, {
   3.783444966911703*^9, 3.783445005505773*^9}, {3.783445153650605*^9, 
   3.7834451537101727`*^9}, {3.783445448810828*^9, 3.7834454619767513`*^9}, {
   3.783500495791047*^9, 3.783500522292639*^9}, 3.783500609333234*^9, {
   3.783500673661529*^9, 3.783500721359827*^9}, {3.783500762548705*^9, 
   3.783500771927684*^9}, {3.783502249268787*^9, 3.7835022552149477`*^9}, {
   3.783502299090485*^9, 3.783502311016773*^9}},
 CellLabel->
  "In[385]:=",ExpressionUUID->"0d593806-21c2-4cc4-b09a-51372abd1f0f"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "0", "1", "0", "1", "0", "0", "0", "0", "1", "0", "0", "1", "0", 
     "1", "1", "0", "0", "1", "1", "0", "1", "0", "0", "0", "0", "1", "0", 
     "0", "1"},
    {"0", "1", "1", "1", "1", "1", "0", "0", "0", "1", "1", "0", "1", "1", 
     "1", "0", "1", "0", "1", "0", "1", "1", "1", "0", "0", "0", "1", "1", 
     "0", "1"},
    {"0", "0", "0", "1", "0", "1", "1", "0", "0", "1", "1", "1", "1", "1", 
     "0", "0", "0", "1", "1", "0", "0", "0", "1", "1", "0", "0", "1", "1", 
     "1", "1"},
    {"0", "0", "0", "0", "0", "0", "1", "1", "0", "1", "1", "1", "0", "1", 
     "0", "1", "0", "0", "0", "0", "0", "1", "0", "1", "1", "0", "1", "1", 
     "1", "0"},
    {"0", "0", "0", "0", "1", "0", "0", "1", "1", "1", "1", "1", "0", "0", 
     "0", "1", "1", "0", "1", "1", "0", "1", "1", "0", "1", "1", "1", "1", 
     "1", "0"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.7842147375770397`*^9, 3.784214796577701*^9, 
  3.784390884575933*^9, 3.784390957257409*^9, 3.7921360480302773`*^9, 
  3.793084213259795*^9, 3.793339962693583*^9, 3.7949857584462147`*^9, 
  3.794986405223116*^9, 3.794988244230421*^9, 3.798871705301898*^9, 
  3.799333472352611*^9},
 CellLabel->
  "Out[385]//TableForm=",ExpressionUUID->"86279cd2-db7a-4849-8dcb-\
0953ee6dca35"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dsMScNotes", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", "30"}], "]"}], "}"}], "~", "Join", "~", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"LinearComplexities", "[", 
       RowBox[{"usQuadratic", "[", 
        RowBox[{"m", ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
          "}"}], ",", "30"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"m", ",", "1", ",", "5"}], "}"}]}], "]"}]}]}], ";", 
  RowBox[{"dsMScNotes", "//", "TF"}]}]], "Input",
 CellChangeTimes->{{3.783503883668782*^9, 3.783503914096987*^9}, {
  3.783503944811597*^9, 3.783503964232779*^9}, {3.783929986049889*^9, 
  3.783929991711917*^9}},
 CellLabel->
  "In[386]:=",ExpressionUUID->"8682700d-0816-4a4a-9a4f-0523a169239f"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", 
     "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", 
     "26", "27", "28", "29", "30"},
    {"1", "1", "2", "2", "2", "2", "5", "5", "5", "5", "5", "5", "5", "5", 
     "5", "5", "5", "5", "5", "5", "16", "16", "16", "16", "16", "16", "16", 
     "16", "16", "16"},
    {"0", "2", "2", "2", "2", "2", "5", "5", "5", "5", "5", "5", "5", "5", 
     "5", "5", "5", "5", "5", "5", "16", "16", "16", "16", "16", "16", "16", 
     "16", "16", "16"},
    {"0", "0", "0", "4", "4", "4", "4", "4", "4", "6", "6", "6", "6", "6", 
     "6", "6", "6", "6", "6", "6", "15", "15", "15", "15", "15", "15", "15", 
     "15", "15", "15"},
    {"0", "0", "0", "0", "0", "0", "7", "7", "7", "7", "7", "7", "7", "7", 
     "8", "8", "8", "8", "8", "8", "13", "13", "13", "13", "13", "13", "13", 
     "15", "15", "15"},
    {"0", "0", "0", "0", "5", "5", "5", "5", "5", "5", "5", "7", "7", "7", 
     "8", "8", "9", "9", "9", "9", "12", "12", "12", "12", "12", "14", "14", 
     "14", "14", "16"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.784390957757462*^9, 3.7921360482819633`*^9, 
  3.793084213577051*^9, 3.793339962968346*^9, 3.794985758703546*^9, 
  3.79498640546951*^9, 3.794988244888122*^9, 3.7988717055643597`*^9, 
  3.799333472762395*^9},
 CellLabel->
  "Out[386]//TableForm=",ExpressionUUID->"e7dd29ab-51fe-43c0-af45-\
45bcaae4e31c"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other examples", "Subsection",
 CellChangeTimes->{{3.7828276501333103`*^9, 
  3.7828276527737226`*^9}},ExpressionUUID->"d7a232ae-27e0-4dcc-8dec-\
6da08af8b279"],

Cell[CellGroupData[{

Cell["Fibonacci and Tribonacci numbers", "Subsubsection",
 CellChangeTimes->{{3.782827407141264*^9, 
  3.782827413220378*^9}},ExpressionUUID->"efd3488d-322d-4537-99e2-\
45df73791b63"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"BerlekampMassey", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", 
       "13", ",", "21", ",", "34"}], "}"}], ",", "0"}], "]"}], ",", 
   RowBox[{"BerlekampMassey", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "1", ",", "3", ",", "5", ",", "9", ",", 
       "17", ",", "31"}], "}"}], ",", "0"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.7826305304763737`*^9, 3.782630543621346*^9}, {
  3.7827282666016293`*^9, 3.782728302143271*^9}, {3.7828274149439497`*^9, 
  3.7828274272457323`*^9}, {3.793086055843141*^9, 3.7930860559329777`*^9}},
 CellLabel->
  "In[387]:=",ExpressionUUID->"6816504f-9125-4b4d-ad7b-2f24b6c1a23c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"10", ",", "2", ",", "0", ",", 
     RowBox[{"1", "-", "z", "-", 
      SuperscriptBox["z", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "4", ",", "0", ",", 
     RowBox[{"1", "-", "z", "-", 
      SuperscriptBox["z", "2"], "-", 
      SuperscriptBox["z", "3"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.78272824668856*^9, {3.782728277012426*^9, 3.782728302635766*^9}, 
   3.78280307701044*^9, 3.782812903119252*^9, 3.78282221514729*^9, 
   3.7828274276302757`*^9, 3.783084488349927*^9, 3.783096581520784*^9, 
   3.783097560341066*^9, 3.783101659660874*^9, 3.783186666100821*^9, 
   3.783445231598475*^9, 3.7838782688032093`*^9, 3.7839297976605167`*^9, 
   3.7842147386345797`*^9, 3.784214797011713*^9, 3.7843909578771753`*^9, 
   3.792136048388647*^9, 3.793084213726714*^9, 3.793086056272477*^9, 
   3.793339963102532*^9, 3.794985758837055*^9, 3.7949864056032467`*^9, 
   3.7949882450551577`*^9, 3.798871705669017*^9, 3.799333472892002*^9},
 CellLabel->
  "Out[387]=",ExpressionUUID->"e606f36e-df40-48c8-893e-6ff747d69035"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BerlekampMassey", "[", 
  RowBox[{
   RowBox[{"TakeEvery", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "1", ",", "2", ",", "3", ",", "5", ",", "8", ",", 
       "13", ",", "21", ",", "34"}], "}"}], ",", "2"}], "]"}], ",", "0"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.793086025989592*^9, 3.793086047836668*^9}},
 CellLabel->
  "In[388]:=",ExpressionUUID->"f5b771be-b3b1-4aa6-b15d-82e5d06c9ab6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5", ",", "2", ",", "0", ",", 
   RowBox[{"1", "-", 
    RowBox[{"3", " ", "z"}], "+", 
    SuperscriptBox["z", "2"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.793086039987257*^9, 3.793086058465735*^9}, 
   3.79333996323034*^9, 3.794985758964589*^9, 3.794986405707137*^9, 
   3.794988245256833*^9, 3.7988717058386593`*^9, 3.799333472994467*^9},
 CellLabel->
  "Out[388]=",ExpressionUUID->"1d84fe6f-e2e3-4aec-8e5b-726fa70a7ecd"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Number of regions made by joining all pairs of n points in random positions \
on the circumference of a circle: 1, 2, 4, 8, 16, ?, ?, ...\
\>", "Subsubsection",
 CellChangeTimes->{{3.7828274313692904`*^9, 
  3.782827462429093*^9}},ExpressionUUID->"20b9e03f-d2f3-431c-9063-\
419ae90c62d1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BerlekampMassey", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "4", ",", "8", ",", "16", ",", "31", ",", "57", ",", 
     "99", ",", "163", ",", "256", ",", "386"}], "}"}], ",", "0"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7826306333716183`*^9, 3.782630667373316*^9}},
 CellLabel->
  "In[389]:=",ExpressionUUID->"a6696058-5687-46d9-a53a-e9bab4d014b9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"11", ",", "5", ",", "0", ",", 
   RowBox[{"1", "-", 
    RowBox[{"5", " ", "z"}], "+", 
    RowBox[{"10", " ", 
     SuperscriptBox["z", "2"]}], "-", 
    RowBox[{"10", " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"5", " ", 
     SuperscriptBox["z", "4"]}], "-", 
    SuperscriptBox["z", "5"]}]}], "}"}]], "Output",
 CellChangeTimes->{3.78272839721294*^9, 3.7828030771106367`*^9, 
  3.7828129032516613`*^9, 3.782822215375536*^9, 3.7830844884502087`*^9, 
  3.783096581647058*^9, 3.783097560458416*^9, 3.7831016600082483`*^9, 
  3.783186666236349*^9, 3.783445231699094*^9, 3.783878268940981*^9, 
  3.783929797760694*^9, 3.7842147390216084`*^9, 3.7842147971465178`*^9, 
  3.784390958207601*^9, 3.7921360485041227`*^9, 3.793084213832594*^9, 
  3.79333996336267*^9, 3.794985759079187*^9, 3.79498640580807*^9, 
  3.794988245394958*^9, 3.798871705969713*^9, 3.7993334730931396`*^9},
 CellLabel->
  "Out[389]=",ExpressionUUID->"d11f635a-d07f-442f-9686-b67b609d1b47"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
This suggests the sequence satisfies the recurrence a[n] = 5a[n-1] - 10a[n-2] \
+ 10a[n-3] - 5a[n-4] + a[n-5]. From this it is routine using methods from \
generating functions (see our course MT354/454/5454 Combinatorics next term!) \
to get the formula below. For a nice proof that it is correct, see \
www.cut-the-knot.org/Generalization/cuttingcircle.shtml.\
\>", "Subsubsection",
 CellChangeTimes->{{3.782827472300548*^9, 3.782827551049725*^9}, {
  3.782827591695568*^9, 3.782827637559924*^9}, {3.782828335782778*^9, 
  3.782828359563719*^9}},ExpressionUUID->"89ab1411-9625-4d19-b572-\
fc81da270cbc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CircleRegions", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Binomial", "[", 
    RowBox[{"n", ",", "4"}], "]"}], "+", 
   RowBox[{"Binomial", "[", 
    RowBox[{"n", ",", "2"}], "]"}], "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.782827552925878*^9, 3.782827568349523*^9}},
 CellLabel->
  "In[390]:=",ExpressionUUID->"933a4a99-ca6d-4b85-a533-e24e4417085c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"CircleRegions", "[", "n", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.782827570072234*^9, 3.782827585420455*^9}},
 CellLabel->
  "In[391]:=",ExpressionUUID->"27d5be7f-cba7-4ca8-b165-37fe363144fe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "4", ",", "8", ",", "16", ",", "31", ",", "57", ",", 
   "99", ",", "163", ",", "256"}], "}"}]], "Output",
 CellChangeTimes->{{3.782827575467279*^9, 3.7828275857652283`*^9}, 
   3.783084488552676*^9, 3.7830965817840843`*^9, 3.783097560593315*^9, 
   3.783101660209229*^9, 3.783186666396564*^9, 3.783445231801054*^9, 
   3.783878269101247*^9, 3.783929797867858*^9, 3.784214739581545*^9, 
   3.784214797299695*^9, 3.784390958416318*^9, 3.792136048652169*^9, 
   3.793084213954372*^9, 3.79333996350972*^9, 3.794985759223379*^9, 
   3.794986405920464*^9, 3.794988245597414*^9, 3.798871706085723*^9, 
   3.799333473354371*^9},
 CellLabel->
  "Out[391]=",ExpressionUUID->"0b900e58-edbf-4d74-9a82-ff56af0844a8"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Taking every m-th position from a keystream: some field theory is needed to \
predict the results below: the keystream for {3,4} is annihilated by the \
polynomial 1+z^3+z^4 with roots \[Alpha], \[Alpha]^2, \[Alpha]^4, \[Alpha]^8 \
where GF(16) = GF(2)(\[Alpha]). Taking every m-th position gives a keystream \
annihilated by the polynomial whose roots are the m-th, \[Alpha]^m, \
\[Alpha]^2m, \[Alpha]^4m, \[Alpha]^8m:
\tm \[Element] {1,2,4,8} mod 15 -> 1+z^3+z^4
\tm \[Element] {7,14,13,11} mod 15 -> 1+z+z^4 (the other primitive polynomial \
of degree 4)
\tm \[Element] {3,6,9,12} mod 15 -> 1+z+z^2+z^3+z^4 (irreducible but not \
primitive)
\tm \[Element] {5,10} mod 15 -> (1+z+z^2)^2 (not irreducible)
In fact since every 5-th position from 0 is 0, even the zero polynomial \
annihilates the keystream in the final case. (Change the key to get the more \
typical case.)\
\>", "Subsubsection",
 CellChangeTimes->{{3.7930843032590017`*^9, 3.793084310606659*^9}, {
  3.793084810091404*^9, 3.793084823846088*^9}, {3.793085453789002*^9, 
  3.7930857912018347`*^9}, {3.793085842700713*^9, 
  3.793085954379754*^9}},ExpressionUUID->"4a95bf3e-bc5a-46a9-8657-\
92f810eac00b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Keystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "]"}], ",", 
    RowBox[{"TakeEvery", "[", 
     RowBox[{
      RowBox[{"Keystream", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"3", ",", "4"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "30"}], 
       "]"}], ",", "2"}], "]"}]}], "}"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.793084489645294*^9, 3.793084599118718*^9}, {
  3.793085403691633*^9, 3.7930854114127903`*^9}},
 CellLabel->
  "In[392]:=",ExpressionUUID->"ea738ec3-7bd6-42ee-b5d2-6590754dd7e4"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", 
     "1"},
    {"0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.793084599416967*^9, 3.793085412273637*^9, 
  3.793339963630179*^9, 3.794985759345949*^9, 3.794986406025073*^9, 
  3.794988245867467*^9, 3.7988717062734213`*^9, 3.79933347346128*^9},
 CellLabel->
  "Out[392]//TableForm=",ExpressionUUID->"66cf711c-db6f-4dbe-90cb-\
072751ba79e6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{"BerlekampMassey", "[", 
       RowBox[{"TakeEvery", "[", 
        RowBox[{
         RowBox[{"Keystream", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
           RowBox[{"m", "*", "15"}]}], "]"}], ",", "m"}], "]"}], "]"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "1", ",", "20"}], "}"}]}], "]"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.793084992061721*^9, 3.793084997047896*^9}, {
  3.7930853471285954`*^9, 3.793085398428854*^9}, {3.793085958293726*^9, 
  3.7930859761559896`*^9}},
 CellLabel->
  "In[393]:=",ExpressionUUID->"ad528a24-69e9-432d-b049-e1b51d1f68ac"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"2", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"3", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"4", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"5", 
     RowBox[{"{", 
      RowBox[{"15", ",", "0", ",", "0", ",", "0"}], "}"}]},
    {"6", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"7", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"8", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"9", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"10", 
     RowBox[{"{", 
      RowBox[{"15", ",", "0", ",", "0", ",", "0"}], "}"}]},
    {"11", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"12", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"13", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"14", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"15", 
     RowBox[{"{", 
      RowBox[{"15", ",", "0", ",", "0", ",", "0"}], "}"}]},
    {"16", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"17", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"18", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", "z", "+", 
        SuperscriptBox["z", "2"], "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"19", 
     RowBox[{"{", 
      RowBox[{"15", ",", "4", ",", "0", ",", 
       RowBox[{"1", "+", 
        SuperscriptBox["z", "3"], "+", 
        SuperscriptBox["z", "4"]}]}], "}"}]},
    {"20", 
     RowBox[{"{", 
      RowBox[{"15", ",", "0", ",", "0", ",", "0"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.793084997605698*^9, {3.793085337209858*^9, 3.7930853642558603`*^9}, 
   3.79308539880929*^9, 3.79308543589062*^9, {3.793085958863102*^9, 
   3.793085976465569*^9}, 3.793339963836842*^9, 3.794985759464748*^9, 
   3.794986406141827*^9, 3.7949882461007967`*^9, 3.798871706618691*^9, 
   3.799333473599535*^9},
 CellLabel->
  "Out[393]//TableForm=",ExpressionUUID->"62df0dfd-d161-4c9e-8490-\
b562148255d0"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Product of two keystreams, binary case only unless specify length\
\>", "Subsubsection",
 CellChangeTimes->{{3.794985791802698*^9, 3.794985799688019*^9}, {
  3.794986207403528*^9, 
  3.794986213339244*^9}},ExpressionUUID->"41afe232-ad43-49a8-91a8-\
3a65b1cbf2fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProductKeystream", "[", 
   RowBox[{"ts_", ",", "k_", ",", "tsP_", ",", "kP_", ",", "n_", ",", 
    RowBox[{"q_:", "2"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Keystream", "[", 
    RowBox[{"ts", ",", "k", ",", "n", ",", "q"}], "]"}], "*", 
   RowBox[{"Keystream", "[", 
    RowBox[{"tsP", ",", "kP", ",", "n", ",", "q"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7949858036324663`*^9, 3.794985881983911*^9}, {
  3.794986534763047*^9, 3.794986536393433*^9}},
 CellLabel->
  "In[394]:=",ExpressionUUID->"525d5068-0fd5-438c-98bd-08654f931f33"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProductKeystream", "[", 
   RowBox[{"ts_", ",", "k_", ",", "tsP_", ",", "kP_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ks", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{"ts", ",", "k"}], "]"}]}], ",", 
      RowBox[{"ksP", "=", 
       RowBox[{"Keystream", "[", 
        RowBox[{"tsP", ",", "kP"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"ProductKeystream", "[", 
     RowBox[{"ts", ",", "k", ",", "tsP", ",", "kP", ",", 
      RowBox[{"LCM", "[", 
       RowBox[{
        RowBox[{"Length", "[", "ks", "]"}], ",", 
        RowBox[{"Length", "[", "ksP", "]"}]}], "]"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.794985898885312*^9, 3.794985984164317*^9}, {
  3.794986183794333*^9, 3.794986191738657*^9}, {3.7949864224548273`*^9, 
  3.794986425600388*^9}, {3.794986551805378*^9, 3.794986553370665*^9}},
 CellLabel->
  "In[395]:=",ExpressionUUID->"f34de29c-8f87-4862-932c-857dff6fe120"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Running Berlekamp--Massey on product get a feedback polynomial of a minimal \
width LFSR, so have an interesting commutative operation on polynomials. NB \
need to take more than cycle, e.g. for taps {1}, get {1} as generating cycle, \
so BM returns {1} with no taps, but we\[CloseCurlyQuote]d rather generate \
{1,1,1,...}, and for taps {3}, get {0,0,1,0,0,1,...} so even taking 6 \
positions BM returns no taps.\
\>", "Subsubsection",
 CellChangeTimes->{{3.794986718545301*^9, 3.7949867460564613`*^9}, {
  3.794987357400674*^9, 3.794987384002141*^9}, {3.794987980453537*^9, 
  3.794987999380254*^9}},ExpressionUUID->"6c9a5392-d00d-4946-a73e-\
8134ac513f29"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefaultKey", "[", "l_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", 
       RowBox[{"l", "-", "2"}]}], "}"}]}], "]"}], "~", "Join", "~", 
   RowBox[{"{", "1", "}"}]}]}]], "Input",
 CellChangeTimes->{{3.794986810316676*^9, 3.7949868264929*^9}},
 CellLabel->
  "In[396]:=",ExpressionUUID->"67640478-7287-4a40-a57d-09c671f57698"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BMP", "[", 
   RowBox[{"ts_", ",", "tsP_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bm", "=", 
      RowBox[{"BerlekampMassey", "[", 
       RowBox[{"ProductKeystream", "[", 
        RowBox[{"ts", ",", 
         RowBox[{"DefaultKey", "[", 
          RowBox[{"Max", "[", "ts", "]"}], "]"}], ",", "tsP", ",", 
         RowBox[{"DefaultKey", "[", 
          RowBox[{"Max", "[", "tsP", "]"}], "]"}], ",", "n"}], "]"}], "]"}]}],
      "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"bm", "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{"bm", "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.794986750124448*^9, 3.794986809222694*^9}, {
  3.794986848666884*^9, 3.7949868487647333`*^9}, {3.794987421977131*^9, 
  3.794987424177306*^9}, {3.794987672162189*^9, 3.7949876925958147`*^9}, {
  3.794987866868744*^9, 3.794987866958753*^9}, {3.794987928479013*^9, 
  3.794987928527824*^9}, {3.7949880118155327`*^9, 3.7949880396832857`*^9}},
 CellLabel->
  "In[397]:=",ExpressionUUID->"d31b9171-a396-4250-a8cc-89cbb618cbac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BMP", "[", 
   RowBox[{"ts_", ",", "tsP_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n", "=", 
      RowBox[{"2", "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Max", "[", "ts", "]"}], "+", 
         RowBox[{"Max", "[", "tsP", "]"}]}], ")"}]}]}], "}"}], ",", 
    RowBox[{"BMP", "[", 
     RowBox[{"ts", ",", "tsP", ",", "n"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7949880430238323`*^9, 3.7949880771480427`*^9}},
 CellLabel->
  "In[398]:=",ExpressionUUID->"df41a957-49cf-4689-a427-342b9a3350f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonZeroCoefficients", "[", "f_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"cs", "=", 
      RowBox[{"CoefficientList", "[", 
       RowBox[{"f", ",", "z"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"cs", "[", 
            RowBox[{"[", 
             RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{
            RowBox[{"Length", "[", "cs", "]"}], "-", "1"}]}], "}"}]}], "]"}], 
       ",", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}], "&"}]}], 
      "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7949868883888407`*^9, 3.794987043644927*^9}},
 CellLabel->
  "In[399]:=",ExpressionUUID->"2c50850a-436b-4916-9bfa-04e07aa2019d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BMTs", "[", 
   RowBox[{"ts_", ",", "tsP_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"bmp", "=", 
      RowBox[{"BMP", "[", 
       RowBox[{"ts", ",", "tsP"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"bmp", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"NonZeroCoefficients", "[", 
         RowBox[{"bmp", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{"#", "\[Equal]", "0"}], "]"}], "&"}]}], "]"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7949870685446653`*^9, 3.794987082620451*^9}, {
  3.794987247497081*^9, 3.7949872529551888`*^9}, {3.79498770020443*^9, 
  3.794987727412223*^9}, {3.7949877591133947`*^9, 3.794987763056549*^9}},
 CellLabel->
  "In[400]:=",ExpressionUUID->"954f2903-1e9f-4c90-890e-002518eb327b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example:", "Subsubsection",
 CellChangeTimes->{{3.7949862192497177`*^9, 
  3.7949862207629623`*^9}},ExpressionUUID->"50075147-7541-40dd-9667-\
f9c056872576"],

Cell[BoxData[
 RowBox[{"us", ":=", 
  RowBox[{"ProductKeystream", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "210"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.794986062510934*^9, 3.794986093158044*^9}, {
  3.7949874328050947`*^9, 3.7949874347242203`*^9}},
 CellLabel->
  "In[401]:=",ExpressionUUID->"8be448b7-4bbc-4fbd-8156-58e0fbcb2cc1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"us", "[", 
        RowBox[{"[", 
         RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"Keystream", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"3", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "210"}], 
         "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"Keystream", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "210"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", "+", "1"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "209"}], "}"}]}], "]"}], "//", 
   "Transpose"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7949860941329727`*^9, 3.794986113520754*^9}, {
  3.794986261556974*^9, 3.7949863210892563`*^9}},
 CellLabel->
  "In[402]:=",ExpressionUUID->"a9b1c938-3d50-4b72-bfec-0dafb4906df4"],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13",
      "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", 
     "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", 
     "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", 
     "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", 
     "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", 
     "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", 
     "86", "87", "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", 
     "98", "99", "100", "101", "102", "103", "104", "105", "106", "107", 
     "108", "109", "110", "111", "112", "113", "114", "115", "116", "117", 
     "118", "119", "120", "121", "122", "123", "124", "125", "126", "127", 
     "128", "129", "130", "131", "132", "133", "134", "135", "136", "137", 
     "138", "139", "140", "141", "142", "143", "144", "145", "146", "147", 
     "148", "149", "150", "151", "152", "153", "154", "155", "156", "157", 
     "158", "159", "160", "161", "162", "163", "164", "165", "166", "167", 
     "168", "169", "170", "171", "172", "173", "174", "175", "176", "177", 
     "178", "179", "180", "181", "182", "183", "184", "185", "186", "187", 
     "188", "189", "190", "191", "192", "193", "194", "195", "196", "197", 
     "198", "199", "200", "201", "202", "203", "204", "205", "206", "207", 
     "208", "209"},
    {"0", "0", "0", "0", "0", "0", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "1", "1", 
     "0", "0", "0", "0", "0", "1", "0", "0", "0", "1", "0", "1", "0", "1", 
     "0", "0", "1", "0", "0", "0", "1", "0", "0", "1", "0", "0", "1", "0", 
     "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "1", 
     "0", "0", "1", "0", "1", "0", "0", "0", "0", "0", "0", "1", "1", "0", 
     "0", "0", "1", "0", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", 
     "0", "0", "0", "0", "1", "1", "1", "0", "0", "0", "0", "0", "0", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "0", "0", "1", "0", "0", 
     "0", "0", "0", "0", "0", "1", "1", "0", "0", "0", "0", "0", "1", "0", 
     "0", "0", "1", "0", "1", "0", "1", "0", "0", "1", "0", "0", "0", "1", 
     "0", "0", "1", "0", "0", "1", "0", "0", "0", "1", "0", "0", "0", "0", 
     "0", "0", "0", "0", "1", "0", "1", "0", "0", "1", "0", "1", "0", "0", 
     "0", "0", "0", "0", "1", "1", "0", "0", "0", "1", "0", "1", "1", "0", 
     "0", "0", "1", "0", "0", "1", "1", "0", "0", "0", "0", "1", "1", "1"},
    {"0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", 
     "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", 
     "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", 
     "1", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", 
     "1", "1", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", "1", 
     "0", "1", "1", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", "0", 
     "1", "0", "1", "1", "1", "1", "0", "0", "0", "1", "0", "0", "1", "1", 
     "0", "1", "0", "1", "1", "1", "1", "0", "0", "0", "1", "0", "0", "1", 
     "1", "0", "1", "0", "1", "1", "1", "1", "0", "0", "0", "1", "0", "0", 
     "1", "1", "0", "1", "0", "1", "1", "1", "1", "0", "0", "0", "1", "0", 
     "0", "1", "1", "0", "1", "0", "1", "1", "1", "1", "0", "0", "0", "1", 
     "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1", "0", "0", "0", 
     "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1", "0", "0", 
     "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1", "0", 
     "0", "0", "1", "0", "0", "1", "1", "0", "1", "0", "1", "1", "1", "1"},
    {"0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1", 
     "0", "0", "1", "0", "1", "1", "1", "0", "0", "1", "0", "1", "1", "1"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.794986104790019*^9, 3.794986115159587*^9}, 
   3.794986197471683*^9, {3.794986277509925*^9, 3.794986285239667*^9}, 
   3.794986324751665*^9, 3.794986409238679*^9, 3.7949865585924377`*^9, 
   3.7949874384971237`*^9, 3.7949880847004347`*^9, 3.794988249645212*^9, 
   3.798871710552041*^9, 3.7993334777207413`*^9},
 CellLabel->
  "Out[402]//TableForm=",ExpressionUUID->"2d5e3265-6e38-455e-b9d0-\
eb9dabdad464"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"BerlekampMassey", "[", 
    RowBox[{"ProductKeystream", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}], "]"}], ",", 
   RowBox[{"BMP", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "]"}], ",", 
   RowBox[{"BMTs", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.7949862228747873`*^9, 3.794986232281765*^9}, {
  3.7949868571070337`*^9, 3.794986862101457*^9}, {3.794987090501175*^9, 
  3.794987096316353*^9}, {3.794987444817227*^9, 3.794987445654647*^9}, {
  3.794988087355739*^9, 3.7949880875262527`*^9}},
 CellLabel->
  "In[403]:=",ExpressionUUID->"0d1c12e5-f43b-4260-ae11-ba8981ca2108"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"105", ",", "12", ",", "0", ",", 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "7"], "+", 
      SuperscriptBox["z", "8"], "+", 
      SuperscriptBox["z", "9"], "+", 
      SuperscriptBox["z", "11"], "+", 
      SuperscriptBox["z", "12"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", 
     RowBox[{"1", "+", 
      SuperscriptBox["z", "3"], "+", 
      SuperscriptBox["z", "7"], "+", 
      SuperscriptBox["z", "8"], "+", 
      SuperscriptBox["z", "9"], "+", 
      SuperscriptBox["z", "11"], "+", 
      SuperscriptBox["z", "12"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "7", ",", "8", ",", "9", ",", "11", ",", "12"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.79498623344103*^9, 3.7949864094726133`*^9, 3.79498656473071*^9, 
   3.794986862589635*^9, 3.79498709850701*^9, {3.794987441096431*^9, 
   3.794987446243938*^9}, 3.794987735452553*^9, 3.794987765927815*^9, 
   3.79498808875275*^9, 3.794988250006978*^9, 3.794989314201379*^9, 
   3.7988717107827806`*^9, 3.799333477925861*^9},
 CellLabel->
  "Out[403]=",ExpressionUUID->"736b980b-c9ae-414b-907d-3e23902068bb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multiplication table", "Subsubsection",
 CellChangeTimes->{{3.794987110540702*^9, 
  3.794987112460814*^9}},ExpressionUUID->"bb5894fe-54a9-4b7a-962f-\
e002b6b4b4c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonEmptySubsets", "[", "xs_", "]"}], ":=", 
  RowBox[{"Select", "[", 
   RowBox[{
    RowBox[{"Subsets", "[", "xs", "]"}], ",", 
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"#", "==", 
       RowBox[{"{", "}"}]}], "]"}], "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.794987175480701*^9, 3.794987203020804*^9}},
 CellLabel->
  "In[404]:=",ExpressionUUID->"4b250917-a378-4edb-bd45-5d23f7a10611"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NonEmptySubsets", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7949875817326803`*^9, 3.794987585552226*^9}},
 CellLabel->
  "In[405]:=",ExpressionUUID->"da380d43-81a3-4dcb-b4ea-605773688a52"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7949875858672247`*^9, 3.794987773548501*^9, 
  3.794988250538855*^9, 3.79887171093089*^9, 3.7993334780756683`*^9},
 CellLabel->
  "Out[405]=",ExpressionUUID->"c307aa97-4b43-4a2c-b8a1-da803e89aa34"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"BMTs", "[", 
      RowBox[{"ts", ",", "tsP"}], "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"ts", ",", 
      RowBox[{"NonEmptySubsets", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"tsP", ",", 
      RowBox[{"NonEmptySubsets", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]}], "}"}]}], "]"}], "//",
   "TF"}]], "Input",
 CellChangeTimes->{{3.7949871192519608`*^9, 3.794987173207428*^9}, {
  3.794987210076663*^9, 3.794987228351774*^9}, {3.795004521711259*^9, 
  3.7950045222056093`*^9}},
 CellLabel->
  "In[406]:=",ExpressionUUID->"0e8f83b2-1ea5-4a57-994b-112fd46b86a3"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "1", "}"}], 
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}]},
    {
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}], 
     RowBox[{"{", "4", "}"}]},
    {
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "6"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", "7", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "5", ",", "6", ",", "7", ",", "9"}], 
      "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", "7", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "7", ",", "8", ",", "9"}], 
      "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "5", ",", "6", ",", "7", ",", "9"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "7", ",", "8", ",", "9"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.794987124137349*^9, 3.794987256142764*^9}, 
   3.7949874536129627`*^9, 3.7949877743912497`*^9, 3.794987871423242*^9, 
   3.794988094201213*^9, 3.794988251350766*^9, 3.794989341271627*^9, 
   3.795004523613872*^9, 3.798871711233437*^9, 3.799333478757069*^9},
 CellLabel->
  "Out[406]//TableForm=",ExpressionUUID->"5e3b4ffd-025a-42b3-8591-\
cfc11e04c466"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NonEmptySubsets", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7950046165441427`*^9, 3.795004616622367*^9}},
 CellLabel->
  "In[407]:=",ExpressionUUID->"0d8d8992-d016-43a8-ab68-79cd71540095"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"{", "4", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7950046169965067`*^9, 3.798871711347143*^9, 
  3.799333478938237*^9},
 CellLabel->
  "Out[407]=",ExpressionUUID->"d5e7b8cc-b68c-4eb9-8112-667104eff0d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"BMTs", "[", 
      RowBox[{"ts", ",", "tsP"}], "]"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"ts", ",", 
      RowBox[{"NonEmptySubsets", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"tsP", ",", 
      RowBox[{"NonEmptySubsets", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "]"}]}], "}"}]}], 
   "]"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.795004552665391*^9, 3.795004556419929*^9}},
 CellLabel->
  "In[408]:=",ExpressionUUID->"2c0f39d5-37f4-4943-8ae3-35f424df4e2e"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", "1", "}"}], 
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]},
    {
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "2", "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "8"}], "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "6", ",", "8"}], "}"}]},
    {
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", "12", "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "9"}], "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}]},
    {
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", "12", "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"12", ",", "16"}], "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8", ",", "12", ",", "16"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", "3", "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "7", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "5", ",", "7", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5", ",", "7", ",", "8"}], 
      "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", "7", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "7", ",", "9", ",", "10", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "5", ",", "6", ",", "7", ",", "9"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "7", ",", "10", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "4", ",", "7", ",", "8", ",", "9", ",", "10", ",", 
       "12"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "5", ",", "6", ",", "8", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "4", ",", "6", ",", "8", ",", "9", ",", 
       "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "5", ",", "6", ",", "8", ",", "10", ",", "13", ",", 
       "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "9", ",", "12", ",", "16"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", ",", 
       "10", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", "7", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "5", ",", "6", ",", "8", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8", ",", "10", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "7", ",", "8", ",", "9", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "7", ",", "8", ",", "9"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"2", ",", "5", ",", "6", ",", "9", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "5", ",", "8", ",", "10", ",", "11", ",", 
       "12"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8", ",", "10", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "12", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "10", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6", ",", "8", ",", "10", ",", "14", ",", "16"}], 
      "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "7", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "7", ",", "9", ",", "10", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "7", ",", "8", ",", "9", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "12", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "6", ",", "8", ",", "9", ",", "10", ",", "11", ",", 
       "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "4", ",", "6", ",", "8", ",", "9", ",", "10", ",", "11", ",", "12", ",",
        "13", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "7", ",", "10", ",", "13", ",", "15", ",", "16"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "6", ",", "8", ",", "10", ",", "11", ",", "14", ",", "15", 
       ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9"}], "}"}], 
     RowBox[{"{", "4", "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "5", ",", "6", ",", "7", ",", "9"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "4", ",", "6", ",", "8", ",", "9", ",", 
       "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "7", ",", "8", ",", "9"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "6", ",", "8", ",", "9", ",", "10", ",", "11", ",", 
       "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "4", ",", "5", ",", "9", ",", "10", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "4", ",", "6", ",", "7", ",", "9", ",", "10"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "7", ",", "8", ",", "9", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "6", ",", "8", ",", "11", ",", "12"}], 
      "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "5", ",", "6", ",", "8", ",", "10", ",", "13", ",", 
       "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"2", ",", "6", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "4", ",", "6", ",", "8", ",", "9", ",", "10", ",", "11", ",", "12", ",",
        "13", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "4", ",", "5", ",", "9", ",", "10", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "4", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
       "11", ",", "12", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "7", ",", "8", ",", "11", ",", "13", ",", "14", ",",
        "16"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", "6", "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "7", ",", "10", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "6", ",", "9", ",", "12", ",", "16"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "5", ",", "6", ",", "9", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "7", ",", "10", ",", "13", ",", "15", ",", "16"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "4", ",", "6", ",", "7", ",", "9", ",", "10"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "4", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
       "11", ",", "12", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "4", ",", "5", ",", "7", ",", "8", ",", "9", ",", "10", ",", 
       "12", ",", "14", ",", "15", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "5", ",", "8", ",", "11", ",", "14", ",", "15", ",",
        "16"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "5", ",", "7", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", ",", 
       "10", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{"4", ",", "10", ",", "14", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "6", ",", "8", ",", "10", ",", "11", ",", "14", ",", "15", 
       ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "7", ",", "8", ",", "9", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "2", ",", "4", ",", "5", ",", "7", ",", "8", ",", "9", ",", "10", ",", 
       "12", ",", "14", ",", "15", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "5", ",", "8", ",", "9", ",", "13", ",", "15", ",", 
       "16"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6", ",", "9", ",", "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8", ",", "12", ",", "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "4", ",", "5", ",", "7", ",", "8"}], "}"}], 
     
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "4", ",", "7", ",", "8", ",", "9", ",", "10", ",", 
       "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "10"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "5", ",", "8", ",", "10", ",", "11", ",", 
       "12"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6", ",", "8", ",", "10", ",", "14", ",", "16"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "10"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "6", ",", "8", ",", "11", ",", "12"}], 
      "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "3", ",", "7", ",", "8", ",", "11", ",", "13", ",", "14", ",",
        "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "5", ",", "8", ",", "11", ",", "14", ",", "15", ",",
        "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "5", ",", "8", ",", "9", ",", "13", ",", "15", ",", 
       "16"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{3.795004564339223*^9, 3.7988717205267563`*^9, 
  3.799333486958022*^9},
 CellLabel->
  "Out[408]//TableForm=",ExpressionUUID->"cacd1d42-62a3-4714-8201-\
75794989f207"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example: full period keystreams periods 2^4-1 and 2^5-1 so product has period \
15*31=465 but is generated by LFSR of width 20\
\>", "Subsubsection",
 CellChangeTimes->{{3.7950122942133293`*^9, 
  3.79501232441053*^9}},ExpressionUUID->"2d1963a6-aaf3-4f7c-9b2e-\
3cb7fde123c0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BMTs", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7950106785782967`*^9, 3.795010699266521*^9}, {
   3.795012254105043*^9, 3.795012277238595*^9}, 3.795069913618545*^9},
 CellLabel->
  "In[409]:=",ExpressionUUID->"a4c974e2-5fb4-4aee-97b1-8e1e7c32ac56"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"20", ",", 
   RowBox[{"{", 
    RowBox[{
    "2", ",", "8", ",", "9", ",", "10", ",", "11", ",", "14", ",", "17", ",", 
     "20"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.795010684709515*^9, 3.7950107009901133`*^9}, 
   3.795012277898768*^9, 3.795069914839096*^9, 3.798871721024502*^9, 
   3.799333487527547*^9},
 CellLabel->
  "Out[409]=",ExpressionUUID->"f0a6103f-5ef5-40c2-9c22-5e21d877713b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ProductKeystream", "[", 
  RowBox[{
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.79501071225422*^9, 3.7950107206725397`*^9}, {
  3.795011478405648*^9, 3.795011493413061*^9}},
 CellLabel->
  "In[410]:=",ExpressionUUID->"72ed3158-d721-4a7f-8509-37de7da630c5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.795010721048715*^9, 3.795011493943674*^9, 
  3.7988717211382*^9, 3.79933348766567*^9},
 CellLabel->
  "Out[410]=",ExpressionUUID->"37668cce-391d-45c2-97e9-1786978c20df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Keystream", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.795010721716103*^9, 3.795010727953363*^9}},
 CellLabel->
  "In[411]:=",ExpressionUUID->"869a89c4-23ba-4e85-b2af-7be15f05c155"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}],
   "}"}]], "Output",
 CellChangeTimes->{3.795010728271884*^9, 3.7988717212625523`*^9, 
  3.799333487795122*^9},
 CellLabel->
  "Out[411]=",ExpressionUUID->"1b665062-1770-4d99-905d-525ca494ba25"]
}, Open  ]]
}, Open  ]],

Cell["\<\
The product can be generated by a bilinear map applied to the tensor product \
of the matrices for each LFSR: so have roots in F_2^l and F_2^l\
\[CloseCurlyQuote], meaning roots of tensor product are in F_2^{lcm(l,l\
\[CloseCurlyQuote]}. Therefore maximum width is lcm(l,l\[CloseCurlyQuote]).\
\>", "Subsubsection",
 CellChangeTimes->{{3.795012706799756*^9, 
  3.795012786246593*^9}},ExpressionUUID->"8cb75b4c-8d60-4a19-a704-\
333aa264c2bb"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Trivium (Example 8.7)", "Section",
 CellChangeTimes->{{3.777043446073493*^9, 3.777043449007001*^9}, {
  3.78309671405284*^9, 3.783096720427109*^9}, {3.783097514837345*^9, 
  3.783097518964078*^9}},ExpressionUUID->"8f7b796d-1208-426b-b688-\
8061662e1eb8"],

Cell[CellGroupData[{

Cell["\<\
Trivium defined exactly as in the specification with a right (clockwise) \
shifting register of length 288\
\>", "Subsection",
 CellChangeTimes->{{3.7770385198340797`*^9, 3.77703852866052*^9}, {
  3.777040592715074*^9, 3.777040604060367*^9}, {3.777188379315797*^9, 
  3.777188381580978*^9}},ExpressionUUID->"27f6ab76-008e-4d64-ba3a-\
1b2f1d6453e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriviumS", "[", "s_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t1", ",", "t2", ",", "t3", ",", "z", ",", "sNew"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"t1", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"[", "66", "]"}], "]"}], "+", 
         RowBox[{"s", "[", 
          RowBox[{"[", "93", "]"}], "]"}]}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"t2", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"[", "162", "]"}], "]"}], "+", 
         RowBox[{"s", "[", 
          RowBox[{"[", "177", "]"}], "]"}]}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"t3", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"[", "243", "]"}], "]"}], "+", 
         RowBox[{"s", "[", 
          RowBox[{"[", "288", "]"}], "]"}]}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"z", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"t1", "+", "t2", "+", "t3"}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"t1", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"t1", "+", 
         RowBox[{
          RowBox[{"s", "[", 
           RowBox[{"[", "91", "]"}], "]"}], "*", 
          RowBox[{"s", "[", 
           RowBox[{"[", "92", "]"}], "]"}]}], "+", 
         RowBox[{"s", "[", 
          RowBox[{"[", "171", "]"}], "]"}]}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"t2", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"t2", "+", 
         RowBox[{
          RowBox[{"s", "[", 
           RowBox[{"[", "175", "]"}], "]"}], "*", 
          RowBox[{"s", "[", 
           RowBox[{"[", "176", "]"}], "]"}]}], "+", 
         RowBox[{"s", "[", 
          RowBox[{"[", "264", "]"}], "]"}]}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"t3", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"t3", "+", 
         RowBox[{
          RowBox[{"s", "[", 
           RowBox[{"[", "286", "]"}], "]"}], "*", 
          RowBox[{"s", "[", 
           RowBox[{"[", "287", "]"}], "]"}]}], "+", 
         RowBox[{"s", "[", 
          RowBox[{"[", "69", "]"}], "]"}]}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sNew", "=", 
      RowBox[{
       RowBox[{"{", "t3", "}"}], "~", "Join", "~", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", "92"}], "}"}]}], "]"}], "~", "Join", 
       "~", 
       RowBox[{"{", "t1", "}"}], "~", "Join", "~", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "94", ",", "176"}], "}"}]}], "]"}], "~", "Join", 
       "~", 
       RowBox[{"{", "t2", "}"}], "~", "Join", "~", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"s", "[", 
          RowBox[{"[", "j", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "178", ",", "287"}], "}"}]}], "]"}]}]}], ";", 
     RowBox[{"{", 
      RowBox[{"sNew", ",", "z"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777038553265749*^9, 3.777038767682502*^9}, {
  3.777038798437354*^9, 3.7770388100470057`*^9}, {3.777039007401021*^9, 
  3.777039009662771*^9}},
 CellLabel->
  "In[412]:=",ExpressionUUID->"bd48693f-cc6b-4673-b0c8-3683b94e5ffe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriviumS", "[", 
   RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sLoop", ",", "sz", ",", 
      RowBox[{"zs", "=", 
       RowBox[{"{", "}"}]}], ",", "c"}], "}"}], ",", 
    RowBox[{
     RowBox[{"sLoop", "=", "s"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"c", "=", "0"}], ",", 
       RowBox[{"c", "<", "n"}], ",", 
       RowBox[{"c", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sz", "=", 
         RowBox[{"TriviumS", "[", "sLoop", "]"}]}], ";", 
        RowBox[{"sLoop", "=", 
         RowBox[{"sz", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"zs", ",", 
          RowBox[{"sz", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"sLoop", ",", "zs"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7770388309900103`*^9, 3.777038887058385*^9}, {
  3.7770390249454517`*^9, 3.777039129845253*^9}},
 CellLabel->
  "In[413]:=",ExpressionUUID->"1faedac8-4b5a-44c3-bed3-66266b5d24c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriviumKeystreamS", "[", 
   RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"TriviumS", "[", 
    RowBox[{"s", ",", "n"}], "]"}], "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7770392168368063`*^9, 3.777039228144552*^9}},
 CellLabel->
  "In[414]:=",ExpressionUUID->"d8f66825-a05d-49e7-b814-1efe7b2318bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Trivium as defined as in lecture notes using three left-shifting registers\
\>", "Subsection",
 CellChangeTimes->{{3.777029732736045*^9, 3.7770297350179567`*^9}, {
   3.777040612286578*^9, 3.77704061924139*^9}, {3.7770424428364143`*^9, 
   3.777042444626112*^9}, 3.777043231150255*^9, {3.7771883846712217`*^9, 
   3.777188384996685*^9}},ExpressionUUID->"b3f3f2bf-3a21-4278-95fb-\
bf10a72906db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShiftLeft", "[", "xs_", "]"}], ":=", 
  RowBox[{"xs", "[", 
   RowBox[{"[", 
    RowBox[{"2", ";;"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777030088378448*^9, 3.777030130658585*^9}},
 CellLabel->
  "In[415]:=",ExpressionUUID->"bba8046b-cf7c-4630-8e11-03f53cdceedf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fTrivium", "[", 
   RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Entry", "[", 
      RowBox[{"z", ",", "0"}], "]"}], "+", 
     RowBox[{"Entry", "[", 
      RowBox[{"z", ",", 
       RowBox[{"111", "-", "66"}]}], "]"}], "+", 
     RowBox[{
      RowBox[{"Entry", "[", 
       RowBox[{"z", ",", "1"}], "]"}], "*", 
      RowBox[{"Entry", "[", 
       RowBox[{"z", ",", "2"}], "]"}]}], "+", 
     RowBox[{"Entry", "[", 
      RowBox[{"x", ",", "24"}], "]"}]}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777030470274448*^9, 3.777030512705222*^9}, {
  3.7770315532896957`*^9, 3.777031578720236*^9}, {3.783096734470821*^9, 
  3.7830967354585047`*^9}},
 CellLabel->
  "In[416]:=",ExpressionUUID->"47a1d39c-7d0f-408c-b95b-a9a382129712"],

Cell[BoxData[
 RowBox[{
  RowBox[{"gTrivium", "[", 
   RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Entry", "[", 
      RowBox[{"x", ",", "0"}], "]"}], "+", 
     RowBox[{"Entry", "[", 
      RowBox[{"x", ",", 
       RowBox[{"93", "-", "66"}]}], "]"}], "+", 
     RowBox[{
      RowBox[{"Entry", "[", 
       RowBox[{"x", ",", "1"}], "]"}], "*", 
      RowBox[{"Entry", "[", 
       RowBox[{"x", ",", "2"}], "]"}]}], "+", 
     RowBox[{"Entry", "[", 
      RowBox[{"y", ",", "6"}], "]"}]}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777030514314293*^9, 3.777030550035117*^9}, {
  3.777031553310678*^9, 3.777031581687419*^9}, {3.777035951520053*^9, 
  3.7770359515973587`*^9}, {3.783096736827479*^9, 3.783096737698264*^9}},
 CellLabel->
  "In[417]:=",ExpressionUUID->"408cbc01-67e2-43af-9551-823ca5311fe5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"hTrivium", "[", 
   RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], ":=", 
  RowBox[{"Mod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Entry", "[", 
      RowBox[{"y", ",", "0"}], "]"}], "+", 
     RowBox[{"Entry", "[", 
      RowBox[{"y", ",", 
       RowBox[{"84", "-", "69"}]}], "]"}], "+", 
     RowBox[{
      RowBox[{"Entry", "[", 
       RowBox[{"y", ",", "1"}], "]"}], "*", 
      RowBox[{"Entry", "[", 
       RowBox[{"y", ",", "2"}], "]"}]}], "+", 
     RowBox[{"Entry", "[", 
      RowBox[{"z", ",", "24"}], "]"}]}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777030531528303*^9, 3.7770305541199007`*^9}, {
  3.777031553333775*^9, 3.7770315533502274`*^9}, {3.777031585228842*^9, 
  3.7770315865498943`*^9}, {3.783096739133738*^9, 3.783096739936204*^9}},
 CellLabel->
  "In[418]:=",ExpressionUUID->"400d3065-f9c3-4779-a044-5ad404465d3b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Trivium", "[", "xyz_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "=", 
       RowBox[{"xyz", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ",", 
      RowBox[{"y", "=", 
       RowBox[{"xyz", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ",", 
      RowBox[{"z", "=", 
       RowBox[{"xyz", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"ShiftLeft", "[", "x", "]"}], "~", "Join", "~", 
       RowBox[{"{", 
        RowBox[{"fTrivium", "[", 
         RowBox[{"x", ",", "y", ",", "z"}], "]"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"ShiftLeft", "[", "y", "]"}], "~", "Join", "~", 
       RowBox[{"{", 
        RowBox[{"gTrivium", "[", 
         RowBox[{"x", ",", "y", ",", "z"}], "]"}], "}"}]}], ",", 
      RowBox[{
       RowBox[{"ShiftLeft", "[", "z", "]"}], "~", "Join", "~", 
       RowBox[{"{", 
        RowBox[{"hTrivium", "[", 
         RowBox[{"x", ",", "y", ",", "z"}], "]"}], "}"}]}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777030069665841*^9, 3.777030086850149*^9}, {
  3.7770301414296923`*^9, 3.777030162877191*^9}, {3.777030558178129*^9, 
  3.7770305877088003`*^9}, {3.777031335705723*^9, 3.777031359032385*^9}, {
  3.777031729244576*^9, 3.777031741776349*^9}, {3.783096742475032*^9, 
  3.7830967486635017`*^9}},
 CellLabel->
  "In[419]:=",ExpressionUUID->"e7b96df7-e81a-4115-a201-8e73f8d4f726"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Trivium", "[", 
   RowBox[{"xyz_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xyzLoop", ",", "s"}], "}"}], ",", 
    RowBox[{
     RowBox[{"xyzLoop", "=", "xyz"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"s", "=", "0"}], ",", 
       RowBox[{"s", "<", "n"}], ",", 
       RowBox[{"s", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"xyzLoop", "=", 
        RowBox[{"Trivium", "[", "xyzLoop", "]"}]}]}], "]"}], ";", 
     "xyzLoop"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7770317518088903`*^9, 3.777031924193965*^9}, {
  3.777031970209052*^9, 3.777032001191215*^9}, {3.777032037551318*^9, 
  3.777032055739793*^9}},
 CellLabel->
  "In[420]:=",ExpressionUUID->"96cf071b-c447-4563-ae87-071e76b7d961"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriviumKeystreamFrom", "[", 
   RowBox[{"n_", ",", "xyz_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"ks", "=", 
       RowBox[{"{", "}"}]}], ",", "s", ",", 
      RowBox[{"xyzNew", "=", "xyz"}], ",", "x", ",", "y", ",", "z"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"s", "=", "0"}], ",", 
       RowBox[{"s", "<", "n"}], ",", 
       RowBox[{"s", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"x", "=", 
         RowBox[{"xyzNew", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", 
        RowBox[{"y", "=", 
         RowBox[{"xyzNew", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", 
        RowBox[{"z", "=", 
         RowBox[{"xyzNew", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ";", 
        RowBox[{"k", "=", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Entry", "[", 
             RowBox[{"x", ",", "0"}], "]"}], "+", 
            RowBox[{"Entry", "[", 
             RowBox[{"x", ",", 
              RowBox[{"93", "-", "66"}]}], "]"}], "+", 
            RowBox[{"Entry", "[", 
             RowBox[{"y", ",", "0"}], "]"}], "+", 
            RowBox[{"Entry", "[", 
             RowBox[{"y", ",", 
              RowBox[{"84", "-", "69"}]}], "]"}], "+", 
            RowBox[{"Entry", "[", 
             RowBox[{"z", ",", "0"}], "]"}], "+", 
            RowBox[{"Entry", "[", 
             RowBox[{"z", ",", 
              RowBox[{"111", "-", "66"}]}], "]"}]}], ",", "2"}], "]"}]}], ";", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"ks", ",", "k"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"xyzNew", "=", 
         RowBox[{"Trivium", "[", "xyzNew", "]"}]}]}]}], "]"}], ";", "ks"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7770305939896507`*^9, 3.777030837974864*^9}, {
  3.777031190885365*^9, 3.777031192154155*^9}, {3.777031240064726*^9, 
  3.777031252562604*^9}, {3.777031361743348*^9, 3.7770314209118757`*^9}, {
  3.777031472445139*^9, 3.7770314955482273`*^9}, {3.7770315533575478`*^9, 
  3.777031571428282*^9}, {3.7770341884178543`*^9, 3.777034188725788*^9}, {
  3.777034320543827*^9, 3.7770343665826883`*^9}, {3.777036446678276*^9, 
  3.777036446789641*^9}},
 CellLabel->
  "In[421]:=",ExpressionUUID->"2cfc4ecd-33f3-40b5-acfd-ec69799c8dce"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriviumInitialization", "[", 
   RowBox[{"K_", ",", "IV_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "12"}], "}"}]}], "]"}], "~", "Join", "~", 
     
     RowBox[{"Reverse", "[", "K", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}], "~", "Join", "~", 
     RowBox[{"Reverse", "[", "IV", "]"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], "~", "Join", "~", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "3", ",", "110"}], "}"}]}], "]"}]}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.777031016870522*^9, 3.7770311521508827`*^9}},
 CellLabel->
  "In[422]:=",ExpressionUUID->"44708150-390c-4152-92e8-918805ed5c7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TriviumKeystream", "[", 
   RowBox[{"K_", ",", "IV_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"xyz", "=", 
      RowBox[{"TriviumInitialization", "[", 
       RowBox[{"K", ",", "IV"}], "]"}]}], "}"}], ",", 
    RowBox[{"TriviumKeystreamFrom", "[", 
     RowBox[{"n", ",", "xyz"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777031194108639*^9, 3.777031260680956*^9}, {
  3.777034126989997*^9, 3.777034130233644*^9}},
 CellLabel->
  "In[423]:=",ExpressionUUID->"79530fd4-4189-41d0-b93c-b4e73a90093b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeroKey", "[", "n_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{"0", ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.777031292156775*^9, 3.77703130343007*^9}},
 CellLabel->
  "In[424]:=",ExpressionUUID->"39d0cf4a-7f21-4aba-aab5-9c782442933a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check two versions agree", "Subsection",
 CellChangeTimes->{{3.777043308846547*^9, 3.777043316213344*^9}, {
  3.7770437459539824`*^9, 
  3.777043748656732*^9}},ExpressionUUID->"d3132f3b-6eac-4955-8330-\
442661fa1a4d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToBytes", "[", "ks_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "ks", "]"}], "<", "8"}], ",", 
    RowBox[{"{", "ks", "}"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ks", "[", 
       RowBox[{"[", 
        RowBox[{"1", ";;", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"Length", "[", "ks", "]"}], ",", "8"}], "]"}]}], "]"}], 
       "]"}], "}"}], "~", "Join", "~", 
     RowBox[{"ToBytes", "[", 
      RowBox[{"ks", "[", 
       RowBox[{"[", 
        RowBox[{"9", ";;"}], "]"}], "]"}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.783096917039147*^9, 3.7830969396252623`*^9}, {
  3.783096975189172*^9, 3.783096976809314*^9}, {3.78309705535282*^9, 
  3.783097122354154*^9}},
 CellLabel->
  "In[425]:=",ExpressionUUID->"12601d6f-6f51-4a26-b142-51adfd5fced5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToHex", "[", "bs_", "]"}], ":=", 
  RowBox[{"BaseForm", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Length", "[", "bs", "]"}], "-", "i"}], ")"}]}], "*", 
       RowBox[{"bs", "[", 
        RowBox[{"[", "i", "]"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "bs", "]"}]}], "}"}]}], "]"}], ",", "16"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.783097149251319*^9, 3.78309721090984*^9}},
 CellLabel->
  "In[426]:=",ExpressionUUID->"f4b2430a-da43-4e32-88df-acd4baf03da3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamToHex", "[", "ks_", "]"}], ":=", 
  RowBox[{"ToHex", "/@", 
   RowBox[{"(", 
    RowBox[{"ks", "//", "ToBytes"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.783096804772388*^9, 3.783096806748879*^9}, {
  3.783096851982381*^9, 3.783096854406184*^9}, {3.783096898912195*^9, 
  3.7830969139711113`*^9}},
 CellLabel->
  "In[427]:=",ExpressionUUID->"06f109b9-cc17-43c9-ac91-1d788ccd6ce6"],

Cell[CellGroupData[{

Cell["On zero key and zero IV", "Subsubsection",
 CellChangeTimes->{{3.7770437501920137`*^9, 
  3.77704375304657*^9}},ExpressionUUID->"d48066fd-2178-4761-8e7e-\
d9dc72ed33ae"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToHex", "[", 
  RowBox[{"TriviumKeystream", "[", 
   RowBox[{
    RowBox[{"ZeroKey", "[", "80", "]"}], ",", 
    RowBox[{"ZeroKey", "[", "80", "]"}], ",", "1500"}], "]"}], "]"}]], "Input",\

 CellChangeTimes->{{3.783097307048815*^9, 3.7830973088848467`*^9}, 
   3.783097345400868*^9},
 CellLabel->
  "In[428]:=",ExpressionUUID->"6f401191-5ad5-420b-a171-1681851f5183"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"18\"\>", "\<\"16\"\>"],
     24,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"80\"\>", "\<\"16\"\>"],
     128,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"20\"\>", "\<\"16\"\>"],
     32,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"70\"\>", "\<\"16\"\>"],
     112,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ec\"\>", "\<\"16\"\>"],
     236,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9\"\>", "\<\"16\"\>"],
     9,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ce\"\>", "\<\"16\"\>"],
     206,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c7\"\>", "\<\"16\"\>"],
     199,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d\"\>", "\<\"16\"\>"],
     13,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e6\"\>", "\<\"16\"\>"],
     230,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c9\"\>", "\<\"16\"\>"],
     201,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ea\"\>", "\<\"16\"\>"],
     234,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8f\"\>", "\<\"16\"\>"],
     143,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"23\"\>", "\<\"16\"\>"],
     35,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b8\"\>", "\<\"16\"\>"],
     184,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b\"\>", "\<\"16\"\>"],
     11,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"38\"\>", "\<\"16\"\>"],
     56,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cc\"\>", "\<\"16\"\>"],
     204,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3f\"\>", "\<\"16\"\>"],
     63,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d5\"\>", "\<\"16\"\>"],
     213,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"21\"\>", "\<\"16\"\>"],
     33,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"59\"\>", "\<\"16\"\>"],
     89,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9b\"\>", "\<\"16\"\>"],
     155,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bd\"\>", "\<\"16\"\>"],
     189,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cd\"\>", "\<\"16\"\>"],
     205,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b2\"\>", "\<\"16\"\>"],
     178,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"72\"\>", "\<\"16\"\>"],
     114,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9\"\>", "\<\"16\"\>"],
     9,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"50\"\>", "\<\"16\"\>"],
     80,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"14\"\>", "\<\"16\"\>"],
     20,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f7\"\>", "\<\"16\"\>"],
     247,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"23\"\>", "\<\"16\"\>"],
     35,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d3\"\>", "\<\"16\"\>"],
     211,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c8\"\>", "\<\"16\"\>"],
     200,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6b\"\>", "\<\"16\"\>"],
     107,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9c\"\>", "\<\"16\"\>"],
     156,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"45\"\>", "\<\"16\"\>"],
     69,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ba\"\>", "\<\"16\"\>"],
     186,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dd\"\>", "\<\"16\"\>"],
     221,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"18\"\>", "\<\"16\"\>"],
     24,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"37\"\>", "\<\"16\"\>"],
     55,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"24\"\>", "\<\"16\"\>"],
     36,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a0\"\>", "\<\"16\"\>"],
     160,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fb\"\>", "\<\"16\"\>"],
     251,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9b\"\>", "\<\"16\"\>"],
     155,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b5\"\>", "\<\"16\"\>"],
     181,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"61\"\>", "\<\"16\"\>"],
     97,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"41\"\>", "\<\"16\"\>"],
     65,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f\"\>", "\<\"16\"\>"],
     15,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a1\"\>", "\<\"16\"\>"],
     161,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2e\"\>", "\<\"16\"\>"],
     46,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"86\"\>", "\<\"16\"\>"],
     134,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e2\"\>", "\<\"16\"\>"],
     226,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bb\"\>", "\<\"16\"\>"],
     187,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"48\"\>", "\<\"16\"\>"],
     72,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fb\"\>", "\<\"16\"\>"],
     251,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4f\"\>", "\<\"16\"\>"],
     79,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b2\"\>", "\<\"16\"\>"],
     178,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"69\"\>", "\<\"16\"\>"],
     105,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"52\"\>", "\<\"16\"\>"],
     82,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"27\"\>", "\<\"16\"\>"],
     39,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3a\"\>", "\<\"16\"\>"],
     58,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ca\"\>", "\<\"16\"\>"],
     202,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"af\"\>", "\<\"16\"\>"],
     175,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3a\"\>", "\<\"16\"\>"],
     58,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"42\"\>", "\<\"16\"\>"],
     66,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"96\"\>", "\<\"16\"\>"],
     150,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"81\"\>", "\<\"16\"\>"],
     129,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a3\"\>", "\<\"16\"\>"],
     163,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f\"\>", "\<\"16\"\>"],
     15,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e7\"\>", "\<\"16\"\>"],
     231,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e1\"\>", "\<\"16\"\>"],
     225,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c1\"\>", "\<\"16\"\>"],
     193,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7d\"\>", "\<\"16\"\>"],
     125,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"35\"\>", "\<\"16\"\>"],
     53,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4b\"\>", "\<\"16\"\>"],
     75,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"27\"\>", "\<\"16\"\>"],
     39,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ec\"\>", "\<\"16\"\>"],
     236,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"59\"\>", "\<\"16\"\>"],
     89,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7\"\>", "\<\"16\"\>"],
     7,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fd\"\>", "\<\"16\"\>"],
     253,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"64\"\>", "\<\"16\"\>"],
     100,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9a\"\>", "\<\"16\"\>"],
     154,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a0\"\>", "\<\"16\"\>"],
     160,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8a\"\>", "\<\"16\"\>"],
     138,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5e\"\>", "\<\"16\"\>"],
     94,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"74\"\>", "\<\"16\"\>"],
     116,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"72\"\>", "\<\"16\"\>"],
     114,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f9\"\>", "\<\"16\"\>"],
     249,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fe\"\>", "\<\"16\"\>"],
     254,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6a\"\>", "\<\"16\"\>"],
     106,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4c\"\>", "\<\"16\"\>"],
     76,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c0\"\>", "\<\"16\"\>"],
     192,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"68\"\>", "\<\"16\"\>"],
     104,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"98\"\>", "\<\"16\"\>"],
     152,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f3\"\>", "\<\"16\"\>"],
     243,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b4\"\>", "\<\"16\"\>"],
     180,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e7\"\>", "\<\"16\"\>"],
     231,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9e\"\>", "\<\"16\"\>"],
     158,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"85\"\>", "\<\"16\"\>"],
     133,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4d\"\>", "\<\"16\"\>"],
     77,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"97\"\>", "\<\"16\"\>"],
     151,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ef\"\>", "\<\"16\"\>"],
     239,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"49\"\>", "\<\"16\"\>"],
     73,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c0\"\>", "\<\"16\"\>"],
     192,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"40\"\>", "\<\"16\"\>"],
     64,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"16\"\>", "\<\"16\"\>"],
     22,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ed\"\>", "\<\"16\"\>"],
     237,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1c\"\>", "\<\"16\"\>"],
     28,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d4\"\>", "\<\"16\"\>"],
     212,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"32\"\>", "\<\"16\"\>"],
     50,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"58\"\>", "\<\"16\"\>"],
     88,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a\"\>", "\<\"16\"\>"],
     10,
     Editable->False],
    BaseForm[#, 16]& ]}], "}"}]], "Output",
 CellChangeTimes->{3.783097309776382*^9, 3.783097347122076*^9, 
  3.783097561094406*^9, 3.7831016611201477`*^9, 3.783186666935645*^9, 
  3.783445232255176*^9, 3.783878269770307*^9, 3.7839297983733673`*^9, 
  3.784214741743891*^9, 3.784214797846923*^9, 3.7843909589934063`*^9, 
  3.792136049153109*^9, 3.7930842144791737`*^9, 3.793339964330718*^9, 
  3.794985759909605*^9, 3.794986410138298*^9, 3.79498825193528*^9, 
  3.79887172176437*^9, 3.799333488226324*^9},
 CellLabel->
  "Out[428]=",ExpressionUUID->"af158c75-8886-432b-be36-3752e2946a44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToHex", "[", 
  RowBox[{"TriviumKeystreamS", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"ZeroKey", "[", "285", "]"}], "~", "Join", "~", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", "1500"}], "]"}], 
  "]"}]], "Input",
 CellLabel->
  "In[429]:=",ExpressionUUID->"7b9d571f-75c4-4d45-804e-8f1becb15f07"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"18\"\>", "\<\"16\"\>"],
     24,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"80\"\>", "\<\"16\"\>"],
     128,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"20\"\>", "\<\"16\"\>"],
     32,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"70\"\>", "\<\"16\"\>"],
     112,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ec\"\>", "\<\"16\"\>"],
     236,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9\"\>", "\<\"16\"\>"],
     9,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ce\"\>", "\<\"16\"\>"],
     206,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c7\"\>", "\<\"16\"\>"],
     199,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d\"\>", "\<\"16\"\>"],
     13,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e6\"\>", "\<\"16\"\>"],
     230,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c9\"\>", "\<\"16\"\>"],
     201,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ea\"\>", "\<\"16\"\>"],
     234,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8f\"\>", "\<\"16\"\>"],
     143,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"23\"\>", "\<\"16\"\>"],
     35,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b8\"\>", "\<\"16\"\>"],
     184,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b\"\>", "\<\"16\"\>"],
     11,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"38\"\>", "\<\"16\"\>"],
     56,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cc\"\>", "\<\"16\"\>"],
     204,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3f\"\>", "\<\"16\"\>"],
     63,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d5\"\>", "\<\"16\"\>"],
     213,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"21\"\>", "\<\"16\"\>"],
     33,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"59\"\>", "\<\"16\"\>"],
     89,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9b\"\>", "\<\"16\"\>"],
     155,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bd\"\>", "\<\"16\"\>"],
     189,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cd\"\>", "\<\"16\"\>"],
     205,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b2\"\>", "\<\"16\"\>"],
     178,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"72\"\>", "\<\"16\"\>"],
     114,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9\"\>", "\<\"16\"\>"],
     9,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"50\"\>", "\<\"16\"\>"],
     80,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"14\"\>", "\<\"16\"\>"],
     20,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f7\"\>", "\<\"16\"\>"],
     247,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"23\"\>", "\<\"16\"\>"],
     35,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d3\"\>", "\<\"16\"\>"],
     211,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c8\"\>", "\<\"16\"\>"],
     200,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6b\"\>", "\<\"16\"\>"],
     107,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9c\"\>", "\<\"16\"\>"],
     156,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"45\"\>", "\<\"16\"\>"],
     69,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ba\"\>", "\<\"16\"\>"],
     186,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dd\"\>", "\<\"16\"\>"],
     221,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"18\"\>", "\<\"16\"\>"],
     24,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"37\"\>", "\<\"16\"\>"],
     55,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"24\"\>", "\<\"16\"\>"],
     36,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a0\"\>", "\<\"16\"\>"],
     160,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fb\"\>", "\<\"16\"\>"],
     251,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9b\"\>", "\<\"16\"\>"],
     155,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b5\"\>", "\<\"16\"\>"],
     181,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"61\"\>", "\<\"16\"\>"],
     97,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"41\"\>", "\<\"16\"\>"],
     65,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f\"\>", "\<\"16\"\>"],
     15,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a1\"\>", "\<\"16\"\>"],
     161,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2e\"\>", "\<\"16\"\>"],
     46,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"86\"\>", "\<\"16\"\>"],
     134,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e2\"\>", "\<\"16\"\>"],
     226,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bb\"\>", "\<\"16\"\>"],
     187,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"48\"\>", "\<\"16\"\>"],
     72,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fb\"\>", "\<\"16\"\>"],
     251,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4f\"\>", "\<\"16\"\>"],
     79,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b2\"\>", "\<\"16\"\>"],
     178,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"69\"\>", "\<\"16\"\>"],
     105,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"52\"\>", "\<\"16\"\>"],
     82,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"27\"\>", "\<\"16\"\>"],
     39,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3a\"\>", "\<\"16\"\>"],
     58,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ca\"\>", "\<\"16\"\>"],
     202,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"af\"\>", "\<\"16\"\>"],
     175,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3a\"\>", "\<\"16\"\>"],
     58,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"42\"\>", "\<\"16\"\>"],
     66,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"96\"\>", "\<\"16\"\>"],
     150,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"81\"\>", "\<\"16\"\>"],
     129,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a3\"\>", "\<\"16\"\>"],
     163,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f\"\>", "\<\"16\"\>"],
     15,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e7\"\>", "\<\"16\"\>"],
     231,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e1\"\>", "\<\"16\"\>"],
     225,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c1\"\>", "\<\"16\"\>"],
     193,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7d\"\>", "\<\"16\"\>"],
     125,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"35\"\>", "\<\"16\"\>"],
     53,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4b\"\>", "\<\"16\"\>"],
     75,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"27\"\>", "\<\"16\"\>"],
     39,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ec\"\>", "\<\"16\"\>"],
     236,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"59\"\>", "\<\"16\"\>"],
     89,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7\"\>", "\<\"16\"\>"],
     7,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fd\"\>", "\<\"16\"\>"],
     253,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"64\"\>", "\<\"16\"\>"],
     100,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9a\"\>", "\<\"16\"\>"],
     154,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a0\"\>", "\<\"16\"\>"],
     160,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8a\"\>", "\<\"16\"\>"],
     138,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5e\"\>", "\<\"16\"\>"],
     94,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"74\"\>", "\<\"16\"\>"],
     116,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"72\"\>", "\<\"16\"\>"],
     114,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f9\"\>", "\<\"16\"\>"],
     249,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fe\"\>", "\<\"16\"\>"],
     254,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6a\"\>", "\<\"16\"\>"],
     106,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4c\"\>", "\<\"16\"\>"],
     76,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c0\"\>", "\<\"16\"\>"],
     192,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"68\"\>", "\<\"16\"\>"],
     104,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"98\"\>", "\<\"16\"\>"],
     152,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f3\"\>", "\<\"16\"\>"],
     243,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b4\"\>", "\<\"16\"\>"],
     180,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e7\"\>", "\<\"16\"\>"],
     231,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9e\"\>", "\<\"16\"\>"],
     158,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"85\"\>", "\<\"16\"\>"],
     133,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4d\"\>", "\<\"16\"\>"],
     77,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"97\"\>", "\<\"16\"\>"],
     151,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ef\"\>", "\<\"16\"\>"],
     239,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"49\"\>", "\<\"16\"\>"],
     73,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c0\"\>", "\<\"16\"\>"],
     192,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"40\"\>", "\<\"16\"\>"],
     64,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"16\"\>", "\<\"16\"\>"],
     22,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ed\"\>", "\<\"16\"\>"],
     237,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1c\"\>", "\<\"16\"\>"],
     28,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d4\"\>", "\<\"16\"\>"],
     212,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"32\"\>", "\<\"16\"\>"],
     50,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"58\"\>", "\<\"16\"\>"],
     88,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a\"\>", "\<\"16\"\>"],
     10,
     Editable->False],
    BaseForm[#, 16]& ]}], "}"}]], "Output",
 CellChangeTimes->{3.783097363994288*^9, 3.783097561378009*^9, 
  3.783101661964841*^9, 3.783186667243042*^9, 3.7834452325232067`*^9, 
  3.783878270073001*^9, 3.783929798662239*^9, 3.784214743441389*^9, 
  3.784214798162002*^9, 3.784390959443285*^9, 3.7921360494395657`*^9, 
  3.793084214779978*^9, 3.793339964631503*^9, 3.794985760195107*^9, 
  3.794986410416092*^9, 3.794988252216473*^9, 3.798871722057472*^9, 
  3.799333488535901*^9},
 CellLabel->
  "Out[429]=",ExpressionUUID->"f203d364-bb35-40e1-9e57-2d0ab1d64bec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamToHex", "[", 
   RowBox[{"TriviumKeystream", "[", 
    RowBox[{
     RowBox[{"ZeroKey", "[", "80", "]"}], ",", 
     RowBox[{"ZeroKey", "[", "80", "]"}], ",", "1500"}], "]"}], "]"}], "==", 
  RowBox[{"KeystreamToHex", "[", 
   RowBox[{"TriviumKeystreamS", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ZeroKey", "[", "285", "]"}], "~", "Join", "~", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", "1500"}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.777034269378234*^9, 3.777034285987267*^9}, {
  3.777034348658658*^9, 3.7770343487935038`*^9}, {3.777034483382904*^9, 
  3.777034486086464*^9}, {3.777034587463667*^9, 3.777034594028759*^9}, {
  3.77703466927477*^9, 3.7770347502038393`*^9}, {3.777043733579077*^9, 
  3.7770437374574957`*^9}, {3.783097237159655*^9, 3.783097242829546*^9}, {
  3.783097368656067*^9, 3.783097370635199*^9}},
 CellLabel->
  "In[430]:=",ExpressionUUID->"e98e2f07-a9d2-4d2e-a03f-085bba745472"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.777034286490738*^9, {3.7770343380848722`*^9, 3.777034370914179*^9}, 
   3.7770344867477293`*^9, {3.777034594782731*^9, 3.777034785311356*^9}, 
   3.7770364984678383`*^9, 3.7770433190318947`*^9, 3.777043738553875*^9, 
   3.777188349720297*^9, 3.7775676444923687`*^9, 3.7775681556469307`*^9, 
   3.777568296102262*^9, 3.777620443776462*^9, 3.78219606173309*^9, 
   3.783096776394936*^9, 3.78309718016486*^9, {3.783097220572921*^9, 
   3.7830972438766823`*^9}, 3.783097371898596*^9, 3.783097561761284*^9, 
   3.7831016623897457`*^9, 3.783186667623362*^9, 3.783445232893715*^9, 
   3.783878270590735*^9, 3.783929799033389*^9, 3.784214744509666*^9, 
   3.7842147986643877`*^9, 3.784390960082477*^9, 3.792136049810494*^9, 
   3.7930842152501497`*^9, 3.79333996520518*^9, 3.794985760569206*^9, 
   3.794986410894652*^9, 3.794988252625206*^9, 3.798871722620924*^9, 
   3.799333488948004*^9},
 CellLabel->
  "Out[430]=",ExpressionUUID->"ff1cc609-0509-493d-b8cc-9d768be02238"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["On a non-zero key and IV", "Subsubsection",
 CellChangeTimes->{{3.777043755887459*^9, 
  3.77704376633209*^9}},ExpressionUUID->"f9b3b13a-380d-480f-84fe-\
f46d306d255c"],

Cell[BoxData[
 RowBox[{"TriviumTestKey", ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
       "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "10"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.777043583848754*^9, 3.77704363275469*^9}, {
  3.783097379080862*^9, 3.783097379905443*^9}},
 CellLabel->
  "In[431]:=",ExpressionUUID->"d9516ca3-50fc-4180-9967-27aed2d635a0"],

Cell[BoxData[
 RowBox[{"TriviumTestIV", ":=", 
  RowBox[{"Join", "@@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
       "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "10"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.777043639805092*^9, 3.777043643707039*^9}, {
  3.7830973808372927`*^9, 3.7830973816080847`*^9}},
 CellLabel->
  "In[432]:=",ExpressionUUID->"e8e9f27a-d756-48ff-9d10-281fd120afbe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToHex", "[", 
  RowBox[{"TriviumKeystream", "[", 
   RowBox[{"TriviumTestKey", ",", "TriviumTestIV", ",", "1500"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.777034269378234*^9, 3.777034285987267*^9}, {
  3.777034348658658*^9, 3.7770343487935038`*^9}, {3.777034483382904*^9, 
  3.777034486086464*^9}, {3.777034587463667*^9, 3.777034594028759*^9}, {
  3.77703466927477*^9, 3.7770347502038393`*^9}, {3.7770436509530783`*^9, 
  3.777043660121005*^9}, {3.783097385076692*^9, 3.783097393548171*^9}},
 CellLabel->
  "In[433]:=",ExpressionUUID->"099b74e6-3cee-4bff-a4de-29cc90f1d29a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"eb\"\>", "\<\"16\"\>"],
     235,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"67\"\>", "\<\"16\"\>"],
     103,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b7\"\>", "\<\"16\"\>"],
     183,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"60\"\>", "\<\"16\"\>"],
     96,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4b\"\>", "\<\"16\"\>"],
     75,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f4\"\>", "\<\"16\"\>"],
     244,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b4\"\>", "\<\"16\"\>"],
     180,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b9\"\>", "\<\"16\"\>"],
     185,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"86\"\>", "\<\"16\"\>"],
     134,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"39\"\>", "\<\"16\"\>"],
     57,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"32\"\>", "\<\"16\"\>"],
     50,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d1\"\>", "\<\"16\"\>"],
     209,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"71\"\>", "\<\"16\"\>"],
     113,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6c\"\>", "\<\"16\"\>"],
     108,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ef\"\>", "\<\"16\"\>"],
     239,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b0\"\>", "\<\"16\"\>"],
     176,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5a\"\>", "\<\"16\"\>"],
     90,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"60\"\>", "\<\"16\"\>"],
     96,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ba\"\>", "\<\"16\"\>"],
     186,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"89\"\>", "\<\"16\"\>"],
     137,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a8\"\>", "\<\"16\"\>"],
     168,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1e\"\>", "\<\"16\"\>"],
     30,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4\"\>", "\<\"16\"\>"],
     4,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"69\"\>", "\<\"16\"\>"],
     105,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6f\"\>", "\<\"16\"\>"],
     111,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"31\"\>", "\<\"16\"\>"],
     49,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"81\"\>", "\<\"16\"\>"],
     129,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ed\"\>", "\<\"16\"\>"],
     237,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8c\"\>", "\<\"16\"\>"],
     140,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"82\"\>", "\<\"16\"\>"],
     130,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f7\"\>", "\<\"16\"\>"],
     247,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6b\"\>", "\<\"16\"\>"],
     107,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"76\"\>", "\<\"16\"\>"],
     118,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"37\"\>", "\<\"16\"\>"],
     55,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ee\"\>", "\<\"16\"\>"],
     238,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"14\"\>", "\<\"16\"\>"],
     20,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5d\"\>", "\<\"16\"\>"],
     93,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"61\"\>", "\<\"16\"\>"],
     97,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9e\"\>", "\<\"16\"\>"],
     158,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a6\"\>", "\<\"16\"\>"],
     166,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e3\"\>", "\<\"16\"\>"],
     227,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b7\"\>", "\<\"16\"\>"],
     183,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8c\"\>", "\<\"16\"\>"],
     140,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d\"\>", "\<\"16\"\>"],
     13,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4f\"\>", "\<\"16\"\>"],
     79,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f9\"\>", "\<\"16\"\>"],
     249,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a7\"\>", "\<\"16\"\>"],
     167,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ea\"\>", "\<\"16\"\>"],
     234,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d1\"\>", "\<\"16\"\>"],
     209,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cb\"\>", "\<\"16\"\>"],
     203,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9f\"\>", "\<\"16\"\>"],
     159,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"24\"\>", "\<\"16\"\>"],
     36,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"29\"\>", "\<\"16\"\>"],
     41,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c\"\>", "\<\"16\"\>"],
     12,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"88\"\>", "\<\"16\"\>"],
     136,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"54\"\>", "\<\"16\"\>"],
     84,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"74\"\>", "\<\"16\"\>"],
     116,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6e\"\>", "\<\"16\"\>"],
     110,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"28\"\>", "\<\"16\"\>"],
     40,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"39\"\>", "\<\"16\"\>"],
     57,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"82\"\>", "\<\"16\"\>"],
     130,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"71\"\>", "\<\"16\"\>"],
     113,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bc\"\>", "\<\"16\"\>"],
     188,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5d\"\>", "\<\"16\"\>"],
     93,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2b\"\>", "\<\"16\"\>"],
     43,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5e\"\>", "\<\"16\"\>"],
     94,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d7\"\>", "\<\"16\"\>"],
     215,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6e\"\>", "\<\"16\"\>"],
     110,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"57\"\>", "\<\"16\"\>"],
     87,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e1\"\>", "\<\"16\"\>"],
     225,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8a\"\>", "\<\"16\"\>"],
     138,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9d\"\>", "\<\"16\"\>"],
     157,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"33\"\>", "\<\"16\"\>"],
     51,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a3\"\>", "\<\"16\"\>"],
     163,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4d\"\>", "\<\"16\"\>"],
     77,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1e\"\>", "\<\"16\"\>"],
     30,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"16\"\>", "\<\"16\"\>"],
     22,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"13\"\>", "\<\"16\"\>"],
     19,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dc\"\>", "\<\"16\"\>"],
     220,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"84\"\>", "\<\"16\"\>"],
     132,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6c\"\>", "\<\"16\"\>"],
     108,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"51\"\>", "\<\"16\"\>"],
     81,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5a\"\>", "\<\"16\"\>"],
     90,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"39\"\>", "\<\"16\"\>"],
     57,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"eb\"\>", "\<\"16\"\>"],
     235,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"99\"\>", "\<\"16\"\>"],
     153,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ac\"\>", "\<\"16\"\>"],
     172,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"db\"\>", "\<\"16\"\>"],
     219,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9c\"\>", "\<\"16\"\>"],
     156,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8a\"\>", "\<\"16\"\>"],
     138,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3e\"\>", "\<\"16\"\>"],
     62,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"13\"\>", "\<\"16\"\>"],
     19,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"20\"\>", "\<\"16\"\>"],
     32,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e4\"\>", "\<\"16\"\>"],
     228,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"22\"\>", "\<\"16\"\>"],
     34,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b8\"\>", "\<\"16\"\>"],
     184,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d4\"\>", "\<\"16\"\>"],
     212,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5a\"\>", "\<\"16\"\>"],
     90,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"10\"\>", "\<\"16\"\>"],
     16,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2a\"\>", "\<\"16\"\>"],
     42,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b7\"\>", "\<\"16\"\>"],
     183,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2b\"\>", "\<\"16\"\>"],
     43,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1b\"\>", "\<\"16\"\>"],
     27,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"97\"\>", "\<\"16\"\>"],
     151,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f8\"\>", "\<\"16\"\>"],
     248,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ae\"\>", "\<\"16\"\>"],
     174,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9a\"\>", "\<\"16\"\>"],
     154,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c7\"\>", "\<\"16\"\>"],
     199,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"67\"\>", "\<\"16\"\>"],
     103,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c8\"\>", "\<\"16\"\>"],
     200,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"80\"\>", "\<\"16\"\>"],
     128,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9d\"\>", "\<\"16\"\>"],
     157,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"46\"\>", "\<\"16\"\>"],
     70,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f2\"\>", "\<\"16\"\>"],
     242,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8c\"\>", "\<\"16\"\>"],
     140,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cb\"\>", "\<\"16\"\>"],
     203,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2\"\>", "\<\"16\"\>"],
     2,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"28\"\>", "\<\"16\"\>"],
     40,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3f\"\>", "\<\"16\"\>"],
     63,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ed\"\>", "\<\"16\"\>"],
     237,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"87\"\>", "\<\"16\"\>"],
     135,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7a\"\>", "\<\"16\"\>"],
     122,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dc\"\>", "\<\"16\"\>"],
     220,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3c\"\>", "\<\"16\"\>"],
     60,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ee\"\>", "\<\"16\"\>"],
     238,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"aa\"\>", "\<\"16\"\>"],
     170,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9f\"\>", "\<\"16\"\>"],
     159,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"99\"\>", "\<\"16\"\>"],
     153,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e3\"\>", "\<\"16\"\>"],
     227,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5e\"\>", "\<\"16\"\>"],
     94,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"60\"\>", "\<\"16\"\>"],
     96,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ee\"\>", "\<\"16\"\>"],
     238,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c9\"\>", "\<\"16\"\>"],
     201,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c5\"\>", "\<\"16\"\>"],
     197,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"58\"\>", "\<\"16\"\>"],
     88,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5\"\>", "\<\"16\"\>"],
     5,
     Editable->False],
    BaseForm[#, 16]& ]}], "}"}]], "Output",
 CellChangeTimes->{
  3.777034286490738*^9, {3.7770343380848722`*^9, 3.777034370914179*^9}, 
   3.7770344867477293`*^9, {3.777034594782731*^9, 3.777034785311356*^9}, 
   3.7770364984678383`*^9, 3.7770433190318947`*^9, 3.777043660507605*^9, 
   3.7771883500729113`*^9, 3.7775676447344646`*^9, 3.77756815586804*^9, 
   3.7775682962858143`*^9, 3.777620444277021*^9, {3.7830973906443653`*^9, 
   3.783097394332526*^9}, 3.783097562018195*^9, 3.783101662717314*^9, 
   3.783186667906534*^9, 3.783445233128601*^9, 3.783878271992258*^9, 
   3.783929799296736*^9, 3.784214745627698*^9, 3.7842147989182043`*^9, 
   3.78439096036439*^9, 3.792136050078856*^9, 3.793084215492897*^9, 
   3.7933399656102533`*^9, 3.7949857608267517`*^9, 3.794986411132143*^9, 
   3.794988253099361*^9, 3.798871722859598*^9, 3.799333489204391*^9},
 CellLabel->
  "Out[433]=",ExpressionUUID->"6e635010-0793-42c4-ac7e-5e969d4498d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KeystreamToHex", "[", 
  RowBox[{"TriviumKeystreamS", "[", 
   RowBox[{
    RowBox[{"TriviumTestKey", "~", "Join", "~", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "81", ",", "93"}], "}"}]}], "]"}], "~", "Join", "~",
      "TriviumTestIV", "~", "Join", "~", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "81", ",", "84"}], "}"}]}], "]"}], "~", "Join", "~", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "108"}], "}"}]}], "]"}], "~", "Join", "~", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], ",", "1500"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7770436710122843`*^9, 3.777043718890452*^9}, {
  3.783097399590032*^9, 3.783097405235396*^9}},
 CellLabel->
  "In[434]:=",ExpressionUUID->"1aa05a6c-5dac-449c-80bf-15ca38682056"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"eb\"\>", "\<\"16\"\>"],
     235,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7b\"\>", "\<\"16\"\>"],
     123,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"67\"\>", "\<\"16\"\>"],
     103,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b7\"\>", "\<\"16\"\>"],
     183,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"60\"\>", "\<\"16\"\>"],
     96,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4b\"\>", "\<\"16\"\>"],
     75,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f4\"\>", "\<\"16\"\>"],
     244,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b4\"\>", "\<\"16\"\>"],
     180,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b9\"\>", "\<\"16\"\>"],
     185,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"86\"\>", "\<\"16\"\>"],
     134,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"39\"\>", "\<\"16\"\>"],
     57,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"32\"\>", "\<\"16\"\>"],
     50,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d1\"\>", "\<\"16\"\>"],
     209,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"71\"\>", "\<\"16\"\>"],
     113,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6c\"\>", "\<\"16\"\>"],
     108,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ef\"\>", "\<\"16\"\>"],
     239,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b0\"\>", "\<\"16\"\>"],
     176,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5a\"\>", "\<\"16\"\>"],
     90,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"60\"\>", "\<\"16\"\>"],
     96,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ba\"\>", "\<\"16\"\>"],
     186,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"89\"\>", "\<\"16\"\>"],
     137,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a8\"\>", "\<\"16\"\>"],
     168,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1e\"\>", "\<\"16\"\>"],
     30,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4\"\>", "\<\"16\"\>"],
     4,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"69\"\>", "\<\"16\"\>"],
     105,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6f\"\>", "\<\"16\"\>"],
     111,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"31\"\>", "\<\"16\"\>"],
     49,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"81\"\>", "\<\"16\"\>"],
     129,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ed\"\>", "\<\"16\"\>"],
     237,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8c\"\>", "\<\"16\"\>"],
     140,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"82\"\>", "\<\"16\"\>"],
     130,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f7\"\>", "\<\"16\"\>"],
     247,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6b\"\>", "\<\"16\"\>"],
     107,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"76\"\>", "\<\"16\"\>"],
     118,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"37\"\>", "\<\"16\"\>"],
     55,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ee\"\>", "\<\"16\"\>"],
     238,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"14\"\>", "\<\"16\"\>"],
     20,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5d\"\>", "\<\"16\"\>"],
     93,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"61\"\>", "\<\"16\"\>"],
     97,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9e\"\>", "\<\"16\"\>"],
     158,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a6\"\>", "\<\"16\"\>"],
     166,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e3\"\>", "\<\"16\"\>"],
     227,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b7\"\>", "\<\"16\"\>"],
     183,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8c\"\>", "\<\"16\"\>"],
     140,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d\"\>", "\<\"16\"\>"],
     13,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4f\"\>", "\<\"16\"\>"],
     79,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f9\"\>", "\<\"16\"\>"],
     249,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a7\"\>", "\<\"16\"\>"],
     167,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ea\"\>", "\<\"16\"\>"],
     234,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d1\"\>", "\<\"16\"\>"],
     209,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cb\"\>", "\<\"16\"\>"],
     203,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9f\"\>", "\<\"16\"\>"],
     159,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"24\"\>", "\<\"16\"\>"],
     36,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"29\"\>", "\<\"16\"\>"],
     41,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c\"\>", "\<\"16\"\>"],
     12,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"88\"\>", "\<\"16\"\>"],
     136,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"54\"\>", "\<\"16\"\>"],
     84,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"74\"\>", "\<\"16\"\>"],
     116,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6e\"\>", "\<\"16\"\>"],
     110,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"28\"\>", "\<\"16\"\>"],
     40,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"39\"\>", "\<\"16\"\>"],
     57,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"82\"\>", "\<\"16\"\>"],
     130,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"71\"\>", "\<\"16\"\>"],
     113,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bc\"\>", "\<\"16\"\>"],
     188,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5d\"\>", "\<\"16\"\>"],
     93,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2b\"\>", "\<\"16\"\>"],
     43,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5e\"\>", "\<\"16\"\>"],
     94,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d7\"\>", "\<\"16\"\>"],
     215,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6e\"\>", "\<\"16\"\>"],
     110,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"57\"\>", "\<\"16\"\>"],
     87,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e1\"\>", "\<\"16\"\>"],
     225,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8a\"\>", "\<\"16\"\>"],
     138,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9d\"\>", "\<\"16\"\>"],
     157,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"33\"\>", "\<\"16\"\>"],
     51,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a3\"\>", "\<\"16\"\>"],
     163,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4d\"\>", "\<\"16\"\>"],
     77,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1e\"\>", "\<\"16\"\>"],
     30,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"16\"\>", "\<\"16\"\>"],
     22,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"13\"\>", "\<\"16\"\>"],
     19,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dc\"\>", "\<\"16\"\>"],
     220,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"84\"\>", "\<\"16\"\>"],
     132,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6c\"\>", "\<\"16\"\>"],
     108,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"51\"\>", "\<\"16\"\>"],
     81,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5a\"\>", "\<\"16\"\>"],
     90,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"39\"\>", "\<\"16\"\>"],
     57,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"eb\"\>", "\<\"16\"\>"],
     235,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"99\"\>", "\<\"16\"\>"],
     153,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ac\"\>", "\<\"16\"\>"],
     172,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"db\"\>", "\<\"16\"\>"],
     219,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9c\"\>", "\<\"16\"\>"],
     156,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8a\"\>", "\<\"16\"\>"],
     138,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3e\"\>", "\<\"16\"\>"],
     62,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"13\"\>", "\<\"16\"\>"],
     19,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"20\"\>", "\<\"16\"\>"],
     32,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e4\"\>", "\<\"16\"\>"],
     228,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"22\"\>", "\<\"16\"\>"],
     34,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b8\"\>", "\<\"16\"\>"],
     184,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d4\"\>", "\<\"16\"\>"],
     212,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5a\"\>", "\<\"16\"\>"],
     90,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"10\"\>", "\<\"16\"\>"],
     16,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2a\"\>", "\<\"16\"\>"],
     42,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b7\"\>", "\<\"16\"\>"],
     183,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2b\"\>", "\<\"16\"\>"],
     43,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1b\"\>", "\<\"16\"\>"],
     27,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"97\"\>", "\<\"16\"\>"],
     151,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f8\"\>", "\<\"16\"\>"],
     248,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ae\"\>", "\<\"16\"\>"],
     174,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9a\"\>", "\<\"16\"\>"],
     154,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c7\"\>", "\<\"16\"\>"],
     199,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"67\"\>", "\<\"16\"\>"],
     103,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c8\"\>", "\<\"16\"\>"],
     200,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"80\"\>", "\<\"16\"\>"],
     128,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9d\"\>", "\<\"16\"\>"],
     157,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"46\"\>", "\<\"16\"\>"],
     70,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f2\"\>", "\<\"16\"\>"],
     242,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8c\"\>", "\<\"16\"\>"],
     140,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cb\"\>", "\<\"16\"\>"],
     203,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2\"\>", "\<\"16\"\>"],
     2,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"28\"\>", "\<\"16\"\>"],
     40,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3f\"\>", "\<\"16\"\>"],
     63,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ed\"\>", "\<\"16\"\>"],
     237,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"87\"\>", "\<\"16\"\>"],
     135,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7a\"\>", "\<\"16\"\>"],
     122,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dc\"\>", "\<\"16\"\>"],
     220,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3c\"\>", "\<\"16\"\>"],
     60,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ee\"\>", "\<\"16\"\>"],
     238,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"aa\"\>", "\<\"16\"\>"],
     170,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9f\"\>", "\<\"16\"\>"],
     159,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"99\"\>", "\<\"16\"\>"],
     153,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e3\"\>", "\<\"16\"\>"],
     227,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5e\"\>", "\<\"16\"\>"],
     94,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"60\"\>", "\<\"16\"\>"],
     96,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ee\"\>", "\<\"16\"\>"],
     238,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c9\"\>", "\<\"16\"\>"],
     201,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c5\"\>", "\<\"16\"\>"],
     197,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d8\"\>", "\<\"16\"\>"],
     216,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"58\"\>", "\<\"16\"\>"],
     88,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5\"\>", "\<\"16\"\>"],
     5,
     Editable->False],
    BaseForm[#, 16]& ]}], "}"}]], "Output",
 CellChangeTimes->{3.777043720764885*^9, 3.777188350416295*^9, 
  3.777567645034965*^9, 3.777568156234241*^9, 3.777568296599104*^9, 
  3.777620444542859*^9, 3.783097405896229*^9, 3.783097562310285*^9, 
  3.783101663053813*^9, 3.783186668224099*^9, 3.783445233396432*^9, 
  3.783878273097776*^9, 3.783929799582203*^9, 3.784214746274197*^9, 
  3.7842147992291613`*^9, 3.78439096093286*^9, 3.792136050357566*^9, 
  3.79308421578559*^9, 3.7933399659161663`*^9, 3.794985761197715*^9, 
  3.794986411402397*^9, 3.794988253379554*^9, 3.798871723145158*^9, 
  3.799333489484539*^9},
 CellLabel->
  "Out[434]=",ExpressionUUID->"6224db42-f2d0-4e03-9bf0-1de01e4a12e9"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Example to show why first 1152 bits are discarded: unusually many 0 bits\
\>", "Subsection",
 CellChangeTimes->{{3.777032088665051*^9, 3.7770320990844393`*^9}, {
  3.783097466576234*^9, 
  3.783097469647024*^9}},ExpressionUUID->"d0981fdd-5c13-4a72-9d09-\
e4efbc66168c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"KeystreamToHex", "[", 
   RowBox[{"TriviumKeystream", "[", 
    RowBox[{
     RowBox[{"ZeroKey", "[", "80", "]"}], ",", 
     RowBox[{"ZeroKey", "[", "80", "]"}], ",", "1500"}], "]"}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", 
    RowBox[{"1152", "/", "8"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.77704335476602*^9, 3.77704336589361*^9}, {
  3.7830974209869823`*^9, 3.783097430283739*^9}},
 CellLabel->
  "In[435]:=",ExpressionUUID->"c93ad751-5e67-40fe-b096-8911d6428591"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"18\"\>", "\<\"16\"\>"],
     24,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"80\"\>", "\<\"16\"\>"],
     128,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"20\"\>", "\<\"16\"\>"],
     32,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"70\"\>", "\<\"16\"\>"],
     112,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3\"\>", "\<\"16\"\>"],
     3,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ec\"\>", "\<\"16\"\>"],
     236,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9\"\>", "\<\"16\"\>"],
     9,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"0\"\>", "\<\"16\"\>"],
     0,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ce\"\>", "\<\"16\"\>"],
     206,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1\"\>", "\<\"16\"\>"],
     1,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c7\"\>", "\<\"16\"\>"],
     199,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d\"\>", "\<\"16\"\>"],
     13,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f0\"\>", "\<\"16\"\>"],
     240,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e6\"\>", "\<\"16\"\>"],
     230,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c9\"\>", "\<\"16\"\>"],
     201,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ea\"\>", "\<\"16\"\>"],
     234,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8f\"\>", "\<\"16\"\>"],
     143,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4a\"\>", "\<\"16\"\>"],
     74,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"23\"\>", "\<\"16\"\>"],
     35,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b8\"\>", "\<\"16\"\>"],
     184,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7c\"\>", "\<\"16\"\>"],
     124,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b\"\>", "\<\"16\"\>"],
     11,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"38\"\>", "\<\"16\"\>"],
     56,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cc\"\>", "\<\"16\"\>"],
     204,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3f\"\>", "\<\"16\"\>"],
     63,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d5\"\>", "\<\"16\"\>"],
     213,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"21\"\>", "\<\"16\"\>"],
     33,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"59\"\>", "\<\"16\"\>"],
     89,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9b\"\>", "\<\"16\"\>"],
     155,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bd\"\>", "\<\"16\"\>"],
     189,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"cd\"\>", "\<\"16\"\>"],
     205,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b2\"\>", "\<\"16\"\>"],
     178,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"72\"\>", "\<\"16\"\>"],
     114,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9\"\>", "\<\"16\"\>"],
     9,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"50\"\>", "\<\"16\"\>"],
     80,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8b\"\>", "\<\"16\"\>"],
     139,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"14\"\>", "\<\"16\"\>"],
     20,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b3\"\>", "\<\"16\"\>"],
     179,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f7\"\>", "\<\"16\"\>"],
     247,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"23\"\>", "\<\"16\"\>"],
     35,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"d3\"\>", "\<\"16\"\>"],
     211,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c8\"\>", "\<\"16\"\>"],
     200,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a4\"\>", "\<\"16\"\>"],
     164,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"30\"\>", "\<\"16\"\>"],
     48,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6b\"\>", "\<\"16\"\>"],
     107,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9c\"\>", "\<\"16\"\>"],
     156,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"45\"\>", "\<\"16\"\>"],
     69,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ba\"\>", "\<\"16\"\>"],
     186,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"dd\"\>", "\<\"16\"\>"],
     221,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8e\"\>", "\<\"16\"\>"],
     142,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"18\"\>", "\<\"16\"\>"],
     24,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"37\"\>", "\<\"16\"\>"],
     55,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"24\"\>", "\<\"16\"\>"],
     36,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a0\"\>", "\<\"16\"\>"],
     160,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e0\"\>", "\<\"16\"\>"],
     224,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fb\"\>", "\<\"16\"\>"],
     251,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"9b\"\>", "\<\"16\"\>"],
     155,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b5\"\>", "\<\"16\"\>"],
     181,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"61\"\>", "\<\"16\"\>"],
     97,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"41\"\>", "\<\"16\"\>"],
     65,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f\"\>", "\<\"16\"\>"],
     15,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a1\"\>", "\<\"16\"\>"],
     161,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2e\"\>", "\<\"16\"\>"],
     46,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"86\"\>", "\<\"16\"\>"],
     134,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e2\"\>", "\<\"16\"\>"],
     226,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"bb\"\>", "\<\"16\"\>"],
     187,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"48\"\>", "\<\"16\"\>"],
     72,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"fb\"\>", "\<\"16\"\>"],
     251,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4f\"\>", "\<\"16\"\>"],
     79,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"b2\"\>", "\<\"16\"\>"],
     178,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c2\"\>", "\<\"16\"\>"],
     194,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"69\"\>", "\<\"16\"\>"],
     105,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"52\"\>", "\<\"16\"\>"],
     82,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"90\"\>", "\<\"16\"\>"],
     144,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"27\"\>", "\<\"16\"\>"],
     39,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3a\"\>", "\<\"16\"\>"],
     58,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"93\"\>", "\<\"16\"\>"],
     147,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ca\"\>", "\<\"16\"\>"],
     202,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c4\"\>", "\<\"16\"\>"],
     196,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"5f\"\>", "\<\"16\"\>"],
     95,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"15\"\>", "\<\"16\"\>"],
     21,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"af\"\>", "\<\"16\"\>"],
     175,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"6d\"\>", "\<\"16\"\>"],
     109,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"2c\"\>", "\<\"16\"\>"],
     44,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"3a\"\>", "\<\"16\"\>"],
     58,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"42\"\>", "\<\"16\"\>"],
     66,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"96\"\>", "\<\"16\"\>"],
     150,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"81\"\>", "\<\"16\"\>"],
     129,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a3\"\>", "\<\"16\"\>"],
     163,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"f\"\>", "\<\"16\"\>"],
     15,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e7\"\>", "\<\"16\"\>"],
     231,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"78\"\>", "\<\"16\"\>"],
     120,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c3\"\>", "\<\"16\"\>"],
     195,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e1\"\>", "\<\"16\"\>"],
     225,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a9\"\>", "\<\"16\"\>"],
     169,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"c1\"\>", "\<\"16\"\>"],
     193,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"7d\"\>", "\<\"16\"\>"],
     125,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"35\"\>", "\<\"16\"\>"],
     53,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"df\"\>", "\<\"16\"\>"],
     223,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"4b\"\>", "\<\"16\"\>"],
     75,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"27\"\>", "\<\"16\"\>"],
     39,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"e5\"\>", "\<\"16\"\>"],
     229,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"a5\"\>", "\<\"16\"\>"],
     165,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8\"\>", "\<\"16\"\>"],
     8,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"8d\"\>", "\<\"16\"\>"],
     141,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"ec\"\>", "\<\"16\"\>"],
     236,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"59\"\>", "\<\"16\"\>"],
     89,
     Editable->False],
    BaseForm[#, 16]& ], ",", 
   TagBox[
    InterpretationBox[
     SubscriptBox["\<\"1a\"\>", "\<\"16\"\>"],
     26,
     Editable->False],
    BaseForm[#, 16]& ]}], "}"}]], "Output",
 CellChangeTimes->{{3.7770433568723783`*^9, 3.777043366278386*^9}, 
   3.777188350684206*^9, 3.77756764520975*^9, 3.777568156415223*^9, 
   3.777568296739546*^9, 3.77762044477219*^9, {3.783097417602306*^9, 
   3.7830974308905497`*^9}, 3.783097562468313*^9, 3.783101663245328*^9, 
   3.7831866684098053`*^9, 3.783445233543562*^9, 3.78387827396102*^9, 
   3.783929799746337*^9, 3.784214746538082*^9, 3.7842147995253057`*^9, 
   3.7843909612814007`*^9, 3.792136050519678*^9, 3.7930842159508142`*^9, 
   3.793339966186344*^9, 3.794985761357523*^9, 3.7949864115486717`*^9, 
   3.794988253534914*^9, 3.798871723307691*^9, 3.7993334896407757`*^9},
 CellLabel->
  "Out[435]=",ExpressionUUID->"8ec7f069-3e1c-4c6d-bd8a-04482968a00c"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{780, 853},
WindowMargins->{{67, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 150, 3, 67, "Section",ExpressionUUID->"dcd5b47e-013a-48a7-be10-cda80ac72cac"],
Cell[732, 27, 1089, 16, 108, "Subsection",ExpressionUUID->"e72e416d-521a-4fee-a3f8-629371a09719"],
Cell[CellGroupData[{
Cell[1846, 47, 476, 11, 65, "Subsection",ExpressionUUID->"b8520252-0ff8-494f-897c-1ed1c99b2d96"],
Cell[2325, 60, 329, 8, 30, "Input",ExpressionUUID->"f35bb72d-50e7-4510-b36e-0ea44bcf2cfa"],
Cell[2657, 70, 328, 8, 30, "Input",ExpressionUUID->"358fd49b-e743-4b6a-bdbd-8ec977b69900"],
Cell[2988, 80, 347, 9, 30, "Input",ExpressionUUID->"54e438ae-97d3-4a60-9f5d-ccbd3de42b69"],
Cell[3338, 91, 868, 25, 52, "Input",ExpressionUUID->"c3ab7357-9b09-477b-9770-739f6efebc7f"],
Cell[4209, 118, 293, 7, 30, "Input",ExpressionUUID->"a4751333-a4b1-4b06-8297-b995d224a6ea"],
Cell[4505, 127, 322, 9, 30, "Input",ExpressionUUID->"84e64a6a-5c95-4c0d-9057-40ce75bee30e"],
Cell[4830, 138, 348, 8, 30, "Input",ExpressionUUID->"93a79fcb-fabd-4265-a47a-79b0f17caf1c"],
Cell[5181, 148, 449, 12, 30, "Input",ExpressionUUID->"bf73e156-b09b-405e-8638-da3380749e7c"],
Cell[5633, 162, 409, 11, 30, "Input",ExpressionUUID->"48bb1567-034d-466b-be48-e338314d8923"],
Cell[6045, 175, 893, 22, 73, "Input",ExpressionUUID->"bb6cafd8-4219-46d0-b657-d9e2f166d587"],
Cell[6941, 199, 478, 10, 30, "Input",ExpressionUUID->"7d17d65a-cdd8-4040-9569-5b3915925176"],
Cell[7422, 211, 332, 8, 30, "Input",ExpressionUUID->"d305b802-1ef0-4baa-8fa2-feb5b45f664f"],
Cell[7757, 221, 377, 7, 30, "Input",ExpressionUUID->"15d6e8d6-531c-4ba0-b2ce-bf24e6ed1b7d"],
Cell[8137, 230, 621, 18, 30, "Input",ExpressionUUID->"04140778-a316-4fbc-bbe6-ca7fa057b1b6"],
Cell[8761, 250, 326, 8, 30, "Input",ExpressionUUID->"9c27ef61-2acf-49b8-8792-a23de056681f"],
Cell[9090, 260, 369, 11, 30, "Input",ExpressionUUID->"412c0729-20af-4ab9-ba97-41b2f54dddb9"],
Cell[9462, 273, 721, 21, 30, "Input",ExpressionUUID->"ac9e4d7a-d99b-4725-a7ca-235639bdb395"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10232, 300, 225, 4, 67, "Section",ExpressionUUID->"7fe319ed-0102-4658-ae42-f003dce31d4f"],
Cell[CellGroupData[{
Cell[10482, 308, 158, 3, 54, "Subsection",ExpressionUUID->"68495d32-5051-49f6-a9e7-fcf737202a1d"],
Cell[10643, 313, 1592, 45, 94, "Input",ExpressionUUID->"d128e455-883e-4a03-ae56-6cf4217bf07b"],
Cell[CellGroupData[{
Cell[12260, 362, 579, 11, 97, "Subsubsection",ExpressionUUID->"43d70fbb-db9b-4350-8d39-5ea1285951a6"],
Cell[12842, 375, 782, 22, 52, "Input",ExpressionUUID->"3ceee378-1929-43cf-ba00-743e3e0a28b8"],
Cell[13627, 399, 951, 28, 94, "Input",ExpressionUUID->"2715e150-1268-4a26-9dab-a8dbda5bd223"],
Cell[14581, 429, 652, 18, 30, "Input",ExpressionUUID->"4e8e5376-a929-4889-8cf9-c0e2de4a848f"]
}, Open  ]],
Cell[15248, 450, 328, 7, 45, "Subsubsection",ExpressionUUID->"cabad2d0-8b49-4142-814b-d27ad9f6ae53"],
Cell[CellGroupData[{
Cell[15601, 461, 878, 16, 167, "Subsubsection",ExpressionUUID->"ba1037c8-03e1-415f-b1ab-5b1c436e9b3d"],
Cell[16482, 479, 426, 10, 30, "Input",ExpressionUUID->"90d2ac1b-8eb1-4a07-b858-f9301c523d69"],
Cell[16911, 491, 903, 22, 73, "Input",ExpressionUUID->"778561b9-76fc-448f-9468-602ed626fda5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17863, 519, 262, 4, 54, "Subsection",ExpressionUUID->"0e5fc754-6578-45e3-9914-548a82583447"],
Cell[CellGroupData[{
Cell[18150, 527, 470, 12, 30, "Input",ExpressionUUID->"5f17137c-3ea2-4026-83b1-a125e28c38d2"],
Cell[18623, 541, 1344, 21, 34, "Output",ExpressionUUID->"0912abc4-d7a2-4b27-8c62-67e263567db4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20004, 567, 513, 12, 30, "Input",ExpressionUUID->"5b742c10-3741-496f-8587-2c884a2c4c32"],
Cell[20520, 581, 1871, 29, 34, "Output",ExpressionUUID->"3ca98eec-8dd7-4f58-9f64-319ddb2f1a0a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22428, 615, 368, 10, 30, "Input",ExpressionUUID->"ee10bdf7-3a12-43cd-b46a-01ea3bd3e848"],
Cell[22799, 627, 2685, 59, 98, "Output",ExpressionUUID->"1b639230-f68e-4176-bc7f-7e993c61740f"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25533, 692, 273, 4, 54, "Subsection",ExpressionUUID->"fe4ae4fd-d8f4-4552-9ab1-e2d125ba2833"],
Cell[25809, 698, 731, 20, 30, "Input",ExpressionUUID->"d41cb2c7-da4c-4991-94a3-7ef39d5e43be"],
Cell[26543, 720, 681, 18, 52, "Input",ExpressionUUID->"08fb816b-7083-4191-876d-229980ae459c"],
Cell[27227, 740, 1255, 34, 73, "Input",ExpressionUUID->"8a61c224-a1eb-4e61-8af2-413eaab73346"],
Cell[28485, 776, 1902, 48, 115, "Input",ExpressionUUID->"00d78f28-8682-4b2b-8b87-7b585786ad9e"],
Cell[30390, 826, 463, 12, 30, "Input",ExpressionUUID->"bb2200d4-2ca5-4720-b0bd-3748f544adb6"],
Cell[30856, 840, 328, 8, 30, "Input",ExpressionUUID->"0c735fcf-c5a5-4437-b2c4-97a461a3b184"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31221, 853, 164, 3, 54, "Subsection",ExpressionUUID->"7e922286-3601-4138-8afa-5b70b8f10ae8"],
Cell[31388, 858, 439, 11, 30, "Input",ExpressionUUID->"716ee0b4-49fa-4480-ae3e-36c191a3645f"],
Cell[31830, 871, 1311, 35, 94, "Input",ExpressionUUID->"7d3b2da7-48a8-4215-8f78-98fa5923403a"],
Cell[33144, 908, 543, 13, 30, "Input",ExpressionUUID->"db496a13-568f-4f76-b91b-841e60217a08"],
Cell[33690, 923, 536, 13, 30, "Input",ExpressionUUID->"053add1b-f2e2-48f6-aaea-53e1bf442e52"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34263, 941, 314, 7, 54, "Subsection",ExpressionUUID->"059c0fe5-bc3e-4960-97ee-f737af03d31e"],
Cell[34580, 950, 598, 18, 30, "Input",ExpressionUUID->"c97a8199-b6d0-42c4-a35b-d15d0df638dd"],
Cell[35181, 970, 1219, 37, 73, "Input",ExpressionUUID->"a8d4f298-d94e-492e-86b5-d392e76ecca0"],
Cell[36403, 1009, 975, 29, 52, "Input",ExpressionUUID->"ca524cc2-5608-48f2-b4db-e31e2d0663c4"],
Cell[37381, 1040, 889, 23, 73, "Input",ExpressionUUID->"7d704294-1be2-4e00-89aa-91a913f49147"],
Cell[38273, 1065, 1467, 44, 115, "Input",ExpressionUUID->"94aa72f9-e355-4bee-baca-799a8fe515d8"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39789, 1115, 153, 3, 67, "Section",ExpressionUUID->"d4ed4e6a-58a9-48ce-976d-b3909fdc79a2"],
Cell[CellGroupData[{
Cell[39967, 1122, 388, 6, 54, "Subsection",ExpressionUUID->"df50ce1e-f12a-49a8-b741-129316b2f621"],
Cell[CellGroupData[{
Cell[40380, 1132, 445, 11, 30, "Input",ExpressionUUID->"d3319e56-33af-4388-80e0-60e58cef5573"],
Cell[40828, 1145, 3028, 52, 60, "Output",ExpressionUUID->"67d887b9-2d64-494d-ac35-9991a604495e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43905, 1203, 211, 4, 54, "Subsection",ExpressionUUID->"81a91348-4740-450e-85ec-57d32804140a"],
Cell[CellGroupData[{
Cell[44141, 1211, 448, 11, 30, "Input",ExpressionUUID->"dc05b608-809e-4634-aaa3-2c20dbb21eea"],
Cell[44592, 1224, 2373, 37, 34, "Output",ExpressionUUID->"7a39eb62-121d-4eec-953a-df8a2fafd355"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[47014, 1267, 212, 4, 54, "Subsection",ExpressionUUID->"6ba7fe3e-75fe-44a5-bda9-e3a3895b721a"],
Cell[CellGroupData[{
Cell[47251, 1275, 648, 19, 30, "Input",ExpressionUUID->"d752dcdd-2d07-43b1-a93d-d93e617c8103"],
Cell[47902, 1296, 988, 23, 56, "Output",ExpressionUUID->"0a997a8f-f380-4d0c-852a-09733139be1d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48927, 1324, 347, 8, 30, "Input",ExpressionUUID->"2c9d9d93-32b9-413c-8af8-1e597bd88b57"],
Cell[49277, 1334, 874, 21, 34, "Output",ExpressionUUID->"26665094-5126-43a7-99e4-2ee0dfe67fe4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[50200, 1361, 257, 4, 54, "Subsection",ExpressionUUID->"e01bbd4a-309e-445f-92f1-3bb761d24a5c"],
Cell[CellGroupData[{
Cell[50482, 1369, 353, 9, 30, "Input",ExpressionUUID->"552cd961-9dd1-477f-a1aa-84440747670f"],
Cell[50838, 1380, 888, 18, 34, "Output",ExpressionUUID->"12700a5d-3436-4bf1-bdd6-ed7b61116f97"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51763, 1403, 459, 12, 30, "Input",ExpressionUUID->"542e8490-ccf3-47a8-a5d1-c654a86fd803"],
Cell[52225, 1417, 1114, 28, 34, "Output",ExpressionUUID->"b2945776-bfe8-4e63-9248-2315241b2f6f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53376, 1450, 799, 20, 30, "Input",ExpressionUUID->"8c05ea5e-267c-4bc0-b02a-5e05ea85ba03"],
Cell[54178, 1472, 1476, 27, 34, "Output",ExpressionUUID->"2588da9b-2d86-4651-bfc7-4ffaeeda5c44"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55691, 1504, 636, 18, 52, "Input",ExpressionUUID->"2670e880-db1b-4518-a61b-66266f323b61"],
Cell[56330, 1524, 624, 14, 34, "Output",ExpressionUUID->"92a66940-072b-49bc-bfaa-44185fda9c68"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56991, 1543, 609, 17, 30, "Input",ExpressionUUID->"b53861e4-c823-448e-914e-457b4501d4b1"],
Cell[57603, 1562, 1703, 34, 34, "Output",ExpressionUUID->"ad7913e8-6a61-457e-aeee-5d83d31b6bb1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59343, 1601, 406, 10, 30, "Input",ExpressionUUID->"091cebf7-4d61-45c8-8365-0866b00952ce"],
Cell[59752, 1613, 900, 18, 34, "Output",ExpressionUUID->"ca86294a-84ff-4c2e-9e3e-097ad0a428d4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[60701, 1637, 312, 7, 81, "Subsection",ExpressionUUID->"cac8c3a2-4b7a-4b1a-9b4d-8c375506e06e"],
Cell[CellGroupData[{
Cell[61038, 1648, 258, 6, 71, "Subsubsection",ExpressionUUID->"6b50bc99-d6e0-4d08-8951-03cee94faa4e"],
Cell[CellGroupData[{
Cell[61321, 1658, 353, 9, 30, "Input",ExpressionUUID->"b91148d2-19fd-42a8-bb67-567d4a0bb63c"],
Cell[61677, 1669, 1268, 21, 56, "Output",ExpressionUUID->"65c300a4-f28c-4e75-995d-fd2df079b992"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62982, 1695, 353, 9, 30, "Input",ExpressionUUID->"9582a003-fd2f-4c67-935e-0ea23e60a098"],
Cell[63338, 1706, 1237, 20, 34, "Output",ExpressionUUID->"8916b58d-3632-4ee8-9df9-5efb562dea37"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64612, 1731, 328, 9, 30, "Input",ExpressionUUID->"6e74c221-24d0-4108-831f-00a83aa592b1"],
Cell[64943, 1742, 2518, 46, 76, "Output",ExpressionUUID->"2b377120-2884-447c-a7fa-d00b9b3e516d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67498, 1793, 639, 19, 30, "Input",ExpressionUUID->"f739c3e6-176f-4ee1-814e-909c6bbb933e"],
Cell[68140, 1814, 6444, 113, 117, "Output",ExpressionUUID->"11d0d81a-804a-42e7-8d29-456da6b75d16"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[74657, 1935, 234, 4, 67, "Section",ExpressionUUID->"df6cbd15-de77-470c-98ef-862347567859"],
Cell[74894, 1941, 496, 14, 30, "Input",ExpressionUUID->"04947d38-987a-49ff-bb36-f9080582ba68"],
Cell[75393, 1957, 561, 11, 30, "Input",ExpressionUUID->"31cd3958-1c68-41e2-865c-473bc23451a6"],
Cell[CellGroupData[{
Cell[75979, 1972, 458, 12, 30, "Input",ExpressionUUID->"92df64b3-18c6-4a24-8823-096c87eadf9a"],
Cell[76440, 1986, 3484, 90, 314, "Output",ExpressionUUID->"eb8494d6-b484-457d-80b8-b3b5e641d9f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79961, 2081, 286, 6, 45, "Subsubsection",ExpressionUUID->"d8d763bb-7f76-4a34-8109-add6d36790be"],
Cell[80250, 2089, 2438, 52, 157, "Input",ExpressionUUID->"dbbbc000-b8c8-465e-b4c0-3e40788467c8"],
Cell[CellGroupData[{
Cell[82713, 2145, 277, 6, 30, "Input",ExpressionUUID->"07bd3c17-4440-4737-b977-fa09a47fda93"],
Cell[82993, 2153, 4450, 96, 108, "Output",ExpressionUUID->"88d2bf02-95c8-49ec-a3e7-018076b36837"]
}, Open  ]],
Cell[CellGroupData[{
Cell[87480, 2254, 275, 6, 30, "Input",ExpressionUUID->"87f0b30a-57ab-4607-8148-3d5d741c12a4"],
Cell[87758, 2262, 6080, 150, 198, "Output",ExpressionUUID->"d2229b65-0439-45bb-85d6-b55973bd82f7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93875, 2417, 230, 5, 30, "Input",ExpressionUUID->"a58789a8-9f74-4b04-a515-ae326a52f59c"],
Cell[94108, 2424, 10313, 282, 372, "Output",ExpressionUUID->"256b7b0b-08ab-40e3-866c-d90623f5a383"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[104482, 2713, 274, 4, 67, "Section",ExpressionUUID->"8c69d485-adbf-4c7f-8bb4-ad36eefed0cd"],
Cell[104759, 2719, 279, 7, 30, "Input",ExpressionUUID->"721c8e78-f0ad-4a61-8f18-bd08689c1e2b"],
Cell[105041, 2728, 532, 15, 30, "Input",ExpressionUUID->"9649efed-29d4-49f7-8e31-0ea8cdeba83e"],
Cell[105576, 2745, 348, 9, 30, "Input",ExpressionUUID->"ec37a5d4-fee5-4544-8626-1b1eac9a1ce9"],
Cell[105927, 2756, 346, 8, 30, "Input",ExpressionUUID->"57109bdb-0a46-48a8-8617-7cf03d8a487a"],
Cell[106276, 2766, 255, 6, 30, "Input",ExpressionUUID->"40f2526e-d548-4eaa-ab2d-d5d809ebd7ca"],
Cell[106534, 2774, 443, 12, 30, "Input",ExpressionUUID->"c9003530-ffda-4cca-8462-0ce20f2afce1"],
Cell[106980, 2788, 316, 7, 30, "Input",ExpressionUUID->"175d1e81-ae07-4d73-bc55-5d476143481c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107333, 2800, 170, 3, 67, "Section",ExpressionUUID->"a2eea997-f27f-433e-8cfd-fe83ec128e86"],
Cell[107506, 2805, 428, 10, 30, "Input",ExpressionUUID->"9f5bc608-1567-4a99-9032-58fca8ff2fd0"],
Cell[CellGroupData[{
Cell[107959, 2819, 1346, 31, 73, "Input",ExpressionUUID->"cd23c790-7472-4435-95ff-e696fcda8641"],
Cell[109308, 2852, 5125, 122, 296, "Output",ExpressionUUID->"c931ad9c-85b0-4c6e-9eeb-f08662ca7c1a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114470, 2979, 511, 9, 108, "Subsection",ExpressionUUID->"2efd07be-83be-4c25-9d3f-e8c3b969d2d3"],
Cell[114984, 2990, 270, 7, 30, "Input",ExpressionUUID->"c6bb27a9-af5c-44dc-b01d-e63dd667a263"],
Cell[115257, 2999, 637, 18, 30, "Input",ExpressionUUID->"d2f6f18a-0419-43c0-aa70-a0a9ca888339"],
Cell[115897, 3019, 727, 18, 52, "Input",ExpressionUUID->"fb219d2f-150f-4fdd-870b-915fd7b5b1fb"],
Cell[116627, 3039, 372, 8, 30, "Input",ExpressionUUID->"a3b46dd0-83ed-4201-8668-6f0f729425fe"],
Cell[117002, 3049, 323, 7, 30, "Input",ExpressionUUID->"3756a7f1-1661-4fcb-b9ef-3be4547eb6bd"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[117374, 3062, 309, 7, 105, "Section",ExpressionUUID->"dd42704d-55ed-484d-81a7-3ca57ac9deb7"],
Cell[117686, 3071, 550, 14, 30, "Input",ExpressionUUID->"9d165fee-8bd1-4977-9491-8337168130f5"],
Cell[118239, 3087, 580, 12, 30, "Input",ExpressionUUID->"a95a1b0c-f1c4-4c36-976d-8dc2d4ddc9a5"],
Cell[118822, 3101, 424, 10, 30, "Input",ExpressionUUID->"a3fa0507-59cd-41e9-953a-04783edf1220"]
}, Open  ]],
Cell[CellGroupData[{
Cell[119283, 3116, 706, 13, 105, "Section",ExpressionUUID->"f2e93dfc-94aa-43df-8c5b-0f5e43ff79ac"],
Cell[CellGroupData[{
Cell[120014, 3133, 259, 5, 54, "Subsection",ExpressionUUID->"383a5bb3-2e2b-40b2-952e-bc54fe5d2366"],
Cell[120276, 3140, 2180, 32, 157, "Input",ExpressionUUID->"69ebe8f2-f565-4a6b-84e2-8d9add3b145a"],
Cell[CellGroupData[{
Cell[122481, 3176, 304, 6, 30, "Input",ExpressionUUID->"0c8a55ae-ada3-483b-aebe-31b50badb9af"],
Cell[122788, 3184, 4921, 119, 182, "Output",ExpressionUUID->"88e1ebdf-95c1-4ecc-ab2f-6ef1d6eeb005"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[127758, 3309, 559, 11, 108, "Subsection",ExpressionUUID->"4c6122d8-072b-4092-b367-1d76b190ecc7"],
Cell[CellGroupData[{
Cell[128342, 3324, 287, 5, 30, "Input",ExpressionUUID->"4ecb1aa1-c6bf-4246-80b8-c0536f940051"],
Cell[128632, 3331, 3039, 45, 77, "Output",ExpressionUUID->"a8f47352-9bd0-46c7-a9a9-a17dfe9e1e35"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131708, 3381, 598, 13, 30, "Input",ExpressionUUID->"b0d4604e-0f8b-4ab1-a739-561cd3c3074e"],
Cell[132309, 3396, 3021, 44, 77, "Output",ExpressionUUID->"71c09139-3a0b-463c-95b0-f5ad90f0d951"]
}, Open  ]],
Cell[CellGroupData[{
Cell[135367, 3445, 708, 17, 52, "Input",ExpressionUUID->"a2b6b921-7e2b-4ebc-90e4-bc8e71abbc67"],
Cell[136078, 3464, 3016, 44, 77, "Output",ExpressionUUID->"6a648b35-00cc-4f22-a5a3-1b693c06dddf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139131, 3513, 420, 11, 30, "Input",ExpressionUUID->"e4a96625-d930-45ad-97b1-d6bdbf1c97e3"],
Cell[139554, 3526, 2339, 36, 56, "Output",ExpressionUUID->"15a63dae-ae97-45ce-b759-1ec2958512a5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[141942, 3568, 448, 8, 54, "Subsection",ExpressionUUID->"8b218f54-f3cd-4650-8b40-d6a68652b7a3"],
Cell[CellGroupData[{
Cell[142415, 3580, 868, 19, 52, "Input",ExpressionUUID->"4481fde5-4903-4e7f-8d6f-3c51fc48b048"],
Cell[143286, 3601, 6027, 148, 224, "Output",ExpressionUUID->"2a9f29cc-f0ed-4497-bdf5-5fbb5e6ac864"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[149362, 3755, 322, 6, 81, "Subsection",ExpressionUUID->"3fac8a95-abb9-424f-9958-ef64143a6b35"],
Cell[CellGroupData[{
Cell[149709, 3765, 574, 15, 94, "Input",ExpressionUUID->"b803e2a5-9bf3-4490-b9f4-ed180cd05262"],
Cell[150286, 3782, 3556, 49, 224, "Output",ExpressionUUID->"42d643c6-f705-49c6-9e5f-8b2ad441c305"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[153891, 3837, 497, 9, 81, "Subsection",ExpressionUUID->"ae548b0e-1d59-402e-8b4a-2113362b3478"],
Cell[CellGroupData[{
Cell[154413, 3850, 1539, 29, 73, "Input",ExpressionUUID->"fce95233-b17d-4cf8-8e6e-61a94cb0c2d1"],
Cell[155955, 3881, 3065, 45, 56, "Output",ExpressionUUID->"de197cf3-e630-4b76-9b70-7a9fc1f08582"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[159069, 3932, 172, 3, 54, "Subsection",ExpressionUUID->"19f1db7a-f921-4df8-8c6d-a40cf450faf5"],
Cell[CellGroupData[{
Cell[159266, 3939, 1178, 19, 52, "Input",ExpressionUUID->"362d78b4-f6e5-461c-b3cd-f0144e703eb7"],
Cell[160447, 3960, 2334, 35, 34, "Output",ExpressionUUID->"63cf5734-c7e5-4923-8480-17f62f7bcfc9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[162830, 4001, 391, 6, 81, "Subsection",ExpressionUUID->"3bb4f889-d462-4cc3-966b-12cc5eb6cf84"],
Cell[CellGroupData[{
Cell[163246, 4011, 2642, 42, 178, "Input",ExpressionUUID->"85497670-6aa1-4e91-a714-a425bbc93c75"],
Cell[165891, 4055, 2721, 40, 34, "Output",ExpressionUUID->"a77f1fe3-1630-454f-bbfc-403ec22cf40d"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[168673, 4102, 535, 11, 105, "Section",ExpressionUUID->"647a6bfa-e532-4f48-a35f-1e7d7c550b67"],
Cell[169211, 4115, 788, 20, 52, "Input",ExpressionUUID->"0289aae2-6d1c-4f23-96ac-a0cdc00d88da"],
Cell[170002, 4137, 381, 9, 30, "Input",ExpressionUUID->"91c7318e-1b48-4736-90ff-c54202fad52d"],
Cell[170386, 4148, 921, 25, 52, "Input",ExpressionUUID->"a6386952-5006-44bf-9d1a-e0fe4b109e62"],
Cell[171310, 4175, 1358, 38, 94, "Input",ExpressionUUID->"2657faa8-09a3-4d23-8b85-4ce050a08c15"],
Cell[CellGroupData[{
Cell[172693, 4217, 255, 6, 45, "Subsubsection",ExpressionUUID->"36d9de0e-0367-4b8c-a6e4-e3f72be24a9c"],
Cell[172951, 4225, 893, 22, 52, "Input",ExpressionUUID->"1ea5b44d-5308-40b1-a638-085c6b742e4a"],
Cell[173847, 4249, 1134, 33, 52, "Input",ExpressionUUID->"8a5b58a1-c384-44b5-94c7-c1a71c5c0b99"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175018, 4287, 502, 9, 81, "Subsection",ExpressionUUID->"eabab49b-f49c-474a-8a2a-68e8611d1b5b"],
Cell[CellGroupData[{
Cell[175545, 4300, 1256, 29, 73, "Input",ExpressionUUID->"c48ccc4e-7533-4350-8142-704cac5d4e20"],
Cell[176804, 4331, 3545, 89, 87, "Output",ExpressionUUID->"c95e1f2a-1a01-40e8-a038-254f3e829280"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[180398, 4426, 439, 8, 108, "Subsection",ExpressionUUID->"985ddd81-6645-46f4-a2d6-908a0f80c880"],
Cell[CellGroupData[{
Cell[180862, 4438, 638, 18, 30, "Input",ExpressionUUID->"d04b7b9a-5651-4d4a-ab1c-b2e1ce4e3c2a"],
Cell[181503, 4458, 1258, 24, 34, "Output",ExpressionUUID->"b829fddd-2169-4bcc-a938-c752a1b25120"]
}, Open  ]],
Cell[CellGroupData[{
Cell[182798, 4487, 368, 10, 30, "Input",ExpressionUUID->"32fd99f4-676e-4c16-a08a-9efcfd88567f"],
Cell[183169, 4499, 1220, 20, 34, "Output",ExpressionUUID->"4295e830-9920-42e6-b9d3-337459f6cd2b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184426, 4524, 353, 9, 30, "Input",ExpressionUUID->"35d6184e-3890-41de-aa74-5aa9cf9d7f72"],
Cell[184782, 4535, 1219, 20, 34, "Output",ExpressionUUID->"efba188f-5606-4f85-b40f-536b126dd99c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[186038, 4560, 902, 24, 73, "Input",ExpressionUUID->"162c539b-758f-482c-8ed0-97ea24bd1f4f"],
Cell[186943, 4586, 2108, 32, 98, "Output",ExpressionUUID->"e5a46db1-ba64-40cc-bfe1-182fb27b175e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[189088, 4623, 534, 9, 45, "Subsubsection",ExpressionUUID->"23844b88-be46-44a7-bb36-0916abfc988e"],
Cell[CellGroupData[{
Cell[189647, 4636, 613, 13, 30, "Input",ExpressionUUID->"05a70527-7971-4703-9801-3004f842e316"],
Cell[190263, 4651, 3340, 91, 201, "Output",ExpressionUUID->"dc83adf0-0b0c-4161-a83b-18e3b2f620df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[193640, 4747, 667, 13, 30, "Input",ExpressionUUID->"f55511b9-9aed-430a-8eea-4d15ec605645"],
Cell[194310, 4762, 1108, 20, 24, "Message",ExpressionUUID->"f65c3b7f-868a-4cb8-89e1-2703b9898fd8"],
Cell[195421, 4784, 2186, 46, 77, "Output",ExpressionUUID->"affd5595-b841-427a-b962-7571c88c35d5"]
}, Open  ]]
}, Open  ]],
Cell[197634, 4834, 668, 11, 123, "Subsubsection",ExpressionUUID->"4f47f168-c5a4-407b-ba15-670ae60049e0"],
Cell[CellGroupData[{
Cell[198327, 4849, 610, 12, 115, "Subsubsection",ExpressionUUID->"362d52af-4dc6-4cfd-8543-a109aae2d9b9"],
Cell[CellGroupData[{
Cell[198962, 4865, 520, 13, 30, "Input",ExpressionUUID->"86c45a40-c86a-4b14-9ccf-031d2a90bfd6"],
Cell[199485, 4880, 2923, 71, 98, "Output",ExpressionUUID->"3029874b-3bb7-4430-925f-a340c7c354da"]
}, Open  ]],
Cell[CellGroupData[{
Cell[202445, 4956, 642, 19, 52, "Input",ExpressionUUID->"ae8fc042-5f6a-4e74-877d-9a0361e59370"],
Cell[203090, 4977, 1005, 17, 34, "Output",ExpressionUUID->"d069afc8-ced3-4c93-9f83-e34134d6553d"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[204144, 5000, 304, 7, 71, "Subsubsection",ExpressionUUID->"1d7a7905-6acb-4fc5-898a-0249264021fd"],
Cell[CellGroupData[{
Cell[204473, 5011, 461, 12, 30, "Input",ExpressionUUID->"dfef1f40-13d4-4ac6-a079-075226c3c8d4"],
Cell[204937, 5025, 3051, 75, 98, "Output",ExpressionUUID->"2d8ab56d-0933-46b0-b3d5-94248bcc22a0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[208025, 5105, 655, 20, 52, "Input",ExpressionUUID->"11babc03-83be-468f-b7e3-e3b42e4f33bb"],
Cell[208683, 5127, 1004, 17, 34, "Output",ExpressionUUID->"2355944a-9599-4875-bf0b-1bf0a5bc35a6"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[209736, 5150, 209, 4, 45, "Subsubsection",ExpressionUUID->"60081ff1-f2be-4d1b-b104-57a5c2616912"],
Cell[CellGroupData[{
Cell[209970, 5158, 228, 4, 30, "Input",ExpressionUUID->"5d59817f-3c68-4f8e-95d0-96e3cdfdca99"],
Cell[210201, 5164, 2744, 67, 77, "Output",ExpressionUUID->"7cd2eeed-8793-4e17-9df2-6a09376692aa"]
}, Open  ]]
}, Open  ]],
Cell[212972, 5235, 464, 9, 71, "Subsubsection",ExpressionUUID->"7b6bd876-cd20-43dd-b95a-25ac7d872a85"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[213485, 5250, 326, 5, 67, "Section",ExpressionUUID->"7a9fce8a-60f1-45a3-9689-ef7a3b43e127"],
Cell[CellGroupData[{
Cell[213836, 5259, 245, 6, 45, "Subsubsection",ExpressionUUID->"6ab1d1ba-5314-4063-9881-36735d049367"],
Cell[CellGroupData[{
Cell[214106, 5269, 740, 16, 30, "Input",ExpressionUUID->"dd28c3f7-d9d5-4011-9705-3d3764634879"],
Cell[214849, 5287, 1327, 22, 34, "Output",ExpressionUUID->"9b8ed333-ed5f-4eaa-9441-245b58fb3954"]
}, Open  ]],
Cell[CellGroupData[{
Cell[216213, 5314, 703, 16, 30, "Input",ExpressionUUID->"1b25fc58-c104-4cc5-bffc-0b6f51e29751"],
Cell[216919, 5332, 1409, 23, 34, "Output",ExpressionUUID->"13f74b1e-178f-4378-992f-817f9f152673"]
}, Open  ]],
Cell[CellGroupData[{
Cell[218365, 5360, 773, 19, 30, "Input",ExpressionUUID->"2090cfd6-038c-4f00-a0f8-66157c3467d2"],
Cell[219141, 5381, 1933, 37, 60, "Output",ExpressionUUID->"93c22652-c043-439d-a18d-9fc7280fb8de"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[221123, 5424, 252, 6, 71, "Subsubsection",ExpressionUUID->"771f53e8-0012-4be8-91b8-8f8794ab87b4"],
Cell[CellGroupData[{
Cell[221400, 5434, 367, 10, 30, "Input",ExpressionUUID->"d21443d5-e0fd-4160-b30e-f1c984b04cd2"],
Cell[221770, 5446, 2774, 39, 161, "Output",ExpressionUUID->"90b4c53b-77cf-4e8f-be35-095fb2b5646d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[224581, 5490, 354, 9, 30, "Input",ExpressionUUID->"54db74e2-0224-4c44-95f2-91ad0f6cced8"],
Cell[224938, 5501, 2777, 39, 161, "Output",ExpressionUUID->"30761e32-6741-4b9e-bba2-d67d9a3049af"]
}, Open  ]],
Cell[CellGroupData[{
Cell[227752, 5545, 624, 19, 52, "Input",ExpressionUUID->"d67b1852-5873-4c7f-8603-f0b1580c5a63"],
Cell[228379, 5566, 2804, 39, 161, "Output",ExpressionUUID->"90c0cb22-b3fd-4202-b066-91bfdd25f8a8"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[231232, 5611, 259, 6, 71, "Subsubsection",ExpressionUUID->"ff2984fc-962c-43d6-b245-efc6c61e83d8"],
Cell[CellGroupData[{
Cell[231516, 5621, 482, 15, 30, "Input",ExpressionUUID->"1faad803-62dc-4925-b9fe-c49f2ef0e870"],
Cell[232001, 5638, 782, 15, 34, "Output",ExpressionUUID->"f2ca4468-25fe-4554-ba4a-9e7da306892a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[232820, 5658, 431, 10, 30, "Input",ExpressionUUID->"e4a28d8d-be4c-4664-bd25-cb0fac796cb6"],
Cell[233254, 5670, 2777, 39, 161, "Output",ExpressionUUID->"5fc4cbda-e91a-405e-9ca8-51169f5f4671"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[236092, 5716, 209, 4, 67, "Section",ExpressionUUID->"84b9020a-f60d-473a-8d45-204a5345d4ea"],
Cell[236304, 5722, 1093, 33, 73, "Input",ExpressionUUID->"fdf1d846-50c2-492e-9cbe-99fdd8ed72b9"],
Cell[CellGroupData[{
Cell[237422, 5759, 179, 3, 45, "Subsubsection",ExpressionUUID->"9ed5f865-961e-4044-b0ae-32f493ce0837"],
Cell[CellGroupData[{
Cell[237626, 5766, 520, 12, 30, "Input",ExpressionUUID->"5c32a284-ac68-4a31-9219-ea4b32660540"],
Cell[238149, 5780, 2367, 36, 56, "Output",ExpressionUUID->"116790dc-5ff1-4da3-9a68-bbb773be95f8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[240553, 5821, 930, 23, 30, "Input",ExpressionUUID->"12826c78-0d21-4997-b085-8d2c2a322373"],
Cell[241486, 5846, 2109, 32, 51, "Output",ExpressionUUID->"671428a5-97b8-4d8e-86a2-4609b2fda3cf"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[243656, 5885, 221, 3, 67, "Section",ExpressionUUID->"e8aa5e59-b2ca-4eab-96cf-5f556240f3ac"],
Cell[CellGroupData[{
Cell[243902, 5892, 2279, 65, 136, "Input",ExpressionUUID->"ca730dd4-efd0-4e0a-9ee1-0fb88ba25883"],
Cell[246184, 5959, 2258, 42, 94, "Output",ExpressionUUID->"6a141ae4-2ac6-47c3-825f-829671a2f358"]
}, Open  ]],
Cell[248457, 6004, 1446, 39, 94, "Input",ExpressionUUID->"a20c9716-eee1-4328-8615-8b3296e2b4c9"],
Cell[CellGroupData[{
Cell[249928, 6047, 910, 22, 52, "Input",ExpressionUUID->"acdb7496-1037-48d6-a7e2-045ab9f3a646"],
Cell[250841, 6071, 2335, 35, 34, "Output",ExpressionUUID->"80a60256-2b2b-45b3-9f70-a92ccd1db388"]
}, Open  ]],
Cell[253191, 6109, 806, 21, 52, "Input",ExpressionUUID->"31954fa9-f229-4e4e-8273-4250e5bbed31"],
Cell[CellGroupData[{
Cell[254022, 6134, 682, 15, 52, "Input",ExpressionUUID->"ebaa4ab5-8769-4010-a161-951f5ddd7430"],
Cell[254707, 6151, 924, 23, 51, "Output",ExpressionUUID->"bb9cad01-e297-404e-afb9-b5438726bd2a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[255668, 6179, 228, 5, 45, "Subsubsection",ExpressionUUID->"9bcf77fc-d200-4fc6-bd0f-542bb442c1c2"],
Cell[CellGroupData[{
Cell[255921, 6188, 858, 23, 48, "Input",ExpressionUUID->"8bd45cd5-dfb1-40e7-b2dd-54fb9be64213"],
Cell[256782, 6213, 3906, 86, 133, "Output",ExpressionUUID->"c82ed19e-9b44-475b-813d-1ccdb3721d12"]
}, Open  ]],
Cell[CellGroupData[{
Cell[260725, 6304, 733, 16, 52, "Input",ExpressionUUID->"2eaf788c-afab-4a8f-bd89-852d7dfa6cdb"],
Cell[261461, 6322, 1011, 19, 34, "Output",ExpressionUUID->"e4cb0ee5-fb7c-47f0-8e8a-c8cf7606507f"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[262521, 6347, 364, 7, 97, "Subsubsection",ExpressionUUID->"c0157232-d434-4629-a000-28f432de384b"],
Cell[CellGroupData[{
Cell[262910, 6358, 1181, 34, 76, "Input",ExpressionUUID->"e24f7fef-89c8-4aa7-bc7c-946197205a2b"],
Cell[264094, 6394, 4355, 96, 269, "Output",ExpressionUUID->"6dcdce08-64c9-477d-a29b-117de56b272b"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[268510, 6497, 428, 8, 105, "Section",ExpressionUUID->"658750c3-2edf-46c6-ba0a-6c4211a7da42"],
Cell[268941, 6507, 685, 20, 30, "Input",ExpressionUUID->"1f46602f-167c-4f55-9638-97abc8c52480"],
Cell[CellGroupData[{
Cell[269651, 6531, 401, 8, 108, "Subsection",ExpressionUUID->"9633a7b0-a3b9-42d8-b3eb-2e1b5e42e5ab"],
Cell[CellGroupData[{
Cell[270077, 6543, 842, 23, 52, "Input",ExpressionUUID->"5e0880dd-0181-4dc5-9b32-a9e21c9330da"],
Cell[270922, 6568, 554, 10, 34, "Output",ExpressionUUID->"cca1e7de-bd38-4745-8f13-9247e0ae85bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[271513, 6583, 200, 4, 30, "Input",ExpressionUUID->"e68ee020-572c-47af-a8fe-5cec401fe283"],
Cell[271716, 6589, 509, 8, 34, "Output",ExpressionUUID->"23aacd6c-16f0-44b4-b4ea-2f03e3140a1f"]
}, Open  ]],
Cell[272240, 6600, 1748, 48, 94, "Input",ExpressionUUID->"6f7c20f5-bd31-488e-a659-a7da3fce6f12"],
Cell[273991, 6650, 1103, 32, 73, "Input",ExpressionUUID->"416dd472-6558-4ffa-9b2c-a971523fb479"],
Cell[275097, 6684, 1963, 49, 115, "Input",ExpressionUUID->"05e3b4e6-bf07-4ed4-afc0-e50593949467"],
Cell[277063, 6735, 747, 17, 30, "Input",ExpressionUUID->"5ff4c386-b90b-4b0d-963c-8aa149a67049"],
Cell[277813, 6754, 791, 19, 30, "Input",ExpressionUUID->"3888365f-ea39-4d2d-bd12-f60734dc1ea9"],
Cell[278607, 6775, 914, 22, 73, "Input",ExpressionUUID->"37d03ff1-a00f-4395-9c10-827800798ac0"],
Cell[279524, 6799, 1452, 37, 52, "Input",ExpressionUUID->"1802c8bf-9057-425d-b7ca-9cb808427f31"],
Cell[CellGroupData[{
Cell[281001, 6840, 307, 7, 45, "Subsubsection",ExpressionUUID->"cc40fcf8-0ccb-41ad-befc-8a9c5eeb578c"],
Cell[281311, 6849, 561, 13, 30, "Input",ExpressionUUID->"8891ec7b-13ca-4447-8027-768598119f14"],
Cell[281875, 6864, 752, 16, 30, "Input",ExpressionUUID->"2da0dfb7-a6be-4b74-b54d-aa3f3ac88d63"]
}, Open  ]],
Cell[CellGroupData[{
Cell[282664, 6885, 350, 7, 71, "Subsubsection",ExpressionUUID->"09452199-2d87-4800-b502-4cfed7842ad0"],
Cell[283017, 6894, 1161, 21, 30, "Input",ExpressionUUID->"e59d6f07-e671-4ed0-a2c2-6095e38082c8"],
Cell[284181, 6917, 745, 17, 30, "Input",ExpressionUUID->"dea4da8b-f412-4b72-83b7-e4ad3bea25ad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[284963, 6939, 679, 11, 149, "Subsubsection",ExpressionUUID->"c2c446e7-a324-42f5-80fe-fcaa9450753e"],
Cell[285645, 6952, 866, 23, 52, "Input",ExpressionUUID->"fe9e57d7-5789-4e06-80ab-60d1a4c0605e"],
Cell[286514, 6977, 431, 12, 30, "Input",ExpressionUUID->"36cd62b9-90e4-4b73-b9e0-1c153b4394a6"],
Cell[286948, 6991, 1810, 48, 136, "Input",ExpressionUUID->"58a28190-bdfd-473b-9605-676b8aeae0d3"],
Cell[288761, 7041, 474, 12, 30, "Input",ExpressionUUID->"a57a33b7-5ad0-42df-8808-fceb07388b86"],
Cell[289238, 7055, 1394, 40, 94, "Input",ExpressionUUID->"d7634f89-329c-4d7a-ba80-3b616aeb1cbf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[290669, 7100, 444, 8, 71, "Subsubsection",ExpressionUUID->"b1558e4a-ad01-4af6-9250-dcc4edef19d9"],
Cell[291116, 7110, 535, 13, 30, "Input",ExpressionUUID->"83c7c8f7-3f3a-4073-8e51-6facd71f37c9"],
Cell[291654, 7125, 587, 14, 30, "Input",ExpressionUUID->"f4969d3d-2b47-48c8-8f0f-97e7382a562c"],
Cell[292244, 7141, 485, 12, 30, "Input",ExpressionUUID->"69a80420-8a80-49a7-8b68-53d1977f9d0e"],
Cell[292732, 7155, 585, 14, 30, "Input",ExpressionUUID->"eaabc332-c7f9-4952-af0d-cf49d3e0935f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[293378, 7176, 229, 4, 67, "Section",ExpressionUUID->"4ea3f260-82b5-4cc6-bcbc-2f690cbc8bb6"],
Cell[CellGroupData[{
Cell[293632, 7184, 216, 4, 30, "Input",ExpressionUUID->"835bf556-e668-4ab8-b6a5-b22604496f1e"],
Cell[293851, 7190, 808, 16, 34, "Output",ExpressionUUID->"4e12c877-754a-4b9f-bbe4-dc4a495ad602"]
}, Open  ]],
Cell[CellGroupData[{
Cell[294696, 7211, 320, 8, 30, "Input",ExpressionUUID->"02dc5c5b-709b-4f8c-b0e0-3ac532705e24"],
Cell[295019, 7221, 12944, 385, 405, "Output",ExpressionUUID->"79a76f0e-0e34-47c2-b068-f3e67122301a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[308000, 7611, 366, 9, 30, "Input",ExpressionUUID->"d1c10f3e-7348-4a36-9b5b-bc8894a22131"],
Cell[308369, 7622, 3279, 72, 60, "Output",ExpressionUUID->"361b2fa9-1905-4ebd-bf70-6e3df2ef5b64"]
}, Open  ]],
Cell[CellGroupData[{
Cell[311685, 7699, 319, 8, 30, "Input",ExpressionUUID->"0e888897-00fc-4bab-9551-aa7d447311fe"],
Cell[312007, 7709, 836, 15, 34, "Output",ExpressionUUID->"c009c593-0a0e-48a3-8612-28caae12a1e6"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[312892, 7730, 498, 8, 67, "Section",ExpressionUUID->"e422bf2b-b8ce-47e4-9fe4-d5297b662e30"],
Cell[CellGroupData[{
Cell[313415, 7742, 300, 6, 71, "Subsubsection",ExpressionUUID->"aa6edde8-aa56-4595-b1fa-6cec381a29e4"],
Cell[313718, 7750, 967, 30, 52, "Input",ExpressionUUID->"8fb96835-a8ba-4a36-89dc-c1c96967b3b7"],
Cell[314688, 7782, 774, 19, 52, "Input",ExpressionUUID->"e1e8ec0f-5d1f-4f30-8db0-64fcc2becfe0"],
Cell[315465, 7803, 343, 10, 30, "Input",ExpressionUUID->"1d41eeb0-593c-4a30-b103-728d932b48e1"],
Cell[315811, 7815, 650, 17, 52, "Input",ExpressionUUID->"16be062e-deb8-445d-a132-029d633b0117"]
}, Open  ]],
Cell[316476, 7835, 713, 11, 97, "Subsubsection",ExpressionUUID->"31fa9d88-9649-4238-b56b-f5ca2fab3d0a"],
Cell[CellGroupData[{
Cell[317214, 7850, 290, 6, 37, "Subsubsection",ExpressionUUID->"362dbf31-0c23-45a8-891f-7ccce0422651"],
Cell[317507, 7858, 1282, 36, 73, "Input",ExpressionUUID->"f0848c0e-721b-4051-803a-1dcc34abb59c"],
Cell[318792, 7896, 2350, 57, 94, "Input",ExpressionUUID->"dff8af42-61e7-4c5e-8197-8b7dc876cd8d"],
Cell[321145, 7955, 1263, 30, 73, "Input",ExpressionUUID->"bd6087a7-d8d7-4538-ad82-374212be3624"],
Cell[322411, 7987, 1235, 29, 73, "Input",ExpressionUUID->"86340e21-4680-4c7a-9e6b-5e044c766c62"],
Cell[323649, 8018, 2799, 68, 115, "Input",ExpressionUUID->"fce32fe8-e173-4566-b910-74de02d4530b"],
Cell[326451, 8088, 2234, 52, 115, "Input",ExpressionUUID->"b33a8328-c147-4475-a086-002375ae7738"],
Cell[328688, 8142, 2376, 58, 115, "Input",ExpressionUUID->"5212550a-bc03-450f-892a-5e5918d23cfe"]
}, Open  ]],
Cell[CellGroupData[{
Cell[331101, 8205, 173, 3, 45, "Subsubsection",ExpressionUUID->"efd95474-370d-4100-b253-f92e4f0283ae"],
Cell[331277, 8210, 1674, 40, 73, "Input",ExpressionUUID->"1e6ba31b-82ba-428c-b0ea-fb9308ac4c24"],
Cell[332954, 8252, 876, 22, 52, "Input",ExpressionUUID->"dc9d3ed0-c5cc-41a8-b63d-47f45679684c"],
Cell[333833, 8276, 645, 16, 30, "Input",ExpressionUUID->"95ca7819-ae7e-4039-a76d-1d07d10d54d4"],
Cell[334481, 8294, 651, 17, 52, "Input",ExpressionUUID->"daec97f8-75ad-4993-bbe7-28b08c698539"]
}, Open  ]],
Cell[CellGroupData[{
Cell[335169, 8316, 538, 9, 81, "Subsection",ExpressionUUID->"9b587d4c-6bf0-49c8-90da-d7ee9a2721a9"],
Cell[CellGroupData[{
Cell[335732, 8329, 574, 14, 30, "Input",ExpressionUUID->"b47b917d-4cb0-4ef4-90cf-31aa9716b587"],
Cell[336309, 8345, 965, 20, 34, "Output",ExpressionUUID->"b005fd96-4baa-4c71-8396-60255222fc99"]
}, Open  ]],
Cell[CellGroupData[{
Cell[337311, 8370, 277, 6, 30, "Input",ExpressionUUID->"a5074edd-9c32-43ac-9c2c-fdb5621ac1e9"],
Cell[337591, 8378, 4038, 109, 292, "Output",ExpressionUUID->"1519fec6-c83b-4031-86de-bab7b3d582d5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[341678, 8493, 296, 7, 81, "Subsection",ExpressionUUID->"55998dc9-741a-4816-bb91-7b45f1a6bad4"],
Cell[CellGroupData[{
Cell[341999, 8504, 499, 12, 30, "Input",ExpressionUUID->"b57247b7-ab2e-4249-9f5a-612a9c665b38"],
Cell[342501, 8518, 1397, 27, 37, "Output",ExpressionUUID->"6cfcf78d-5c1c-4802-a41e-a86313665d5a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[343935, 8550, 524, 13, 30, "Input",ExpressionUUID->"feb7b596-63c8-477a-8390-fde9bf1662b6"],
Cell[344462, 8565, 1242, 20, 34, "Output",ExpressionUUID->"a52b984c-988b-438d-8673-a7ed1cc16661"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[345753, 8591, 242, 4, 54, "Subsection",ExpressionUUID->"010de687-446e-4b41-8313-cfc3f6103c9b"],
Cell[CellGroupData[{
Cell[346020, 8599, 550, 14, 30, "Input",ExpressionUUID->"f2a797ce-0f2c-433d-acfe-5ec5a5d76a5e"],
Cell[346573, 8615, 608, 14, 37, "Output",ExpressionUUID->"f11189f8-12fa-4f08-916b-93298fc85f28"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[347230, 8635, 174, 3, 54, "Subsection",ExpressionUUID->"53db41a3-7c6e-4ed5-8a3e-1a9cad481c43"],
Cell[CellGroupData[{
Cell[347429, 8642, 179, 3, 30, "Input",ExpressionUUID->"e85dfd36-fccb-498d-b3b9-e6c73a7aeebb"],
Cell[347611, 8647, 1876, 28, 98, "Output",ExpressionUUID->"0dc802cc-2a71-49c2-9655-1a708bf93612"]
}, Open  ]],
Cell[CellGroupData[{
Cell[349524, 8680, 194, 3, 45, "Subsubsection",ExpressionUUID->"7e9df92a-2406-46ff-bf2f-1f31b5a33a45"],
Cell[CellGroupData[{
Cell[349743, 8687, 257, 6, 30, "Input",ExpressionUUID->"04b1ab9e-079d-4825-9a2b-e6bc3c449975"],
Cell[350003, 8695, 897, 15, 34, "Output",ExpressionUUID->"b7c866de-18d7-47bf-8cfa-8e96b9fef373"]
}, Open  ]],
Cell[CellGroupData[{
Cell[350937, 8715, 331, 8, 30, "Input",ExpressionUUID->"e4986900-e8cb-444e-84d7-3106f4d9888a"],
Cell[351271, 8725, 7628, 216, 420, "Output",ExpressionUUID->"f758dce9-a916-4214-b847-d8279b25d030"]
}, Open  ]],
Cell[CellGroupData[{
Cell[358936, 8946, 1733, 50, 94, "Input",ExpressionUUID->"25521fe2-c065-4810-85f3-08de1751cf06"],
Cell[360672, 8998, 2516, 48, 144, "Output",ExpressionUUID->"6e4cb5d7-c7a2-4a1c-a8a9-c88374ef4477"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[363249, 9053, 251, 4, 54, "Subsection",ExpressionUUID->"73d0086e-cae7-416c-ba6b-1a6696182e9a"],
Cell[CellGroupData[{
Cell[363525, 9061, 261, 5, 30, "Input",ExpressionUUID->"3e7b6814-4a45-4941-9585-f412b3f16267"],
Cell[363789, 9068, 1172, 19, 34, "Output",ExpressionUUID->"1065901f-74a8-4aaa-97a3-7c1b82df76e7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[364998, 9092, 337, 7, 30, "Input",ExpressionUUID->"dcc72ea0-fdda-4448-8f29-e3c79fcd656d"],
Cell[365338, 9101, 12077, 335, 604, "Output",ExpressionUUID->"6193b402-e3c6-4d5c-9c7a-e64959953da2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[377464, 9442, 174, 3, 54, "Subsection",ExpressionUUID->"ee3a3bcc-aae6-46a2-a6e6-d7517207175e"],
Cell[CellGroupData[{
Cell[377663, 9449, 448, 10, 30, "Input",ExpressionUUID->"68b0f41f-3d61-4e06-9214-012d9723092e"],
Cell[378114, 9461, 4090, 116, 264, "Output",ExpressionUUID->"d1f0f5a6-9e10-4496-b773-16e875df5235"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[382253, 9583, 410, 7, 54, "Subsection",ExpressionUUID->"538771cf-5812-4a69-9704-13a355769e77"],
Cell[CellGroupData[{
Cell[382688, 9594, 835, 16, 30, "Input",ExpressionUUID->"9b2d9eb4-154a-4d65-95f0-56599efc7b41"],
Cell[383526, 9612, 6750, 174, 360, "Output",ExpressionUUID->"c827695f-cdec-4e2b-9cbd-65ed57177e36"]
}, Open  ]],
Cell[CellGroupData[{
Cell[390313, 9791, 156, 3, 45, "Subsubsection",ExpressionUUID->"706624c4-9a29-47f7-a75a-2a437fa71f78"],
Cell[CellGroupData[{
Cell[390494, 9798, 974, 26, 52, "Input",ExpressionUUID->"16da7f7f-9398-43a8-ac46-20c4384fae63"],
Cell[391471, 9826, 1510, 31, 76, "Output",ExpressionUUID->"bb81279b-20ea-419f-8b16-98f6d79de81f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[393042, 9864, 252, 6, 81, "Subsection",ExpressionUUID->"77909174-728b-4063-8688-a2e50fdbaf93"],
Cell[CellGroupData[{
Cell[393319, 9874, 1411, 31, 52, "Input",ExpressionUUID->"0d593806-21c2-4cc4-b09a-51372abd1f0f"],
Cell[394733, 9907, 1757, 37, 110, "Output",ExpressionUUID->"86279cd2-db7a-4849-8dcb-0953ee6dca35"]
}, Open  ]],
Cell[CellGroupData[{
Cell[396527, 9949, 957, 24, 115, "Input",ExpressionUUID->"8682700d-0816-4a4a-9a4f-0523a169239f"],
Cell[397487, 9975, 1924, 39, 128, "Output",ExpressionUUID->"e7dd29ab-51fe-43c0-af45-45bcaae4e31c"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[399460, 10020, 166, 3, 54, "Subsection",ExpressionUUID->"d7a232ae-27e0-4dcc-8dec-6da08af8b279"],
Cell[CellGroupData[{
Cell[399651, 10027, 183, 3, 45, "Subsubsection",ExpressionUUID->"efd3488d-322d-4537-99e2-45df73791b63"],
Cell[CellGroupData[{
Cell[399859, 10034, 802, 19, 52, "Input",ExpressionUUID->"6816504f-9125-4b4d-ad7b-2f24b6c1a23c"],
Cell[400664, 10055, 1123, 23, 37, "Output",ExpressionUUID->"e606f36e-df40-48c8-893e-6ff747d69035"]
}, Open  ]],
Cell[CellGroupData[{
Cell[401824, 10083, 456, 12, 30, "Input",ExpressionUUID->"f5b771be-b3b1-4aa6-b15d-82e5d06c9ab6"],
Cell[402283, 10097, 468, 10, 37, "Output",ExpressionUUID->"1d84fe6f-e2e3-4aec-8e5b-726fa70a7ecd"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[402800, 10113, 298, 6, 71, "Subsubsection",ExpressionUUID->"20b9e03f-d2f3-431c-9063-419ae90c62d1"],
Cell[CellGroupData[{
Cell[403123, 10123, 405, 10, 30, "Input",ExpressionUUID->"a6696058-5687-46d9-a53a-e9bab4d014b9"],
Cell[403531, 10135, 1010, 21, 37, "Output",ExpressionUUID->"d11f635a-d07f-442f-9686-b67b609d1b47"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[404590, 10162, 615, 10, 97, "Subsubsection",ExpressionUUID->"89ab1411-9625-4d19-b572-fc81da270cbc"],
Cell[405208, 10174, 395, 10, 30, "Input",ExpressionUUID->"933a4a99-ca6d-4b85-a533-e24e4417085c"],
Cell[CellGroupData[{
Cell[405628, 10188, 331, 8, 30, "Input",ExpressionUUID->"27d5be7f-cba7-4ca8-b165-37fe363144fe"],
Cell[405962, 10198, 766, 14, 34, "Output",ExpressionUUID->"0b900e58-edbf-4d74-9a82-ff56af0844a8"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[406777, 10218, 1180, 21, 331, "Subsubsection",ExpressionUUID->"4a95bf3e-bc5a-46a9-8657-92f810eac00b"],
Cell[CellGroupData[{
Cell[407982, 10243, 781, 22, 52, "Input",ExpressionUUID->"ea738ec3-7bd6-42ee-b5d2-6590754dd7e4"],
Cell[408766, 10267, 986, 23, 60, "Output",ExpressionUUID->"66cf711c-db6f-4dbe-90cb-072751ba79e6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[409789, 10295, 863, 24, 52, "Input",ExpressionUUID->"ad528a24-69e9-432d-b049-e1b51d1f68ac"],
Cell[410655, 10321, 4455, 132, 466, "Output",ExpressionUUID->"62df0dfd-d161-4c9e-8490-b562148255d0"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[415159, 10459, 273, 6, 45, "Subsubsection",ExpressionUUID->"41afe232-ad43-49a8-91a8-3a65b1cbf2fc"],
Cell[415435, 10467, 579, 13, 30, "Input",ExpressionUUID->"525d5068-0fd5-438c-98bd-08654f931f33"],
Cell[416017, 10482, 1001, 25, 52, "Input",ExpressionUUID->"f34de29c-8f87-4862-932c-857dff6fe120"]
}, Open  ]],
Cell[CellGroupData[{
Cell[417055, 10512, 669, 11, 97, "Subsubsection",ExpressionUUID->"6c9a5392-d00d-4946-a73e-8134ac513f29"],
Cell[417727, 10525, 444, 12, 30, "Input",ExpressionUUID->"67640478-7287-4a40-a57d-09c671f57698"],
Cell[418174, 10539, 1199, 28, 52, "Input",ExpressionUUID->"d31b9171-a396-4250-a8cc-89cbb618cbac"],
Cell[419376, 10569, 602, 17, 30, "Input",ExpressionUUID->"df41a957-49cf-4689-a427-342b9a3350f0"],
Cell[419981, 10588, 1143, 34, 52, "Input",ExpressionUUID->"2c50850a-436b-4916-9bfa-04e07aa2019d"],
Cell[421127, 10624, 984, 27, 30, "Input",ExpressionUUID->"954f2903-1e9f-4c90-890e-002518eb327b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[422148, 10656, 163, 3, 45, "Subsubsection",ExpressionUUID->"50075147-7541-40dd-9667-f9c056872576"],
Cell[422314, 10661, 588, 16, 30, "Input",ExpressionUUID->"8be448b7-4bbc-4fbd-8156-58e0fbcb2cc1"],
Cell[CellGroupData[{
Cell[422927, 10681, 1222, 35, 73, "Input",ExpressionUUID->"a9b1c938-3d50-4b72-bfec-0dafb4906df4"],
Cell[424152, 10718, 5849, 87, 94, "Output",ExpressionUUID->"2d5e3265-6e38-455e-b9d0-eb9dabdad464"]
}, Open  ]],
Cell[CellGroupData[{
Cell[430038, 10810, 1139, 31, 52, "Input",ExpressionUUID->"0d1c12e5-f43b-4260-ae11-ba8981ca2108"],
Cell[431180, 10843, 1281, 33, 60, "Output",ExpressionUUID->"736b980b-c9ae-414b-907d-3e23902068bb"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[432510, 10882, 171, 3, 45, "Subsubsection",ExpressionUUID->"bb5894fe-54a9-4b7a-962f-e002b6b4b4c7"],
Cell[432684, 10887, 441, 12, 30, "Input",ExpressionUUID->"4b250917-a378-4edb-bd45-5d23f7a10611"],
Cell[CellGroupData[{
Cell[433150, 10903, 276, 6, 30, "Input",ExpressionUUID->"da380d43-81a3-4dcb-b4ea-605773688a52"],
Cell[433429, 10911, 620, 17, 34, "Output",ExpressionUUID->"c307aa97-4b43-4a2c-b8a1-da803e89aa34"]
}, Open  ]],
Cell[CellGroupData[{
Cell[434086, 10933, 822, 23, 52, "Input",ExpressionUUID->"0e8f83b2-1ea5-4a57-994b-112fd46b86a3"],
Cell[434911, 10958, 3730, 115, 152, "Output",ExpressionUUID->"5e3b4ffd-025a-42b3-8591-cfc11e04c466"]
}, Open  ]],
Cell[CellGroupData[{
Cell[438678, 11078, 286, 6, 30, "Input",ExpressionUUID->"0d8d8992-d016-43a8-ab68-79cd71540095"],
Cell[438967, 11086, 1072, 32, 56, "Output",ExpressionUUID->"d5e7b8cc-b68c-4eb9-8112-667104eff0d4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[440076, 11123, 746, 22, 52, "Input",ExpressionUUID->"2c0f39d5-37f4-4943-8ae3-35f424df4e2e"],
Cell[440825, 11147, 18493, 548, 296, "Output",ExpressionUUID->"cacd1d42-62a3-4714-8201-75794989f207"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[459367, 11701, 286, 6, 71, "Subsubsection",ExpressionUUID->"2d1963a6-aaf3-4f7c-9b2e-3cb7fde123c0"],
Cell[CellGroupData[{
Cell[459678, 11711, 401, 10, 30, "Input",ExpressionUUID->"a4c974e2-5fb4-4aee-97b1-8e1e7c32ac56"],
Cell[460082, 11723, 446, 11, 34, "Output",ExpressionUUID->"f0a6103f-5ef5-40c2-9c22-5e21d877713b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[460565, 11739, 492, 13, 30, "Input",ExpressionUUID->"72ed3158-d721-4a7f-8509-37de7da630c5"],
Cell[461060, 11754, 394, 9, 34, "Output",ExpressionUUID->"37668cce-391d-45c2-97e9-1786978c20df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[461491, 11768, 375, 10, 30, "Input",ExpressionUUID->"869a89c4-23ba-4e85-b2af-7be15f05c155"],
Cell[461869, 11780, 313, 8, 34, "Output",ExpressionUUID->"1b665062-1770-4d99-905d-525ca494ba25"]
}, Open  ]]
}, Open  ]],
Cell[462209, 11792, 451, 8, 71, "Subsubsection",ExpressionUUID->"8cb75b4c-8d60-4a19-a704-333aa264c2bb"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[462709, 11806, 260, 4, 67, "Section",ExpressionUUID->"8f7b796d-1208-426b-b688-8061662e1eb8"],
Cell[CellGroupData[{
Cell[462994, 11814, 358, 7, 54, "Subsection",ExpressionUUID->"27f6ab76-008e-4d64-ba3a-1b2f1d6453e4"],
Cell[463355, 11823, 3730, 108, 241, "Input",ExpressionUUID->"bd48693f-cc6b-4673-b0c8-3683b94e5ffe"],
Cell[467088, 11933, 1210, 33, 94, "Input",ExpressionUUID->"1faedac8-4b5a-44c3-bed3-66266b5d24c1"],
Cell[468301, 11968, 384, 10, 30, "Input",ExpressionUUID->"d8f66825-a05d-49e7-b814-1efe7b2318bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[468722, 11983, 404, 7, 54, "Subsection",ExpressionUUID->"b3f3f2bf-3a21-4278-95fb-bf10a72906db"],
Cell[469129, 11992, 311, 8, 30, "Input",ExpressionUUID->"bba8046b-cf7c-4630-8e11-03f53cdceedf"],
Cell[469443, 12002, 844, 23, 30, "Input",ExpressionUUID->"47a1d39c-7d0f-408c-b95b-a9a382129712"],
Cell[470290, 12027, 886, 23, 30, "Input",ExpressionUUID->"408cbc01-67e2-43af-9551-823ca5311fe5"],
Cell[471179, 12052, 891, 23, 30, "Input",ExpressionUUID->"400d3065-f9c3-4779-a044-5ad404465d3b"],
Cell[472073, 12077, 1510, 40, 52, "Input",ExpressionUUID->"e7b96df7-e81a-4115-a201-8e73f8d4f726"],
Cell[473586, 12119, 842, 22, 73, "Input",ExpressionUUID->"96cf071b-c447-4563-ae87-071e76b7d961"],
Cell[474431, 12143, 2436, 60, 199, "Input",ExpressionUUID->"2cfc4ecd-33f3-40b5-acfd-ec69799c8dce"],
Cell[476870, 12205, 985, 29, 52, "Input",ExpressionUUID->"44708150-390c-4152-92e8-918805ed5c7b"],
Cell[477858, 12236, 597, 15, 30, "Input",ExpressionUUID->"79530fd4-4189-41d0-b93c-b4e73a90093b"],
Cell[478458, 12253, 377, 10, 30, "Input",ExpressionUUID->"39d0cf4a-7f21-4aba-aab5-9c782442933a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[478872, 12268, 223, 4, 54, "Subsection",ExpressionUUID->"d3132f3b-6eac-4955-8330-442661fa1a4d"],
Cell[479098, 12274, 882, 25, 30, "Input",ExpressionUUID->"12601d6f-6f51-4a26-b142-51adfd5fced5"],
Cell[479983, 12301, 678, 20, 30, "Input",ExpressionUUID->"f4b2430a-da43-4e32-88df-acd4baf03da3"],
Cell[480664, 12323, 427, 10, 30, "Input",ExpressionUUID->"06f109b9-cc17-43c9-ac91-1d788ccd6ce6"],
Cell[CellGroupData[{
Cell[481116, 12337, 175, 3, 45, "Subsubsection",ExpressionUUID->"d48066fd-2178-4761-8e7e-d9dc72ed33ae"],
Cell[CellGroupData[{
Cell[481316, 12344, 400, 10, 30, "Input",ExpressionUUID->"6f401191-5ad5-420b-a171-1681851f5183"],
Cell[481719, 12356, 27520, 1139, 287, "Output",ExpressionUUID->"af158c75-8886-432b-be36-3752e2946a44"]
}, Open  ]],
Cell[CellGroupData[{
Cell[509276, 13500, 364, 10, 30, "Input",ExpressionUUID->"7b9d571f-75c4-4d45-804e-8f1becb15f07"],
Cell[509643, 13512, 27496, 1139, 287, "Output",ExpressionUUID->"f203d364-bb35-40e1-9e57-2d0ab1d64bec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[537176, 14656, 1002, 22, 52, "Input",ExpressionUUID->"e98e2f07-a9d2-4d2e-a03f-085bba745472"],
Cell[538181, 14680, 1022, 16, 34, "Output",ExpressionUUID->"ff1cc609-0509-493d-b8cc-9d768be02238"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[539252, 14702, 174, 3, 45, "Subsubsection",ExpressionUUID->"f9b3b13a-380d-480f-84fe-f46d306d255c"],
Cell[539429, 14707, 537, 14, 30, "Input",ExpressionUUID->"d9516ca3-50fc-4180-9967-27aed2d635a0"],
Cell[539969, 14723, 541, 14, 30, "Input",ExpressionUUID->"e8e9f27a-d756-48ff-9d10-281fd120afbe"],
Cell[CellGroupData[{
Cell[540535, 14741, 617, 11, 30, "Input",ExpressionUUID->"099b74e6-3cee-4bff-a4de-29cc90f1d29a"],
Cell[541155, 14754, 27948, 1144, 287, "Output",ExpressionUUID->"6e635010-0793-42c4-ac7e-5e969d4498d0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[569140, 15903, 958, 24, 94, "Input",ExpressionUUID->"1aa05a6c-5dac-449c-80bf-15ca38682056"],
Cell[570101, 15929, 27707, 1141, 287, "Output",ExpressionUUID->"6224db42-f2d0-4e03-9bf0-1de01e4a12e9"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[597869, 17077, 279, 6, 54, "Subsection",ExpressionUUID->"d0981fdd-5c13-4a72-9d09-e4efbc66168c"],
Cell[CellGroupData[{
Cell[598173, 17087, 527, 13, 52, "Input",ExpressionUUID->"c93ad751-5e67-40fe-b096-8911d6428591"],
Cell[598703, 17102, 21380, 877, 224, "Output",ExpressionUUID->"8ec7f069-3e1c-4c6d-bd8a-04482968a00c"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

