(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    102805,       2721]
NotebookOptionsPosition[     82788,       2349]
NotebookOutlinePosition[     83205,       2367]
CellTagsIndexPosition[     83162,       2364]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["Use ' Evaluate Notebook' in ' Evaluation' menu to get \
everything loaded (blue text should change to black, this will take a few \
seconds). Scroll down for Problem Sheet 9 Question 3",
 FontWeight->"Bold"]], "Subsubsection",
 CellChangeTimes->{{3.7531160035551367`*^9, 3.753116006057843*^9}, {
  3.753116985150736*^9, 
  3.753116992036504*^9}},ExpressionUUID->"85ddcb8e-e69b-4ad8-98c9-\
c3bccf375c36"],

Cell[CellGroupData[{

Cell["Public Key Cryptography Examples", "Section",
 CellChangeTimes->{{3.7212383805093317`*^9, 
  3.721238383837453*^9}},ExpressionUUID->"14adf787-eb25-4f12-941f-\
9ca67fa65c12"],

Cell[BoxData[
 RowBox[{
  RowBox[{"TF", "[", "xs_", "]"}], ":=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"xs", ",", 
    RowBox[{"TableDepth", "\[Rule]", "2"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.75311603848466*^9, 3.753116043748253*^9}},
 CellLabel->
  "In[346]:=",ExpressionUUID->"14f89deb-4f9f-4101-a57c-0d7726772cde"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GroupIn", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "_"}], "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.7531161877270727`*^9, 3.753116190962716*^9}, {
  3.777204293970277*^9, 3.777204294568626*^9}},
 CellLabel->
  "In[347]:=",ExpressionUUID->"8bf13888-db3c-4bf9-9403-a8a055382217"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GroupIn", "[", 
   RowBox[{"xs_", ",", "m_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Take", "[", 
     RowBox[{"xs", ",", 
      RowBox[{"Min", "[", 
       RowBox[{"m", ",", 
        RowBox[{"Length", "[", "xs", "]"}]}], "]"}]}], "]"}], "}"}], "~", 
   "Join", "~", 
   RowBox[{"GroupIn", "[", 
    RowBox[{
     RowBox[{"Drop", "[", 
      RowBox[{"xs", ",", 
       RowBox[{"Min", "[", 
        RowBox[{"m", ",", 
         RowBox[{"Length", "[", "xs", "]"}]}], "]"}]}], "]"}], ",", "m"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.753116167149445*^9, 3.753116204100235*^9}, {
  3.753116306248901*^9, 3.7531163339376707`*^9}, {3.7772043086736507`*^9, 
  3.7772043092096663`*^9}, {3.777204471822246*^9, 3.77720447235699*^9}},
 CellLabel->
  "In[348]:=",ExpressionUUID->"2b8aa4de-8514-4244-a99a-57c571b59635"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ToBits", "[", 
    RowBox[{"_", ",", "0"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";", 
  RowBox[{
   RowBox[{"ToBits", "[", 
    RowBox[{"x_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Mod", "[", 
      RowBox[{"x", ",", "2"}], "]"}], "}"}], "~", "Join", "~", 
    RowBox[{"ToBits", "[", 
     RowBox[{
      RowBox[{"Quotient", "[", 
       RowBox[{"x", ",", "2"}], "]"}], ",", 
      RowBox[{"n", "-", "1"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.753177732490737*^9, 3.753177760959846*^9}, {
  3.753177890781316*^9, 3.753177902961732*^9}, {3.753177954714562*^9, 
  3.7531779569742727`*^9}, {3.753177993464913*^9, 3.7531779978593616`*^9}},
 CellLabel->
  "In[349]:=",ExpressionUUID->"05987e33-89e2-4af3-b899-b2fdbe195be4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Diffie\[Dash]Hellman Example", "Section",
 CellChangeTimes->{{3.7211139101279716`*^9, 
  3.721113916502709*^9}},ExpressionUUID->"7361d337-3b63-4f59-813a-\
0cd667bf2d7b"],

Cell[CellGroupData[{

Cell["\<\
Alice and Bob want to use AES with a 128-bit key. They agree on a prime p > \
2^128 and a primitive-root (see the lecture notes) g. This is done \
communicating across the snooped-on channel.\
\>", "Subsubsection",
 CellChangeTimes->{{3.721238426405939*^9, 3.7212384443475018`*^9}, {
  3.72123881333956*^9, 3.7212388279259977`*^9}, {3.753116013295961*^9, 
  3.753116015423472*^9}},ExpressionUUID->"cbf0d910-4791-4509-9315-\
3e76215ed93b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"p", " ", ":=", " ", 
   RowBox[{"NextPrime", "[", 
    RowBox[{"2", "^", "128"}], "]"}]}], ";", " ", "p"}]], "Input",
 CellChangeTimes->{{3.721114549849402*^9, 3.7211145545378723`*^9}, {
  3.721238404788474*^9, 3.721238405047387*^9}, {3.784619704005995*^9, 
  3.784619705351486*^9}, {3.784619772801989*^9, 3.7846197740349483`*^9}},
 CellLabel->
  "In[423]:=",ExpressionUUID->"6271c3c6-6490-4786-aa60-d5b4ba553f6d"],

Cell[BoxData["340282366920938463463374607431768211507"], "Output",
 CellChangeTimes->{{3.784619694323555*^9, 3.784619706024918*^9}, 
   3.784619774640931*^9},
 CellLabel->
  "Out[423]=",ExpressionUUID->"fc0cfb3c-efa0-42d1-a1bb-f78ddcff4b59"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"g", " ", ":=", " ", 
   RowBox[{"PrimitiveRoot", "[", "p", "]"}]}], ";", " ", "g"}]], "Input",
 CellChangeTimes->{{3.721114615465478*^9, 3.721114618273787*^9}, {
  3.7211146521720257`*^9, 3.721114652726632*^9}, {3.7212384018962517`*^9, 
  3.7212384021078653`*^9}},
 CellLabel->
  "In[424]:=",ExpressionUUID->"f44fb10a-545f-4c84-b64d-9aa7f1c3b367"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.784619778111261*^9},
 CellLabel->
  "Out[424]=",ExpressionUUID->"01c0cd59-03e8-4a05-ba16-c4113e739427"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Privately Alice and Bob choose their exponents. (You can use Random[Integer, \
p]; I\[CloseCurlyQuote]ve made a particular choice for them below.)\
\>", "Subsubsection",
 CellChangeTimes->{{3.721238447141983*^9, 3.721238454892425*^9}, {
  3.721238491662362*^9, 3.721238512044414*^9}, {3.721239317490087*^9, 
  3.72123932194471*^9}},ExpressionUUID->"ab551172-b535-4e2b-bdc1-\
bbc85c3a507c"],

Cell[BoxData[
 RowBox[{"a", " ", ":=", " ", 
  RowBox[{"Mod", "[", 
   RowBox[{"284811772986862444437494298372862386684", ",", "p"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.753170547524598*^9, 3.75317056976254*^9}, {
  3.784619796135993*^9, 3.78461979944773*^9}},
 CellLabel->
  "In[428]:=",ExpressionUUID->"66fee14b-eacd-46e2-8bb8-decf1e95ddf9"],

Cell[CellGroupData[{

Cell[BoxData["a"], "Input",
 CellChangeTimes->{3.784619800854432*^9},
 CellLabel->
  "In[429]:=",ExpressionUUID->"3660d8d2-9fb6-44a4-9cf7-f8693eadd809"],

Cell[BoxData["284811772986862444437494298372862386684"], "Output",
 CellChangeTimes->{3.784619801324396*^9},
 CellLabel->
  "Out[429]=",ExpressionUUID->"f9c100e3-f06e-47cc-86e7-6b473baf7b65"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"b", " ", ":=", " ", 
  RowBox[{"Mod", "[", 
   RowBox[{"211014939078240880659963865257540496215", ",", "p"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.721114628011115*^9, 3.7211146322961597`*^9}, 
   3.72111497031514*^9, {3.721238523477948*^9, 3.7212385249285192`*^9}, 
   3.721238661577837*^9, {3.78461980586944*^9, 3.7846198084005327`*^9}},
 CellLabel->
  "In[430]:=",ExpressionUUID->"d18d032a-38dd-43ce-9b77-cec967ac7023"],

Cell[CellGroupData[{

Cell[BoxData["b"], "Input",
 CellChangeTimes->{3.7846198093002653`*^9},
 CellLabel->
  "In[431]:=",ExpressionUUID->"3442daf2-934b-4ec7-9cdb-bec1c84f5652"],

Cell[BoxData["211014939078240880659963865257540496215"], "Output",
 CellChangeTimes->{3.784619809740363*^9},
 CellLabel->
  "Out[431]=",ExpressionUUID->"1f243cee-9555-43d4-91fe-2a07331db5e4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["p"], "Input",
 CellChangeTimes->{3.784619790409829*^9},
 CellLabel->
  "In[427]:=",ExpressionUUID->"db3c88ab-5dcd-48b5-b1b3-2eba39f951d7"],

Cell[BoxData["340282366920938463463374607431768211507"], "Output",
 CellChangeTimes->{3.784619791506043*^9},
 CellLabel->
  "Out[427]=",ExpressionUUID->"5f5d2caa-943f-47c9-b91a-91880f49053d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Alice sends Bob g^a mod p and Bob sends Alice g^b mod p. These must be \
assumed known to the eavesdropper Eve. They are computed efficiently by \
repeated squaring, working modulo p. (Not, as immediately below, by computing \
g^a, and then reducing mod p, since g^a is enormous.)\
\>", "Subsubsection",
 CellChangeTimes->{{3.721238461927404*^9, 3.721238480197145*^9}, {
  3.753177827768901*^9, 
  3.7531778784845867`*^9}},ExpressionUUID->"2a0bbfb3-3f01-40d8-a6a3-\
73045973e55e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{"2", "^", "a"}], ",", "p"}], "]"}]], "Input",
 CellChangeTimes->{{3.753170608199974*^9, 3.753170613056655*^9}},
 CellLabel->
  "In[432]:=",ExpressionUUID->"8af2281f-23fe-48cf-89a8-13e3d742a4ce"],

Cell[BoxData[
 TemplateBox[{
  "General","ovfl","\"Overflow occurred in computation.\"",2,432,18,
   28852019092688393960,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.753772543707602*^9, 3.764921826669039*^9, 
  3.777204184482432*^9, 3.784618413769905*^9, 3.7846198241407623`*^9},
 CellLabel->
  "During evaluation of \
In[432]:=",ExpressionUUID->"18f9f059-c895-4eee-8898-4d064c517779"],

Cell[BoxData[
 RowBox[{"Overflow", "[", "]"}]], "Output",
 CellChangeTimes->{3.784619824170229*^9},
 CellLabel->
  "Out[432]=",ExpressionUUID->"a9b0a146-e19e-4149-a9c2-0a63658769b4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PowerMod", "[", 
  RowBox[{"2", ",", "a", ",", "p"}], "]"}]], "Input",
 CellChangeTimes->{{3.7211146364326563`*^9, 3.721114646417425*^9}, {
  3.784619897000782*^9, 3.7846198971405277`*^9}},
 CellLabel->
  "In[434]:=",ExpressionUUID->"ceb38681-3f22-4d4b-8810-32877c69a4e8"],

Cell[BoxData["102455208830543395831397055456972963798"], "Output",
 CellChangeTimes->{{3.784619892173725*^9, 3.7846198979877157`*^9}},
 CellLabel->
  "Out[434]=",ExpressionUUID->"23585071-d7ab-42bc-8aaa-4479fbe719b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PowerMod", "[", 
  RowBox[{"2", ",", "b", ",", "p"}], "]"}]], "Input",
 CellChangeTimes->{{3.72111465715108*^9, 3.721114660879533*^9}, {
  3.7846198999760427`*^9, 3.7846199001095047`*^9}},
 CellLabel->
  "In[435]:=",ExpressionUUID->"ed597df0-3b06-44db-ac9c-cd57fecff879"],

Cell[BoxData["205807086496694708070736358138337810183"], "Output",
 CellChangeTimes->{3.784619900778776*^9},
 CellLabel->
  "Out[435]=",ExpressionUUID->"dadf3577-384a-4461-816d-e8ec8af57f6d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Alice computes (g^b)^a. (Everyone knows g^b, Alice knows a.) \
\>", "Subsubsection",
 CellChangeTimes->{{3.72123853543364*^9, 
  3.7212385621677027`*^9}},ExpressionUUID->"a8d3c07f-4b6b-4821-a509-\
9cc5de947be7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PowerMod", "[", 
  RowBox[{"205807086496694708070736358138337810183", ",", "a", ",", "p"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.721114664713848*^9, 3.721114673614397*^9}, {
   3.721238576987969*^9, 3.7212385902663383`*^9}, 3.721238675486187*^9, 
   3.753170708541114*^9, 3.784619927054336*^9},
 CellLabel->
  "In[436]:=",ExpressionUUID->"9a6980ae-56b0-41e0-91e4-43e2586ee639"],

Cell[BoxData["305734425960186645508257486947327312923"], "Output",
 CellChangeTimes->{3.784619932573913*^9},
 CellLabel->
  "Out[436]=",ExpressionUUID->"02a60487-4dd9-4c89-9d8d-6eacefd5d016"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bob computes (g^a)^b. (Everyone knows g^a, Bob knows b.)", \
"Subsubsection",
 CellChangeTimes->{{3.7212385677684727`*^9, 
  3.7212385706749763`*^9}},ExpressionUUID->"563c6c1d-9dc7-413d-85a8-\
3b53bd18899d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PowerMod", "[", 
  RowBox[{"102455208830543395831397055456972963798", ",", "b", ",", "p"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.721114674791271*^9, 3.721114678579854*^9}, {
   3.721238588082612*^9, 3.721238592720336*^9}, 3.7212387373836117`*^9, 
   3.753170751073688*^9, 3.784619946348789*^9},
 CellLabel->
  "In[437]:=",ExpressionUUID->"49347725-e6ee-4d69-aef7-2fefd664de4d"],

Cell[BoxData["305734425960186645508257486947327312923"], "Output",
 CellChangeTimes->{3.784619949487873*^9},
 CellLabel->
  "Out[437]=",ExpressionUUID->"4fa800b5-cd86-4465-ad61-5e3bdde784dc"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Both now have 305734425960186645508257486947327312923. Each can convert it to \
binary and take 128 bits (say the last 128) as the secret key. \
\>", "Subsubsection",
 CellChangeTimes->{{3.721238740938672*^9, 3.721238810281588*^9}, 
   3.78461844538655*^9},ExpressionUUID->"18139181-b83a-4a6f-bffe-\
42b14ab73b0e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BaseForm", "[", 
  RowBox[{"305734425960186645508257486947327312923", ",", "2"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.721238781124778*^9, 3.721238790661731*^9}, 
   3.753170778218644*^9, 3.7846184497039213`*^9},
 CellLabel->
  "In[438]:=",ExpressionUUID->"06313682-024a-401a-861f-fe6d408b7158"],

Cell[BoxData[
 TagBox[
  InterpretationBox[
   SubscriptBox["\<\"\
111001100000001001001111000000000101001010100111011110011100110011100100010111\
00011100101011101011111011010011101000010000011011\"\>", "\<\"2\"\>"],
   305734425960186645508257486947327312923,
   Editable->False],
  BaseForm[#, 2]& ]], "Output",
 CellChangeTimes->{3.784619962143621*^9},
 CellLabel->
  "Out[438]//BaseForm=",ExpressionUUID->"911b8782-4eab-4046-8e24-\
25dd0571aa84"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"ToBits", "[", 
     RowBox[{"305734425960186645508257486947327312923", ",", "128"}], "]"}], "//",
     "Reverse"}], ")"}], "[", 
  RowBox[{"[", 
   RowBox[{"1", ";;", "128"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.753177770370351*^9, 3.753177799554337*^9}, {
   3.753177908728574*^9, 3.753177909104682*^9}, {3.7531780205360937`*^9, 
   3.7531780348995028`*^9}, 3.784618454814434*^9},
 CellLabel->
  "In[439]:=",ExpressionUUID->"ed6ae9ca-6e57-4d9a-bbd8-b830148b7201"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
   "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
   "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", 
   ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
   "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", 
   ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
   "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
   "1"}], "}"}]], "Output",
 CellChangeTimes->{3.784619964929257*^9},
 CellLabel->
  "Out[439]=",ExpressionUUID->"9f6c8775-c7f3-4ff1-833e-7b2a5d820b3a"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Modular exponentiation example: p = 131", "Section",
 CellChangeTimes->{{3.753166928799226*^9, 3.7531669323176394`*^9}, {
  3.753166982009038*^9, 
  3.7531669829118443`*^9}},ExpressionUUID->"73b6c3e2-ea75-4fbf-b2f2-\
e580a15d96f6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Powers131", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"PowerMod", "[", 
        RowBox[{"2", ",", "x", ",", "131"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "1", ",", "129"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.753166949249868*^9, 3.753167006426882*^9}, {
  3.75317804394939*^9, 3.753178058362645*^9}},
 CellLabel->
  "In[361]:=",ExpressionUUID->"6936e130-a7df-4b3e-adb4-e3e909e3f91f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Powers131", "//", "Transpose"}], "//", "TF"}]], "Input",
 CellChangeTimes->{{3.7531672251929607`*^9, 3.753167234293392*^9}, {
  3.7531882041995373`*^9, 3.7531882109927597`*^9}},
 CellLabel->
  "In[362]:=",ExpressionUUID->"e1563b66-2cab-4fab-a950-ed865c339ad4"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", 
     "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", 
     "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", 
     "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", 
     "50", "51", "52", "53", "54", "55", "56", "57", "58", "59", "60", "61", 
     "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", 
     "74", "75", "76", "77", "78", "79", "80", "81", "82", "83", "84", "85", 
     "86", "87", "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", 
     "98", "99", "100", "101", "102", "103", "104", "105", "106", "107", 
     "108", "109", "110", "111", "112", "113", "114", "115", "116", "117", 
     "118", "119", "120", "121", "122", "123", "124", "125", "126", "127", 
     "128", "129"},
    {"2", "4", "8", "16", "32", "64", "128", "125", "119", "107", "83", "35", 
     "70", "9", "18", "36", "72", "13", "26", "52", "104", "77", "23", "46", 
     "92", "53", "106", "81", "31", "62", "124", "117", "103", "75", "19", 
     "38", "76", "21", "42", "84", "37", "74", "17", "34", "68", "5", "10", 
     "20", "40", "80", "29", "58", "116", "101", "71", "11", "22", "44", "88",
      "45", "90", "49", "98", "65", "130", "129", "127", "123", "115", "99", 
     "67", "3", "6", "12", "24", "48", "96", "61", "122", "113", "95", "59", 
     "118", "105", "79", "27", "54", "108", "85", "39", "78", "25", "50", 
     "100", "69", "7", "14", "28", "56", "112", "93", "55", "110", "89", "47",
      "94", "57", "114", "97", "63", "126", "121", "111", "91", "51", "102", 
     "73", "15", "30", "60", "120", "109", "87", "43", "86", "41", "82", "33",
      "66"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{
  3.753167234670978*^9, 3.75317823411292*^9, 3.753178364871625*^9, {
   3.753188205871108*^9, 3.7531882114539337`*^9}, 3.753445643423081*^9, 
   3.753772544530775*^9, 3.764921827533429*^9, 3.777204185235099*^9, 
   3.784618414372055*^9},
 CellLabel->
  "Out[362]//TableForm=",ExpressionUUID->"c010a1b2-6417-4858-a30c-\
9b190a41a217"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"DiscreteLog131", "[", "y_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Powers131", "/.", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x_", ",", "y"}], "}"}], "\[RuleDelayed]", 
         RowBox[{"Sow", "[", "x", "]"}]}]}], "//", "Reap"}], ")"}], "[", 
     RowBox[{"[", "2", "]"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753166984536557*^9, 3.753167080202157*^9}},
 CellLabel->
  "In[363]:=",ExpressionUUID->"eb3005fa-573c-46c2-bb28-8b707f5b7b3e"],

Cell[CellGroupData[{

Cell["Example of Lemma 11.4", "Subsubsection",
 CellChangeTimes->{{3.753186295530768*^9, 3.753186302583828*^9}, 
   3.784623458587551*^9},ExpressionUUID->"1b25aead-7753-4424-bb7b-\
7d939df4d94c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"11", "*", "17"}], ",", 
   RowBox[{"10", "*", "16"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.784654964884679*^9, 3.784654977098394*^9}, {
  3.784655041002865*^9, 3.784655070027145*^9}},
 CellLabel->
  "In[623]:=",ExpressionUUID->"7d4c480f-f0d6-4106-bd35-106615733973"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"187", ",", "160"}], "}"}]], "Output",
 CellChangeTimes->{
  3.784654969923317*^9, {3.784655044062838*^9, 3.784655070881117*^9}},
 CellLabel->
  "Out[623]=",ExpressionUUID->"bffaaafe-5971-4aa4-b366-5c71a41d627e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"9", "*", "89"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"9", "*", "89"}], ",", "160"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.784654953671938*^9, 3.78465496334004*^9}, {
  3.7846550454718237`*^9, 3.7846550741380568`*^9}},
 CellLabel->
  "In[624]:=",ExpressionUUID->"ef8a183a-c002-415f-b3c9-4e69412c92ae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"801", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.784654956134919*^9, {3.78465506316507*^9, 3.784655075062241*^9}},
 CellLabel->
  "Out[624]=",ExpressionUUID->"00cd5f9c-734b-46f9-998d-07657bd2eeaa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"x", "^", "11"}], ",", "187"}], "]"}], ",", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"x", "^", "9"}], ",", "187"}], "]"}], "^", "89"}], ",", 
        "187"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "1", ",", "10"}], "}"}]}], "]"}], "//", 
  "TF"}]], "Input",
 CellChangeTimes->{{3.7531863345209417`*^9, 3.7531863958286257`*^9}, {
  3.7531895138643017`*^9, 3.753189534052898*^9}, {3.75318965066989*^9, 
  3.753189652762075*^9}, {3.753190254084984*^9, 3.753190271327094*^9}, {
  3.7534456579587517`*^9, 3.7534456622932673`*^9}, {3.784655002008655*^9, 
  3.784655035080614*^9}},
 CellLabel->
  "In[625]:=",ExpressionUUID->"f5ca1a89-a0ec-4aa0-aac7-2ac570900f48"],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "1", "1"},
    {"2", "178", "2"},
    {"3", "58", "3"},
    {"4", "81", "4"},
    {"5", "181", "5"},
    {"6", "39", "6"},
    {"7", "150", "7"},
    {"8", "19", "8"},
    {"9", "185", "9"},
    {"10", "54", "10"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.7534456437012*^9, 3.753445662756961*^9}, 
   3.753772544723872*^9, 3.7649218277678957`*^9, 3.7772041853640213`*^9, 
   3.784618414551577*^9, 3.784655036642908*^9, 3.784655078446991*^9},
 CellLabel->
  "Out[625]//TableForm=",ExpressionUUID->"7a78242a-2118-409b-b924-\
0eb81f0dfad2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["RSA Example", "Section",
 CellChangeTimes->{{3.721114724789328*^9, 3.7211147262066593`*^9}, {
  3.721238391759017*^9, 
  3.721238395297104*^9}},ExpressionUUID->"8acebd57-64ce-4b50-b00f-\
ce650f75cdbb"],

Cell[CellGroupData[{

Cell["\<\
Alice chooses two large primes p and q and computes their product. (It is \
fast to check it a number is prime.)\
\>", "Subsubsection",
 CellChangeTimes->{{3.7212388996605663`*^9, 
  3.721238940790676*^9}},ExpressionUUID->"16db76e4-8dea-4232-b3ed-\
954a5ad14e95"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"p", ":=", " ", 
   RowBox[{"NextPrime", "[", 
    RowBox[{"2", "^", "80"}], "]"}]}], ";", "p"}]], "Input",
 CellChangeTimes->{{3.721238907895712*^9, 3.7212389287639837`*^9}},
 CellLabel->
  "In[365]:=",ExpressionUUID->"081d4121-a816-4ef5-9cdd-e46b03989efa"],

Cell[BoxData["1208925819614629174706189"], "Output",
 CellChangeTimes->{3.7534456438487587`*^9, 3.7534473181288233`*^9, 
  3.7534473960212173`*^9, 3.7537725447479067`*^9, 3.7649218278014803`*^9, 
  3.77720418545356*^9, 3.784618414629818*^9},
 CellLabel->
  "Out[365]=",ExpressionUUID->"ea04a8c3-ffc8-4eb9-851a-4a9574f8a972"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"q", " ", ":=", " ", 
   RowBox[{"NextPrime", "[", 
    RowBox[{"2", "^", "81"}], "]"}]}], ";", "q"}]], "Input",
 CellChangeTimes->{{3.7212389232187433`*^9, 3.7212389303829412`*^9}},
 CellLabel->
  "In[366]:=",ExpressionUUID->"bbd15b5a-5d9a-46e4-8542-5efa17eafa83"],

Cell[BoxData["2417851639229258349412369"], "Output",
 CellChangeTimes->{3.753445643904914*^9, 3.7534473247288723`*^9, 
  3.753447397280205*^9, 3.75377254481385*^9, 3.7649218278487577`*^9, 
  3.777204185535684*^9, 3.784618414707549*^9},
 CellLabel->
  "Out[366]=",ExpressionUUID->"e8c7d9dd-9195-45f4-b4a5-aaf45c459ff5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"n", ":=", 
   RowBox[{"p", "*", "q"}]}], ";", "n"}]], "Input",
 CellChangeTimes->{{3.7212389433331823`*^9, 3.721238949582521*^9}},
 CellLabel->
  "In[367]:=",ExpressionUUID->"bf1396cd-be57-41b0-8731-52940fd6f115"],

Cell[BoxData["2923003274661805836407421649242809468366377451741"], "Output",
 CellChangeTimes->{3.753445643976604*^9, 3.7534474004023237`*^9, 
  3.753772544838211*^9, 3.764921827918709*^9, 3.7772041856205397`*^9, 
  3.784618414783626*^9},
 CellLabel->
  "Out[367]=",ExpressionUUID->"89042f11-681b-4185-9203-748e213da304"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Alice chooses an encryption exponent a coprime to (p-1)(q-1): the possible \
choices between 1 and 100 are below.\
\>", "Subsubsection",
 CellChangeTimes->{{3.721239093838395*^9, 3.721239103594933*^9}, {
   3.7212391618968678`*^9, 3.721239169976759*^9}, 3.753445677885035*^9, 
   3.777204375109365*^9},ExpressionUUID->"ee8f1b72-e792-405a-97ac-\
569158e31dbe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "100"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"GCD", "[", 
      RowBox[{"#", ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "-", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}], "\[Equal]", "1"}], 
    "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7212391066526527`*^9, 3.721239143149835*^9}},
 CellLabel->
  "In[368]:=",ExpressionUUID->"b688b54a-7656-466c-bc3b-ae928336f2f5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "5", ",", "7", ",", "11", ",", "13", ",", "17", ",", "19", ",", 
   "23", ",", "25", ",", "29", ",", "31", ",", "35", ",", "37", ",", "41", 
   ",", "47", ",", "49", ",", "53", ",", "55", ",", "59", ",", "61", ",", 
   "65", ",", "67", ",", "71", ",", "73", ",", "77", ",", "79", ",", "83", 
   ",", "85", ",", "89", ",", "91", ",", "95", ",", "97"}], "}"}]], "Output",
 CellChangeTimes->{3.7531166460142517`*^9, 3.753178234547092*^9, 
  3.753178365249049*^9, 3.7534456440376253`*^9, 3.7534474118423023`*^9, 
  3.753772544897767*^9, 3.764921828235145*^9, 3.777204185704508*^9, 
  3.7846184148625937`*^9},
 CellLabel->
  "Out[368]=",ExpressionUUID->"077b3738-c79a-4433-b1f4-e18667364881"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"a", ":=", "5"}]], "Input",
 CellChangeTimes->{{3.753187240482951*^9, 3.753187241741744*^9}, {
   3.753447603367337*^9, 3.75344760347019*^9}, 3.777204378063489*^9},
 CellLabel->
  "In[369]:=",ExpressionUUID->"38e3768b-934a-41b6-baf4-14aa80fcc7ef"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Privately Alice computes r such that cr = 1 mod (p-1)(q-1). Note she needs \
to know p and q to calculate (p-1)(q-1). Then it is easy for us, and ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", to find r using Euclid\[CloseCurlyQuote]s Algorithm."
}], "Subsubsection",
 CellChangeTimes->{{3.7212391804497547`*^9, 3.721239224042315*^9}, {
   3.721390317654128*^9, 3.7213903367897587`*^9}, 
   3.753445697602366*^9},ExpressionUUID->"78dc6599-9a55-4f86-a165-\
0afc83c30902"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"r", " ", ":=", " ", 
   RowBox[{"PowerMod", "[", 
    RowBox[{"5", ",", 
     RowBox[{"-", "1"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"p", "-", "1"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}]}], ";", "r"}]], "Input",
 CellChangeTimes->{{3.7212392060996943`*^9, 3.721239219694607*^9}, {
  3.721394888148407*^9, 3.721394888222148*^9}},
 CellLabel->
  "In[370]:=",ExpressionUUID->"30023491-6523-4d02-9948-938df172e486"],

Cell[BoxData["584600654932361167281483604493070124895770666637"], "Output",
 CellChangeTimes->{3.753445644152426*^9, 3.753447615019409*^9, 
  3.753772545146406*^9, 3.764921828355389*^9, 3.777204185798253*^9, 
  3.777204387325377*^9, 3.78461841496185*^9},
 CellLabel->
  "Out[370]=",ExpressionUUID->"faacab2f-ab03-431f-9090-1eac52de98ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{"r", "*", "5"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p", "-", "1"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.721395601507921*^9, 3.721395611594082*^9}},
 CellLabel->
  "In[371]:=",ExpressionUUID->"e9f3035f-748a-47ab-8b14-f79c047fc6df"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.753116646144661*^9, 3.75317823466296*^9, 
  3.753178365347917*^9, 3.753187215071815*^9, 3.753445644199501*^9, 
  3.753772545196561*^9, 3.764921828434826*^9, 3.777204185866034*^9, 
  3.777204388020001*^9, 3.784618415046143*^9},
 CellLabel->
  "Out[371]=",ExpressionUUID->"1f329420-0573-4bf1-bef3-7e6a318bf46b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["She publishes her public key", "Subsubsection",
 CellChangeTimes->{{3.721239235640522*^9, 
  3.721239241206318*^9}},ExpressionUUID->"6d0bbf95-6c52-4f93-905d-\
9577af29b991"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"n", ",", "a"}], "}"}]], "Input",
 CellChangeTimes->{{3.7212392421431913`*^9, 3.721239246645753*^9}},
 CellLabel->
  "In[372]:=",ExpressionUUID->"49300199-a3f7-4c68-819b-bb55dcc85385"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2923003274661805836407421649242809468366377451741", ",", "5"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.753116646349769*^9, 3.7531782347155952`*^9, 
  3.7531783653829107`*^9, 3.753187244143278*^9, 3.7534456442558937`*^9, 
  3.75344766102418*^9, 3.753772545226695*^9, 3.764921828567474*^9, 
  3.777204185938065*^9, 3.777204390317165*^9, 3.784618415124977*^9},
 CellLabel->
  "Out[372]=",ExpressionUUID->"f25a7949-9727-4aae-bd0b-6a71d2287d8e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Bob now wants to send a plaintext to Alice. The permitted plaintexts are \
numbers between 0 and n-1. Below Mathematica makes a random choice for his \
message.\
\>", "Subsubsection",
 CellChangeTimes->{{3.721239252084756*^9, 3.721239262683178*^9}, {
   3.721396970237253*^9, 3.721396992078287*^9}, {3.721481073435007*^9, 
   3.721481076439392*^9}, 3.7531872217323713`*^9, {3.75344575753406*^9, 
   3.753445779338324*^9}, {3.777204400429941*^9, 
   3.777204411052596*^9}},ExpressionUUID->"48b0490f-ba53-4550-886d-\
849dbac69f7d"],

Cell[CellGroupData[{

Cell[BoxData["n"], "Input",
 CellChangeTimes->{3.753187224497314*^9},
 CellLabel->
  "In[373]:=",ExpressionUUID->"6046e028-f6b4-434f-b0e5-66aad95ed2fb"],

Cell[BoxData["2923003274661805836407421649242809468366377451741"], "Output",
 CellChangeTimes->{3.753187224843416*^9, 3.7534456444918137`*^9, 
  3.753447672845002*^9, 3.753772545310692*^9, 3.764921828627733*^9, 
  3.7772041860204372`*^9, 3.7846184152134657`*^9},
 CellLabel->
  "Out[373]=",ExpressionUUID->"30a28059-7433-44cb-bda4-03bc72131b49"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", " ", "=", 
  RowBox[{"Random", "[", 
   RowBox[{"Integer", ",", "n"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.721239327416793*^9, 3.72123932784748*^9}, 
   3.721396995402719*^9, 3.7214810782742653`*^9, {3.753445718841012*^9, 
   3.7534457260085573`*^9}},
 CellLabel->
  "In[374]:=",ExpressionUUID->"f61f2d30-a637-455e-a786-90790d21b684"],

Cell[BoxData["377403900542934767598187829460492782640375169022"], "Output",
 CellChangeTimes->{
  3.753116646372546*^9, 3.75317823476475*^9, 3.7531783654125566`*^9, {
   3.753187218534659*^9, 3.753187223360469*^9}, 3.7534456446011066`*^9, 
   3.753445726516707*^9, 3.7534476801307993`*^9, 3.753772545356103*^9, 
   3.764921828690927*^9, 3.777204186148567*^9, 3.777204394883606*^9, 
   3.784618415301361*^9},
 CellLabel->
  "Out[374]=",ExpressionUUID->"6f453f40-42bd-4f08-af8d-a3e27d1d4307"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Bob looks up Alice\[CloseCurlyQuote]s public key (n,c) and computes x^c mod n.\
\>", "Subsubsection",
 CellChangeTimes->{{3.721239336825878*^9, 3.721239355141261*^9}, 
   3.721481081031193*^9, {3.753447688280696*^9, 
   3.7534476918945627`*^9}},ExpressionUUID->"32401195-957a-412e-a630-\
2b9509d4e22e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PowerMod", "[", 
  RowBox[{"x", ",", "5", ",", "n"}], "]"}]], "Input",
 CellChangeTimes->{{3.721395670276519*^9, 3.721395676836664*^9}, {
  3.72148108326483*^9, 3.721481095211356*^9}},
 CellLabel->
  "In[375]:=",ExpressionUUID->"81ab889f-7144-4869-a151-5756e7fac141"],

Cell[BoxData["597645046732360237858519926991910188907142904480"], "Output",
 CellChangeTimes->{
  3.753116646441164*^9, 3.753178234848402*^9, 3.753178365443748*^9, {
   3.7531872292878036`*^9, 3.75318724652381*^9}, 3.7534456446509647`*^9, 
   3.753445732530409*^9, 3.753447699945776*^9, 3.753772545394664*^9, 
   3.764921828834429*^9, 3.777204186222335*^9, 3.777204396784148*^9, 
   3.784618415384613*^9},
 CellLabel->
  "Out[375]=",ExpressionUUID->"db319dc5-7db2-459f-a02d-4409c9d3fa09"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["He sends this to Alice, who computes (x^a)^r mod n.", "Subsubsection",
 CellChangeTimes->{{3.721239362033103*^9, 3.721239370742062*^9}, 
   3.753445738164214*^9},ExpressionUUID->"9b197bc0-e3f1-495d-8774-\
53a45bed5a7f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PowerMod", "[", 
  RowBox[{
  "407402218292673317098562253817778975363814079457", ",", "r", ",", "n"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.721239371925284*^9, 3.721239378783033*^9}, 
   3.721394852063908*^9, 3.721481113694188*^9, 3.753445746505693*^9, 
   3.75344771718544*^9},
 CellLabel->
  "In[376]:=",ExpressionUUID->"bb5fa308-82ad-4ca2-9618-455f69dd246a"],

Cell[BoxData["2371452023287268045307927650363773056284065139954"], "Output",
 CellChangeTimes->{
  3.753116646489513*^9, 3.753178234895822*^9, 3.75317836547642*^9, 
   3.7531872496074123`*^9, 3.75344564470679*^9, {3.753445739668293*^9, 
   3.753445747005467*^9}, 3.753447722856551*^9, 3.753772545481576*^9, 
   3.764921828886538*^9, 3.7772041863029747`*^9, 3.784618415463935*^9},
 CellLabel->
  "Out[376]=",ExpressionUUID->"06f19f17-746a-4925-8ac6-255ac5b4658b"]
}, Open  ]]
}, Open  ]],

Cell["Alice now has Bob\[CloseCurlyQuote]s message.", "Subsubsection",
 CellChangeTimes->{{3.721239382263937*^9, 
  3.721239386643146*^9}},ExpressionUUID->"adace218-0a60-48b4-a791-\
bd92915bbded"],

Cell[CellGroupData[{

Cell["Factoring attack on RSA", "Subsection",
 CellChangeTimes->{{3.721239391906765*^9, 3.721239399230674*^9}, {
  3.721303960942403*^9, 3.7213039624837503`*^9}, {3.753454390851171*^9, 
  3.753454395563249*^9}, {3.753723995415366*^9, 
  3.753723996731986*^9}},ExpressionUUID->"7f4154e9-23a4-4dda-a8df-\
306ef73ab850"],

Cell[CellGroupData[{

Cell[TextData[{
 "You will probably find ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " takes a few seconds to factorize n. If you change 80 and 81 to 100 and 101 \
in the definitions of p and q, it will take a few minutes. In 2009 a number \
of size about 2^768 was factored; using the fastest known algorithm this took \
about 1500 years of computer time."
}], "Subsubsection",
 CellChangeTimes->{{3.7212389628699827`*^9, 3.721239080524835*^9}, {
  3.721303927841045*^9, 
  3.721303947335104*^9}},ExpressionUUID->"3eef61ad-a7d8-4071-a04b-\
af2763e2cb4b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"FactorInteger", "[", "n", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7212389527255363`*^9, 3.721238956699478*^9}, {
  3.721239408963449*^9, 3.721239437133781*^9}},
 CellLabel->
  "In[377]:=",ExpressionUUID->"d84d5e09-1056-4ced-b4c4-54afd9bec80f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.700309`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1208925819614629174706189", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2417851639229258349412369", ",", "1"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.721300525414249*^9, 3.753116651156053*^9, 
  3.753178239636765*^9, 3.753178369929943*^9, 3.753445649721819*^9, 
  3.7537725540887737`*^9, 3.764921838296184*^9, 3.777204193723454*^9, 
  3.784618419350919*^9},
 CellLabel->
  "Out[377]=",ExpressionUUID->"01985c51-d904-4e16-8f0e-0a28db1de412"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Incidentally, choosing p and q by taking the next prime to a large power of 2 \
is a terrible idea: the binary form of n rather obviously leaks how the \
primes were chosen!\
\>", "Subsubsection",
 CellChangeTimes->{{3.7772045263179283`*^9, 
  3.777204549797983*^9}},ExpressionUUID->"fb4515e0-281b-4e36-ae66-\
5bf58850035b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BaseForm", "[", 
  RowBox[{"n", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.753718184472898*^9, 3.7537181861054993`*^9}},
 CellLabel->
  "In[378]:=",ExpressionUUID->"29a4a0b5-8609-49df-bd98-b972a750f7ee"],

Cell[BoxData[
 TagBox[
  InterpretationBox[
   SubscriptBox["\<\"\
100000000000000000000000000000000000000000000000000000000000000000000000000010\
101100000000000000000000000000000000000000000000000000000000000000000000000011\
011101\"\>", "\<\"2\"\>"],
   2923003274661805836407421649242809468366377451741,
   Editable->False],
  BaseForm[#, 2]& ]], "Output",
 CellChangeTimes->{3.7537181866913967`*^9, 3.7537725557976503`*^9, 
  3.764921841140552*^9, 3.77720419613647*^9, 3.784618419529161*^9},
 CellLabel->
  "Out[378]//BaseForm=",ExpressionUUID->"9e2a3cab-d03e-45c1-bdfa-\
f94683ed5fbe"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Strings to numbers", "Section",
 CellChangeTimes->{{3.753116104910822*^9, 
  3.753116108915028*^9}},ExpressionUUID->"f74641d2-4f81-4534-adc1-\
222bf270892f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StringToNumbers", "[", "str_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "f", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "xs_", "]"}], ":=", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"xs", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "*", 
         RowBox[{"128", "^", 
          RowBox[{"(", 
           RowBox[{"i", "-", "1"}], ")"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "xs", "]"}]}], "}"}]}], "]"}]}], ";", 
     RowBox[{"f", "/@", 
      RowBox[{"GroupIn", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", 
         RowBox[{"ToCharacterCode", "/@", 
          RowBox[{"Characters", "[", "str", "]"}]}]}], ",", "8"}], 
       "]"}]}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753116112155548*^9, 3.753116114371085*^9}, {
  3.7531162108028193`*^9, 3.753116292821328*^9}, {3.753116348538722*^9, 
  3.7531163757440147`*^9}, {3.777204457922271*^9, 3.77720445843699*^9}},
 CellLabel->
  "In[379]:=",ExpressionUUID->"a60c764a-d39f-47e7-816f-190f1e7bf806"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberToCharacters", "[", "0", "]"}], ":=", 
  RowBox[{"{", "}"}]}]], "Input",
 CellChangeTimes->{{3.7531163978487787`*^9, 3.753116405103546*^9}},
 CellLabel->
  "In[380]:=",ExpressionUUID->"b5e03c73-fcfe-4c19-8e30-053e831d9158"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberToCharacters", "[", "m_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"FromCharacterCode", "[", 
     RowBox[{"Mod", "[", 
      RowBox[{"m", ",", "128"}], "]"}], "]"}], "}"}], "~", "Join", "~", 
   RowBox[{"NumberToCharacters", "[", 
    RowBox[{"Quotient", "[", 
     RowBox[{"m", ",", "128"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.753116405902912*^9, 3.75311643137985*^9}},
 CellLabel->
  "In[381]:=",ExpressionUUID->"40e376c4-ce7c-457f-a702-49e5813c4134"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumbersToString", "[", "ms_", "]"}], ":=", 
  RowBox[{"StringJoin", "@@", 
   RowBox[{"NumberToCharacters", "/@", "ms"}]}]}]], "Input",
 CellChangeTimes->{{3.753116456461508*^9, 3.753116477607772*^9}},
 CellLabel->
  "In[382]:=",ExpressionUUID->"da7aeffc-b980-461a-a39b-ea3f6c7ab402"],

Cell[CellGroupData[{

Cell["Example", "Subsubsection",
 CellChangeTimes->{{3.753116496374844*^9, 3.753116497092375*^9}, {
   3.753117175611746*^9, 3.7531171830094223`*^9}, 
   3.7531172207476254`*^9},ExpressionUUID->"93a45b74-c186-4b88-9cea-\
c559d4259a43"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringToNumbers", "[", 
  "\"\<Here is a string that we will send using the RSA Cryptosystem.\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{{3.753116266482718*^9, 3.7531162779562693`*^9}},
 CellLabel->
  "In[383]:=",ExpressionUUID->"3e0e5b07-ebfc-4dac-b202-dbb8c0e36f86"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "18523790434415304", ",", "58471268937945185", ",", "57382443685657120", 
   ",", "57364849375214496", ",", "58471269207126638", ",", 
   "36959611134818848", ",", "65231443856236960", ",", "1610021157369"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.7531162784498873`*^9, 3.753116377725336*^9}, 
   3.753116651645805*^9, 3.753178240417264*^9, 3.753178370216346*^9, 
   3.753445650081596*^9, 3.7537725544586163`*^9, 3.764921839092312*^9, 
   3.7772041944881983`*^9, {3.7772044488596373`*^9, 3.777204477111683*^9}, 
   3.784618419783655*^9},
 CellLabel->
  "Out[383]=",ExpressionUUID->"52a796b8-c996-4789-9cbf-d483b8ca9039"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NumbersToString", "[", 
  RowBox[{"{", 
   RowBox[{
   "18523790434415304", ",", "58471268937945185", ",", "57382443685657120", 
    ",", "57364849375214496", ",", "58471269207126638", ",", 
    "36959611134818848", ",", "65231443856236960", ",", "1610021157369"}], 
   "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.7531164800904837`*^9, 3.7531164875655937`*^9}},
 CellLabel->
  "In[384]:=",ExpressionUUID->"843db4e9-d77a-4273-90ef-a1876d6f7974"],

Cell[BoxData["\<\"Here is a string that we will send using the RSA \
Cryptosystem.\"\>"], "Output",
 CellChangeTimes->{3.753116488245677*^9, 3.753116651731044*^9, 
  3.753178240600995*^9, 3.753178370293215*^9, 3.753445650139649*^9, 
  3.753772554532093*^9, 3.764921839125003*^9, 3.7772041945557737`*^9, 
  3.7772044799272957`*^9, 3.784618419865794*^9},
 CellLabel->
  "Out[384]=",ExpressionUUID->"cf774b48-b465-4000-8194-dddcffc6c827"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["RSA encryption and decryption of numbers and strings",
 
 FontWeight->"Bold"]], "Section",
 CellChangeTimes->{{3.7531165023519497`*^9, 3.753116522092999*^9}, {
  3.753116739676304*^9, 
  3.753116748447805*^9}},ExpressionUUID->"6a24792a-d2d4-4311-ba50-\
8a0634567622"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Encrypt", "[", 
   RowBox[{"m_", ",", "n_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"PowerMod", "[", 
   RowBox[{"m", ",", "c", ",", "n"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753116511314801*^9, 3.753116528772851*^9}, {
  3.753117062154174*^9, 3.7531170647655067`*^9}, {3.7531183669514303`*^9, 
  3.75311836834201*^9}, {3.753120045739216*^9, 3.753120047034511*^9}},
 CellLabel->
  "In[385]:=",ExpressionUUID->"94a3d8c3-c1da-41d1-9d0a-f8012296249a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DecryptionExponent", "[", 
   RowBox[{"p_", ",", "q_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"PowerMod", "[", 
   RowBox[{"c", ",", 
    RowBox[{"-", "1"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"p", "-", "1"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7531165446227283`*^9, 3.753116561015718*^9}, {
   3.7531170678478413`*^9, 3.753117070025799*^9}, {3.753118369814334*^9, 
   3.7531183720894737`*^9}, 3.7531200440643063`*^9, {3.753178318464246*^9, 
   3.753178318569088*^9}},
 CellLabel->
  "In[386]:=",ExpressionUUID->"f9609966-6e24-432f-b198-421caaeca985"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Decrypt", "[", 
   RowBox[{"m_", ",", "p_", ",", "q_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"PowerMod", "[", 
   RowBox[{"m", ",", 
    RowBox[{"DecryptionExponent", "[", 
     RowBox[{"p", ",", "q", ",", "c"}], "]"}], ",", 
    RowBox[{"p", "*", "q"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7531165300153313`*^9, 3.7531165713841343`*^9}, {
  3.753116678588801*^9, 3.753116693248913*^9}, {3.7531167246959352`*^9, 
  3.753116727347438*^9}, {3.753117071992725*^9, 3.753117076896657*^9}, {
  3.753118373460127*^9, 3.7531183752795343`*^9}, {3.753120049327442*^9, 
  3.753120051588202*^9}},
 CellLabel->
  "In[387]:=",ExpressionUUID->"8548e8d1-f194-4e3d-9a83-d49ce24e29d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EncryptString", "[", 
   RowBox[{"str_", ",", "n_", ",", "c_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"Encrypt", "[", 
     RowBox[{"#1", ",", "n", ",", "c"}], "]"}], "&"}], "/@", 
   RowBox[{"StringToNumbers", "[", "str", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.75311657407124*^9, 3.753116591192461*^9}, {
   3.753117080234385*^9, 3.7531170835225697`*^9}, {3.7531183769699173`*^9, 
   3.7531183791584597`*^9}, 3.753120050606303*^9, {3.777204241917383*^9, 
   3.777204245008616*^9}},
 CellLabel->
  "In[388]:=",ExpressionUUID->"7226fbe5-a058-49b2-befa-5e2746a0159c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DecryptNumbersToString", "[", 
   RowBox[{"ms_", ",", "p_", ",", "q_", ",", "c_"}], "]"}], ":=", 
  RowBox[{"NumbersToString", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Decrypt", "[", 
      RowBox[{"#1", ",", "p", ",", "q", ",", "c"}], "]"}], "&"}], "/@", 
    "ms"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753116592464835*^9, 3.753116622853229*^9}, {
  3.753117085076816*^9, 3.7531170928314323`*^9}, {3.753118380571*^9, 
  3.753118382287059*^9}, {3.753120053803548*^9, 3.753120056263442*^9}, {
  3.7772042569174013`*^9, 3.777204257000209*^9}},
 CellLabel->
  "In[389]:=",ExpressionUUID->"be535854-964c-42d8-935b-c7dfab35499c"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Example: using p and q from above",
 FontWeight->"Bold"]], "Subsubsection",
 CellChangeTimes->{{3.753116625649247*^9, 3.7531166263626213`*^9}, {
  3.753117166278307*^9, 3.753117166833665*^9}, {3.753117232718216*^9, 
  3.753117237717408*^9}},ExpressionUUID->"2b441eab-ba49-4f40-9889-\
08e28d3cb45d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"p", ":=", " ", 
   RowBox[{"NextPrime", "[", 
    RowBox[{"2", "^", "80"}], "]"}]}], ";", "p"}]], "Input",
 CellChangeTimes->{{3.721238907895712*^9, 3.7212389287639837`*^9}},
 CellLabel->
  "In[390]:=",ExpressionUUID->"419297f9-c09f-4c60-a882-5e21b6d7791f"],

Cell[BoxData["1208925819614629174706189"], "Output",
 CellChangeTimes->{3.753116645859132*^9, 3.753117238906245*^9, 
  3.7531782417685547`*^9, 3.75317837058048*^9, 3.753445650553874*^9, 
  3.7537725550472717`*^9, 3.764921839966715*^9, 3.7772041947228003`*^9, 
  3.7846184214151573`*^9},
 CellLabel->
  "Out[390]=",ExpressionUUID->"e28f8444-5d8e-444b-ae27-5f783602d6bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"q", " ", ":=", " ", 
   RowBox[{"NextPrime", "[", 
    RowBox[{"2", "^", "81"}], "]"}]}], ";", "q"}]], "Input",
 CellChangeTimes->{{3.7212389232187433`*^9, 3.7212389303829412`*^9}},
 CellLabel->
  "In[391]:=",ExpressionUUID->"76b9985d-1e2d-488a-be43-428fe6f2ac1c"],

Cell[BoxData["2417851639229258349412369"], "Output",
 CellChangeTimes->{3.753116645910309*^9, 3.7531172396240587`*^9, 
  3.753178242217861*^9, 3.753178370621656*^9, 3.753445650575314*^9, 
  3.753772555074731*^9, 3.76492184000683*^9, 3.777204194795682*^9, 
  3.784618421552454*^9},
 CellLabel->
  "Out[391]=",ExpressionUUID->"674a897d-6681-45d5-9f23-27502f3c3f66"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Public key, using encryption exponent 17 (a standard choice, check that \
neither p-1 nor q-1 is divisible by 17)\
\>", "Subsubsection",
 CellChangeTimes->{{3.7531171853616467`*^9, 3.753117193165515*^9}, {
  3.753178275728828*^9, 
  3.753178341192225*^9}},ExpressionUUID->"43660f95-d109-4890-b295-\
2ae0c2ef5017"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"p", "-", "1"}], ",", "17"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"q", "-", "1"}], ",", "17"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.753178343500908*^9, 3.753178349381271*^9}},
 CellLabel->
  "In[392]:=",ExpressionUUID->"5dfff923-94ab-49e1-acec-6a10ee51ef2e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"13", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.753178349886704*^9, 3.7531783706803513`*^9}, 
   3.753445650663312*^9, 3.753772555112369*^9, 3.764921840087694*^9, 
   3.777204195303424*^9, 3.7846184217031507`*^9},
 CellLabel->
  "Out[392]=",ExpressionUUID->"fb702d00-71f5-420f-b319-def1b80bc589"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"p", "*", "q"}], ",", "17"}], "}"}]], "Input",
 CellChangeTimes->{{3.753117194800619*^9, 3.75311719766812*^9}, {
  3.753178280590625*^9, 3.7531783072280807`*^9}},
 CellLabel->
  "In[393]:=",ExpressionUUID->"edba67d4-00f4-4d48-b1a0-3520b8790f2d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2923003274661805836407421649242809468366377451741", ",", "17"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.753117198219667*^9, 3.75311724110594*^9, 3.753178242260996*^9, {
   3.7531782831514997`*^9, 3.7531783076980133`*^9}, {3.753178352520157*^9, 
   3.7531783707631407`*^9}, 3.753445650692339*^9, 3.753772555325801*^9, 
   3.764921840188881*^9, 3.777204195378847*^9, 3.784618421802328*^9},
 CellLabel->
  "Out[393]=",ExpressionUUID->"bc6d4862-9123-44c7-9981-f7df6bb1dc03"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Private key", "Subsubsection",
 CellChangeTimes->{{3.753117200138309*^9, 
  3.75311720264116*^9}},ExpressionUUID->"9c59bf43-47d3-4ec5-af60-\
dfaae1450f31"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"p", "*", "q"}], ",", 
   RowBox[{"DecryptionExponent", "[", 
    RowBox[{"p", ",", "q", ",", "17"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.753117203505637*^9, 3.753117214603983*^9}, {
  3.7531191485619507`*^9, 3.753119149520701*^9}},
 CellLabel->
  "In[394]:=",ExpressionUUID->"c09ee3f3-5277-4aba-8839-14352297e890"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2923003274661805836407421649242809468366377451741", ",", 
   "2235237798270792698429202017179385771660299607729"}], "}"}]], "Output",
 CellChangeTimes->{{3.753117215177772*^9, 3.753117242242449*^9}, 
   3.753119150169413*^9, 3.753178242330915*^9, {3.7531783109347477`*^9, 
   3.7531783225698423`*^9}, {3.753178354337286*^9, 3.753178370846977*^9}, 
   3.753445650807485*^9, 3.753772555382245*^9, 3.764921840233211*^9, 
   3.777204195462762*^9, 3.784618421889308*^9},
 CellLabel->
  "Out[394]=",ExpressionUUID->"1f258847-8190-4fb5-8aff-9a3b0216a9eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EncryptString", "[", 
  RowBox[{
  "\"\<Here is a string that we will send using the RSA Cryptosystem.\>\"", 
   ",", "n", ",", "17"}], "]"}]], "Input",
 CellChangeTimes->{{3.753116627382917*^9, 3.753116635072942*^9}, {
  3.753117095558004*^9, 3.753117096202025*^9}},
 CellLabel->
  "In[395]:=",ExpressionUUID->"83703154-7e69-4e31-9c09-1fbf9f53ceae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2685694885684278700848146981729275492758521497836", ",", 
   "256280854711531492335264332439935964854757623023", ",", 
   "1336777804336711570327386619804640301525419637368", ",", 
   "2210941436696756483988968043898596577965527005448", ",", 
   "754310062949276881751307456517509778979494511551", ",", 
   "926636131594982397926841792435639166127169225314", ",", 
   "355988985629234054796255882536589125499377753342", ",", 
   "2107162756704721449121962308246337720267599399543"}], "}"}]], "Output",
 CellChangeTimes->{{3.753116635671732*^9, 3.753116652246737*^9}, 
   3.753116707406579*^9, {3.7531170966549797`*^9, 3.753117103070058*^9}, 
   3.7531172471271257`*^9, 3.753178242400216*^9, 3.753178370888527*^9, 
   3.753445650980371*^9, 3.753772555414031*^9, 3.764921840343498*^9, 
   3.777204195543106*^9, 3.77720426960972*^9, 3.7772044892256117`*^9, 
   3.784618421971942*^9},
 CellLabel->
  "Out[395]=",ExpressionUUID->"c2f50e79-3130-4fec-9e6d-7f6c9fc2d5d7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DecryptNumbersToString", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "2685694885684278700848146981729275492758521497836", ",", 
     "256280854711531492335264332439935964854757623023", ",", 
     "1336777804336711570327386619804640301525419637368", ",", 
     "2210941436696756483988968043898596577965527005448", ",", 
     "754310062949276881751307456517509778979494511551", ",", 
     "926636131594982397926841792435639166127169225314", ",", 
     "355988985629234054796255882536589125499377753342", ",", 
     "2107162756704721449121962308246337720267599399543"}], "}"}], ",", "p", 
   ",", "q", ",", "17"}], "]"}]], "Input",
 CellChangeTimes->{{3.7531166541622143`*^9, 3.753116668185185*^9}, {
  3.753117106534149*^9, 3.7531171068189173`*^9}},
 CellLabel->
  "In[396]:=",ExpressionUUID->"5e33b9bd-eec3-471c-8f18-8b7b82efbaa4"],

Cell[BoxData["\<\"Here is a string that we will send using the RSA \
Cryptosystem.\"\>"], "Output",
 CellChangeTimes->{{3.7531166722555113`*^9, 3.7531167307865467`*^9}, 
   3.7531171072910833`*^9, 3.753117250478115*^9, 3.753178246586008*^9, 
   3.753178370950307*^9, 3.753445651102151*^9, 3.7537725555331078`*^9, 
   3.764921840666801*^9, 3.7772041956373367`*^9, 3.777204491792777*^9, 
   3.784618422068715*^9},
 CellLabel->
  "Out[396]=",ExpressionUUID->"3373fcb1-0f8b-4638-bcdc-bbd94a3adb0a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["If your do not receive a message from your partner, \
then instead email the lecturer your public key and you\[CloseCurlyQuote]ll \
get a substitute. His public key is below.",
 FontWeight->"Bold"]], "Subsubsection",
 CellChangeTimes->{{3.753117867658421*^9, 3.7531178810112057`*^9}, {
  3.753117933803091*^9, 
  3.753117999006077*^9}},ExpressionUUID->"c3333d20-d2a8-4c4f-a6ba-\
e053d3588aad"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5805340078229214916722731276062787475461682833619538046845735412311", ",", 
   "17"}], "}"}]], "Input",
 CellChangeTimes->{{3.753117925267873*^9, 3.7531179288877487`*^9}, 
   3.753184398962326*^9},
 CellLabel->
  "In[397]:=",ExpressionUUID->"2ea4a4c3-6420-4a49-8c8f-b3ead81ce91d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5805340078229214916722731276062787475461682833619538046845735412311", ",", 
   "17"}], "}"}]], "Output",
 CellChangeTimes->{3.7531179294713097`*^9, 3.753178246935802*^9, 
  3.753178371346342*^9, 3.753184400410013*^9, 3.753445651152721*^9, 
  3.753772555582985*^9, 3.764921840821989*^9, 3.777204195735219*^9, 
  3.784618422182254*^9},
 CellLabel->
  "Out[397]=",ExpressionUUID->"89c0adc6-9aa2-464d-b0c5-cc022d732bda"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Extra: factoring n given the private key (n, r), but not the factors p and q\
\>", "Section",
 CellChangeTimes->{{3.753724022610168*^9, 
  3.7537240360425987`*^9}},ExpressionUUID->"63f0a21f-e094-492d-a2ab-\
ba2b1c550062"],

Cell[CellGroupData[{

Cell["\<\
We divide cr-1 by its small factors to get t and compute x^t mod n for chosen \
x. It is likely that t has some, but not all, of the factors of (p-1)(q-1) \
and that some x^t will be 1 mod p, but not 1 mod q (or vice versa). Here is \
the example in the Extras for Part D.\
\>", "Subsubsection",
 CellChangeTimes->{{3.7534515223440447`*^9, 3.7534515805417624`*^9}, {
  3.753451796174211*^9, 3.7534518042208347`*^9}, {3.753453964415188*^9, 
  3.7534539901619997`*^9}, {3.75355206766018*^9, 3.7535520752582893`*^9}, {
  3.7537240430768423`*^9, 
  3.7537240543329144`*^9}},ExpressionUUID->"987dd62a-c0d7-4e50-9582-\
af067405d25a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MakeExample", "[", 
   RowBox[{"d_", ",", "cMin_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p", "=", 
       RowBox[{"NextPrime", "[", 
        RowBox[{"2", "^", "d"}], "]"}]}], ",", 
      RowBox[{"q", "=", 
       RowBox[{"NextPrime", "[", 
        RowBox[{"2", "^", 
         RowBox[{"(", 
          RowBox[{"d", "+", "1"}], ")"}]}], "]"}]}], ",", "c", ",", "r"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{"c", ":=", 
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"cMin", ",", 
           RowBox[{"cMin", "+", "1000"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"GCD", "[", 
            RowBox[{"#", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"p", "-", "1"}], ")"}], "*", 
              RowBox[{"(", 
               RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}], "\[Equal]", "1"}], 
          "&"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
     RowBox[{"r", " ", ":=", " ", 
      RowBox[{"PowerMod", "[", 
       RowBox[{"c", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"p", "-", "1"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}]}], ";", 
     RowBox[{"{", 
      RowBox[{"p", ",", "q", ",", 
       RowBox[{"p", "*", "q"}], ",", "c", ",", "r", ",", 
       RowBox[{
        RowBox[{"c", "*", "r"}], "-", "1"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"p", "-", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{"q", "-", "1"}], ")"}]}], ",", 
       RowBox[{"Quotient", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"c", "*", "r"}], "-", "1"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"p", "-", "1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"q", "-", "1"}], ")"}]}]}], "]"}], ",", 
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"c", "*", "r"}], "-", "1"}], ",", 
         RowBox[{"p", "*", "q"}]}], "]"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753551897806185*^9, 3.753552045793428*^9}, {
   3.753552336774395*^9, 3.75355234166315*^9}, {3.753552671266129*^9, 
   3.753552681403035*^9}, {3.753552739466899*^9, 3.753552752097583*^9}, 
   3.7535527891902447`*^9, {3.7535528607256393`*^9, 3.753552864176558*^9}, {
   3.753553027733439*^9, 3.75355303560594*^9}, {3.753553212981835*^9, 
   3.7535532155821*^9}},
 CellLabel->
  "In[398]:=",ExpressionUUID->"1aa7d284-bdf6-4c6a-b5e9-3cdd0c8d36c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeExample", "[", "80", "]"}]], "Input",
 CellChangeTimes->{{3.753552032983851*^9, 3.753552035589308*^9}},
 CellLabel->
  "In[399]:=",ExpressionUUID->"8e30c81f-8d7a-4a0a-87d2-2e05e4efa3a4"],

Cell[BoxData[
 RowBox[{"MakeExample", "[", "80", "]"}]], "Output",
 CellChangeTimes->{{3.7535520361220713`*^9, 3.753552047652618*^9}, 
   3.753552343250408*^9, 3.753772555681871*^9, 3.76492184100486*^9, 
   3.777204195849201*^9, 3.78461842230016*^9},
 CellLabel->
  "Out[399]=",ExpressionUUID->"3fa1af3e-8adb-4d13-9f9c-7cb2175ae130"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "p", ",", "q", ",", "n", ",", "c", ",", "r", ",", "s", ",", "phipq", ",", 
     "sq", ",", "smodpq"}], "}"}], "=", 
   RowBox[{"MakeExample", "[", 
    RowBox[{"80", ",", 
     RowBox[{
      RowBox[{"2", "^", "16"}], "+", "1"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"p", ",", "q", ",", "n", ",", "c", ",", "r"}], "}"}], "//", 
   "TableForm"}]}]], "Input",
 CellChangeTimes->{{3.753552032983851*^9, 3.753552035589308*^9}, {
  3.753552066348712*^9, 3.7535521688440323`*^9}, {3.753552350539791*^9, 
  3.75355236809184*^9}, {3.7535524036657887`*^9, 3.753552405417145*^9}, {
  3.753552659685712*^9, 3.7535526601879597`*^9}, {3.753552690263507*^9, 
  3.7535526905249567`*^9}, {3.753552730764257*^9, 3.753552730877037*^9}, {
  3.753552763702434*^9, 3.7535527740907307`*^9}, {3.753552834498958*^9, 
  3.7535528350352182`*^9}, {3.7535528705770893`*^9, 3.75355287603543*^9}, {
  3.7535530433505487`*^9, 3.753553159369928*^9}, {3.753553230496619*^9, 
  3.753553235365218*^9}, {3.753553349979446*^9, 3.7535533502394257`*^9}, {
  3.753553592918681*^9, 3.7535536177112837`*^9}},
 CellLabel->
  "In[400]:=",ExpressionUUID->"e3b1bd65-5f2a-43bc-a4e6-ab6e7867c359"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"1208925819614629174706189"},
     {"2417851639229258349412369"},
     {"2923003274661805836407421649242809468366377451741"},
     {"65537"},
     {"2486450547921342349724234361267998717733060629441"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.7535521139523687`*^9, 3.753552169232609*^9}, {
   3.7535523525348377`*^9, 3.753552368464555*^9}, 3.7535524058337603`*^9, 
   3.753552660592651*^9, 3.753552691009289*^9, {3.753552756237097*^9, 
   3.753552794090432*^9}, 3.7535528366880417`*^9, 3.753552876523625*^9, {
   3.753553050055668*^9, 3.753553150858076*^9}, {3.7535532178005133`*^9, 
   3.753553235844132*^9}, 3.753553350881081*^9, {3.753553606395502*^9, 
   3.753553617998374*^9}, 3.753772555768114*^9, 3.76492184105271*^9, 
   3.7772041960241747`*^9, 3.7846184223920927`*^9},
 CellLabel->
  "Out[400]//TableForm=",ExpressionUUID->"e62d651d-7408-4896-bfa4-\
bc4749288dc6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "1000"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"c", "*", "r"}], "-", "1"}], ",", "#"}], "]"}], "\[Equal]", 
     RowBox[{"0", "~", "And", "~", 
      RowBox[{"PrimeQ", "[", "#", "]"}]}]}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75355338910769*^9, 3.7535533891198378`*^9}},
 CellLabel->
  "In[401]:=",ExpressionUUID->"1a46ff07-4db0-4aae-8ea2-6b10870986f0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "3", ",", "43", ",", "617", ",", "683"}], "}"}]], "Output",\

 CellChangeTimes->{3.753553392106388*^9, 3.7535545073901854`*^9, 
  3.7537725558654003`*^9, 3.764921841173695*^9, 3.777204196253804*^9, 
  3.784618422483341*^9},
 CellLabel->
  "Out[401]=",ExpressionUUID->"2185e2f2-a7bb-4ebb-8d61-0e5ed3571d47"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Avoid prime 3 since might divide p-1 and q-1", "Subsubsection",
 CellChangeTimes->{{3.753553466616171*^9, 
  3.753553474679528*^9}},ExpressionUUID->"312c6e4a-cd5b-4778-a7fa-\
6a023e647483"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ",", "3"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ",", "9"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ",", "27"}], "]"}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.7535529772316837`*^9, 3.753552981042057*^9}, {
  3.753553405537073*^9, 3.753553415996977*^9}, {3.7535534493924093`*^9, 
  3.7535534644274387`*^9}},
 CellLabel->
  "In[402]:=",ExpressionUUID->"f6d57cc3-1760-40b6-8a93-c5e50e0230f3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "18"}], "}"}]], "Output",
 CellChangeTimes->{
  3.753552981534082*^9, {3.7535533764969797`*^9, 3.753553416301785*^9}, {
   3.753553450232522*^9, 3.753553464916032*^9}, 3.753772555916518*^9, 
   3.76492184127925*^9, 3.7772041963541603`*^9, 3.7846184225737534`*^9},
 CellLabel->
  "Out[402]=",ExpressionUUID->"69c1bb5a-d005-48be-8869-485ad52bb5b9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ",", "43"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ",", 
     RowBox[{"43", "^", "2"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.753553451921604*^9, 3.753553483207087*^9}},
 CellLabel->
  "In[403]:=",ExpressionUUID->"457f7660-9cf5-4a40-a9b6-8ccddf89accb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "817"}], "}"}]], "Output",
 CellChangeTimes->{3.753553483789658*^9, 3.7537725559472313`*^9, 
  3.764921841385124*^9, 3.777204196453755*^9, 3.784618422657696*^9},
 CellLabel->
  "Out[403]=",ExpressionUUID->"ae62a93e-fe6f-4269-93db-8b35cf542992"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "*", "r"}], "-", "1"}]], "Input",
 CellChangeTimes->{{3.753554529149358*^9, 3.753554529774637*^9}},
 CellLabel->
  "In[404]:=",ExpressionUUID->"596bc46b-ed5b-477f-b637-7e1c6d9bf095"],

Cell[BoxData["162954509559121013573877147334420831964071594471674816"], \
"Output",
 CellChangeTimes->{3.7535545300895863`*^9, 3.7537725560660477`*^9, 
  3.7649218419786863`*^9, 3.777204196552106*^9, 3.784618422741344*^9},
 CellLabel->
  "Out[404]=",ExpressionUUID->"4e39b14f-ea12-4222-97cf-55acf4a10760"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{"10", ",", 
    RowBox[{
     RowBox[{"c", "*", "r"}], "-", "1"}]}], "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.753554554745061*^9, 3.753554557345203*^9}},
 CellLabel->
  "In[405]:=",ExpressionUUID->"2ccdb444-91af-4cce-b3d8-b7b28ad89b8c"],

Cell[BoxData["53.21206638351575`"], "Output",
 CellChangeTimes->{3.753554557707987*^9, 3.7537725561119204`*^9, 
  3.7649218421223183`*^9, 3.7772041966543922`*^9, 3.784618422837862*^9},
 CellLabel->
  "Out[405]=",ExpressionUUID->"af996881-95c7-4d0f-9cc3-ef39d5391082"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"t", ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ")"}], "/", "43"}]}], ";", 
  "t"}]], "Input",
 CellChangeTimes->{{3.753553629213785*^9, 3.7535536353034687`*^9}},
 CellLabel->
  "In[406]:=",ExpressionUUID->"8edb579c-6564-4d65-b95d-20f953056591"],

Cell[BoxData["3789639757188860780787840635684205394513292894690112"], "Output",
 CellChangeTimes->{3.753553635646742*^9, 3.7535546086342373`*^9, 
  3.75377255616446*^9, 3.764921842168212*^9, 3.777204196753811*^9, 
  3.7846184229247227`*^9},
 CellLabel->
  "Out[406]=",ExpressionUUID->"b0a4a840-fa33-466e-9ca5-a7c42264bc65"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"GCD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"PowerMod", "[", 
       RowBox[{"2", ",", "t", ",", "n"}], "]"}], "-", "1"}], ",", "n"}], 
    "]"}], ",", "p"}], "}"}]], "Input",
 CellChangeTimes->{{3.753549552173376*^9, 3.7535495784431267`*^9}, {
  3.753553508074074*^9, 3.7535535122406387`*^9}, {3.753553639085483*^9, 
  3.753553639344431*^9}},
 CellLabel->
  "In[407]:=",ExpressionUUID->"c6cd2299-6e4f-40f5-aa15-ffd9dfc2e458"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1208925819614629174706189", ",", "1208925819614629174706189"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.753549578970133*^9, {3.7535535048036737`*^9, 3.75355351251713*^9}, {
   3.753553636548368*^9, 3.753553639748026*^9}, 3.753772556352602*^9, 
   3.764921842207918*^9, 3.7772041968539257`*^9, 3.784618423017397*^9},
 CellLabel->
  "Out[407]=",ExpressionUUID->"cfa9a7d6-8cd8-44e2-83a1-92e12bae3571"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Why it worked", "Subsubsection",
 CellChangeTimes->{{3.753553649506571*^9, 
  3.753553657945208*^9}},ExpressionUUID->"1dec17eb-6ac6-4809-a5ff-\
014cb18093a2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", 
  RowBox[{
   RowBox[{"PowerMod", "[", 
    RowBox[{"2", ",", "t", ",", "n"}], "]"}], "-", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.753451785785781*^9, 3.753451834162917*^9}, {
  3.7535495453072968`*^9, 3.7535495454209623`*^9}},
 CellLabel->
  "In[408]:=",ExpressionUUID->"605c54e6-609e-43ab-b7e2-3efe1cc7ade4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1489", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"49326255650037279629", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1208925819614629174706189", ",", "1"}], "}"}]}], "}"}]], "Output",\

 CellChangeTimes->{{3.753451815440386*^9, 3.753451834490274*^9}, 
   3.75345401202395*^9, 3.753548921943541*^9, 3.7535495482896767`*^9, 
   3.753772556680524*^9, 3.764921842649514*^9, 3.7772041971847687`*^9, 
   3.7846184234365387`*^9},
 CellLabel->
  "Out[408]=",ExpressionUUID->"14616285-ea3b-4144-8166-417f955c3e69"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", 
  RowBox[{"p", "-", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.753451785785781*^9, 3.753451834162917*^9}, {
  3.7535495453072968`*^9, 3.7535495454209623`*^9}, {3.753554373815195*^9, 
  3.753554374418775*^9}},
 CellLabel->
  "In[409]:=",ExpressionUUID->"a1c8e935-016d-4777-a6bb-e1b8c32a3b12"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1093", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"31039", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8908647580887961", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.753451815440386*^9, 3.753451834490274*^9}, 
   3.75345401202395*^9, 3.753548921943541*^9, 3.7535495482896767`*^9, 
   3.753554374986437*^9, 3.753772556753806*^9, 3.764921843103245*^9, 
   3.777204197316762*^9, 3.7846184235498037`*^9},
 CellLabel->
  "Out[409]=",ExpressionUUID->"421f43d8-3fc0-41f9-8d63-8f5c4a188ee5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", 
  RowBox[{"q", "-", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.753554378928021*^9, 3.753554379052102*^9}},
 CellLabel->
  "In[410]:=",ExpressionUUID->"fb8e9c61-4590-429b-be43-0282cf16e826"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"43", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"617", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"683", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"78233", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"35532364099", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.753554379292835*^9, 3.7537725567818947`*^9, 
  3.764921843176385*^9, 3.777204197419415*^9, 3.784618423633257*^9},
 CellLabel->
  "Out[410]=",ExpressionUUID->"85b90e65-4a27-4d5a-b962-2fcef66a20ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FactorInteger", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"c", "*", "r"}], "-", "1"}], ")"}], "/", 
    RowBox[{"(", 
     RowBox[{"p", "-", "1"}], ")"}]}], "/", 
   RowBox[{"(", 
    RowBox[{"q", "-", "1"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753554716211211*^9, 3.753554723164789*^9}},
 CellLabel->
  "In[411]:=",ExpressionUUID->"555ea035-8a6c-466f-826c-34dc247d0801"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"18583", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7535547236512003`*^9, 3.753772556882114*^9, 
  3.7649218432392797`*^9, 3.777204197520591*^9, 3.7846184237203913`*^9},
 CellLabel->
  "Out[411]=",ExpressionUUID->"7e0f3f37-c98e-4c6e-912d-fac3c61379ed"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
An example with numbers of cryptographically strong size: trial division will \
take a minute or so (there are faster methods that could be used here, for \
example elliptic curve factorization)\
\>", "Subsection",
 CellChangeTimes->{{3.7537226822576036`*^9, 3.753722690470098*^9}, {
  3.753723107384066*^9, 
  3.753723131566093*^9}},ExpressionUUID->"ef0f61b2-33d1-4d89-8961-\
afdeb1b03276"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "pBig", ",", "qBig", ",", "nBig", ",", "cBig", ",", "rBig", ",", "sBig", 
     ",", "phipqBig", ",", "sqBig", ",", "smodpqBig"}], "}"}], "=", 
   RowBox[{"MakeExample", "[", 
    RowBox[{"1024", ",", 
     RowBox[{
      RowBox[{"2", "^", "16"}], "+", "1"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"pBig", ",", "qBig", ",", "nBig", ",", "cBig", ",", "rBig"}], 
    "}"}], "//", "TableForm"}]}]], "Input",
 CellChangeTimes->{{3.753722678713776*^9, 3.75372268104681*^9}, {
  3.753722712269064*^9, 3.753722738490778*^9}, {3.753723269909216*^9, 
  3.753723282624007*^9}},
 CellLabel->
  "In[412]:=",ExpressionUUID->"be1bfb08-fdab-406f-85db-230c07202f34"],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"17976931348623159077293051907890247336179769789423065727343008115773267\
580550096313270847732240753602112011387987139335765878976881441662249284743063\
947412437776789342486548527630221960124609411945308295208500576883815068234246\
288147391311054082723716335051068458629823994724593847971630483535632962422413\
7859"},
     {"35953862697246318154586103815780494672359539578846131454686016231546535\
161100192626541695464481507204224022775974278671531757953762883324498569486127\
894824875553578684973097055260443920249218823890616590417001153767630136468492\
576294782622108165447432670102136917259647989449187695943260967071265924844827\
5913"},
     {"64634012142622014601429753377339903920888205339430968064260690855049310\
277735781786394402823045826927377435921843796038988239118300981842190176304772\
896566241261754734601992183500395500779304213592115276768135136553584437285239\
512323676188676952340941163291704072610085775151783082131617215104798247860771\
541250357195739496510068695864452282781806582143988872791736645882108366339238\
085616504873936830006403891242313041069135357067992614094086246516235805891476\
615738012476024438178978555840101805075466037613580524358245254932578300790314\
748627199247839902078067335116746439224666468983279311866542671292347381090267\
"},
     {"65537"},
     {"43256670378374722407698100506332385154555099781692504848658592269913450\
388204664921083432293538200022303457847749984559349118146509595565563015135017\
532329705479070210940048814570560859662191771249275495587640191409078337485205\
155103662989022381351389602257311630510260954635280189288109963405580907722680\
326336685099804251720698972379248094220676153515349793199907705184341320434637\
020919383387951413500161264731848385480198875681564458197252459236343976934741\
171168731136463124766453556963866434344149043757803548797822819113120560640106\
538407750765458223558920321927242575789647337134025625024631542695465221130961\
"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.5599999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   Column],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.753722691748022*^9, 3.7537227395816193`*^9}, 
   3.75372328416855*^9, 3.753772557229014*^9, 3.764921843625639*^9, 
   3.777204197760551*^9, 3.784618424000804*^9},
 CellLabel->
  "Out[412]//TableForm=",ExpressionUUID->"26c3b434-1e67-4f66-a480-\
69fa185b043f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"pBig", "-", "1"}], ",", "#"}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
   "2", ",", "3", ",", "5", ",", "7", ",", "11", ",", "13", ",", "17"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.753723360686872*^9, 3.753723365338953*^9}, {
  3.753723730855607*^9, 3.753723744488357*^9}},
 CellLabel->
  "In[413]:=",ExpressionUUID->"3037408a-8196-4beb-a47c-b639de40edeb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "3", ",", "0", ",", "9", ",", "8", ",", "14"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.753723365802496*^9, 3.753723740179335*^9, 
  3.753772557448041*^9, 3.764921843709049*^9, 3.77720419786019*^9, 
  3.7846184240867767`*^9},
 CellLabel->
  "Out[413]=",ExpressionUUID->"49873d31-df71-4f81-8ee9-dc86ed23140d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mod", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"cBig", "*", "rBig"}], "-", "1"}], ",", " ", "15360437"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.753723295763995*^9, 3.7537233222063303`*^9}},
 CellLabel->
  "In[414]:=",ExpressionUUID->"546a89dd-9f48-4dd1-bf53-e45ccca736cc"],

Cell[BoxData["1448497"], "Output",
 CellChangeTimes->{{3.753723298009513*^9, 3.753723323114552*^9}, 
   3.753772557477591*^9, 3.764921844109177*^9, 3.777204197965089*^9, 
   3.784618424225218*^9},
 CellLabel->
  "Out[414]=",ExpressionUUID->"002d1c89-33b5-4f77-b389-24dfb3ba6d30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "100000"}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"cBig", "*", "rBig"}], "-", "1"}], ",", "#"}], "]"}], 
     "\[Equal]", 
     RowBox[{"0", "~", "And", "~", 
      RowBox[{"PrimeQ", "[", "#", "]"}]}]}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75355338910769*^9, 3.7535533891198378`*^9}, 
   3.753722870749605*^9, {3.753722939150249*^9, 3.753722942245832*^9}, 
   3.753722973211488*^9, {3.7537230982664633`*^9, 3.753723098384081*^9}, {
   3.753723211491898*^9, 3.7537232200453987`*^9}},
 CellLabel->
  "In[415]:=",ExpressionUUID->"b1d9d906-51ed-4c8d-8b8c-1a065740231b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "7", ",", "23", ",", "29", ",", "283", ",", "1907", ",",
    "3539"}], "}"}]], "Output",
 CellChangeTimes->{
  3.753553392106388*^9, 3.7535545073901854`*^9, 3.753722757845037*^9, 
   3.753722871149658*^9, {3.753722939699358*^9, 3.753722945307829*^9}, 
   3.753723003655341*^9, 3.753723171476639*^9, {3.75372322183001*^9, 
   3.753723223414031*^9}, 3.753723754577919*^9, 3.7537725577526407`*^9, 
   3.764921844406601*^9, 3.7772041982483263`*^9, 3.784618424500379*^9},
 CellLabel->
  "Out[415]=",ExpressionUUID->"6206d793-8be0-43b1-a6af-09742f83767d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"cBig", "*", "rBig"}], "-", "1"}], ",", 
     RowBox[{"#", "^", "2"}]}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
   "2", ",", "3", ",", "7", ",", "23", ",", "29", ",", "283", ",", "1907", 
    ",", "3539"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.753722892830917*^9, 3.753722952896509*^9}},
 CellLabel->
  "In[416]:=",ExpressionUUID->"13445ec9-28c1-4fba-8792-d051d52017be"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "0", ",", "0", ",", "0", ",", "87", ",", "13301", ",", "840987", 
   ",", "10139235"}], "}"}]], "Output",
 CellChangeTimes->{{3.753722900786353*^9, 3.753722915531714*^9}, {
   3.7537229500811043`*^9, 3.753722953261175*^9}, 3.7537725578124037`*^9, 
   3.7649218444333963`*^9, 3.777204198387321*^9, 3.784618424616906*^9},
 CellLabel->
  "Out[416]=",ExpressionUUID->"8a61c86a-540e-419c-a8f1-e94f6054e9cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tBig", ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"cBig", "*", "rBig"}], "-", "1"}], ")"}], "/", "29"}]}], ";", 
  " ", 
  RowBox[{"GCD", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"PowerMod", "[", 
      RowBox[{"2", ",", "tBig", ",", "nBig"}], "]"}], "-", "1"}], ",", 
    "nBig"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753724094433277*^9, 3.753724105849483*^9}},
 CellLabel->
  "In[417]:=",ExpressionUUID->"de378903-7fe0-4dae-9620-c8050dc9332d"],

Cell[BoxData[\
"35953862697246318154586103815780494672359539578846131454686016231546535161100\
192626541695464481507204224022775974278671531757953762883324498569486127894824\
875553578684973097055260443920249218823890616590417001153767630136468492576294\
7826221081654474326701021369172596479894491876959432609670712659248448275913"]\
, "Output",
 CellChangeTimes->{{3.753724102980261*^9, 3.753724108771192*^9}, 
   3.753772557867453*^9, 3.764921844541656*^9, 3.777204198490149*^9, 
   3.784618424688645*^9},
 CellLabel->
  "Out[417]=",ExpressionUUID->"5092b667-8cfd-4653-8bff-570afb093ad4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"GCD", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"PowerMod", "[", 
       RowBox[{"2", ",", "tBig", ",", "nBig"}], "]"}], "-", "1"}], ",", 
     "nBig"}], "]"}], "\[Equal]", "qBig"}]}]], "Input",
 CellChangeTimes->{{3.753724132321973*^9, 3.753724132611334*^9}, {
  3.7537726649241447`*^9, 3.75377266526046*^9}},
 CellLabel->
  "In[418]:=",ExpressionUUID->"1c355841-0f44-423f-96ef-da39d6a9903e"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.753724133057863*^9, 3.753772557896912*^9, 
  3.7537726657921*^9, 3.764921844575611*^9, 3.77720419859476*^9, 
  3.784618424768018*^9},
 CellLabel->
  "Out[418]=",ExpressionUUID->"c74b6b7c-3bb6-4790-8cb0-2428107e763b"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"SlideShow",
WindowSize->{1228, 698},
WindowMargins->{{Automatic, -1338}, {Automatic, -55}},
ShowSelection->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 427, 7, 130, "Subsubsection",ExpressionUUID->"85ddcb8e-e69b-4ad8-98c9-c3bccf375c36"],
Cell[CellGroupData[{
Cell[1009, 31, 179, 3, 72, "Section",ExpressionUUID->"14adf787-eb25-4f12-941f-9ca67fa65c12"],
Cell[1191, 36, 330, 8, 49, "Input",ExpressionUUID->"14f89deb-4f9f-4101-a57c-0d7726772cde"],
Cell[1524, 46, 346, 9, 49, "Input",ExpressionUUID->"8bf13888-db3c-4bf9-9403-a8a055382217"],
Cell[1873, 57, 867, 24, 82, "Input",ExpressionUUID->"2b8aa4de-8514-4244-a99a-57c571b59635"],
Cell[2743, 83, 810, 22, 49, "Input",ExpressionUUID->"05987e33-89e2-4af3-b899-b2fdbe195be4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3590, 110, 175, 3, 110, "Section",ExpressionUUID->"7361d337-3b63-4f59-813a-0cd667bf2d7b"],
Cell[CellGroupData[{
Cell[3790, 117, 448, 8, 130, "Subsubsection",ExpressionUUID->"cbf0d910-4791-4509-9315-3e76215ed93b"],
Cell[CellGroupData[{
Cell[4263, 129, 449, 9, 49, "Input",ExpressionUUID->"6271c3c6-6490-4786-aa60-d5b4ba553f6d"],
Cell[4715, 140, 241, 4, 49, "Output",ExpressionUUID->"fc0cfb3c-efa0-42d1-a1bb-f78ddcff4b59"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4993, 149, 382, 8, 49, "Input",ExpressionUUID->"f44fb10a-545f-4c84-b64d-9aa7f1c3b367"],
Cell[5378, 159, 153, 3, 49, "Output",ExpressionUUID->"01c0cd59-03e8-4a05-ba16-c4113e739427"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5580, 168, 399, 7, 92, "Subsubsection",ExpressionUUID->"ab551172-b535-4e2b-bdc1-bbc85c3a507c"],
Cell[5982, 177, 352, 8, 49, "Input",ExpressionUUID->"66fee14b-eacd-46e2-8bb8-decf1e95ddf9"],
Cell[CellGroupData[{
Cell[6359, 189, 152, 3, 49, "Input",ExpressionUUID->"3660d8d2-9fb6-44a4-9cf7-f8693eadd809"],
Cell[6514, 194, 191, 3, 49, "Output",ExpressionUUID->"f9c100e3-f06e-47cc-86e7-6b473baf7b65"]
}, Open  ]],
Cell[6720, 200, 453, 9, 49, "Input",ExpressionUUID->"d18d032a-38dd-43ce-9b77-cec967ac7023"],
Cell[CellGroupData[{
Cell[7198, 213, 154, 3, 49, "Input",ExpressionUUID->"3442daf2-934b-4ec7-9cdb-bec1c84f5652"],
Cell[7355, 218, 191, 3, 49, "Output",ExpressionUUID->"1f243cee-9555-43d4-91fe-2a07331db5e4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7583, 226, 152, 3, 49, "Input",ExpressionUUID->"db3c88ab-5dcd-48b5-b1b3-2eba39f951d7"],
Cell[7738, 231, 191, 3, 49, "Output",ExpressionUUID->"5f5d2caa-943f-47c9-b91a-91880f49053d"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7978, 240, 490, 9, 168, "Subsubsection",ExpressionUUID->"2a0bbfb3-3f01-40d8-a6a3-73045973e55e"],
Cell[CellGroupData[{
Cell[8493, 253, 252, 6, 49, "Input",ExpressionUUID->"8af2281f-23fe-48cf-89a8-13e3d742a4ce"],
Cell[8748, 261, 413, 9, 50, "Message",ExpressionUUID->"18f9f059-c895-4eee-8898-4d064c517779"],
Cell[9164, 272, 182, 4, 49, "Output",ExpressionUUID->"a9b0a146-e19e-4149-a9c2-0a63658769b4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9383, 281, 296, 6, 49, "Input",ExpressionUUID->"ceb38681-3f22-4d4b-8810-32877c69a4e8"],
Cell[9682, 289, 217, 3, 49, "Output",ExpressionUUID->"23585071-d7ab-42bc-8aaa-4479fbe719b2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9936, 297, 295, 6, 49, "Input",ExpressionUUID->"ed597df0-3b06-44db-ac9c-cd57fecff879"],
Cell[10234, 305, 191, 3, 49, "Output",ExpressionUUID->"dadf3577-384a-4461-816d-e8ec8af57f6d"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10474, 314, 221, 5, 54, "Subsubsection",ExpressionUUID->"a8d3c07f-4b6b-4821-a509-9cc5de947be7"],
Cell[CellGroupData[{
Cell[10720, 323, 406, 8, 49, "Input",ExpressionUUID->"9a6980ae-56b0-41e0-91e4-43e2586ee639"],
Cell[11129, 333, 191, 3, 49, "Output",ExpressionUUID->"02a60487-4dd9-4c89-9d8d-6eacefd5d016"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11369, 342, 213, 4, 54, "Subsubsection",ExpressionUUID->"563c6c1d-9dc7-413d-85a8-3b53bd18899d"],
Cell[CellGroupData[{
Cell[11607, 350, 406, 8, 49, "Input",ExpressionUUID->"49347725-e6ee-4d69-aef7-2fefd664de4d"],
Cell[12016, 360, 191, 3, 49, "Output",ExpressionUUID->"4fa800b5-cd86-4465-ad61-5e3bdde784dc"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12256, 369, 324, 6, 92, "Subsubsection",ExpressionUUID->"18139181-b83a-4a6f-bffe-42b14ab73b0e"],
Cell[CellGroupData[{
Cell[12605, 379, 324, 7, 49, "Input",ExpressionUUID->"06313682-024a-401a-861f-fe6d408b7158"],
Cell[12932, 388, 451, 12, 102, "Output",ExpressionUUID->"911b8782-4eab-4046-8e24-25dd0571aa84"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13420, 405, 539, 13, 49, "Input",ExpressionUUID->"ed6ae9ca-6e57-4d9a-bbd8-b830148b7201"],
Cell[13962, 420, 1529, 23, 146, "Output",ExpressionUUID->"9f6c8775-c7f3-4ff1-833e-7b2a5d820b3a"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15552, 450, 237, 4, 110, "Section",ExpressionUUID->"73b6c3e2-ea75-4fbf-b2f2-e580a15d96f6"],
Cell[15792, 456, 529, 14, 49, "Input",ExpressionUUID->"6936e130-a7df-4b3e-adb4-e3e909e3f91f"],
Cell[CellGroupData[{
Cell[16346, 474, 295, 6, 49, "Input",ExpressionUUID->"e1563b66-2cab-4fab-a950-ed865c339ad4"],
Cell[16644, 482, 2609, 46, 92, "Output",ExpressionUUID->"c010a1b2-6417-4858-a30c-9b190a41a217"]
}, Open  ]],
Cell[19268, 531, 638, 18, 49, "Input",ExpressionUUID->"eb3005fa-573c-46c2-bb28-8b707f5b7b3e"],
Cell[CellGroupData[{
Cell[19931, 553, 195, 3, 54, "Subsubsection",ExpressionUUID->"1b25aead-7753-4424-bb7b-7d939df4d94c"],
Cell[CellGroupData[{
Cell[20151, 560, 322, 8, 49, "Input",ExpressionUUID->"7d4c480f-f0d6-4106-bd35-106615733973"],
Cell[20476, 570, 251, 6, 49, "Output",ExpressionUUID->"bffaaafe-5971-4aa4-b366-5c71a41d627e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20764, 581, 383, 10, 49, "Input",ExpressionUUID->"ef8a183a-c002-415f-b3c9-4e69412c92ae"],
Cell[21150, 593, 248, 6, 49, "Output",ExpressionUUID->"00cd5f9c-734b-46f9-998d-07657bd2eeaa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21435, 604, 932, 25, 49, "Input",ExpressionUUID->"f5ca1a89-a0ec-4aa0-aac7-2ac570900f48"],
Cell[22370, 631, 1048, 30, 308, "Output",ExpressionUUID->"7a78242a-2118-409b-b924-0eb81f0dfad2"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23479, 668, 207, 4, 110, "Section",ExpressionUUID->"8acebd57-64ce-4b50-b00f-ce650f75cdbb"],
Cell[CellGroupData[{
Cell[23711, 676, 273, 6, 92, "Subsubsection",ExpressionUUID->"16db76e4-8dea-4232-b3ed-954a5ad14e95"],
Cell[CellGroupData[{
Cell[24009, 686, 292, 7, 49, "Input",ExpressionUUID->"081d4121-a816-4ef5-9cdd-e46b03989efa"],
Cell[24304, 695, 324, 5, 49, "Output",ExpressionUUID->"ea04a8c3-ffc8-4eb9-851a-4a9574f8a972"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24665, 705, 299, 7, 49, "Input",ExpressionUUID->"bbd15b5a-5d9a-46e4-8542-5efa17eafa83"],
Cell[24967, 714, 318, 5, 49, "Output",ExpressionUUID->"e8c7d9dd-9195-45f4-b4a5-aaf45c459ff5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25322, 724, 248, 6, 49, "Input",ExpressionUUID->"bf1396cd-be57-41b0-8731-52940fd6f115"],
Cell[25573, 732, 321, 5, 49, "Output",ExpressionUUID->"89042f11-681b-4185-9203-748e213da304"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25943, 743, 369, 7, 92, "Subsubsection",ExpressionUUID->"ee8f1b72-e792-405a-97ac-569158e31dbe"],
Cell[CellGroupData[{
Cell[26337, 754, 555, 17, 49, "Input",ExpressionUUID->"b688b54a-7656-466c-bc3b-ae928336f2f5"],
Cell[26895, 773, 739, 13, 82, "Output",ExpressionUUID->"077b3738-c79a-4433-b1f4-e18667364881"]
}, Open  ]],
Cell[27649, 789, 270, 5, 49, "Input",ExpressionUUID->"38e3768b-934a-41b6-baf4-14aa80fcc7ef"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27956, 799, 497, 10, 130, "Subsubsection",ExpressionUUID->"78dc6599-9a55-4f86-a165-0afc83c30902"],
Cell[CellGroupData[{
Cell[28478, 813, 511, 14, 49, "Input",ExpressionUUID->"30023491-6523-4d02-9948-938df172e486"],
Cell[28992, 829, 337, 5, 49, "Output",ExpressionUUID->"faacab2f-ab03-431f-9090-1eac52de98ad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29366, 839, 378, 11, 49, "Input",ExpressionUUID->"e9f3035f-748a-47ab-8b14-f79c047fc6df"],
Cell[29747, 852, 359, 6, 49, "Output",ExpressionUUID->"1f329420-0573-4bf1-bef3-7e6a318bf46b"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30155, 864, 179, 3, 54, "Subsubsection",ExpressionUUID->"6d0bbf95-6c52-4f93-905d-9577af29b991"],
Cell[CellGroupData[{
Cell[30359, 871, 223, 5, 49, "Input",ExpressionUUID->"49300199-a3f7-4c68-819b-bb55dcc85385"],
Cell[30585, 878, 483, 9, 49, "Output",ExpressionUUID->"f25a7949-9727-4aae-bd0b-6a71d2287d8e"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31117, 893, 539, 10, 92, "Subsubsection",ExpressionUUID->"48b0490f-ba53-4550-886d-849dbac69f7d"],
Cell[CellGroupData[{
Cell[31681, 907, 152, 3, 49, "Input",ExpressionUUID->"6046e028-f6b4-434f-b0e5-66aad95ed2fb"],
Cell[31836, 912, 345, 5, 49, "Output",ExpressionUUID->"30a28059-7433-44cb-bda4-03bc72131b49"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32218, 922, 367, 8, 49, "Input",ExpressionUUID->"f61f2d30-a637-455e-a786-90790d21b684"],
Cell[32588, 932, 490, 8, 49, "Output",ExpressionUUID->"6f453f40-42bd-4f08-af8d-a3e27d1d4307"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33127, 946, 312, 6, 54, "Subsubsection",ExpressionUUID->"32401195-957a-412e-a630-2b9509d4e22e"],
Cell[CellGroupData[{
Cell[33464, 956, 291, 6, 49, "Input",ExpressionUUID->"81ab889f-7144-4869-a151-5756e7fac141"],
Cell[33758, 964, 488, 8, 49, "Output",ExpressionUUID->"db319dc5-7db2-459f-a02d-4409c9d3fa09"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34295, 978, 225, 3, 54, "Subsubsection",ExpressionUUID->"9b197bc0-e3f1-495d-8774-53a45bed5a7f"],
Cell[CellGroupData[{
Cell[34545, 985, 391, 9, 49, "Input",ExpressionUUID->"bb5fa308-82ad-4ca2-9618-455f69dd246a"],
Cell[34939, 996, 462, 7, 49, "Output",ExpressionUUID->"06f19f17-746a-4925-8ac6-255ac5b4658b"]
}, Open  ]]
}, Open  ]],
Cell[35428, 1007, 196, 3, 54, "Subsubsection",ExpressionUUID->"adace218-0a60-48b4-a791-bd92915bbded"],
Cell[CellGroupData[{
Cell[35649, 1014, 317, 5, 57, "Subsection",ExpressionUUID->"7f4154e9-23a4-4dda-a8df-306ef73ab850"],
Cell[CellGroupData[{
Cell[35991, 1023, 564, 12, 168, "Subsubsection",ExpressionUUID->"3eef61ad-a7d8-4071-a04b-af2763e2cb4b"],
Cell[CellGroupData[{
Cell[36580, 1039, 299, 6, 49, "Input",ExpressionUUID->"d84d5e09-1056-4ced-b4c4-54afd9bec80f"],
Cell[36882, 1047, 599, 15, 49, "Output",ExpressionUUID->"01985c51-d904-4e16-8f0e-0a28db1de412"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37530, 1068, 334, 7, 130, "Subsubsection",ExpressionUUID->"fb4515e0-281b-4e36-ae66-5bf58850035b"],
Cell[CellGroupData[{
Cell[37889, 1079, 235, 5, 49, "Input",ExpressionUUID->"29a4a0b5-8609-49df-bd98-b972a750f7ee"],
Cell[38127, 1086, 591, 14, 134, "Output",ExpressionUUID->"9e2a3cab-d03e-45c1-bdfa-f94683ed5fbe"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38791, 1108, 163, 3, 110, "Section",ExpressionUUID->"f74641d2-4f81-4534-adc1-222bf270892f"],
Cell[38957, 1113, 1239, 34, 114, "Input",ExpressionUUID->"a60c764a-d39f-47e7-816f-190f1e7bf806"],
Cell[40199, 1149, 264, 6, 49, "Input",ExpressionUUID->"b5e03c73-fcfe-4c19-8e30-053e831d9158"],
Cell[40466, 1157, 523, 13, 82, "Input",ExpressionUUID->"40e376c4-ce7c-457f-a702-49e5813c4134"],
Cell[40992, 1172, 319, 7, 49, "Input",ExpressionUUID->"da7aeffc-b980-461a-a39b-ea3f6c7ab402"],
Cell[CellGroupData[{
Cell[41336, 1183, 235, 4, 54, "Subsubsection",ExpressionUUID->"93a45b74-c186-4b88-9cea-c559d4259a43"],
Cell[CellGroupData[{
Cell[41596, 1191, 294, 6, 49, "Input",ExpressionUUID->"3e0e5b07-ebfc-4dac-b202-dbb8c0e36f86"],
Cell[41893, 1199, 666, 13, 82, "Output",ExpressionUUID->"52a796b8-c996-4789-9cbf-d483b8ca9039"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42596, 1217, 470, 10, 114, "Input",ExpressionUUID->"843db4e9-d77a-4273-90ef-a1876d6f7974"],
Cell[43069, 1229, 435, 7, 49, "Output",ExpressionUUID->"cf774b48-b465-4000-8194-dddcffc6c827"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43565, 1243, 291, 6, 110, "Section",ExpressionUUID->"6a24792a-d2d4-4311-ba50-8a0634567622"],
Cell[43859, 1251, 486, 10, 49, "Input",ExpressionUUID->"94a3d8c3-c1da-41d1-9d0a-f8012296249a"],
Cell[44348, 1263, 681, 17, 49, "Input",ExpressionUUID->"f9609966-6e24-432f-b198-421caaeca985"],
Cell[45032, 1282, 708, 15, 49, "Input",ExpressionUUID->"8548e8d1-f194-4e3d-9a83-d49ce24e29d3"],
Cell[45743, 1299, 616, 14, 49, "Input",ExpressionUUID->"7226fbe5-a058-49b2-befa-5e2746a0159c"],
Cell[46362, 1315, 669, 15, 49, "Input",ExpressionUUID->"be535854-964c-42d8-935b-c7dfab35499c"],
Cell[CellGroupData[{
Cell[47056, 1334, 322, 5, 54, "Subsubsection",ExpressionUUID->"2b441eab-ba49-4f40-9889-08e28d3cb45d"],
Cell[CellGroupData[{
Cell[47403, 1343, 292, 7, 49, "Input",ExpressionUUID->"419297f9-c09f-4c60-a882-5e21b6d7791f"],
Cell[47698, 1352, 369, 6, 49, "Output",ExpressionUUID->"e28f8444-5d8e-444b-ae27-5f783602d6bd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48104, 1363, 299, 7, 49, "Input",ExpressionUUID->"76b9985d-1e2d-488a-be43-428fe6f2ac1c"],
Cell[48406, 1372, 363, 6, 49, "Output",ExpressionUUID->"674a897d-6681-45d5-9f23-27502f3c3f66"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[48818, 1384, 323, 7, 92, "Subsubsection",ExpressionUUID->"43660f95-d109-4890-b295-2ae0c2ef5017"],
Cell[CellGroupData[{
Cell[49166, 1395, 387, 11, 49, "Input",ExpressionUUID->"5dfff923-94ab-49e1-acec-6a10ee51ef2e"],
Cell[49556, 1408, 345, 7, 49, "Output",ExpressionUUID->"fb702d00-71f5-420f-b319-def1b80bc589"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49938, 1420, 296, 7, 49, "Input",ExpressionUUID->"edba67d4-00f4-4d48-b1a0-3520b8790f2d"],
Cell[50237, 1429, 516, 10, 49, "Output",ExpressionUUID->"bc6d4862-9123-44c7-9981-f7df6bb1dc03"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[50802, 1445, 161, 3, 54, "Subsubsection",ExpressionUUID->"9c59bf43-47d3-4ec5-af60-dfaae1450f31"],
Cell[CellGroupData[{
Cell[50988, 1452, 378, 9, 49, "Input",ExpressionUUID->"c09ee3f3-5277-4aba-8839-14352297e890"],
Cell[51369, 1463, 591, 11, 82, "Output",ExpressionUUID->"1f258847-8190-4fb5-8aff-9a3b0216a9eb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51997, 1479, 374, 8, 82, "Input",ExpressionUUID->"83703154-7e69-4e31-9c09-1fbf9f53ceae"],
Cell[52374, 1489, 1006, 18, 274, "Output",ExpressionUUID->"c2f50e79-3130-4fec-9e6d-7f6c9fc2d5d7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53417, 1512, 861, 17, 274, "Input",ExpressionUUID->"5e33b9bd-eec3-471c-8f18-8b7b82efbaa4"],
Cell[54281, 1531, 494, 8, 49, "Output",ExpressionUUID->"3373fcb1-0f8b-4638-bcdc-bbd94a3adb0a"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[54824, 1545, 417, 7, 92, "Subsubsection",ExpressionUUID->"c3333d20-d2a8-4c4f-a6ba-e053d3588aad"],
Cell[CellGroupData[{
Cell[55266, 1556, 323, 8, 49, "Input",ExpressionUUID->"2ea4a4c3-6420-4a49-8c8f-b3ead81ce91d"],
Cell[55592, 1566, 459, 10, 49, "Output",ExpressionUUID->"89c0adc6-9aa2-464d-b0c5-cc022d732bda"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[56112, 1583, 231, 5, 163, "Section",ExpressionUUID->"63f0a21f-e094-492d-a2ab-ba2b1c550062"],
Cell[CellGroupData[{
Cell[56368, 1592, 637, 11, 168, "Subsubsection",ExpressionUUID->"987dd62a-c0d7-4e50-9582-af067405d25a"],
Cell[57008, 1605, 2674, 76, 178, "Input",ExpressionUUID->"1aa7d284-bdf6-4c6a-b5e9-3cdd0c8d36c7"],
Cell[CellGroupData[{
Cell[59707, 1685, 214, 4, 49, "Input",ExpressionUUID->"8e30c81f-8d7a-4a0a-87d2-2e05e4efa3a4"],
Cell[59924, 1691, 333, 6, 49, "Output",ExpressionUUID->"3fa1af3e-8adb-4d13-9f9c-7cb2175ae130"]
}, Open  ]],
Cell[CellGroupData[{
Cell[60294, 1702, 1238, 26, 82, "Input",ExpressionUUID->"e3b1bd65-5f2a-43bc-a4e6-ab6e7867c359"],
Cell[61535, 1730, 1395, 32, 172, "Output",ExpressionUUID->"e62d651d-7408-4896-bfa4-bc4749288dc6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62967, 1767, 536, 15, 49, "Input",ExpressionUUID->"1a46ff07-4db0-4aae-8ea2-6b10870986f0"],
Cell[63506, 1784, 355, 8, 49, "Output",ExpressionUUID->"2185e2f2-a7bb-4ebb-8d61-0e5ed3571d47"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63910, 1798, 195, 3, 54, "Subsubsection",ExpressionUUID->"312c6e4a-cd5b-4778-a7fa-6a023e647483"],
Cell[CellGroupData[{
Cell[64130, 1805, 666, 20, 49, "Input",ExpressionUUID->"f6d57cc3-1760-40b6-8a93-c5e50e0230f3"],
Cell[64799, 1827, 405, 8, 49, "Output",ExpressionUUID->"69c1bb5a-d005-48be-8869-485ad52bb5b9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65241, 1840, 467, 14, 49, "Input",ExpressionUUID->"457f7660-9cf5-4a40-a9b6-8ccddf89accb"],
Cell[65711, 1856, 293, 6, 49, "Output",ExpressionUUID->"ae62a93e-fe6f-4269-93db-8b35cf542992"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66041, 1867, 221, 5, 49, "Input",ExpressionUUID->"596bc46b-ed5b-477f-b637-7e1c6d9bf095"],
Cell[66265, 1874, 305, 5, 49, "Output",ExpressionUUID->"4e39b14f-ea12-4222-97cf-55acf4a10760"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66607, 1884, 305, 8, 49, "Input",ExpressionUUID->"2ccdb444-91af-4cce-b3d8-b7b28ad89b8c"],
Cell[66915, 1894, 267, 4, 49, "Output",ExpressionUUID->"af996881-95c7-4d0f-9cc3-ef39d5391082"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67219, 1903, 330, 10, 49, "Input",ExpressionUUID->"8edb579c-6564-4d65-b95d-20f953056591"],
Cell[67552, 1915, 323, 5, 49, "Output",ExpressionUUID->"b0a4a840-fa33-466e-9ca5-a7c42264bc65"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67912, 1925, 487, 13, 49, "Input",ExpressionUUID->"c6cd2299-6e4f-40f5-aa15-ffd9dfc2e458"],
Cell[68402, 1940, 443, 9, 49, "Output",ExpressionUUID->"cfa9a7d6-8cd8-44e2-83a1-92e12bae3571"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[68894, 1955, 164, 3, 54, "Subsubsection",ExpressionUUID->"1dec17eb-6ac6-4809-a5ff-014cb18093a2"],
Cell[CellGroupData[{
Cell[69083, 1962, 362, 8, 49, "Input",ExpressionUUID->"605c54e6-609e-43ab-b7e2-3efe1cc7ade4"],
Cell[69448, 1972, 657, 17, 49, "Output",ExpressionUUID->"14616285-ea3b-4144-8166-417f955c3e69"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70142, 1994, 340, 7, 49, "Input",ExpressionUUID->"a1c8e935-016d-4777-a6bb-e1b8c32a3b12"],
Cell[70485, 2003, 651, 16, 49, "Output",ExpressionUUID->"421f43d8-3fc0-41f9-8d63-8f5c4a188ee5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[71173, 2024, 238, 5, 49, "Input",ExpressionUUID->"fb8e9c61-4590-429b-be43-0282cf16e826"],
Cell[71414, 2031, 703, 20, 49, "Output",ExpressionUUID->"85b90e65-4a27-4d5a-b962-2fcef66a20ee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72154, 2056, 440, 13, 49, "Input",ExpressionUUID->"555ea035-8a6c-466f-826c-34dc247d0801"],
Cell[72597, 2071, 397, 10, 49, "Output",ExpressionUUID->"7e0f3f37-c98e-4c6e-912d-fac3c61379ed"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[73043, 2087, 401, 8, 171, "Subsection",ExpressionUUID->"ef0f61b2-33d1-4d89-8961-afdeb1b03276"],
Cell[CellGroupData[{
Cell[73469, 2099, 737, 19, 114, "Input",ExpressionUUID->"be1bfb08-fdab-406f-85db-230c07202f34"],
Cell[74209, 2120, 2775, 51, 172, "Output",ExpressionUUID->"26c3b434-1e67-4f66-a480-69fa185b043f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77021, 2176, 459, 13, 49, "Input",ExpressionUUID->"3037408a-8196-4beb-a47c-b639de40edeb"],
Cell[77483, 2191, 369, 8, 49, "Output",ExpressionUUID->"49873d31-df71-4f81-8ee9-dc86ed23140d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77889, 2204, 300, 8, 49, "Input",ExpressionUUID->"546a89dd-9f48-4dd1-bf53-e45ccca736cc"],
Cell[78192, 2214, 279, 5, 49, "Output",ExpressionUUID->"002d1c89-33b5-4f77-b389-24dfb3ba6d30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78508, 2224, 748, 19, 49, "Input",ExpressionUUID->"b1d9d906-51ed-4c8d-8b8c-1a065740231b"],
Cell[79259, 2245, 611, 12, 49, "Output",ExpressionUUID->"6206d793-8be0-43b1-a6af-09742f83767d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[79907, 2262, 484, 14, 49, "Input",ExpressionUUID->"13445ec9-28c1-4fba-8792-d051d52017be"],
Cell[80394, 2278, 454, 9, 49, "Output",ExpressionUUID->"8a61c86a-540e-419c-a8f1-e94f6054e9cd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80885, 2292, 510, 16, 49, "Input",ExpressionUUID->"de378903-7fe0-4dae-9620-c8050dc9332d"],
Cell[81398, 2310, 591, 10, 178, "Output",ExpressionUUID->"5092b667-8cfd-4653-8bff-570afb093ad4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82026, 2325, 450, 12, 49, "Input",ExpressionUUID->"1c355841-0f44-423f-96ef-da39d6a9903e"],
Cell[82479, 2339, 269, 5, 49, "Output",ExpressionUUID->"c74b6b7c-3bb6-4790-8cb0-2428107e763b"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

